# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.element_description import ElementDescription
from vmware_vi.models.type_description import TypeDescription
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AlarmDescription(DataObject):
    """
    Static strings for alarms. 
    """ # noqa: E501
    expr: List[TypeDescription] = Field(description="Descriptions of expression types for a trigger. ")
    state_operator: List[ElementDescription] = Field(description="*State Operator enum description* ", alias="stateOperator")
    metric_operator: List[ElementDescription] = Field(description="*MetricAlarmExpression Metric Operator enum description* ", alias="metricOperator")
    host_system_connection_state: List[ElementDescription] = Field(description="*Host System Connection State enum description* ", alias="hostSystemConnectionState")
    virtual_machine_power_state: List[ElementDescription] = Field(description="*Virtual Machine Power State enum description* ", alias="virtualMachinePowerState")
    datastore_connection_state: List[ElementDescription] = Field(description="*DatastoreSummary.accessible* and *description*  ***Since:*** vSphere API 4.0 ", alias="datastoreConnectionState")
    host_system_power_state: List[ElementDescription] = Field(description="*Host System Power State enum description*  ***Since:*** vSphere API 4.0 ", alias="hostSystemPowerState")
    virtual_machine_guest_heartbeat_status: List[ElementDescription] = Field(description="*Guest Heartbeat Status enum description*  ***Since:*** vSphere API 4.0 ", alias="virtualMachineGuestHeartbeatStatus")
    entity_status: List[ElementDescription] = Field(description="*ManagedEntity Status enum description* ", alias="entityStatus")
    action: List[TypeDescription] = Field(description="Action class descriptions for an alarm. ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AlarmDescription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AlarmDescription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


