# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.profile_deferred_policy_option_parameter import ProfileDeferredPolicyOptionParameter
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AnswerFile(DataObject):
    """
    The *AnswerFile* data object contains host-specific information that a host will use in combination with a *HostProfile* for configuration.  Answer files are stored on the vCenter Server, along with host profiles. An answer file is always associated with a particular host.  To supply host-specific data: - Specify deferred parameters when you call the   *HostProfile*.*HostProfile.ExecuteHostProfile*   method. The host profile engine will verify the set of parameters for the   additional configuration data. - Use the complete required input list   (*ProfileExecuteResult*.*ProfileExecuteResult.requireInput*\\[\\])   as user input for the   *HostProfileManager*.*HostProfileManager.ApplyHostConfig_Task*   method. When you apply the profile, the vCenter Server saves the additional configuration   data in the *AnswerFile.userInput* list. - Use the *HostProfileManager*.*HostProfileManager.UpdateAnswerFile_Task* method. This method will update an existing answer file or create a new one.    ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    user_input: Optional[List[ProfileDeferredPolicyOptionParameter]] = Field(default=None, description="List containing host-specific configuration data.  ***Since:*** vSphere API 5.0 ", alias="userInput")
    created_time: datetime = Field(description="Time at which the answer file was created.  ***Since:*** vSphere API 5.0 ", alias="createdTime")
    modified_time: datetime = Field(description="Time at which the answer file was last modified.  ***Since:*** vSphere API 5.0 ", alias="modifiedTime")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AnswerFile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AnswerFile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


