# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.method_fault import MethodFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CheckResult(DataObject):
    """
    The result of a call to any of the methods in either *VirtualMachineCompatibilityChecker* or *VirtualMachineProvisioningChecker*.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    vm: Optional[ManagedObjectReference] = None
    host: Optional[ManagedObjectReference] = None
    warning: Optional[List[MethodFault]] = Field(default=None, description="A list of faults representing problems which may require attention, but which are not fatal.  ***Since:*** vSphere API 4.0 ")
    error: Optional[List[MethodFault]] = Field(default=None, description="A list of faults representing problems which are fatal to the operation.  For *VirtualMachineProvisioningChecker* an error means that the given provisioning operation would fail. For *VirtualMachineCompatibilityChecker* an error means that either a power-on of this virtual machine would fail, or that the virtual machine would not run correctly once powered-on.  ***Since:*** vSphere API 4.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CheckResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CheckResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


