# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterDasFailoverLevelAdvancedRuntimeInfoSlotInfo(DataObject):
    """
    A slot represents an amount of memory and cpu resources on a physical host for use by a virtual machine.  It is used in computing the resources to be reserved for failover.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    num_vcpus: StrictInt = Field(description="Deprecated as of vSphere API 5.0, the number of vcpus is no longer used for slot calculations.  The number of virtual cpus of a slot is defined as the maximum number of virtual cpus any powered on virtual machine has.  ***Since:*** vSphere API 4.0 ", alias="numVcpus")
    cpu_mhz: StrictInt = Field(description="The cpu speed of a slot is defined as the maximum cpu reservation of any powered on virtual machine in the cluster, or any otherwise defined minimum, whichever is larger.  ***Since:*** vSphere API 4.0 ", alias="cpuMHz")
    memory_mb: StrictInt = Field(description="The memory size of a slot is defined as the maximum memory reservation plus memory overhead of any powered on virtual machine in the cluster, or any otherwise defined minimum, whichever is larger.  ***Since:*** vSphere API 4.0 ", alias="memoryMB")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ClusterDasFailoverLevelAdvancedRuntimeInfoSlotInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ClusterDasFailoverLevelAdvancedRuntimeInfoSlotInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


