# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.dpm_behavior_enum import DpmBehaviorEnum
from vmware_vi.models.option_value import OptionValue
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterDpmConfigInfo(DataObject):
    """
    Configuration of the VMware DPM service.  All fields are defined as optional. In case of a reconfiguration, unset fields are not changed.  ***Since:*** VI API 2.5 
    """ # noqa: E501
    enabled: Optional[StrictBool] = Field(default=None, description="Flag indicating whether or not the service is enabled.  This service can not be enabled, unless DRS is enabled as well.  ***Since:*** VI API 2.5 ")
    default_dpm_behavior: Optional[DpmBehaviorEnum] = Field(default=None, alias="defaultDpmBehavior")
    host_power_action_rate: Optional[StrictInt] = Field(default=None, description="DPM generates only those recommendations that are above the specified rating.  Ratings vary from 1 to 5. This setting applies to both manual and automated (@link DpmBehavior) DPM clusters.  ***Since:*** vSphere API 4.0 ", alias="hostPowerActionRate")
    option: Optional[List[OptionValue]] = Field(default=None, description="Deprecated as of vSphere API 4.1, use *ClusterDrsConfigInfo.option*.  Advanced settings.  ***Since:*** VI API 2.5 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ClusterDpmConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ClusterDpmConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


