# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterDrsMigration(DataObject):
    """
    Describes a single virtual machine migration. 
    """ # noqa: E501
    key: StrictStr = Field(description="A unique key that identifies this recommendation.  This is used as an argument to ComputeResource.applyRecommendation. ")
    time: datetime = Field(description="The time this recommendation was computed. ")
    vm: ManagedObjectReference
    cpu_load: Optional[StrictInt] = Field(default=None, description="Current CPU load for the virtual machine, in MHz.  This property is only populated for recommendations. ", alias="cpuLoad")
    memory_load: Optional[StrictInt] = Field(default=None, description="Current memory load for the virtual machine, in bytes.  This field is only populated for recommendations. ", alias="memoryLoad")
    source: ManagedObjectReference
    source_cpu_load: Optional[StrictInt] = Field(default=None, description="Current CPU load on the source host, in MHz. ", alias="sourceCpuLoad")
    source_memory_load: Optional[StrictInt] = Field(default=None, description="Current memory usage on the source host, in bytes. ", alias="sourceMemoryLoad")
    destination: ManagedObjectReference
    destination_cpu_load: Optional[StrictInt] = Field(default=None, description="Current CPU load on the destination host, in MHz. ", alias="destinationCpuLoad")
    destination_memory_load: Optional[StrictInt] = Field(default=None, description="Current memory usage on the destination host, in bytes. ", alias="destinationMemoryLoad")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ClusterDrsMigration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ClusterDrsMigration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


