# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.cluster_attempted_vm_info import ClusterAttemptedVmInfo
from vmware_vi.models.cluster_not_attempted_vm_info import ClusterNotAttemptedVmInfo
from vmware_vi.models.cluster_recommendation import ClusterRecommendation
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterPowerOnVmResult(DataObject):
    """
    PowerOnVmResult is the base class of the result returned to the *Datacenter.PowerOnMultiVM_Task* method.  ***Since:*** VI API 2.5 
    """ # noqa: E501
    attempted: Optional[List[ClusterAttemptedVmInfo]] = Field(default=None, description="The list of virtual machines the Virtual Center has attempted to power on.  For a virtual machine not managed by DRS, a task ID is also returned.  ***Since:*** VI API 2.5 ")
    not_attempted: Optional[List[ClusterNotAttemptedVmInfo]] = Field(default=None, description="The list of virtual machines DRS can not find suitable hosts for powering on.  There is one fault associated with each virtual machine.  ***Since:*** VI API 2.5 ", alias="notAttempted")
    recommendations: Optional[List[ClusterRecommendation]] = Field(default=None, description="The list of recommendations that need the client to approve manually.  ***Since:*** VI API 2.5 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ClusterPowerOnVmResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ClusterPowerOnVmResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


