# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_entity_status_enum import ManagedEntityStatusEnum
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterRuleInfo(DataObject):
    """
    The *ClusterRuleInfo* data object is the base type for affinity and anti-affinity rules.  The affinity and anti-affinity rules are DRS (Distributed Resource Scheduling) rules that affect the placement of virtual machines in a cluster. Hosts and virtual machines referenced in a DRS rule must be in the same cluster.  Note: DRS rules are different than an individual host's CPU affinity rules (*VirtualMachineAffinityInfo*).  The Server uses DRS rule objects to describe the current rule configuration (*ClusterConfigInfoEx*.*ClusterConfigInfoEx.rule*). Your client application uses rule objects to configure the affinity and anti-affinity rules (*ClusterConfigSpecEx*.*ClusterConfigSpecEx.rulesSpec*).  You can create the following types of rules: - An affinity rule defines a set of virtual machines that should run   on the same host.   The *ClusterAffinityRuleSpec* object describes a rule that   identifies virtual machines, but does not identify any specific host. - An anti-affinity rule defines a set of virtual machines that should run   on different hosts.   The *ClusterAntiAffinityRuleSpec* object describes a rule that   identifies virtual machines, but does not identify any specific host. - A VM-Host rule defines affinity and anti-affinity relationships between   virtual machines and hosts.   The *ClusterVmHostRuleInfo* object describes a rule that identifies   a virtual machine group (*ClusterVmGroup*) and affinity and   anti-affinity host groups (*ClusterHostGroup*).    Rule configuration is a dynamic process. When you create or modify a DRS rule, the Server applies the rule to the cluster. If the existing cluster configuration violates the rule, the Server attempts to correct the situation. If that is not possible, the Server generates a fault and produces a log event. DRS rules do not have precedence; all rules are applied equally. DRS does not validate one rule against another. If you create conflicting rules, the older rule takes precedence and DRS disables the newer rule.  Improperly used, DRS rules can fragment the cluster and inhibit the proper functioning of DRS, HA, and DPM services. vSphere services never take any actions that would result in the violation of mandatory DRS rules. An operation that violates a mandatory rule would produce the following consequences. - DRS does not evacuate virtual machines to place a host in maintenance   mode. - DRS does not place virtual machines for power-on or load balance virtual   machines. - HA does not perform failovers. - DPM does not optimize power management by placing hosts into standby   mode.    To avoid these situations, exercise caution when creating more than one mandatory rule, or consider using only optional rules. Make sure that the number of hosts with which a virtual machine is related by affinity rule is large enough that losing a host does not prevent the virtual machine from running.  For manual and partially automated DRS clusters, the Server produces migration recommendations to satisfy the DRS rules. You are not required to act on the recommendations, but the Server maintains the recommendations until the rules are satisfied. 
    """ # noqa: E501
    key: Optional[StrictInt] = Field(default=None, description="Unique ID for rules.  When adding a new rule, do not specify this property. The Server will assign the key. ")
    status: Optional[ManagedEntityStatusEnum] = None
    enabled: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether or not the rule is enabled.  Set this property when you configure the rule. The default value is false (disabled). If there is a rule conflict, the Server can override the setting to disable a rule. ")
    name: Optional[StrictStr] = Field(default=None, description="Name of the rule. ")
    mandatory: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether compliance with this rule is mandatory or optional.  The default value is false (optional). - A mandatory rule will prevent a virtual machine from being powered on   or migrated to a host that does not satisfy the rule. - An optional rule specifies a preference. DRS takes an optional rule   into consideration when it places a virtual machine in the cluster.   DRS will act on an optional rule as long as it does not impact   the ability of the host to satisfy current CPU or memory requirements   for virtual machines on the system. (As long as the operation does not   cause any host to be more than 100% utilized.)    ***Since:*** vSphere API 4.1 ")
    user_created: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether the rule is created by the user or the system.  ***Since:*** vSphere API 4.1 ", alias="userCreated")
    in_compliance: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether or not the placement of Virtual Machines is currently in compliance with this rule.  The Server does not currently use this property.  ***Since:*** vSphere API 4.1 ", alias="inCompliance")
    rule_uuid: Optional[StrictStr] = Field(default=None, description="UUID for the rule.  When adding a new rule, do not specify this property. The Server will assign the key.  ***Since:*** vSphere API 6.0 ", alias="ruleUuid")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','ClusterAffinityRuleSpec': 'ClusterAffinityRuleSpec','ClusterAntiAffinityRuleSpec': 'ClusterAntiAffinityRuleSpec','ClusterDependencyRuleInfo': 'ClusterDependencyRuleInfo','ClusterVmHostRuleInfo': 'ClusterVmHostRuleInfo','VirtualDiskAntiAffinityRuleSpec': 'VirtualDiskAntiAffinityRuleSpec','VirtualDiskRuleSpec': 'VirtualDiskRuleSpec'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self]:
        """Create an instance of ClusterRuleInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self]:
        """Create an instance of ClusterRuleInfo from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("ClusterRuleInfo failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.cluster_affinity_rule_spec import ClusterAffinityRuleSpec
from vmware_vi.models.cluster_anti_affinity_rule_spec import ClusterAntiAffinityRuleSpec
from vmware_vi.models.cluster_dependency_rule_info import ClusterDependencyRuleInfo
from vmware_vi.models.cluster_vm_host_rule_info import ClusterVmHostRuleInfo
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.virtual_disk_anti_affinity_rule_spec import VirtualDiskAntiAffinityRuleSpec
from vmware_vi.models.virtual_disk_rule_spec import VirtualDiskRuleSpec
# TODO: Rewrite to not use raise_errors
ClusterRuleInfo.model_rebuild(raise_errors=False)

