# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ClusterVmReadiness(DataObject):
    """
    VM readiness policy specifies when a VM is deemed ready.  This is used in cluster VM orchestration settings. For example, vSphere HA restarts lower priority VMs only after higher priority VMs are ready.  ***Since:*** vSphere API 6.5 
    """ # noqa: E501
    ready_condition: Optional[StrictStr] = Field(default=None, description="Ready condition for a virtual machine.  See *ClusterVmReadinessReadyCondition_enum*.  If not specified at either the cluster level or the virtual machine level, this will default to *none*.  ***Since:*** vSphere API 6.5 ", alias="readyCondition")
    post_ready_delay: Optional[StrictInt] = Field(default=None, description="Additional delay in seconds after ready condition is met.  A VM is considered ready at this point.  If not specified in a VM override, cluster default setting is used. Alternatively, set to -1 in per-VM setting to use cluster default value.  ***Since:*** vSphere API 6.5 ", alias="postReadyDelay")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ClusterVmReadiness from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ClusterVmReadiness from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


