# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.cpu_incompatible import CpuIncompatible
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CpuIncompatible1ECX(CpuIncompatible):
    """
    Deprecated as of vSphere API 6.5 use *FeatureRequirementsNotMet*.  Convenience subclass for calling out some named features among the incompatibilities found in CPUID level 1 register ecx.  ***Since:*** VI API 2.5 
    """ # noqa: E501
    sse3: StrictBool = Field(description="Flag to indicate bit 0 is incompatible.  ***Since:*** VI API 2.5 ")
    pclmulqdq: StrictBool = Field(description="Flag to indicate bit 1 is incompatible.  ***Since:*** vSphere API 5.0 ")
    ssse3: StrictBool = Field(description="Flag to indicate bit 9 is incompatible.  ***Since:*** VI API 2.5 ")
    sse41: StrictBool = Field(description="Flag to indicate bit 19 is incompatible.  ***Since:*** VI API 2.5 ")
    sse42: StrictBool = Field(description="Flag to indicate bit 20 is incompatible.  ***Since:*** VI API 2.5 ")
    aes: StrictBool = Field(description="Flag to indicate bit 25 is incompatible.  ***Since:*** vSphere API 5.0 ")
    other: StrictBool = Field(description="Flag to indicate that bits other than 0/1/9/19/20/25 are incompatible.  I.e. the detected incompatibilities cannot be completely described by the sse3, pclmulqdq, ssse3, sse41, sse42, and/or aes flags.  ***Since:*** VI API 2.5 ")
    other_only: StrictBool = Field(description="Flag to indicate that the sse3, pclmulqdq, ssse3, sse41, sse42, and aes flags are all false, and the \"other\" flag is true.  Purely a convenience property for the client processing this fault.  ***Since:*** VI API 2.5 ", alias="otherOnly")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CpuIncompatible1ECX from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CpuIncompatible1ECX from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


