# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.guest_authentication import GuestAuthentication
from vmware_vi.models.guest_reg_key_name_spec import GuestRegKeyNameSpec
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateRegistryKeyInGuestRequestType(BaseModel):
    """
    The parameters of *GuestWindowsRegistryManager.CreateRegistryKeyInGuest*. 
    """ # noqa: E501
    vm: ManagedObjectReference
    auth: GuestAuthentication
    key_name: GuestRegKeyNameSpec = Field(alias="keyName")
    is_volatile: StrictBool = Field(description="If true, the key is created in memory and is not preserved across system reboot. Otherwise, it shall persist in the file system. ", alias="isVolatile")
    class_type: Optional[StrictStr] = Field(default=None, description="User defined class type for this key. May be omitted. ", alias="classType")
    __properties: ClassVar[List[str]] = ["vm", "auth", "keyName", "isVolatile", "classType"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateRegistryKeyInGuestRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of vm
        if self.vm:
            _dict['vm'] = self.vm.to_dict()
        # override the default output from pydantic by calling `to_dict()` of auth
        if self.auth:
            _dict['auth'] = self.auth.to_dict()
        # override the default output from pydantic by calling `to_dict()` of key_name
        if self.key_name:
            _dict['keyName'] = self.key_name.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateRegistryKeyInGuestRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "vm": ManagedObjectReference.from_dict(obj.get("vm")) if obj.get("vm") is not None else None,
            "auth": GuestAuthentication.from_dict(obj.get("auth")) if obj.get("auth") is not None else None,
            "keyName": GuestRegKeyNameSpec.from_dict(obj.get("keyName")) if obj.get("keyName") is not None else None,
            "isVolatile": obj.get("isVolatile"),
            "classType": obj.get("classType")
        })
        return _obj


