# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateTaskRequestType(BaseModel):
    """
    The parameters of *TaskManager.CreateTask*. 
    """ # noqa: E501
    obj: ManagedObjectReference
    task_type_id: StrictStr = Field(description="Extension registered task type identifier for type of task being created ", alias="taskTypeId")
    initiated_by: Optional[StrictStr] = Field(default=None, description="The name of the user on whose behalf the Extension is creating the task ", alias="initiatedBy")
    cancelable: StrictBool = Field(description="True if the task should be cancelable, false otherwise ")
    parent_task_key: Optional[StrictStr] = Field(default=None, description="Key of the task that is the parent of this task ", alias="parentTaskKey")
    activation_id: Optional[StrictStr] = Field(default=None, description="Activation Id is a client-provided token to link an API call with a task. When provided, the activationId is added to the *TaskInfo* ", alias="activationId")
    __properties: ClassVar[List[str]] = ["obj", "taskTypeId", "initiatedBy", "cancelable", "parentTaskKey", "activationId"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateTaskRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of obj
        if self.obj:
            _dict['obj'] = self.obj.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateTaskRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "obj": ManagedObjectReference.from_dict(obj.get("obj")) if obj.get("obj") is not None else None,
            "taskTypeId": obj.get("taskTypeId"),
            "initiatedBy": obj.get("initiatedBy"),
            "cancelable": obj.get("cancelable"),
            "parentTaskKey": obj.get("parentTaskKey"),
            "activationId": obj.get("activationId")
        })
        return _obj


