# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CryptoManagerKmipCertSignRequest(DataObject):
    """
    CryptoManagerKmipCertSignRequest
    """ # noqa: E501
    common_name: Optional[StrictStr] = Field(default=None, description="Common name for the certificate sign request.  This is fully qualified domain name that you wish to secure. ", alias="commonName")
    organization: Optional[StrictStr] = Field(default=None, description="Organization name for the certificate sign request.  Usually the legal name of a company or entity and should include any suffixes such as Ltd., Inc., or Corp. ")
    organization_unit: Optional[StrictStr] = Field(default=None, description="Organizational unit name for the certificate sign request.  Internal organization department/division name. ", alias="organizationUnit")
    locality: Optional[StrictStr] = Field(default=None, description="Locality name for the certificate sign request.  Town, city, village, etc. ")
    state: Optional[StrictStr] = Field(default=None, description="State name for the certificate sign request.  Province, region, county or state. ")
    country: Optional[StrictStr] = Field(default=None, description="Country Name for the certificate sign request.  The two-letter ISO code for the country where your organization is located. ")
    email: Optional[StrictStr] = Field(default=None, description="Email address for the certificate sign request.  The organization contact, usually of the certificate administrator or IT department. ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CryptoManagerKmipCertSignRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CryptoManagerKmipCertSignRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


