# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.customization_password import CustomizationPassword
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CustomizationIdentification(DataObject):
    """
    The Identification data object type provides information needed to join a workgroup or domain.  The Identification data object type maps to the Identification key in the `sysprep.xml` answer file. These values are transferred into the `sysprep.xml` file that VirtualCenter stores on the target virtual disk. For more detailed information, see <a href=\"https://technet.microsoft.com/en-us/library/cc771830(v=ws.10).aspx\"target=\"_blank\">Performing Unattended Installations</a>. 
    """ # noqa: E501
    join_workgroup: Optional[StrictStr] = Field(default=None, description="The workgroup that the virtual machine should join.  If this value is supplied, then the domain name and authentication fields must be empty. ", alias="joinWorkgroup")
    join_domain: Optional[StrictStr] = Field(default=None, description="The domain that the virtual machine should join.  If this value is supplied, then domainAdmin and domainAdminPassword must also be supplied, and the workgroup name must be empty. ", alias="joinDomain")
    domain_admin: Optional[StrictStr] = Field(default=None, description="This is the domain user account used for authentication if the virtual machine is joining a domain.  The user does not need to be a domain administrator, but the account must have the privileges required to add computers to the domain. ", alias="domainAdmin")
    domain_admin_password: Optional[CustomizationPassword] = Field(default=None, alias="domainAdminPassword")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CustomizationIdentification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CustomizationIdentification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


