# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.distributed_virtual_switch_host_member_config_info import DistributedVirtualSwitchHostMemberConfigInfo
from vmware_vi.models.distributed_virtual_switch_host_member_runtime_state import DistributedVirtualSwitchHostMemberRuntimeState
from vmware_vi.models.distributed_virtual_switch_product_spec import DistributedVirtualSwitchProductSpec
from vmware_vi.models.dynamic_property import DynamicProperty
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DistributedVirtualSwitchHostMember(DataObject):
    """
    The *DistributedVirtualSwitchHostMember* data object represents an ESXi host that is a member of a distributed virtual switch.  When you add a host to a switch (*DistributedVirtualSwitchHostMemberConfigSpec*.*DistributedVirtualSwitchHostMemberConfigSpec.host*), the Server creates a proxy switch (*HostProxySwitch*). The host member object contains information about the configuration and state of the proxy.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    dynamic_property: Optional[List[DynamicProperty]] = Field(default=None, description="Set of dynamic properties.  This property is optional because only the properties of an object that are unknown to a client will be part of this set. This property is not readonly just in case we want to send such properties from a client in the future. ", alias="dynamicProperty")
    runtime_state: Optional[DistributedVirtualSwitchHostMemberRuntimeState] = Field(default=None, alias="runtimeState")
    config: DistributedVirtualSwitchHostMemberConfigInfo
    product_info: Optional[DistributedVirtualSwitchProductSpec] = Field(default=None, alias="productInfo")
    uplink_port_key: Optional[List[StrictStr]] = Field(default=None, description="Port keys of the uplink ports created for the host member.  These ports will be deleted after the host leaves the switch.  ***Since:*** vSphere API 4.0 ", alias="uplinkPortKey")
    status: StrictStr = Field(description="Deprecated as of vSphere API 5.1, use *HostMemberRuntimeInfo*.*HostMemberRuntimeInfo.status* instead.  The host DistributedVirtualSwitch component status.  See *HostComponentState* for valid values.  ***Since:*** vSphere API 4.0 ")
    status_detail: Optional[StrictStr] = Field(default=None, description="Deprecated as of vSphere API 5.1, use *HostMemberRuntimeInfo*.*HostMemberRuntimeInfo.statusDetail* instead.  Additional information regarding the host's current status.  ***Since:*** vSphere API 4.1 ", alias="statusDetail")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DistributedVirtualSwitchHostMember from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DistributedVirtualSwitchHostMember from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


