# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.distributed_virtual_switch_host_member_backing import DistributedVirtualSwitchHostMemberBacking
from vmware_vi.models.distributed_virtual_switch_host_member_pnic_spec import DistributedVirtualSwitchHostMemberPnicSpec
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DistributedVirtualSwitchHostMemberPnicBacking(DistributedVirtualSwitchHostMemberBacking):
    """
    The *DistributedVirtualSwitchHostMemberPnicBacking* data object specifies a set of physical NICs to use for a proxy switch.  When you add a host to a distributed virtual switch (*DistributedVirtualSwitchHostMemberConfigSpec*.*DistributedVirtualSwitchHostMemberConfigSpec.host*), the host creates a proxy switch that will use the pNICs as uplinks.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    pnic_spec: Optional[List[DistributedVirtualSwitchHostMemberPnicSpec]] = Field(default=None, description="List of physical NIC specifications.  Each entry identifies a pNIC to the proxy switch and optionally specifies uplink portgroup and port connections for the pNIC.  ***Since:*** vSphere API 4.0 ", alias="pnicSpec")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DistributedVirtualSwitchHostMemberPnicBacking from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DistributedVirtualSwitchHostMemberPnicBacking from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


