# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.import_operation_bulk_fault_fault_on_import import ImportOperationBulkFaultFaultOnImport
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DistributedVirtualSwitchManagerImportResult(DataObject):
    """
    The *DistributedVirtualSwitchManagerImportResult* data object represents the results of a *DistributedVirtualSwitchManager.DVSManagerImportEntity_Task* operation.  It contains lists of the switches and portgroups that were created. It also contains a list of faults that occurred during the operation.  ***Since:*** vSphere API 5.1 
    """ # noqa: E501
    distributed_virtual_switch: Optional[List[ManagedObjectReference]] = Field(default=None, description="List of distributed virtual switches.  ***Since:*** vSphere API 5.1  Refers instances of *DistributedVirtualSwitch*. ", alias="distributedVirtualSwitch")
    distributed_virtual_portgroup: Optional[List[ManagedObjectReference]] = Field(default=None, description="List of distributed virtual portgroups.  ***Since:*** vSphere API 5.1  Refers instances of *DistributedVirtualPortgroup*. ", alias="distributedVirtualPortgroup")
    import_fault: Optional[List[ImportOperationBulkFaultFaultOnImport]] = Field(default=None, description="Faults that occurred on the entities during the import operation.  ***Since:*** vSphere API 5.1 ", alias="importFault")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DistributedVirtualSwitchManagerImportResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DistributedVirtualSwitchManagerImportResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


