# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DistributedVirtualSwitchProductSpec(DataObject):
    """
    This data object type is a subset of *AboutInfo*.  An object of this type can be used to describe the specification for a proxy switch module of a *DistributedVirtualSwitch*.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Short form of the product name.  ***Since:*** vSphere API 4.0 ")
    vendor: Optional[StrictStr] = Field(default=None, description="Name of the vendor of this product.  ***Since:*** vSphere API 4.0 ")
    version: Optional[StrictStr] = Field(default=None, description="Dot-separated version string.  For example, \"1.2\".  ***Since:*** vSphere API 4.0 ")
    build: Optional[StrictStr] = Field(default=None, description="Build string for the server on which this call is made.  For example, x.y.z-num. This string does not apply to the API.  ***Since:*** vSphere API 4.0 ")
    forwarding_class: Optional[StrictStr] = Field(default=None, description="Forwarding class of the distributed virtual switch.  ***Since:*** vSphere API 4.0 ", alias="forwardingClass")
    bundle_id: Optional[StrictStr] = Field(default=None, description="The ID of the bundle if a host component bundle needs to be installed on the host members to support the functionality of the switch.  ***Since:*** vSphere API 4.0 ", alias="bundleId")
    bundle_url: Optional[StrictStr] = Field(default=None, description="The URL of the bundle that VMware Update Manager will use to install the bundle on the host members, if *DistributedVirtualSwitchProductSpec.bundleId* is set.  ***Since:*** vSphere API 4.0 ", alias="bundleUrl")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DistributedVirtualSwitchProductSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DistributedVirtualSwitchProductSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


