# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DVPortgroupPolicy(DataObject):
    """
    The DistributedVirtualPortgroup policies.  This field is not applicable when queried directly against an ESX host.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    block_override_allowed: StrictBool = Field(description="Allow the *DVPortSetting.blocked* setting of an individual port to override the setting in *DVPortgroupConfigInfo.defaultPortConfig* of a portgroup.  ***Since:*** vSphere API 4.0 ", alias="blockOverrideAllowed")
    shaping_override_allowed: StrictBool = Field(description="Allow the *DVPortSetting.inShapingPolicy* or *DVPortSetting.outShapingPolicy* settings of an individual port to override the setting in *DVPortgroupConfigInfo.defaultPortConfig* of a portgroup.  ***Since:*** vSphere API 4.0 ", alias="shapingOverrideAllowed")
    vendor_config_override_allowed: StrictBool = Field(description="Allow the *DVPortSetting.vendorSpecificConfig* setting of an individual port to override the setting in *DVPortgroupConfigInfo.defaultPortConfig* of a portgroup.  ***Since:*** vSphere API 4.0 ", alias="vendorConfigOverrideAllowed")
    live_port_moving_allowed: StrictBool = Field(description="Allow a live port to be moved in and out of the portgroup.  ***Since:*** vSphere API 4.0 ", alias="livePortMovingAllowed")
    port_config_reset_at_disconnect: StrictBool = Field(description="If true, reset the port network setting back to the portgroup setting (thus removing the per-port setting) when the port is disconnected from the connectee.  ***Since:*** vSphere API 4.0 ", alias="portConfigResetAtDisconnect")
    network_resource_pool_override_allowed: Optional[StrictBool] = Field(default=None, description="Allow the setting of *DVPortSetting.networkResourcePoolKey* of an individual port to override the setting in *DVPortgroupConfigInfo.defaultPortConfig* of a portgroup.  ***Since:*** vSphere API 5.0 ", alias="networkResourcePoolOverrideAllowed")
    traffic_filter_override_allowed: Optional[StrictBool] = Field(default=None, description="Allow the setting of *DVPortSetting.filterPolicy*, for an individual port to override the setting in *DVPortgroupConfigInfo.defaultPortConfig* of a portgroup.  ***Since:*** vSphere API 5.5 ", alias="trafficFilterOverrideAllowed")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','VMwareDVSPortgroupPolicy': 'VMwareDVSPortgroupPolicy'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self]:
        """Create an instance of DVPortgroupPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self]:
        """Create an instance of DVPortgroupPolicy from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("DVPortgroupPolicy failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.v_mware_dvs_portgroup_policy import VMwareDVSPortgroupPolicy
# TODO: Rewrite to not use raise_errors
DVPortgroupPolicy.model_rebuild(raise_errors=False)

