# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union

from vmware_vi.models.event import Event
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DvsEvent(Event):
    """
    These are dvs-related events.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','DvsCreatedEvent': 'DvsCreatedEvent','DvsDestroyedEvent': 'DvsDestroyedEvent','DvsHostBackInSyncEvent': 'DvsHostBackInSyncEvent','DvsHostJoinedEvent': 'DvsHostJoinedEvent','DvsHostLeftEvent': 'DvsHostLeftEvent','DvsHostStatusUpdated': 'DvsHostStatusUpdated','DvsHostWentOutOfSyncEvent': 'DvsHostWentOutOfSyncEvent','DvsImportEvent': 'DvsImportEvent','DvsMergedEvent': 'DvsMergedEvent','DvsPortBlockedEvent': 'DvsPortBlockedEvent','DvsPortConnectedEvent': 'DvsPortConnectedEvent','DvsPortCreatedEvent': 'DvsPortCreatedEvent','DvsPortDeletedEvent': 'DvsPortDeletedEvent','DvsPortDisconnectedEvent': 'DvsPortDisconnectedEvent','DvsPortEnteredPassthruEvent': 'DvsPortEnteredPassthruEvent','DvsPortExitedPassthruEvent': 'DvsPortExitedPassthruEvent','DvsPortJoinPortgroupEvent': 'DvsPortJoinPortgroupEvent','DvsPortLeavePortgroupEvent': 'DvsPortLeavePortgroupEvent','DvsPortLinkDownEvent': 'DvsPortLinkDownEvent','DvsPortLinkUpEvent': 'DvsPortLinkUpEvent','DvsPortReconfiguredEvent': 'DvsPortReconfiguredEvent','DvsPortRuntimeChangeEvent': 'DvsPortRuntimeChangeEvent','DvsPortUnblockedEvent': 'DvsPortUnblockedEvent','DvsPortVendorSpecificStateChangeEvent': 'DvsPortVendorSpecificStateChangeEvent','DvsReconfiguredEvent': 'DvsReconfiguredEvent','DvsRenamedEvent': 'DvsRenamedEvent','DvsRestoreEvent': 'DvsRestoreEvent','DvsUpgradeAvailableEvent': 'DvsUpgradeAvailableEvent','DvsUpgradeInProgressEvent': 'DvsUpgradeInProgressEvent','DvsUpgradeRejectedEvent': 'DvsUpgradeRejectedEvent','DvsUpgradedEvent': 'DvsUpgradedEvent','HostLocalPortCreatedEvent': 'HostLocalPortCreatedEvent','OutOfSyncDvsHost': 'OutOfSyncDvsHost','RecoveryEvent': 'RecoveryEvent','RollbackEvent': 'RollbackEvent','VmVnicPoolReservationViolationClearEvent': 'VmVnicPoolReservationViolationClearEvent','VmVnicPoolReservationViolationRaiseEvent': 'VmVnicPoolReservationViolationRaiseEvent'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of DvsEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of DvsEvent from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("DvsEvent failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.dvs_created_event import DvsCreatedEvent
from vmware_vi.models.dvs_destroyed_event import DvsDestroyedEvent
from vmware_vi.models.dvs_host_back_in_sync_event import DvsHostBackInSyncEvent
from vmware_vi.models.dvs_host_joined_event import DvsHostJoinedEvent
from vmware_vi.models.dvs_host_left_event import DvsHostLeftEvent
from vmware_vi.models.dvs_host_status_updated import DvsHostStatusUpdated
from vmware_vi.models.dvs_host_went_out_of_sync_event import DvsHostWentOutOfSyncEvent
from vmware_vi.models.dvs_import_event import DvsImportEvent
from vmware_vi.models.dvs_merged_event import DvsMergedEvent
from vmware_vi.models.dvs_port_blocked_event import DvsPortBlockedEvent
from vmware_vi.models.dvs_port_connected_event import DvsPortConnectedEvent
from vmware_vi.models.dvs_port_created_event import DvsPortCreatedEvent
from vmware_vi.models.dvs_port_deleted_event import DvsPortDeletedEvent
from vmware_vi.models.dvs_port_disconnected_event import DvsPortDisconnectedEvent
from vmware_vi.models.dvs_port_entered_passthru_event import DvsPortEnteredPassthruEvent
from vmware_vi.models.dvs_port_exited_passthru_event import DvsPortExitedPassthruEvent
from vmware_vi.models.dvs_port_join_portgroup_event import DvsPortJoinPortgroupEvent
from vmware_vi.models.dvs_port_leave_portgroup_event import DvsPortLeavePortgroupEvent
from vmware_vi.models.dvs_port_link_down_event import DvsPortLinkDownEvent
from vmware_vi.models.dvs_port_link_up_event import DvsPortLinkUpEvent
from vmware_vi.models.dvs_port_reconfigured_event import DvsPortReconfiguredEvent
from vmware_vi.models.dvs_port_runtime_change_event import DvsPortRuntimeChangeEvent
from vmware_vi.models.dvs_port_unblocked_event import DvsPortUnblockedEvent
from vmware_vi.models.dvs_port_vendor_specific_state_change_event import DvsPortVendorSpecificStateChangeEvent
from vmware_vi.models.dvs_reconfigured_event import DvsReconfiguredEvent
from vmware_vi.models.dvs_renamed_event import DvsRenamedEvent
from vmware_vi.models.dvs_restore_event import DvsRestoreEvent
from vmware_vi.models.dvs_upgrade_available_event import DvsUpgradeAvailableEvent
from vmware_vi.models.dvs_upgrade_in_progress_event import DvsUpgradeInProgressEvent
from vmware_vi.models.dvs_upgrade_rejected_event import DvsUpgradeRejectedEvent
from vmware_vi.models.dvs_upgraded_event import DvsUpgradedEvent
from vmware_vi.models.host_local_port_created_event import HostLocalPortCreatedEvent
from vmware_vi.models.out_of_sync_dvs_host import OutOfSyncDvsHost
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.recovery_event import RecoveryEvent
from vmware_vi.models.rollback_event import RollbackEvent
from vmware_vi.models.vm_vnic_pool_reservation_violation_clear_event import VmVnicPoolReservationViolationClearEvent
from vmware_vi.models.vm_vnic_pool_reservation_violation_raise_event import VmVnicPoolReservationViolationRaiseEvent
# TODO: Rewrite to not use raise_errors
DvsEvent.model_rebuild(raise_errors=False)

