# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union

from vmware_vi.models.vim_fault import VimFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DvsFault(VimFault):
    """
    Base class for faults that can be thrown while invoking a distributed virtual switch operation.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','BackupBlobReadFailure': 'BackupBlobReadFailure','BackupBlobWriteFailure': 'BackupBlobWriteFailure','CollectorAddressUnset': 'CollectorAddressUnset','ConflictingConfiguration': 'ConflictingConfiguration','DvsApplyOperationFault': 'DvsApplyOperationFault','DvsNotAuthorized': 'DvsNotAuthorized','DvsOperationBulkFault': 'DvsOperationBulkFault','DvsScopeViolated': 'DvsScopeViolated','ImportHostAddFailure': 'ImportHostAddFailure','ImportOperationBulkFault': 'ImportOperationBulkFault','InvalidIpfixConfig': 'InvalidIpfixConfig','RollbackFailure': 'RollbackFailure','SwitchIpUnset': 'SwitchIpUnset','SwitchNotInUpgradeMode': 'SwitchNotInUpgradeMode','VspanDestPortConflict': 'VspanDestPortConflict','VspanPortConflict': 'VspanPortConflict','VspanPortMoveFault': 'VspanPortMoveFault','VspanPortPromiscChangeFault': 'VspanPortPromiscChangeFault','VspanPortgroupPromiscChangeFault': 'VspanPortgroupPromiscChangeFault','VspanPortgroupTypeChangeFault': 'VspanPortgroupTypeChangeFault','VspanPromiscuousPortNotSupported': 'VspanPromiscuousPortNotSupported','VspanSameSessionPortConflict': 'VspanSameSessionPortConflict'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of DvsFault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of DvsFault from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("DvsFault failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.backup_blob_read_failure import BackupBlobReadFailure
from vmware_vi.models.backup_blob_write_failure import BackupBlobWriteFailure
from vmware_vi.models.collector_address_unset import CollectorAddressUnset
from vmware_vi.models.conflicting_configuration import ConflictingConfiguration
from vmware_vi.models.dvs_apply_operation_fault import DvsApplyOperationFault
from vmware_vi.models.dvs_not_authorized import DvsNotAuthorized
from vmware_vi.models.dvs_operation_bulk_fault import DvsOperationBulkFault
from vmware_vi.models.dvs_scope_violated import DvsScopeViolated
from vmware_vi.models.import_host_add_failure import ImportHostAddFailure
from vmware_vi.models.import_operation_bulk_fault import ImportOperationBulkFault
from vmware_vi.models.invalid_ipfix_config import InvalidIpfixConfig
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.rollback_failure import RollbackFailure
from vmware_vi.models.switch_ip_unset import SwitchIpUnset
from vmware_vi.models.switch_not_in_upgrade_mode import SwitchNotInUpgradeMode
from vmware_vi.models.vspan_dest_port_conflict import VspanDestPortConflict
from vmware_vi.models.vspan_port_conflict import VspanPortConflict
from vmware_vi.models.vspan_port_move_fault import VspanPortMoveFault
from vmware_vi.models.vspan_port_promisc_change_fault import VspanPortPromiscChangeFault
from vmware_vi.models.vspan_portgroup_promisc_change_fault import VspanPortgroupPromiscChangeFault
from vmware_vi.models.vspan_portgroup_type_change_fault import VspanPortgroupTypeChangeFault
from vmware_vi.models.vspan_promiscuous_port_not_supported import VspanPromiscuousPortNotSupported
from vmware_vi.models.vspan_same_session_port_conflict import VspanSameSessionPortConflict
# TODO: Rewrite to not use raise_errors
DvsFault.model_rebuild(raise_errors=False)

