# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.dvs_backup_restore_capability import DVSBackupRestoreCapability
from vmware_vi.models.dvs_health_check_capability import DVSHealthCheckCapability
from vmware_vi.models.dvs_network_resource_management_capability import DVSNetworkResourceManagementCapability
from vmware_vi.models.dvs_rollback_capability import DVSRollbackCapability
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DVSFeatureCapability(DataObject):
    """
    The *DVSFeatureCapability* data object represents the capabilities supported by a *DistributedVirtualSwitch*.  These properties are read-only with the exception of *DVSFeatureCapability.vmDirectPathGen2Supported*.  ***Since:*** vSphere API 4.1 
    """ # noqa: E501
    network_resource_management_supported: StrictBool = Field(description="Deprecated as of vSphere API 5.0, use <code>networkResourceManagementCapability</code>.*DVSNetworkResourceManagementCapability.networkResourceManagementSupported*.  Indicates whether network I/O control is supported on the vSphere Distributed Switch.  ***Since:*** vSphere API 4.1 ", alias="networkResourceManagementSupported")
    vm_direct_path_gen2_supported: Optional[StrictBool] = Field(default=None, description="Deprecated as of vSphere API 8.0. VMDirectPath Gen 2 is no longer supported and there is no replacement.  Indicates whether VMDirectPath Gen 2 is supported on the distributed virtual switch.  See *HostCapability*.*HostCapability.vmDirectPathGen2Supported* and *PhysicalNic*.*PhysicalNic.vmDirectPathGen2Supported*.  For a third-party distributed switch implementation, you can specify this property during switch creation or when you call the *DistributedVirtualSwitch.UpdateDvsCapability* method.  VMDirectPath Gen 2 is supported in vSphere Distributed Switch Version 4.1 or later.  ***Since:*** vSphere API 4.1 ", alias="vmDirectPathGen2Supported")
    nic_teaming_policy: Optional[List[StrictStr]] = Field(default=None, description="The available teaming modes for the vSphere Distributed Switch.  The value can be one or more of *DistributedVirtualSwitchNicTeamingPolicyMode_enum*.  ***Since:*** vSphere API 4.1 ", alias="nicTeamingPolicy")
    network_resource_pool_high_share_value: Optional[StrictInt] = Field(default=None, description="Deprecated as of vSphere API 5.0, use <code>networkResourceManagementCapability</code>.*DVSNetworkResourceManagementCapability.networkResourcePoolHighShareValue*.  This is the value for *high* in *DVSNetworkResourcePoolAllocationInfo.shares*.  This implicitly defines the legal range of share values to be between 1 and this. This also defines values for other level types, such as *normal* being one half of this value and *low* being one fourth of this value.  ***Since:*** vSphere API 4.1 ", alias="networkResourcePoolHighShareValue")
    network_resource_management_capability: Optional[DVSNetworkResourceManagementCapability] = Field(default=None, alias="networkResourceManagementCapability")
    health_check_capability: Optional[DVSHealthCheckCapability] = Field(default=None, alias="healthCheckCapability")
    rollback_capability: Optional[DVSRollbackCapability] = Field(default=None, alias="rollbackCapability")
    backup_restore_capability: Optional[DVSBackupRestoreCapability] = Field(default=None, alias="backupRestoreCapability")
    network_filter_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether Network Filter feature is supported in vSphere Distributed Switch.  ***Since:*** vSphere API 5.5 ", alias="networkFilterSupported")
    mac_learning_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether MAC learning feature is supported in vSphere Distributed Switch.  ***Since:*** vSphere API 6.7 ", alias="macLearningSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','VMwareDVSFeatureCapability': 'VMwareDVSFeatureCapability'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self]:
        """Create an instance of DVSFeatureCapability from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self]:
        """Create an instance of DVSFeatureCapability from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("DVSFeatureCapability failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.v_mware_dvs_feature_capability import VMwareDVSFeatureCapability
# TODO: Rewrite to not use raise_errors
DVSFeatureCapability.model_rebuild(raise_errors=False)

