# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.inheritable_policy import InheritablePolicy
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DVSMacLearningPolicy(InheritablePolicy):
    """
    This data object type describes MAC learning policy of a port.  ***Since:*** vSphere API 6.7 
    """ # noqa: E501
    enabled: StrictBool = Field(description="The flag to indicate if source MAC address learning is allowed.  ***Since:*** vSphere API 6.7 ")
    allow_unicast_flooding: Optional[StrictBool] = Field(default=None, description="The flag to allow flooding of unlearned MAC for ingress traffic.  ***Since:*** vSphere API 6.7 ", alias="allowUnicastFlooding")
    limit: Optional[StrictInt] = Field(default=None, description="The maximum number of MAC addresses that can be learned.  ***Since:*** vSphere API 6.7 ")
    limit_policy: Optional[StrictStr] = Field(default=None, description="The default switching policy after MAC limit is exceeded.  See *DVSMacLimitPolicyType_enum* for valid values.  ***Since:*** vSphere API 6.7 ", alias="limitPolicy")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DVSMacLearningPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DVSMacLearningPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


