# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictStr
from pydantic import Field
from vmware_vi.models.entity_backup_config import EntityBackupConfig
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DVSManagerImportEntityRequestType(BaseModel):
    """
    The parameters of *DistributedVirtualSwitchManager.DVSManagerImportEntity_Task*. 
    """ # noqa: E501
    entity_backup: List[EntityBackupConfig] = Field(description="Configuration of one or more entities to be imported. The entity backup configuration is returned by the *DistributedVirtualSwitchManager.DVSManagerExportEntity_Task* method.  ***Since:*** vSphere API 5.1 ", alias="entityBackup")
    import_type: StrictStr = Field(description="Specifies whether to create a new configuration or restore a previous configuration. See *EntityImportType_enum* for valid values. ", alias="importType")
    __properties: ClassVar[List[str]] = ["entityBackup", "importType"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DVSManagerImportEntityRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in entity_backup (list)
        _items = []
        if self.entity_backup:
            for _item in self.entity_backup:
                if _item:
                    _items.append(_item.to_dict())
            _dict['entityBackup'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DVSManagerImportEntityRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "entityBackup": [EntityBackupConfig.from_dict(_item) for _item in obj.get("entityBackup")] if obj.get("entityBackup") is not None else None,
            "importType": obj.get("importType")
        })
        return _obj


