# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.element_description import ElementDescription
from vmware_vi.models.host_cpu_id_info import HostCpuIdInfo
from vmware_vi.models.host_feature_capability import HostFeatureCapability
from vmware_vi.models.host_feature_mask import HostFeatureMask
from vmware_vi.models.virtual_machine_feature_requirement import VirtualMachineFeatureRequirement
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class EVCMode(ElementDescription):
    """
    The *EVCMode* data object describes an Enhanced vMotion Compatibility mode.  An EVC mode is associated with a set of CPU features. A vCenter Server defines the available EVC modes. You use them to establish a common set of features for compatibility between hosts in a cluster. An EVC-enabled cluster supports safe vMotion of virtual machines across a range of CPU generations. You must use the vSphere Client to configure EVC.  When you add a host to an EVC-enabled cluster, the vCenter Server determines the CPU compatibility to preserve vMotion compatibility within the cluster. If the host CPU is compatible with those already in the cluster, the Server adds the host to the cluster and configures it for compatible operation. Hosts that are not compatible are not allowed to join the cluster.  The inherited *ElementDescription.key* property is a string value that uniquely identifies an EVC mode. The vCenter Server assigns the key value; the vSphere API uses the key to identify modes in summary and information objects: - *ClusterComputeResourceSummary*.*ClusterComputeResourceSummary.currentEVCModeKey* - *HostListSummary*.*HostListSummary.currentEVCModeKey* - *HostListSummary*.*HostListSummary.maxEVCModeKey* - *VirtualMachineRuntimeInfo*.*VirtualMachineRuntimeInfo.minRequiredEVCModeKey*    The inherited *Description.label* and *Description.summary* properties are human-readable strings.  You can use the *EVCMode.track* and *EVCMode.vendorTier* properties to determine feature-superset relationships between modes without examining the individual feature bits in *EVCMode.guaranteedCPUFeatures*. The CPU feature baseline of mode A is a superset of mode B's baseline if and only if: - modeA.track is the same as or a superset of modeB.track - modeA.vendorTier is equal to or greater than modeB.vendorTier    Use the *EVCMode.track* and *EVCMode.vendorTier* properties only for the purpose of feature-superset calculations as described above. Do not use them to infer the presence or absence of specific features. The property values for a given mode may change across releases as the set of available EVC modes changes, to better represent mode relationships.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    guaranteed_cpu_features: Optional[List[HostCpuIdInfo]] = Field(default=None, description="Deprecated as of vSphere API 6.5 use *EVCMode.featureCapability*.  Describes the CPU feature baseline associated with the EVC mode.  On the cluster where a particular EVC mode is configured, those CPU features are guaranteed, either because the host hardware naturally matches those features or because CPU feature override is used to mask out differences and enforce a match.  ***Since:*** vSphere API 4.1 ", alias="guaranteedCPUFeatures")
    feature_capability: Optional[List[HostFeatureCapability]] = Field(default=None, description="Describes the feature capability baseline associated with the EVC mode.  On the cluster where a particular EVC mode is configured, these features capabilities are guaranteed, either because the host hardware naturally matches those features or because feature masks are used to mask out differences and enforce a match.  ***Since:*** vSphere API 5.1 ", alias="featureCapability")
    feature_mask: Optional[List[HostFeatureMask]] = Field(default=None, description="The masks (modifications to a host's feature capabilities) that limit a host's capabilities to that of the EVC mode baseline.  ***Since:*** vSphere API 5.1 ", alias="featureMask")
    feature_requirement: Optional[List[VirtualMachineFeatureRequirement]] = Field(default=None, description="The conditions that must be true of a host's feature capabilities in order for the host to meet the minimum requirements of the EVC mode baseline.  ***Since:*** vSphere API 5.1 ", alias="featureRequirement")
    vendor: StrictStr = Field(description="CPU hardware vendor required for this mode.  ***Since:*** vSphere API 4.0 ")
    track: List[StrictStr] = Field(description="Identifiers for feature groups that are at least partially present in the *EVCMode.guaranteedCPUFeatures* array for this mode.  Use this property to compare track values from two modes. Do not use this property to determine the presence or absence of specific features.  ***Since:*** vSphere API 4.1 ")
    vendor_tier: StrictInt = Field(description="Index for ordering the set of modes that apply to a given CPU vendor.  Use this property to compare vendor tier values from two modes. Do not use this property to determine the presence or absence of specific features.  ***Since:*** vSphere API 4.0 ", alias="vendorTier")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EVCMode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of EVCMode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


