# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.compute_resource_event_argument import ComputeResourceEventArgument
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.datacenter_event_argument import DatacenterEventArgument
from vmware_vi.models.datastore_event_argument import DatastoreEventArgument
from vmware_vi.models.dvs_event_argument import DvsEventArgument
from vmware_vi.models.host_event_argument import HostEventArgument
from vmware_vi.models.network_event_argument import NetworkEventArgument
from vmware_vi.models.vm_event_argument import VmEventArgument
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Event(DataObject):
    """
    This event is the base data object type from which all events inherit.  All event objects are data structures that describe events. While event data objects are data structures that describe events, event data type documentation may describe what the event records, rather than the data structure, itself. 
    """ # noqa: E501
    key: StrictInt = Field(description="The event ID. ")
    chain_id: StrictInt = Field(description="The parent or group ID. ", alias="chainId")
    created_time: datetime = Field(description="The time the event was created. ", alias="createdTime")
    user_name: StrictStr = Field(description="The user who caused the event. ", alias="userName")
    datacenter: Optional[DatacenterEventArgument] = None
    compute_resource: Optional[ComputeResourceEventArgument] = Field(default=None, alias="computeResource")
    host: Optional[HostEventArgument] = None
    vm: Optional[VmEventArgument] = None
    ds: Optional[DatastoreEventArgument] = None
    net: Optional[NetworkEventArgument] = None
    dvs: Optional[DvsEventArgument] = None
    full_formatted_message: Optional[StrictStr] = Field(default=None, description="A formatted text message describing the event.  The message may be localized. ", alias="fullFormattedMessage")
    change_tag: Optional[StrictStr] = Field(default=None, description="The user entered tag to identify the operations and their side effects  ***Since:*** vSphere API 4.0 ", alias="changeTag")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','AccountCreatedEvent': 'AccountCreatedEvent','AccountRemovedEvent': 'AccountRemovedEvent','AccountUpdatedEvent': 'AccountUpdatedEvent','AdminPasswordNotChangedEvent': 'AdminPasswordNotChangedEvent','AlarmAcknowledgedEvent': 'AlarmAcknowledgedEvent','AlarmActionTriggeredEvent': 'AlarmActionTriggeredEvent','AlarmClearedEvent': 'AlarmClearedEvent','AlarmCreatedEvent': 'AlarmCreatedEvent','AlarmEmailCompletedEvent': 'AlarmEmailCompletedEvent','AlarmEmailFailedEvent': 'AlarmEmailFailedEvent','AlarmEvent': 'AlarmEvent','AlarmReconfiguredEvent': 'AlarmReconfiguredEvent','AlarmRemovedEvent': 'AlarmRemovedEvent','AlarmScriptCompleteEvent': 'AlarmScriptCompleteEvent','AlarmScriptFailedEvent': 'AlarmScriptFailedEvent','AlarmSnmpCompletedEvent': 'AlarmSnmpCompletedEvent','AlarmSnmpFailedEvent': 'AlarmSnmpFailedEvent','AlarmStatusChangedEvent': 'AlarmStatusChangedEvent','AllVirtualMachinesLicensedEvent': 'AllVirtualMachinesLicensedEvent','AlreadyAuthenticatedSessionEvent': 'AlreadyAuthenticatedSessionEvent','AuthorizationEvent': 'AuthorizationEvent','BadUsernameSessionEvent': 'BadUsernameSessionEvent','CanceledHostOperationEvent': 'CanceledHostOperationEvent','ClusterComplianceCheckedEvent': 'ClusterComplianceCheckedEvent','ClusterCreatedEvent': 'ClusterCreatedEvent','ClusterDestroyedEvent': 'ClusterDestroyedEvent','ClusterEvent': 'ClusterEvent','ClusterOvercommittedEvent': 'ClusterOvercommittedEvent','ClusterReconfiguredEvent': 'ClusterReconfiguredEvent','ClusterStatusChangedEvent': 'ClusterStatusChangedEvent','CustomFieldDefAddedEvent': 'CustomFieldDefAddedEvent','CustomFieldDefEvent': 'CustomFieldDefEvent','CustomFieldDefRemovedEvent': 'CustomFieldDefRemovedEvent','CustomFieldDefRenamedEvent': 'CustomFieldDefRenamedEvent','CustomFieldEvent': 'CustomFieldEvent','CustomFieldValueChangedEvent': 'CustomFieldValueChangedEvent','CustomizationEvent': 'CustomizationEvent','CustomizationFailed': 'CustomizationFailed','CustomizationLinuxIdentityFailed': 'CustomizationLinuxIdentityFailed','CustomizationNetworkSetupFailed': 'CustomizationNetworkSetupFailed','CustomizationStartedEvent': 'CustomizationStartedEvent','CustomizationSucceeded': 'CustomizationSucceeded','CustomizationSysprepFailed': 'CustomizationSysprepFailed','CustomizationUnknownFailure': 'CustomizationUnknownFailure','DVPortgroupCreatedEvent': 'DVPortgroupCreatedEvent','DVPortgroupDestroyedEvent': 'DVPortgroupDestroyedEvent','DVPortgroupEvent': 'DVPortgroupEvent','DVPortgroupReconfiguredEvent': 'DVPortgroupReconfiguredEvent','DVPortgroupRenamedEvent': 'DVPortgroupRenamedEvent','DasAdmissionControlDisabledEvent': 'DasAdmissionControlDisabledEvent','DasAdmissionControlEnabledEvent': 'DasAdmissionControlEnabledEvent','DasAgentFoundEvent': 'DasAgentFoundEvent','DasAgentUnavailableEvent': 'DasAgentUnavailableEvent','DasClusterIsolatedEvent': 'DasClusterIsolatedEvent','DasDisabledEvent': 'DasDisabledEvent','DasEnabledEvent': 'DasEnabledEvent','DasHostFailedEvent': 'DasHostFailedEvent','DasHostIsolatedEvent': 'DasHostIsolatedEvent','DatacenterCreatedEvent': 'DatacenterCreatedEvent','DatacenterEvent': 'DatacenterEvent','DatacenterRenamedEvent': 'DatacenterRenamedEvent','DatastoreCapacityIncreasedEvent': 'DatastoreCapacityIncreasedEvent','DatastoreDestroyedEvent': 'DatastoreDestroyedEvent','DatastoreDiscoveredEvent': 'DatastoreDiscoveredEvent','DatastoreDuplicatedEvent': 'DatastoreDuplicatedEvent','DatastoreEvent': 'DatastoreEvent','DatastoreFileCopiedEvent': 'DatastoreFileCopiedEvent','DatastoreFileDeletedEvent': 'DatastoreFileDeletedEvent','DatastoreFileEvent': 'DatastoreFileEvent','DatastoreFileMovedEvent': 'DatastoreFileMovedEvent','DatastoreIORMReconfiguredEvent': 'DatastoreIORMReconfiguredEvent','DatastorePrincipalConfigured': 'DatastorePrincipalConfigured','DatastoreRemovedOnHostEvent': 'DatastoreRemovedOnHostEvent','DatastoreRenamedEvent': 'DatastoreRenamedEvent','DatastoreRenamedOnHostEvent': 'DatastoreRenamedOnHostEvent','DrsDisabledEvent': 'DrsDisabledEvent','DrsEnabledEvent': 'DrsEnabledEvent','DrsEnteredStandbyModeEvent': 'DrsEnteredStandbyModeEvent','DrsEnteringStandbyModeEvent': 'DrsEnteringStandbyModeEvent','DrsExitStandbyModeFailedEvent': 'DrsExitStandbyModeFailedEvent','DrsExitedStandbyModeEvent': 'DrsExitedStandbyModeEvent','DrsExitingStandbyModeEvent': 'DrsExitingStandbyModeEvent','DrsInvocationFailedEvent': 'DrsInvocationFailedEvent','DrsRecoveredFromFailureEvent': 'DrsRecoveredFromFailureEvent','DrsResourceConfigureFailedEvent': 'DrsResourceConfigureFailedEvent','DrsResourceConfigureSyncedEvent': 'DrsResourceConfigureSyncedEvent','DrsRuleComplianceEvent': 'DrsRuleComplianceEvent','DrsRuleViolationEvent': 'DrsRuleViolationEvent','DrsSoftRuleViolationEvent': 'DrsSoftRuleViolationEvent','DrsVmMigratedEvent': 'DrsVmMigratedEvent','DrsVmPoweredOnEvent': 'DrsVmPoweredOnEvent','DuplicateIpDetectedEvent': 'DuplicateIpDetectedEvent','DvpgImportEvent': 'DvpgImportEvent','DvpgRestoreEvent': 'DvpgRestoreEvent','DvsCreatedEvent': 'DvsCreatedEvent','DvsDestroyedEvent': 'DvsDestroyedEvent','DvsEvent': 'DvsEvent','DvsHealthStatusChangeEvent': 'DvsHealthStatusChangeEvent','DvsHostBackInSyncEvent': 'DvsHostBackInSyncEvent','DvsHostJoinedEvent': 'DvsHostJoinedEvent','DvsHostLeftEvent': 'DvsHostLeftEvent','DvsHostStatusUpdated': 'DvsHostStatusUpdated','DvsHostWentOutOfSyncEvent': 'DvsHostWentOutOfSyncEvent','DvsImportEvent': 'DvsImportEvent','DvsMergedEvent': 'DvsMergedEvent','DvsPortBlockedEvent': 'DvsPortBlockedEvent','DvsPortConnectedEvent': 'DvsPortConnectedEvent','DvsPortCreatedEvent': 'DvsPortCreatedEvent','DvsPortDeletedEvent': 'DvsPortDeletedEvent','DvsPortDisconnectedEvent': 'DvsPortDisconnectedEvent','DvsPortEnteredPassthruEvent': 'DvsPortEnteredPassthruEvent','DvsPortExitedPassthruEvent': 'DvsPortExitedPassthruEvent','DvsPortJoinPortgroupEvent': 'DvsPortJoinPortgroupEvent','DvsPortLeavePortgroupEvent': 'DvsPortLeavePortgroupEvent','DvsPortLinkDownEvent': 'DvsPortLinkDownEvent','DvsPortLinkUpEvent': 'DvsPortLinkUpEvent','DvsPortReconfiguredEvent': 'DvsPortReconfiguredEvent','DvsPortRuntimeChangeEvent': 'DvsPortRuntimeChangeEvent','DvsPortUnblockedEvent': 'DvsPortUnblockedEvent','DvsPortVendorSpecificStateChangeEvent': 'DvsPortVendorSpecificStateChangeEvent','DvsReconfiguredEvent': 'DvsReconfiguredEvent','DvsRenamedEvent': 'DvsRenamedEvent','DvsRestoreEvent': 'DvsRestoreEvent','DvsUpgradeAvailableEvent': 'DvsUpgradeAvailableEvent','DvsUpgradeInProgressEvent': 'DvsUpgradeInProgressEvent','DvsUpgradeRejectedEvent': 'DvsUpgradeRejectedEvent','DvsUpgradedEvent': 'DvsUpgradedEvent','EnteredMaintenanceModeEvent': 'EnteredMaintenanceModeEvent','EnteredStandbyModeEvent': 'EnteredStandbyModeEvent','EnteringMaintenanceModeEvent': 'EnteringMaintenanceModeEvent','EnteringStandbyModeEvent': 'EnteringStandbyModeEvent','ErrorUpgradeEvent': 'ErrorUpgradeEvent','EventEx': 'EventEx','ExitMaintenanceModeEvent': 'ExitMaintenanceModeEvent','ExitStandbyModeFailedEvent': 'ExitStandbyModeFailedEvent','ExitedStandbyModeEvent': 'ExitedStandbyModeEvent','ExitingStandbyModeEvent': 'ExitingStandbyModeEvent','ExtendedEvent': 'ExtendedEvent','FailoverLevelRestored': 'FailoverLevelRestored','GeneralEvent': 'GeneralEvent','GeneralHostErrorEvent': 'GeneralHostErrorEvent','GeneralHostInfoEvent': 'GeneralHostInfoEvent','GeneralHostWarningEvent': 'GeneralHostWarningEvent','GeneralUserEvent': 'GeneralUserEvent','GeneralVmErrorEvent': 'GeneralVmErrorEvent','GeneralVmInfoEvent': 'GeneralVmInfoEvent','GeneralVmWarningEvent': 'GeneralVmWarningEvent','GhostDvsProxySwitchDetectedEvent': 'GhostDvsProxySwitchDetectedEvent','GhostDvsProxySwitchRemovedEvent': 'GhostDvsProxySwitchRemovedEvent','GlobalMessageChangedEvent': 'GlobalMessageChangedEvent','HealthStatusChangedEvent': 'HealthStatusChangedEvent','HostAddFailedEvent': 'HostAddFailedEvent','HostAddedEvent': 'HostAddedEvent','HostAdminDisableEvent': 'HostAdminDisableEvent','HostAdminEnableEvent': 'HostAdminEnableEvent','HostCnxFailedAccountFailedEvent': 'HostCnxFailedAccountFailedEvent','HostCnxFailedAlreadyManagedEvent': 'HostCnxFailedAlreadyManagedEvent','HostCnxFailedBadCcagentEvent': 'HostCnxFailedBadCcagentEvent','HostCnxFailedBadUsernameEvent': 'HostCnxFailedBadUsernameEvent','HostCnxFailedBadVersionEvent': 'HostCnxFailedBadVersionEvent','HostCnxFailedCcagentUpgradeEvent': 'HostCnxFailedCcagentUpgradeEvent','HostCnxFailedEvent': 'HostCnxFailedEvent','HostCnxFailedNetworkErrorEvent': 'HostCnxFailedNetworkErrorEvent','HostCnxFailedNoAccessEvent': 'HostCnxFailedNoAccessEvent','HostCnxFailedNoConnectionEvent': 'HostCnxFailedNoConnectionEvent','HostCnxFailedNoLicenseEvent': 'HostCnxFailedNoLicenseEvent','HostCnxFailedNotFoundEvent': 'HostCnxFailedNotFoundEvent','HostCnxFailedTimeoutEvent': 'HostCnxFailedTimeoutEvent','HostComplianceCheckedEvent': 'HostComplianceCheckedEvent','HostCompliantEvent': 'HostCompliantEvent','HostConfigAppliedEvent': 'HostConfigAppliedEvent','HostConnectedEvent': 'HostConnectedEvent','HostConnectionLostEvent': 'HostConnectionLostEvent','HostDasDisabledEvent': 'HostDasDisabledEvent','HostDasDisablingEvent': 'HostDasDisablingEvent','HostDasEnabledEvent': 'HostDasEnabledEvent','HostDasEnablingEvent': 'HostDasEnablingEvent','HostDasErrorEvent': 'HostDasErrorEvent','HostDasEvent': 'HostDasEvent','HostDasOkEvent': 'HostDasOkEvent','HostDisconnectedEvent': 'HostDisconnectedEvent','HostEnableAdminFailedEvent': 'HostEnableAdminFailedEvent','HostEvent': 'HostEvent','HostExtraNetworksEvent': 'HostExtraNetworksEvent','HostGetShortNameFailedEvent': 'HostGetShortNameFailedEvent','HostInAuditModeEvent': 'HostInAuditModeEvent','HostInventoryFullEvent': 'HostInventoryFullEvent','HostInventoryUnreadableEvent': 'HostInventoryUnreadableEvent','HostIpChangedEvent': 'HostIpChangedEvent','HostIpInconsistentEvent': 'HostIpInconsistentEvent','HostIpToShortNameFailedEvent': 'HostIpToShortNameFailedEvent','HostIsolationIpPingFailedEvent': 'HostIsolationIpPingFailedEvent','HostLicenseExpiredEvent': 'HostLicenseExpiredEvent','HostLocalPortCreatedEvent': 'HostLocalPortCreatedEvent','HostMissingNetworksEvent': 'HostMissingNetworksEvent','HostMonitoringStateChangedEvent': 'HostMonitoringStateChangedEvent','HostNoAvailableNetworksEvent': 'HostNoAvailableNetworksEvent','HostNoHAEnabledPortGroupsEvent': 'HostNoHAEnabledPortGroupsEvent','HostNoRedundantManagementNetworkEvent': 'HostNoRedundantManagementNetworkEvent','HostNonCompliantEvent': 'HostNonCompliantEvent','HostNotInClusterEvent': 'HostNotInClusterEvent','HostOvercommittedEvent': 'HostOvercommittedEvent','HostPrimaryAgentNotShortNameEvent': 'HostPrimaryAgentNotShortNameEvent','HostProfileAppliedEvent': 'HostProfileAppliedEvent','HostReconnectionFailedEvent': 'HostReconnectionFailedEvent','HostRemovedEvent': 'HostRemovedEvent','HostShortNameInconsistentEvent': 'HostShortNameInconsistentEvent','HostShortNameToIpFailedEvent': 'HostShortNameToIpFailedEvent','HostShutdownEvent': 'HostShutdownEvent','HostSpecificationChangedEvent': 'HostSpecificationChangedEvent','HostSpecificationRequireEvent': 'HostSpecificationRequireEvent','HostSpecificationUpdateEvent': 'HostSpecificationUpdateEvent','HostStatusChangedEvent': 'HostStatusChangedEvent','HostSubSpecificationDeleteEvent': 'HostSubSpecificationDeleteEvent','HostSubSpecificationUpdateEvent': 'HostSubSpecificationUpdateEvent','HostSyncFailedEvent': 'HostSyncFailedEvent','HostUpgradeFailedEvent': 'HostUpgradeFailedEvent','HostUserWorldSwapNotEnabledEvent': 'HostUserWorldSwapNotEnabledEvent','HostVnicConnectedToCustomizedDVPortEvent': 'HostVnicConnectedToCustomizedDVPortEvent','HostWwnChangedEvent': 'HostWwnChangedEvent','HostWwnConflictEvent': 'HostWwnConflictEvent','IScsiBootFailureEvent': 'IScsiBootFailureEvent','IncorrectHostInformationEvent': 'IncorrectHostInformationEvent','InfoUpgradeEvent': 'InfoUpgradeEvent','InsufficientFailoverResourcesEvent': 'InsufficientFailoverResourcesEvent','InvalidEditionEvent': 'InvalidEditionEvent','LicenseEvent': 'LicenseEvent','LicenseExpiredEvent': 'LicenseExpiredEvent','LicenseNonComplianceEvent': 'LicenseNonComplianceEvent','LicenseRestrictedEvent': 'LicenseRestrictedEvent','LicenseServerAvailableEvent': 'LicenseServerAvailableEvent','LicenseServerUnavailableEvent': 'LicenseServerUnavailableEvent','LocalDatastoreCreatedEvent': 'LocalDatastoreCreatedEvent','LocalTSMEnabledEvent': 'LocalTSMEnabledEvent','LockerMisconfiguredEvent': 'LockerMisconfiguredEvent','LockerReconfiguredEvent': 'LockerReconfiguredEvent','MigrationErrorEvent': 'MigrationErrorEvent','MigrationEvent': 'MigrationEvent','MigrationHostErrorEvent': 'MigrationHostErrorEvent','MigrationHostWarningEvent': 'MigrationHostWarningEvent','MigrationResourceErrorEvent': 'MigrationResourceErrorEvent','MigrationResourceWarningEvent': 'MigrationResourceWarningEvent','MigrationWarningEvent': 'MigrationWarningEvent','MtuMatchEvent': 'MtuMatchEvent','MtuMismatchEvent': 'MtuMismatchEvent','NASDatastoreCreatedEvent': 'NASDatastoreCreatedEvent','NetworkRollbackEvent': 'NetworkRollbackEvent','NoAccessUserEvent': 'NoAccessUserEvent','NoDatastoresConfiguredEvent': 'NoDatastoresConfiguredEvent','NoLicenseEvent': 'NoLicenseEvent','NoMaintenanceModeDrsRecommendationForVM': 'NoMaintenanceModeDrsRecommendationForVM','NonVIWorkloadDetectedOnDatastoreEvent': 'NonVIWorkloadDetectedOnDatastoreEvent','NotEnoughResourcesToStartVmEvent': 'NotEnoughResourcesToStartVmEvent','OutOfSyncDvsHost': 'OutOfSyncDvsHost','PermissionAddedEvent': 'PermissionAddedEvent','PermissionEvent': 'PermissionEvent','PermissionRemovedEvent': 'PermissionRemovedEvent','PermissionUpdatedEvent': 'PermissionUpdatedEvent','ProfileAssociatedEvent': 'ProfileAssociatedEvent','ProfileChangedEvent': 'ProfileChangedEvent','ProfileCreatedEvent': 'ProfileCreatedEvent','ProfileDissociatedEvent': 'ProfileDissociatedEvent','ProfileEvent': 'ProfileEvent','ProfileReferenceHostChangedEvent': 'ProfileReferenceHostChangedEvent','ProfileRemovedEvent': 'ProfileRemovedEvent','RecoveryEvent': 'RecoveryEvent','RemoteTSMEnabledEvent': 'RemoteTSMEnabledEvent','ResourcePoolCreatedEvent': 'ResourcePoolCreatedEvent','ResourcePoolDestroyedEvent': 'ResourcePoolDestroyedEvent','ResourcePoolEvent': 'ResourcePoolEvent','ResourcePoolMovedEvent': 'ResourcePoolMovedEvent','ResourcePoolReconfiguredEvent': 'ResourcePoolReconfiguredEvent','ResourceViolatedEvent': 'ResourceViolatedEvent','RoleAddedEvent': 'RoleAddedEvent','RoleEvent': 'RoleEvent','RoleRemovedEvent': 'RoleRemovedEvent','RoleUpdatedEvent': 'RoleUpdatedEvent','RollbackEvent': 'RollbackEvent','ScheduledTaskCompletedEvent': 'ScheduledTaskCompletedEvent','ScheduledTaskCreatedEvent': 'ScheduledTaskCreatedEvent','ScheduledTaskEmailCompletedEvent': 'ScheduledTaskEmailCompletedEvent','ScheduledTaskEmailFailedEvent': 'ScheduledTaskEmailFailedEvent','ScheduledTaskEvent': 'ScheduledTaskEvent','ScheduledTaskFailedEvent': 'ScheduledTaskFailedEvent','ScheduledTaskReconfiguredEvent': 'ScheduledTaskReconfiguredEvent','ScheduledTaskRemovedEvent': 'ScheduledTaskRemovedEvent','ScheduledTaskStartedEvent': 'ScheduledTaskStartedEvent','ServerLicenseExpiredEvent': 'ServerLicenseExpiredEvent','ServerStartedSessionEvent': 'ServerStartedSessionEvent','SessionEvent': 'SessionEvent','SessionTerminatedEvent': 'SessionTerminatedEvent','TaskEvent': 'TaskEvent','TaskTimeoutEvent': 'TaskTimeoutEvent','TeamingMatchEvent': 'TeamingMatchEvent','TeamingMisMatchEvent': 'TeamingMisMatchEvent','TemplateBeingUpgradedEvent': 'TemplateBeingUpgradedEvent','TemplateUpgradeEvent': 'TemplateUpgradeEvent','TemplateUpgradeFailedEvent': 'TemplateUpgradeFailedEvent','TemplateUpgradedEvent': 'TemplateUpgradedEvent','TimedOutHostOperationEvent': 'TimedOutHostOperationEvent','UnlicensedVirtualMachinesEvent': 'UnlicensedVirtualMachinesEvent','UnlicensedVirtualMachinesFoundEvent': 'UnlicensedVirtualMachinesFoundEvent','UpdatedAgentBeingRestartedEvent': 'UpdatedAgentBeingRestartedEvent','UpgradeEvent': 'UpgradeEvent','UplinkPortMtuNotSupportEvent': 'UplinkPortMtuNotSupportEvent','UplinkPortMtuSupportEvent': 'UplinkPortMtuSupportEvent','UplinkPortVlanTrunkedEvent': 'UplinkPortVlanTrunkedEvent','UplinkPortVlanUntrunkedEvent': 'UplinkPortVlanUntrunkedEvent','UserAssignedToGroup': 'UserAssignedToGroup','UserLoginSessionEvent': 'UserLoginSessionEvent','UserLogoutSessionEvent': 'UserLogoutSessionEvent','UserPasswordChanged': 'UserPasswordChanged','UserUnassignedFromGroup': 'UserUnassignedFromGroup','UserUpgradeEvent': 'UserUpgradeEvent','VMFSDatastoreCreatedEvent': 'VMFSDatastoreCreatedEvent','VMFSDatastoreExpandedEvent': 'VMFSDatastoreExpandedEvent','VMFSDatastoreExtendedEvent': 'VMFSDatastoreExtendedEvent','VMotionLicenseExpiredEvent': 'VMotionLicenseExpiredEvent','VcAgentUninstallFailedEvent': 'VcAgentUninstallFailedEvent','VcAgentUninstalledEvent': 'VcAgentUninstalledEvent','VcAgentUpgradeFailedEvent': 'VcAgentUpgradeFailedEvent','VcAgentUpgradedEvent': 'VcAgentUpgradedEvent','VimAccountPasswordChangedEvent': 'VimAccountPasswordChangedEvent','VmAcquiredMksTicketEvent': 'VmAcquiredMksTicketEvent','VmAcquiredTicketEvent': 'VmAcquiredTicketEvent','VmAutoRenameEvent': 'VmAutoRenameEvent','VmBeingClonedEvent': 'VmBeingClonedEvent','VmBeingClonedNoFolderEvent': 'VmBeingClonedNoFolderEvent','VmBeingCreatedEvent': 'VmBeingCreatedEvent','VmBeingDeployedEvent': 'VmBeingDeployedEvent','VmBeingHotMigratedEvent': 'VmBeingHotMigratedEvent','VmBeingMigratedEvent': 'VmBeingMigratedEvent','VmBeingRelocatedEvent': 'VmBeingRelocatedEvent','VmCloneEvent': 'VmCloneEvent','VmCloneFailedEvent': 'VmCloneFailedEvent','VmClonedEvent': 'VmClonedEvent','VmConfigMissingEvent': 'VmConfigMissingEvent','VmConnectedEvent': 'VmConnectedEvent','VmCreatedEvent': 'VmCreatedEvent','VmDasBeingResetEvent': 'VmDasBeingResetEvent','VmDasBeingResetWithScreenshotEvent': 'VmDasBeingResetWithScreenshotEvent','VmDasResetFailedEvent': 'VmDasResetFailedEvent','VmDasUpdateErrorEvent': 'VmDasUpdateErrorEvent','VmDasUpdateOkEvent': 'VmDasUpdateOkEvent','VmDateRolledBackEvent': 'VmDateRolledBackEvent','VmDeployFailedEvent': 'VmDeployFailedEvent','VmDeployedEvent': 'VmDeployedEvent','VmDisconnectedEvent': 'VmDisconnectedEvent','VmDiscoveredEvent': 'VmDiscoveredEvent','VmDiskFailedEvent': 'VmDiskFailedEvent','VmEmigratingEvent': 'VmEmigratingEvent','VmEndRecordingEvent': 'VmEndRecordingEvent','VmEndReplayingEvent': 'VmEndReplayingEvent','VmEvent': 'VmEvent','VmFailedMigrateEvent': 'VmFailedMigrateEvent','VmFailedRelayoutEvent': 'VmFailedRelayoutEvent','VmFailedRelayoutOnVmfs2DatastoreEvent': 'VmFailedRelayoutOnVmfs2DatastoreEvent','VmFailedStartingSecondaryEvent': 'VmFailedStartingSecondaryEvent','VmFailedToPowerOffEvent': 'VmFailedToPowerOffEvent','VmFailedToPowerOnEvent': 'VmFailedToPowerOnEvent','VmFailedToRebootGuestEvent': 'VmFailedToRebootGuestEvent','VmFailedToResetEvent': 'VmFailedToResetEvent','VmFailedToShutdownGuestEvent': 'VmFailedToShutdownGuestEvent','VmFailedToStandbyGuestEvent': 'VmFailedToStandbyGuestEvent','VmFailedToSuspendEvent': 'VmFailedToSuspendEvent','VmFailedUpdatingSecondaryConfig': 'VmFailedUpdatingSecondaryConfig','VmFailoverFailed': 'VmFailoverFailed','VmFaultToleranceStateChangedEvent': 'VmFaultToleranceStateChangedEvent','VmFaultToleranceTurnedOffEvent': 'VmFaultToleranceTurnedOffEvent','VmFaultToleranceVmTerminatedEvent': 'VmFaultToleranceVmTerminatedEvent','VmGuestOSCrashedEvent': 'VmGuestOSCrashedEvent','VmGuestRebootEvent': 'VmGuestRebootEvent','VmGuestShutdownEvent': 'VmGuestShutdownEvent','VmGuestStandbyEvent': 'VmGuestStandbyEvent','VmHealthMonitoringStateChangedEvent': 'VmHealthMonitoringStateChangedEvent','VmInstanceUuidAssignedEvent': 'VmInstanceUuidAssignedEvent','VmInstanceUuidChangedEvent': 'VmInstanceUuidChangedEvent','VmInstanceUuidConflictEvent': 'VmInstanceUuidConflictEvent','VmMacAssignedEvent': 'VmMacAssignedEvent','VmMacChangedEvent': 'VmMacChangedEvent','VmMacConflictEvent': 'VmMacConflictEvent','VmMaxFTRestartCountReached': 'VmMaxFTRestartCountReached','VmMaxRestartCountReached': 'VmMaxRestartCountReached','VmMessageErrorEvent': 'VmMessageErrorEvent','VmMessageEvent': 'VmMessageEvent','VmMessageWarningEvent': 'VmMessageWarningEvent','VmMigratedEvent': 'VmMigratedEvent','VmNoCompatibleHostForSecondaryEvent': 'VmNoCompatibleHostForSecondaryEvent','VmNoNetworkAccessEvent': 'VmNoNetworkAccessEvent','VmOrphanedEvent': 'VmOrphanedEvent','VmPowerOffOnIsolationEvent': 'VmPowerOffOnIsolationEvent','VmPoweredOffEvent': 'VmPoweredOffEvent','VmPoweredOnEvent': 'VmPoweredOnEvent','VmPoweringOnWithCustomizedDVPortEvent': 'VmPoweringOnWithCustomizedDVPortEvent','VmPrimaryFailoverEvent': 'VmPrimaryFailoverEvent','VmReconfiguredEvent': 'VmReconfiguredEvent','VmRegisteredEvent': 'VmRegisteredEvent','VmRelayoutSuccessfulEvent': 'VmRelayoutSuccessfulEvent','VmRelayoutUpToDateEvent': 'VmRelayoutUpToDateEvent','VmReloadFromPathEvent': 'VmReloadFromPathEvent','VmReloadFromPathFailedEvent': 'VmReloadFromPathFailedEvent','VmRelocateFailedEvent': 'VmRelocateFailedEvent','VmRelocateSpecEvent': 'VmRelocateSpecEvent','VmRelocatedEvent': 'VmRelocatedEvent','VmRemoteConsoleConnectedEvent': 'VmRemoteConsoleConnectedEvent','VmRemoteConsoleDisconnectedEvent': 'VmRemoteConsoleDisconnectedEvent','VmRemovedEvent': 'VmRemovedEvent','VmRenamedEvent': 'VmRenamedEvent','VmRequirementsExceedCurrentEVCModeEvent': 'VmRequirementsExceedCurrentEVCModeEvent','VmResettingEvent': 'VmResettingEvent','VmResourcePoolMovedEvent': 'VmResourcePoolMovedEvent','VmResourceReallocatedEvent': 'VmResourceReallocatedEvent','VmRestartedOnAlternateHostEvent': 'VmRestartedOnAlternateHostEvent','VmResumingEvent': 'VmResumingEvent','VmSecondaryAddedEvent': 'VmSecondaryAddedEvent','VmSecondaryDisabledBySystemEvent': 'VmSecondaryDisabledBySystemEvent','VmSecondaryDisabledEvent': 'VmSecondaryDisabledEvent','VmSecondaryEnabledEvent': 'VmSecondaryEnabledEvent','VmSecondaryStartedEvent': 'VmSecondaryStartedEvent','VmShutdownOnIsolationEvent': 'VmShutdownOnIsolationEvent','VmStartRecordingEvent': 'VmStartRecordingEvent','VmStartReplayingEvent': 'VmStartReplayingEvent','VmStartingEvent': 'VmStartingEvent','VmStartingSecondaryEvent': 'VmStartingSecondaryEvent','VmStaticMacConflictEvent': 'VmStaticMacConflictEvent','VmStoppingEvent': 'VmStoppingEvent','VmSuspendedEvent': 'VmSuspendedEvent','VmSuspendingEvent': 'VmSuspendingEvent','VmTimedoutStartingSecondaryEvent': 'VmTimedoutStartingSecondaryEvent','VmUnsupportedStartingEvent': 'VmUnsupportedStartingEvent','VmUpgradeCompleteEvent': 'VmUpgradeCompleteEvent','VmUpgradeFailedEvent': 'VmUpgradeFailedEvent','VmUpgradingEvent': 'VmUpgradingEvent','VmUuidAssignedEvent': 'VmUuidAssignedEvent','VmUuidChangedEvent': 'VmUuidChangedEvent','VmUuidConflictEvent': 'VmUuidConflictEvent','VmVnicPoolReservationViolationClearEvent': 'VmVnicPoolReservationViolationClearEvent','VmVnicPoolReservationViolationRaiseEvent': 'VmVnicPoolReservationViolationRaiseEvent','VmWwnAssignedEvent': 'VmWwnAssignedEvent','VmWwnChangedEvent': 'VmWwnChangedEvent','VmWwnConflictEvent': 'VmWwnConflictEvent','WarningUpgradeEvent': 'WarningUpgradeEvent'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of Event from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of Event from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("Event failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.account_created_event import AccountCreatedEvent
from vmware_vi.models.account_removed_event import AccountRemovedEvent
from vmware_vi.models.account_updated_event import AccountUpdatedEvent
from vmware_vi.models.admin_password_not_changed_event import AdminPasswordNotChangedEvent
from vmware_vi.models.alarm_acknowledged_event import AlarmAcknowledgedEvent
from vmware_vi.models.alarm_action_triggered_event import AlarmActionTriggeredEvent
from vmware_vi.models.alarm_cleared_event import AlarmClearedEvent
from vmware_vi.models.alarm_created_event import AlarmCreatedEvent
from vmware_vi.models.alarm_email_completed_event import AlarmEmailCompletedEvent
from vmware_vi.models.alarm_email_failed_event import AlarmEmailFailedEvent
from vmware_vi.models.alarm_event import AlarmEvent
from vmware_vi.models.alarm_reconfigured_event import AlarmReconfiguredEvent
from vmware_vi.models.alarm_removed_event import AlarmRemovedEvent
from vmware_vi.models.alarm_script_complete_event import AlarmScriptCompleteEvent
from vmware_vi.models.alarm_script_failed_event import AlarmScriptFailedEvent
from vmware_vi.models.alarm_snmp_completed_event import AlarmSnmpCompletedEvent
from vmware_vi.models.alarm_snmp_failed_event import AlarmSnmpFailedEvent
from vmware_vi.models.alarm_status_changed_event import AlarmStatusChangedEvent
from vmware_vi.models.all_virtual_machines_licensed_event import AllVirtualMachinesLicensedEvent
from vmware_vi.models.already_authenticated_session_event import AlreadyAuthenticatedSessionEvent
from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.authorization_event import AuthorizationEvent
from vmware_vi.models.bad_username_session_event import BadUsernameSessionEvent
from vmware_vi.models.canceled_host_operation_event import CanceledHostOperationEvent
from vmware_vi.models.cluster_compliance_checked_event import ClusterComplianceCheckedEvent
from vmware_vi.models.cluster_created_event import ClusterCreatedEvent
from vmware_vi.models.cluster_destroyed_event import ClusterDestroyedEvent
from vmware_vi.models.cluster_event import ClusterEvent
from vmware_vi.models.cluster_overcommitted_event import ClusterOvercommittedEvent
from vmware_vi.models.cluster_reconfigured_event import ClusterReconfiguredEvent
from vmware_vi.models.cluster_status_changed_event import ClusterStatusChangedEvent
from vmware_vi.models.custom_field_def_added_event import CustomFieldDefAddedEvent
from vmware_vi.models.custom_field_def_event import CustomFieldDefEvent
from vmware_vi.models.custom_field_def_removed_event import CustomFieldDefRemovedEvent
from vmware_vi.models.custom_field_def_renamed_event import CustomFieldDefRenamedEvent
from vmware_vi.models.custom_field_event import CustomFieldEvent
from vmware_vi.models.custom_field_value_changed_event import CustomFieldValueChangedEvent
from vmware_vi.models.customization_event import CustomizationEvent
from vmware_vi.models.customization_failed import CustomizationFailed
from vmware_vi.models.customization_linux_identity_failed import CustomizationLinuxIdentityFailed
from vmware_vi.models.customization_network_setup_failed import CustomizationNetworkSetupFailed
from vmware_vi.models.customization_started_event import CustomizationStartedEvent
from vmware_vi.models.customization_succeeded import CustomizationSucceeded
from vmware_vi.models.customization_sysprep_failed import CustomizationSysprepFailed
from vmware_vi.models.customization_unknown_failure import CustomizationUnknownFailure
from vmware_vi.models.das_admission_control_disabled_event import DasAdmissionControlDisabledEvent
from vmware_vi.models.das_admission_control_enabled_event import DasAdmissionControlEnabledEvent
from vmware_vi.models.das_agent_found_event import DasAgentFoundEvent
from vmware_vi.models.das_agent_unavailable_event import DasAgentUnavailableEvent
from vmware_vi.models.das_cluster_isolated_event import DasClusterIsolatedEvent
from vmware_vi.models.das_disabled_event import DasDisabledEvent
from vmware_vi.models.das_enabled_event import DasEnabledEvent
from vmware_vi.models.das_host_failed_event import DasHostFailedEvent
from vmware_vi.models.das_host_isolated_event import DasHostIsolatedEvent
from vmware_vi.models.datacenter_created_event import DatacenterCreatedEvent
from vmware_vi.models.datacenter_event import DatacenterEvent
from vmware_vi.models.datacenter_renamed_event import DatacenterRenamedEvent
from vmware_vi.models.datastore_capacity_increased_event import DatastoreCapacityIncreasedEvent
from vmware_vi.models.datastore_destroyed_event import DatastoreDestroyedEvent
from vmware_vi.models.datastore_discovered_event import DatastoreDiscoveredEvent
from vmware_vi.models.datastore_duplicated_event import DatastoreDuplicatedEvent
from vmware_vi.models.datastore_event import DatastoreEvent
from vmware_vi.models.datastore_file_copied_event import DatastoreFileCopiedEvent
from vmware_vi.models.datastore_file_deleted_event import DatastoreFileDeletedEvent
from vmware_vi.models.datastore_file_event import DatastoreFileEvent
from vmware_vi.models.datastore_file_moved_event import DatastoreFileMovedEvent
from vmware_vi.models.datastore_iorm_reconfigured_event import DatastoreIORMReconfiguredEvent
from vmware_vi.models.datastore_principal_configured import DatastorePrincipalConfigured
from vmware_vi.models.datastore_removed_on_host_event import DatastoreRemovedOnHostEvent
from vmware_vi.models.datastore_renamed_event import DatastoreRenamedEvent
from vmware_vi.models.datastore_renamed_on_host_event import DatastoreRenamedOnHostEvent
from vmware_vi.models.drs_disabled_event import DrsDisabledEvent
from vmware_vi.models.drs_enabled_event import DrsEnabledEvent
from vmware_vi.models.drs_entered_standby_mode_event import DrsEnteredStandbyModeEvent
from vmware_vi.models.drs_entering_standby_mode_event import DrsEnteringStandbyModeEvent
from vmware_vi.models.drs_exit_standby_mode_failed_event import DrsExitStandbyModeFailedEvent
from vmware_vi.models.drs_exited_standby_mode_event import DrsExitedStandbyModeEvent
from vmware_vi.models.drs_exiting_standby_mode_event import DrsExitingStandbyModeEvent
from vmware_vi.models.drs_invocation_failed_event import DrsInvocationFailedEvent
from vmware_vi.models.drs_recovered_from_failure_event import DrsRecoveredFromFailureEvent
from vmware_vi.models.drs_resource_configure_failed_event import DrsResourceConfigureFailedEvent
from vmware_vi.models.drs_resource_configure_synced_event import DrsResourceConfigureSyncedEvent
from vmware_vi.models.drs_rule_compliance_event import DrsRuleComplianceEvent
from vmware_vi.models.drs_rule_violation_event import DrsRuleViolationEvent
from vmware_vi.models.drs_soft_rule_violation_event import DrsSoftRuleViolationEvent
from vmware_vi.models.drs_vm_migrated_event import DrsVmMigratedEvent
from vmware_vi.models.drs_vm_powered_on_event import DrsVmPoweredOnEvent
from vmware_vi.models.duplicate_ip_detected_event import DuplicateIpDetectedEvent
from vmware_vi.models.dv_portgroup_created_event import DVPortgroupCreatedEvent
from vmware_vi.models.dv_portgroup_destroyed_event import DVPortgroupDestroyedEvent
from vmware_vi.models.dv_portgroup_event import DVPortgroupEvent
from vmware_vi.models.dv_portgroup_reconfigured_event import DVPortgroupReconfiguredEvent
from vmware_vi.models.dv_portgroup_renamed_event import DVPortgroupRenamedEvent
from vmware_vi.models.dvpg_import_event import DvpgImportEvent
from vmware_vi.models.dvpg_restore_event import DvpgRestoreEvent
from vmware_vi.models.dvs_created_event import DvsCreatedEvent
from vmware_vi.models.dvs_destroyed_event import DvsDestroyedEvent
from vmware_vi.models.dvs_event import DvsEvent
from vmware_vi.models.dvs_health_status_change_event import DvsHealthStatusChangeEvent
from vmware_vi.models.dvs_host_back_in_sync_event import DvsHostBackInSyncEvent
from vmware_vi.models.dvs_host_joined_event import DvsHostJoinedEvent
from vmware_vi.models.dvs_host_left_event import DvsHostLeftEvent
from vmware_vi.models.dvs_host_status_updated import DvsHostStatusUpdated
from vmware_vi.models.dvs_host_went_out_of_sync_event import DvsHostWentOutOfSyncEvent
from vmware_vi.models.dvs_import_event import DvsImportEvent
from vmware_vi.models.dvs_merged_event import DvsMergedEvent
from vmware_vi.models.dvs_port_blocked_event import DvsPortBlockedEvent
from vmware_vi.models.dvs_port_connected_event import DvsPortConnectedEvent
from vmware_vi.models.dvs_port_created_event import DvsPortCreatedEvent
from vmware_vi.models.dvs_port_deleted_event import DvsPortDeletedEvent
from vmware_vi.models.dvs_port_disconnected_event import DvsPortDisconnectedEvent
from vmware_vi.models.dvs_port_entered_passthru_event import DvsPortEnteredPassthruEvent
from vmware_vi.models.dvs_port_exited_passthru_event import DvsPortExitedPassthruEvent
from vmware_vi.models.dvs_port_join_portgroup_event import DvsPortJoinPortgroupEvent
from vmware_vi.models.dvs_port_leave_portgroup_event import DvsPortLeavePortgroupEvent
from vmware_vi.models.dvs_port_link_down_event import DvsPortLinkDownEvent
from vmware_vi.models.dvs_port_link_up_event import DvsPortLinkUpEvent
from vmware_vi.models.dvs_port_reconfigured_event import DvsPortReconfiguredEvent
from vmware_vi.models.dvs_port_runtime_change_event import DvsPortRuntimeChangeEvent
from vmware_vi.models.dvs_port_unblocked_event import DvsPortUnblockedEvent
from vmware_vi.models.dvs_port_vendor_specific_state_change_event import DvsPortVendorSpecificStateChangeEvent
from vmware_vi.models.dvs_reconfigured_event import DvsReconfiguredEvent
from vmware_vi.models.dvs_renamed_event import DvsRenamedEvent
from vmware_vi.models.dvs_restore_event import DvsRestoreEvent
from vmware_vi.models.dvs_upgrade_available_event import DvsUpgradeAvailableEvent
from vmware_vi.models.dvs_upgrade_in_progress_event import DvsUpgradeInProgressEvent
from vmware_vi.models.dvs_upgrade_rejected_event import DvsUpgradeRejectedEvent
from vmware_vi.models.dvs_upgraded_event import DvsUpgradedEvent
from vmware_vi.models.entered_maintenance_mode_event import EnteredMaintenanceModeEvent
from vmware_vi.models.entered_standby_mode_event import EnteredStandbyModeEvent
from vmware_vi.models.entering_maintenance_mode_event import EnteringMaintenanceModeEvent
from vmware_vi.models.entering_standby_mode_event import EnteringStandbyModeEvent
from vmware_vi.models.error_upgrade_event import ErrorUpgradeEvent
from vmware_vi.models.event_ex import EventEx
from vmware_vi.models.exit_maintenance_mode_event import ExitMaintenanceModeEvent
from vmware_vi.models.exit_standby_mode_failed_event import ExitStandbyModeFailedEvent
from vmware_vi.models.exited_standby_mode_event import ExitedStandbyModeEvent
from vmware_vi.models.exiting_standby_mode_event import ExitingStandbyModeEvent
from vmware_vi.models.extended_event import ExtendedEvent
from vmware_vi.models.failover_level_restored import FailoverLevelRestored
from vmware_vi.models.general_event import GeneralEvent
from vmware_vi.models.general_host_error_event import GeneralHostErrorEvent
from vmware_vi.models.general_host_info_event import GeneralHostInfoEvent
from vmware_vi.models.general_host_warning_event import GeneralHostWarningEvent
from vmware_vi.models.general_user_event import GeneralUserEvent
from vmware_vi.models.general_vm_error_event import GeneralVmErrorEvent
from vmware_vi.models.general_vm_info_event import GeneralVmInfoEvent
from vmware_vi.models.general_vm_warning_event import GeneralVmWarningEvent
from vmware_vi.models.ghost_dvs_proxy_switch_detected_event import GhostDvsProxySwitchDetectedEvent
from vmware_vi.models.ghost_dvs_proxy_switch_removed_event import GhostDvsProxySwitchRemovedEvent
from vmware_vi.models.global_message_changed_event import GlobalMessageChangedEvent
from vmware_vi.models.health_status_changed_event import HealthStatusChangedEvent
from vmware_vi.models.host_add_failed_event import HostAddFailedEvent
from vmware_vi.models.host_added_event import HostAddedEvent
from vmware_vi.models.host_admin_disable_event import HostAdminDisableEvent
from vmware_vi.models.host_admin_enable_event import HostAdminEnableEvent
from vmware_vi.models.host_cnx_failed_account_failed_event import HostCnxFailedAccountFailedEvent
from vmware_vi.models.host_cnx_failed_already_managed_event import HostCnxFailedAlreadyManagedEvent
from vmware_vi.models.host_cnx_failed_bad_ccagent_event import HostCnxFailedBadCcagentEvent
from vmware_vi.models.host_cnx_failed_bad_username_event import HostCnxFailedBadUsernameEvent
from vmware_vi.models.host_cnx_failed_bad_version_event import HostCnxFailedBadVersionEvent
from vmware_vi.models.host_cnx_failed_ccagent_upgrade_event import HostCnxFailedCcagentUpgradeEvent
from vmware_vi.models.host_cnx_failed_event import HostCnxFailedEvent
from vmware_vi.models.host_cnx_failed_network_error_event import HostCnxFailedNetworkErrorEvent
from vmware_vi.models.host_cnx_failed_no_access_event import HostCnxFailedNoAccessEvent
from vmware_vi.models.host_cnx_failed_no_connection_event import HostCnxFailedNoConnectionEvent
from vmware_vi.models.host_cnx_failed_no_license_event import HostCnxFailedNoLicenseEvent
from vmware_vi.models.host_cnx_failed_not_found_event import HostCnxFailedNotFoundEvent
from vmware_vi.models.host_cnx_failed_timeout_event import HostCnxFailedTimeoutEvent
from vmware_vi.models.host_compliance_checked_event import HostComplianceCheckedEvent
from vmware_vi.models.host_compliant_event import HostCompliantEvent
from vmware_vi.models.host_config_applied_event import HostConfigAppliedEvent
from vmware_vi.models.host_connected_event import HostConnectedEvent
from vmware_vi.models.host_connection_lost_event import HostConnectionLostEvent
from vmware_vi.models.host_das_disabled_event import HostDasDisabledEvent
from vmware_vi.models.host_das_disabling_event import HostDasDisablingEvent
from vmware_vi.models.host_das_enabled_event import HostDasEnabledEvent
from vmware_vi.models.host_das_enabling_event import HostDasEnablingEvent
from vmware_vi.models.host_das_error_event import HostDasErrorEvent
from vmware_vi.models.host_das_event import HostDasEvent
from vmware_vi.models.host_das_ok_event import HostDasOkEvent
from vmware_vi.models.host_disconnected_event import HostDisconnectedEvent
from vmware_vi.models.host_enable_admin_failed_event import HostEnableAdminFailedEvent
from vmware_vi.models.host_event import HostEvent
from vmware_vi.models.host_extra_networks_event import HostExtraNetworksEvent
from vmware_vi.models.host_get_short_name_failed_event import HostGetShortNameFailedEvent
from vmware_vi.models.host_in_audit_mode_event import HostInAuditModeEvent
from vmware_vi.models.host_inventory_full_event import HostInventoryFullEvent
from vmware_vi.models.host_inventory_unreadable_event import HostInventoryUnreadableEvent
from vmware_vi.models.host_ip_changed_event import HostIpChangedEvent
from vmware_vi.models.host_ip_inconsistent_event import HostIpInconsistentEvent
from vmware_vi.models.host_ip_to_short_name_failed_event import HostIpToShortNameFailedEvent
from vmware_vi.models.host_isolation_ip_ping_failed_event import HostIsolationIpPingFailedEvent
from vmware_vi.models.host_license_expired_event import HostLicenseExpiredEvent
from vmware_vi.models.host_local_port_created_event import HostLocalPortCreatedEvent
from vmware_vi.models.host_missing_networks_event import HostMissingNetworksEvent
from vmware_vi.models.host_monitoring_state_changed_event import HostMonitoringStateChangedEvent
from vmware_vi.models.host_no_available_networks_event import HostNoAvailableNetworksEvent
from vmware_vi.models.host_no_ha_enabled_port_groups_event import HostNoHAEnabledPortGroupsEvent
from vmware_vi.models.host_no_redundant_management_network_event import HostNoRedundantManagementNetworkEvent
from vmware_vi.models.host_non_compliant_event import HostNonCompliantEvent
from vmware_vi.models.host_not_in_cluster_event import HostNotInClusterEvent
from vmware_vi.models.host_overcommitted_event import HostOvercommittedEvent
from vmware_vi.models.host_primary_agent_not_short_name_event import HostPrimaryAgentNotShortNameEvent
from vmware_vi.models.host_profile_applied_event import HostProfileAppliedEvent
from vmware_vi.models.host_reconnection_failed_event import HostReconnectionFailedEvent
from vmware_vi.models.host_removed_event import HostRemovedEvent
from vmware_vi.models.host_short_name_inconsistent_event import HostShortNameInconsistentEvent
from vmware_vi.models.host_short_name_to_ip_failed_event import HostShortNameToIpFailedEvent
from vmware_vi.models.host_shutdown_event import HostShutdownEvent
from vmware_vi.models.host_specification_changed_event import HostSpecificationChangedEvent
from vmware_vi.models.host_specification_require_event import HostSpecificationRequireEvent
from vmware_vi.models.host_specification_update_event import HostSpecificationUpdateEvent
from vmware_vi.models.host_status_changed_event import HostStatusChangedEvent
from vmware_vi.models.host_sub_specification_delete_event import HostSubSpecificationDeleteEvent
from vmware_vi.models.host_sub_specification_update_event import HostSubSpecificationUpdateEvent
from vmware_vi.models.host_sync_failed_event import HostSyncFailedEvent
from vmware_vi.models.host_upgrade_failed_event import HostUpgradeFailedEvent
from vmware_vi.models.host_user_world_swap_not_enabled_event import HostUserWorldSwapNotEnabledEvent
from vmware_vi.models.host_vnic_connected_to_customized_dv_port_event import HostVnicConnectedToCustomizedDVPortEvent
from vmware_vi.models.host_wwn_changed_event import HostWwnChangedEvent
from vmware_vi.models.host_wwn_conflict_event import HostWwnConflictEvent
from vmware_vi.models.i_scsi_boot_failure_event import IScsiBootFailureEvent
from vmware_vi.models.incorrect_host_information_event import IncorrectHostInformationEvent
from vmware_vi.models.info_upgrade_event import InfoUpgradeEvent
from vmware_vi.models.insufficient_failover_resources_event import InsufficientFailoverResourcesEvent
from vmware_vi.models.invalid_edition_event import InvalidEditionEvent
from vmware_vi.models.license_event import LicenseEvent
from vmware_vi.models.license_expired_event import LicenseExpiredEvent
from vmware_vi.models.license_non_compliance_event import LicenseNonComplianceEvent
from vmware_vi.models.license_restricted_event import LicenseRestrictedEvent
from vmware_vi.models.license_server_available_event import LicenseServerAvailableEvent
from vmware_vi.models.license_server_unavailable_event import LicenseServerUnavailableEvent
from vmware_vi.models.local_datastore_created_event import LocalDatastoreCreatedEvent
from vmware_vi.models.local_tsm_enabled_event import LocalTSMEnabledEvent
from vmware_vi.models.locker_misconfigured_event import LockerMisconfiguredEvent
from vmware_vi.models.locker_reconfigured_event import LockerReconfiguredEvent
from vmware_vi.models.migration_error_event import MigrationErrorEvent
from vmware_vi.models.migration_event import MigrationEvent
from vmware_vi.models.migration_host_error_event import MigrationHostErrorEvent
from vmware_vi.models.migration_host_warning_event import MigrationHostWarningEvent
from vmware_vi.models.migration_resource_error_event import MigrationResourceErrorEvent
from vmware_vi.models.migration_resource_warning_event import MigrationResourceWarningEvent
from vmware_vi.models.migration_warning_event import MigrationWarningEvent
from vmware_vi.models.mtu_match_event import MtuMatchEvent
from vmware_vi.models.mtu_mismatch_event import MtuMismatchEvent
from vmware_vi.models.nas_datastore_created_event import NASDatastoreCreatedEvent
from vmware_vi.models.network_rollback_event import NetworkRollbackEvent
from vmware_vi.models.no_access_user_event import NoAccessUserEvent
from vmware_vi.models.no_datastores_configured_event import NoDatastoresConfiguredEvent
from vmware_vi.models.no_license_event import NoLicenseEvent
from vmware_vi.models.no_maintenance_mode_drs_recommendation_for_vm import NoMaintenanceModeDrsRecommendationForVM
from vmware_vi.models.non_vi_workload_detected_on_datastore_event import NonVIWorkloadDetectedOnDatastoreEvent
from vmware_vi.models.not_enough_resources_to_start_vm_event import NotEnoughResourcesToStartVmEvent
from vmware_vi.models.out_of_sync_dvs_host import OutOfSyncDvsHost
from vmware_vi.models.permission_added_event import PermissionAddedEvent
from vmware_vi.models.permission_event import PermissionEvent
from vmware_vi.models.permission_removed_event import PermissionRemovedEvent
from vmware_vi.models.permission_updated_event import PermissionUpdatedEvent
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.profile_associated_event import ProfileAssociatedEvent
from vmware_vi.models.profile_changed_event import ProfileChangedEvent
from vmware_vi.models.profile_created_event import ProfileCreatedEvent
from vmware_vi.models.profile_dissociated_event import ProfileDissociatedEvent
from vmware_vi.models.profile_event import ProfileEvent
from vmware_vi.models.profile_reference_host_changed_event import ProfileReferenceHostChangedEvent
from vmware_vi.models.profile_removed_event import ProfileRemovedEvent
from vmware_vi.models.recovery_event import RecoveryEvent
from vmware_vi.models.remote_tsm_enabled_event import RemoteTSMEnabledEvent
from vmware_vi.models.resource_pool_created_event import ResourcePoolCreatedEvent
from vmware_vi.models.resource_pool_destroyed_event import ResourcePoolDestroyedEvent
from vmware_vi.models.resource_pool_event import ResourcePoolEvent
from vmware_vi.models.resource_pool_moved_event import ResourcePoolMovedEvent
from vmware_vi.models.resource_pool_reconfigured_event import ResourcePoolReconfiguredEvent
from vmware_vi.models.resource_violated_event import ResourceViolatedEvent
from vmware_vi.models.role_added_event import RoleAddedEvent
from vmware_vi.models.role_event import RoleEvent
from vmware_vi.models.role_removed_event import RoleRemovedEvent
from vmware_vi.models.role_updated_event import RoleUpdatedEvent
from vmware_vi.models.rollback_event import RollbackEvent
from vmware_vi.models.scheduled_task_completed_event import ScheduledTaskCompletedEvent
from vmware_vi.models.scheduled_task_created_event import ScheduledTaskCreatedEvent
from vmware_vi.models.scheduled_task_email_completed_event import ScheduledTaskEmailCompletedEvent
from vmware_vi.models.scheduled_task_email_failed_event import ScheduledTaskEmailFailedEvent
from vmware_vi.models.scheduled_task_event import ScheduledTaskEvent
from vmware_vi.models.scheduled_task_failed_event import ScheduledTaskFailedEvent
from vmware_vi.models.scheduled_task_reconfigured_event import ScheduledTaskReconfiguredEvent
from vmware_vi.models.scheduled_task_removed_event import ScheduledTaskRemovedEvent
from vmware_vi.models.scheduled_task_started_event import ScheduledTaskStartedEvent
from vmware_vi.models.server_license_expired_event import ServerLicenseExpiredEvent
from vmware_vi.models.server_started_session_event import ServerStartedSessionEvent
from vmware_vi.models.session_event import SessionEvent
from vmware_vi.models.session_terminated_event import SessionTerminatedEvent
from vmware_vi.models.task_event import TaskEvent
from vmware_vi.models.task_timeout_event import TaskTimeoutEvent
from vmware_vi.models.teaming_match_event import TeamingMatchEvent
from vmware_vi.models.teaming_mis_match_event import TeamingMisMatchEvent
from vmware_vi.models.template_being_upgraded_event import TemplateBeingUpgradedEvent
from vmware_vi.models.template_upgrade_event import TemplateUpgradeEvent
from vmware_vi.models.template_upgrade_failed_event import TemplateUpgradeFailedEvent
from vmware_vi.models.template_upgraded_event import TemplateUpgradedEvent
from vmware_vi.models.timed_out_host_operation_event import TimedOutHostOperationEvent
from vmware_vi.models.unlicensed_virtual_machines_event import UnlicensedVirtualMachinesEvent
from vmware_vi.models.unlicensed_virtual_machines_found_event import UnlicensedVirtualMachinesFoundEvent
from vmware_vi.models.updated_agent_being_restarted_event import UpdatedAgentBeingRestartedEvent
from vmware_vi.models.upgrade_event import UpgradeEvent
from vmware_vi.models.uplink_port_mtu_not_support_event import UplinkPortMtuNotSupportEvent
from vmware_vi.models.uplink_port_mtu_support_event import UplinkPortMtuSupportEvent
from vmware_vi.models.uplink_port_vlan_trunked_event import UplinkPortVlanTrunkedEvent
from vmware_vi.models.uplink_port_vlan_untrunked_event import UplinkPortVlanUntrunkedEvent
from vmware_vi.models.user_assigned_to_group import UserAssignedToGroup
from vmware_vi.models.user_login_session_event import UserLoginSessionEvent
from vmware_vi.models.user_logout_session_event import UserLogoutSessionEvent
from vmware_vi.models.user_password_changed import UserPasswordChanged
from vmware_vi.models.user_unassigned_from_group import UserUnassignedFromGroup
from vmware_vi.models.user_upgrade_event import UserUpgradeEvent
from vmware_vi.models.v_motion_license_expired_event import VMotionLicenseExpiredEvent
from vmware_vi.models.vc_agent_uninstall_failed_event import VcAgentUninstallFailedEvent
from vmware_vi.models.vc_agent_uninstalled_event import VcAgentUninstalledEvent
from vmware_vi.models.vc_agent_upgrade_failed_event import VcAgentUpgradeFailedEvent
from vmware_vi.models.vc_agent_upgraded_event import VcAgentUpgradedEvent
from vmware_vi.models.vim_account_password_changed_event import VimAccountPasswordChangedEvent
from vmware_vi.models.vm_acquired_mks_ticket_event import VmAcquiredMksTicketEvent
from vmware_vi.models.vm_acquired_ticket_event import VmAcquiredTicketEvent
from vmware_vi.models.vm_auto_rename_event import VmAutoRenameEvent
from vmware_vi.models.vm_being_cloned_event import VmBeingClonedEvent
from vmware_vi.models.vm_being_cloned_no_folder_event import VmBeingClonedNoFolderEvent
from vmware_vi.models.vm_being_created_event import VmBeingCreatedEvent
from vmware_vi.models.vm_being_deployed_event import VmBeingDeployedEvent
from vmware_vi.models.vm_being_hot_migrated_event import VmBeingHotMigratedEvent
from vmware_vi.models.vm_being_migrated_event import VmBeingMigratedEvent
from vmware_vi.models.vm_being_relocated_event import VmBeingRelocatedEvent
from vmware_vi.models.vm_clone_event import VmCloneEvent
from vmware_vi.models.vm_clone_failed_event import VmCloneFailedEvent
from vmware_vi.models.vm_cloned_event import VmClonedEvent
from vmware_vi.models.vm_config_missing_event import VmConfigMissingEvent
from vmware_vi.models.vm_connected_event import VmConnectedEvent
from vmware_vi.models.vm_created_event import VmCreatedEvent
from vmware_vi.models.vm_das_being_reset_event import VmDasBeingResetEvent
from vmware_vi.models.vm_das_being_reset_with_screenshot_event import VmDasBeingResetWithScreenshotEvent
from vmware_vi.models.vm_das_reset_failed_event import VmDasResetFailedEvent
from vmware_vi.models.vm_das_update_error_event import VmDasUpdateErrorEvent
from vmware_vi.models.vm_das_update_ok_event import VmDasUpdateOkEvent
from vmware_vi.models.vm_date_rolled_back_event import VmDateRolledBackEvent
from vmware_vi.models.vm_deploy_failed_event import VmDeployFailedEvent
from vmware_vi.models.vm_deployed_event import VmDeployedEvent
from vmware_vi.models.vm_disconnected_event import VmDisconnectedEvent
from vmware_vi.models.vm_discovered_event import VmDiscoveredEvent
from vmware_vi.models.vm_disk_failed_event import VmDiskFailedEvent
from vmware_vi.models.vm_emigrating_event import VmEmigratingEvent
from vmware_vi.models.vm_end_recording_event import VmEndRecordingEvent
from vmware_vi.models.vm_end_replaying_event import VmEndReplayingEvent
from vmware_vi.models.vm_event import VmEvent
from vmware_vi.models.vm_failed_migrate_event import VmFailedMigrateEvent
from vmware_vi.models.vm_failed_relayout_event import VmFailedRelayoutEvent
from vmware_vi.models.vm_failed_relayout_on_vmfs2_datastore_event import VmFailedRelayoutOnVmfs2DatastoreEvent
from vmware_vi.models.vm_failed_starting_secondary_event import VmFailedStartingSecondaryEvent
from vmware_vi.models.vm_failed_to_power_off_event import VmFailedToPowerOffEvent
from vmware_vi.models.vm_failed_to_power_on_event import VmFailedToPowerOnEvent
from vmware_vi.models.vm_failed_to_reboot_guest_event import VmFailedToRebootGuestEvent
from vmware_vi.models.vm_failed_to_reset_event import VmFailedToResetEvent
from vmware_vi.models.vm_failed_to_shutdown_guest_event import VmFailedToShutdownGuestEvent
from vmware_vi.models.vm_failed_to_standby_guest_event import VmFailedToStandbyGuestEvent
from vmware_vi.models.vm_failed_to_suspend_event import VmFailedToSuspendEvent
from vmware_vi.models.vm_failed_updating_secondary_config import VmFailedUpdatingSecondaryConfig
from vmware_vi.models.vm_failover_failed import VmFailoverFailed
from vmware_vi.models.vm_fault_tolerance_state_changed_event import VmFaultToleranceStateChangedEvent
from vmware_vi.models.vm_fault_tolerance_turned_off_event import VmFaultToleranceTurnedOffEvent
from vmware_vi.models.vm_fault_tolerance_vm_terminated_event import VmFaultToleranceVmTerminatedEvent
from vmware_vi.models.vm_guest_os_crashed_event import VmGuestOSCrashedEvent
from vmware_vi.models.vm_guest_reboot_event import VmGuestRebootEvent
from vmware_vi.models.vm_guest_shutdown_event import VmGuestShutdownEvent
from vmware_vi.models.vm_guest_standby_event import VmGuestStandbyEvent
from vmware_vi.models.vm_health_monitoring_state_changed_event import VmHealthMonitoringStateChangedEvent
from vmware_vi.models.vm_instance_uuid_assigned_event import VmInstanceUuidAssignedEvent
from vmware_vi.models.vm_instance_uuid_changed_event import VmInstanceUuidChangedEvent
from vmware_vi.models.vm_instance_uuid_conflict_event import VmInstanceUuidConflictEvent
from vmware_vi.models.vm_mac_assigned_event import VmMacAssignedEvent
from vmware_vi.models.vm_mac_changed_event import VmMacChangedEvent
from vmware_vi.models.vm_mac_conflict_event import VmMacConflictEvent
from vmware_vi.models.vm_max_ft_restart_count_reached import VmMaxFTRestartCountReached
from vmware_vi.models.vm_max_restart_count_reached import VmMaxRestartCountReached
from vmware_vi.models.vm_message_error_event import VmMessageErrorEvent
from vmware_vi.models.vm_message_event import VmMessageEvent
from vmware_vi.models.vm_message_warning_event import VmMessageWarningEvent
from vmware_vi.models.vm_migrated_event import VmMigratedEvent
from vmware_vi.models.vm_no_compatible_host_for_secondary_event import VmNoCompatibleHostForSecondaryEvent
from vmware_vi.models.vm_no_network_access_event import VmNoNetworkAccessEvent
from vmware_vi.models.vm_orphaned_event import VmOrphanedEvent
from vmware_vi.models.vm_power_off_on_isolation_event import VmPowerOffOnIsolationEvent
from vmware_vi.models.vm_powered_off_event import VmPoweredOffEvent
from vmware_vi.models.vm_powered_on_event import VmPoweredOnEvent
from vmware_vi.models.vm_powering_on_with_customized_dv_port_event import VmPoweringOnWithCustomizedDVPortEvent
from vmware_vi.models.vm_primary_failover_event import VmPrimaryFailoverEvent
from vmware_vi.models.vm_reconfigured_event import VmReconfiguredEvent
from vmware_vi.models.vm_registered_event import VmRegisteredEvent
from vmware_vi.models.vm_relayout_successful_event import VmRelayoutSuccessfulEvent
from vmware_vi.models.vm_relayout_up_to_date_event import VmRelayoutUpToDateEvent
from vmware_vi.models.vm_reload_from_path_event import VmReloadFromPathEvent
from vmware_vi.models.vm_reload_from_path_failed_event import VmReloadFromPathFailedEvent
from vmware_vi.models.vm_relocate_failed_event import VmRelocateFailedEvent
from vmware_vi.models.vm_relocate_spec_event import VmRelocateSpecEvent
from vmware_vi.models.vm_relocated_event import VmRelocatedEvent
from vmware_vi.models.vm_remote_console_connected_event import VmRemoteConsoleConnectedEvent
from vmware_vi.models.vm_remote_console_disconnected_event import VmRemoteConsoleDisconnectedEvent
from vmware_vi.models.vm_removed_event import VmRemovedEvent
from vmware_vi.models.vm_renamed_event import VmRenamedEvent
from vmware_vi.models.vm_requirements_exceed_current_evc_mode_event import VmRequirementsExceedCurrentEVCModeEvent
from vmware_vi.models.vm_resetting_event import VmResettingEvent
from vmware_vi.models.vm_resource_pool_moved_event import VmResourcePoolMovedEvent
from vmware_vi.models.vm_resource_reallocated_event import VmResourceReallocatedEvent
from vmware_vi.models.vm_restarted_on_alternate_host_event import VmRestartedOnAlternateHostEvent
from vmware_vi.models.vm_resuming_event import VmResumingEvent
from vmware_vi.models.vm_secondary_added_event import VmSecondaryAddedEvent
from vmware_vi.models.vm_secondary_disabled_by_system_event import VmSecondaryDisabledBySystemEvent
from vmware_vi.models.vm_secondary_disabled_event import VmSecondaryDisabledEvent
from vmware_vi.models.vm_secondary_enabled_event import VmSecondaryEnabledEvent
from vmware_vi.models.vm_secondary_started_event import VmSecondaryStartedEvent
from vmware_vi.models.vm_shutdown_on_isolation_event import VmShutdownOnIsolationEvent
from vmware_vi.models.vm_start_recording_event import VmStartRecordingEvent
from vmware_vi.models.vm_start_replaying_event import VmStartReplayingEvent
from vmware_vi.models.vm_starting_event import VmStartingEvent
from vmware_vi.models.vm_starting_secondary_event import VmStartingSecondaryEvent
from vmware_vi.models.vm_static_mac_conflict_event import VmStaticMacConflictEvent
from vmware_vi.models.vm_stopping_event import VmStoppingEvent
from vmware_vi.models.vm_suspended_event import VmSuspendedEvent
from vmware_vi.models.vm_suspending_event import VmSuspendingEvent
from vmware_vi.models.vm_timedout_starting_secondary_event import VmTimedoutStartingSecondaryEvent
from vmware_vi.models.vm_unsupported_starting_event import VmUnsupportedStartingEvent
from vmware_vi.models.vm_upgrade_complete_event import VmUpgradeCompleteEvent
from vmware_vi.models.vm_upgrade_failed_event import VmUpgradeFailedEvent
from vmware_vi.models.vm_upgrading_event import VmUpgradingEvent
from vmware_vi.models.vm_uuid_assigned_event import VmUuidAssignedEvent
from vmware_vi.models.vm_uuid_changed_event import VmUuidChangedEvent
from vmware_vi.models.vm_uuid_conflict_event import VmUuidConflictEvent
from vmware_vi.models.vm_vnic_pool_reservation_violation_clear_event import VmVnicPoolReservationViolationClearEvent
from vmware_vi.models.vm_vnic_pool_reservation_violation_raise_event import VmVnicPoolReservationViolationRaiseEvent
from vmware_vi.models.vm_wwn_assigned_event import VmWwnAssignedEvent
from vmware_vi.models.vm_wwn_changed_event import VmWwnChangedEvent
from vmware_vi.models.vm_wwn_conflict_event import VmWwnConflictEvent
from vmware_vi.models.vmfs_datastore_created_event import VMFSDatastoreCreatedEvent
from vmware_vi.models.vmfs_datastore_expanded_event import VMFSDatastoreExpandedEvent
from vmware_vi.models.vmfs_datastore_extended_event import VMFSDatastoreExtendedEvent
from vmware_vi.models.warning_upgrade_event import WarningUpgradeEvent
# TODO: Rewrite to not use raise_errors
Event.model_rebuild(raise_errors=False)

