# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.profile_deferred_policy_option_parameter import ProfileDeferredPolicyOptionParameter
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ExecuteHostProfileRequestType(BaseModel):
    """
    The parameters of *HostProfile.ExecuteHostProfile*. 
    """ # noqa: E501
    host: ManagedObjectReference
    deferred_param: Optional[List[ProfileDeferredPolicyOptionParameter]] = Field(default=None, description="Additional configuration data to be applied to the host. This should contain all of the host-specific data, including data from from previous calls to the method.  ***Since:*** vSphere API 4.0 ", alias="deferredParam")
    __properties: ClassVar[List[str]] = ["host", "deferredParam"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ExecuteHostProfileRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of host
        if self.host:
            _dict['host'] = self.host.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in deferred_param (list)
        _items = []
        if self.deferred_param:
            for _item in self.deferred_param:
                if _item:
                    _items.append(_item.to_dict())
            _dict['deferredParam'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ExecuteHostProfileRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "host": ManagedObjectReference.from_dict(obj.get("host")) if obj.get("host") is not None else None,
            "deferredParam": [ProfileDeferredPolicyOptionParameter.from_dict(_item) for _item in obj.get("deferredParam")] if obj.get("deferredParam") is not None else None
        })
        return _obj


