# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.fcoe_config_fcoe_capabilities import FcoeConfigFcoeCapabilities
from vmware_vi.models.fcoe_config_vlan_range import FcoeConfigVlanRange
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FcoeConfig(DataObject):
    """
    This data object type describes an FCoE configuration as it pertains to an underlying physical NIC.  Terminology is borrowed from T11's working draft of the Fibre Channel Backbone 5 standard (FC-BB-5). The draft can be found at http://www.t11.org.  ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    priority_class: StrictInt = Field(description="802.1p priority class used for FCoE traffic.  ***Since:*** vSphere API 5.0 ", alias="priorityClass")
    source_mac: StrictStr = Field(description="Source MAC address used for FCoE traffic.  This MAC address is associated with the logical construct that is a physical NIC's associated underlying FCoE Controller, as defined in the FC-BB-5 standard. This MAC address should be of the form \"xx:xx:xx:xx:xx:xx\", where 'x' is a hexadecimal digit. Valid MAC addresses are unicast addresses.  ***Since:*** vSphere API 5.0 ", alias="sourceMac")
    vlan_range: List[FcoeConfigVlanRange] = Field(description="VLAN ranges associated with this FcoeConfig.  ***Since:*** vSphere API 5.0 ", alias="vlanRange")
    capabilities: FcoeConfigFcoeCapabilities
    fcoe_active: StrictBool = Field(description="Indicates whether this FcoeConfig is \"active\" (has been used in conjunction with a parent physical network adapter for FCoE discovery).  ***Since:*** vSphere API 5.0 ", alias="fcoeActive")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FcoeConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FcoeConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


