# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.guest_info_virtual_disk_mapping import GuestInfoVirtualDiskMapping
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GuestDiskInfo(DataObject):
    """
    Information about each local virtual disk configured in the guest operating system. 
    """ # noqa: E501
    disk_path: Optional[StrictStr] = Field(default=None, description="Name of the virtual disk in the guest operating system.  For example: C:\\\\ ", alias="diskPath")
    capacity: Optional[StrictInt] = Field(default=None, description="Total capacity of the disk, in bytes.  This is part of the virtual machine configuration. ")
    free_space: Optional[StrictInt] = Field(default=None, description="Free space on the disk, in bytes.  This is retrieved by VMware Tools. ", alias="freeSpace")
    filesystem_type: Optional[StrictStr] = Field(default=None, description="Filesystem type, if known.  For example NTFS or ext3.  ***Since:*** vSphere API 7.0 ", alias="filesystemType")
    mappings: Optional[List[GuestInfoVirtualDiskMapping]] = Field(default=None, description="VirtualDisks backing the guest partition, if known.  ***Since:*** vSphere API 7.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GuestDiskInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GuestDiskInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


