# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.bool_option import BoolOption
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_cpu_id_info import HostCpuIdInfo
from vmware_vi.models.int_option import IntOption
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GuestOsDescriptor(DataObject):
    """
    This data object type contains information to describe a particular guest operating system. 
    """ # noqa: E501
    id: StrictStr = Field(description="Identifier (short name) for the guest operating system. ")
    family: StrictStr = Field(description="Family to which this guest operating system belongs. ")
    full_name: StrictStr = Field(description="Full name of the guest operating system.  For example, if the value of \"id\" is \"win2000Pro\", then the value of \"fullName\" is \"Windows 2000 Professional\". ", alias="fullName")
    supported_max_cpus: StrictInt = Field(description="Maximum number of processors supported for this guest. ", alias="supportedMaxCPUs")
    num_supported_physical_sockets: StrictInt = Field(description="Maximum number of sockets supported for this guest.  ***Since:*** vSphere API 5.0 ", alias="numSupportedPhysicalSockets")
    num_supported_cores_per_socket: StrictInt = Field(description="Maximum number of cores per socket for this guest.  ***Since:*** vSphere API 5.0 ", alias="numSupportedCoresPerSocket")
    supported_min_mem_mb: StrictInt = Field(description="Minimum memory requirements supported for this guest, in MB. ", alias="supportedMinMemMB")
    supported_max_mem_mb: StrictInt = Field(description="Maximum memory requirements supported for this guest, in MB. ", alias="supportedMaxMemMB")
    recommended_mem_mb: StrictInt = Field(description="Recommended default memory size for this guest, in MB. ", alias="recommendedMemMB")
    recommended_color_depth: StrictInt = Field(description="Recommended default color depth for this guest. ", alias="recommendedColorDepth")
    supported_disk_controller_list: List[StrictStr] = Field(description="List of supported disk controller types for this guest. ", alias="supportedDiskControllerList")
    recommended_scsi_controller: Optional[StrictStr] = Field(default=None, description="Recommended default SCSI controller type for this guest. ", alias="recommendedSCSIController")
    recommended_disk_controller: StrictStr = Field(description="Recommended default disk controller type for this guest. ", alias="recommendedDiskController")
    supported_num_disks: StrictInt = Field(description="Number of disks supported for this guest. ", alias="supportedNumDisks")
    recommended_disk_size_mb: StrictInt = Field(description="Recommended default disk size for this guest, in MB. ", alias="recommendedDiskSizeMB")
    recommended_cdrom_controller: StrictStr = Field(description="Recommended default CD-ROM type for this guest.  ***Since:*** vSphere API 5.5 ", alias="recommendedCdromController")
    supported_ethernet_card: List[StrictStr] = Field(description="List of supported ethernet cards for this guest. ", alias="supportedEthernetCard")
    recommended_ethernet_card: Optional[StrictStr] = Field(default=None, description="Recommended default ethernet controller type for this guest. ", alias="recommendedEthernetCard")
    supports_slave_disk: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether or not this guest can support a disk configured as a slave. ", alias="supportsSlaveDisk")
    cpu_feature_mask: Optional[List[HostCpuIdInfo]] = Field(default=None, description="Specifies the CPU feature compatibility masks. ", alias="cpuFeatureMask")
    smc_required: StrictBool = Field(description="Flag that indicates wether the guest requires an SMC (Apple hardware).  This is logically equivalent to GuestOS = Mac OS  ***Since:*** vSphere API 5.0 ", alias="smcRequired")
    supports_wake_on_lan: StrictBool = Field(description="Flag to indicate whether or not this guest can support Wake-on-LAN. ", alias="supportsWakeOnLan")
    supports_vmi: StrictBool = Field(description="Flag indicating whether or not this guest supports the virtual machine interface.  ***Since:*** vSphere API 4.0 ", alias="supportsVMI")
    supports_memory_hot_add: StrictBool = Field(description="Whether the memory size for this guest can be changed while the virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="supportsMemoryHotAdd")
    supports_cpu_hot_add: StrictBool = Field(description="Whether virtual CPUs can be added to this guest while the virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="supportsCpuHotAdd")
    supports_cpu_hot_remove: StrictBool = Field(description="Whether virtual CPUs can be removed from this guest while the virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="supportsCpuHotRemove")
    supported_firmware: List[StrictStr] = Field(description="Supported firmware types for this guest.  Possible values are described in *GuestOsDescriptorFirmwareType_enum*  ***Since:*** vSphere API 5.0 ", alias="supportedFirmware")
    recommended_firmware: StrictStr = Field(description="Recommended firmware type for this guest.  Possible values are described in *GuestOsDescriptorFirmwareType_enum*  ***Since:*** vSphere API 5.0 ", alias="recommendedFirmware")
    supported_usb_controller_list: Optional[List[StrictStr]] = Field(default=None, description="List of supported USB controllers for this guest.  ***Since:*** vSphere API 5.0 ", alias="supportedUSBControllerList")
    recommended_usb_controller: Optional[StrictStr] = Field(default=None, description="Recommended default USB controller type for this guest.  ***Since:*** vSphere API 5.0 ", alias="recommendedUSBController")
    supports3_d: StrictBool = Field(description="Whether this guest supports 3D graphics.  ***Since:*** vSphere API 5.0 ", alias="supports3D")
    recommended3_d: StrictBool = Field(description="Recommended 3D graphics for this guest.  ***Since:*** vSphere API 5.1 ", alias="recommended3D")
    smc_recommended: StrictBool = Field(description="Whether SMC (Apple hardware) is recommended for this guest.  ***Since:*** vSphere API 5.0 ", alias="smcRecommended")
    ich7m_recommended: StrictBool = Field(description="Whether I/O Controller Hub is recommended for this guest.  ***Since:*** vSphere API 5.0 ", alias="ich7mRecommended")
    usb_recommended: StrictBool = Field(description="Whether USB controller is recommended for this guest.  ***Since:*** vSphere API 5.0 ", alias="usbRecommended")
    support_level: StrictStr = Field(description="Support level of this Guest Possible values are described in *GuestOsDescriptorSupportLevel_enum*  ***Since:*** vSphere API 5.0 ", alias="supportLevel")
    supported_for_create: StrictBool = Field(description="Whether or not this guest should be allowed for selection during virtual machine creation.  ***Since:*** vSphere API 5.0 ", alias="supportedForCreate")
    v_ram_size_in_kb: IntOption = Field(alias="vRAMSizeInKB")
    num_supported_floppy_devices: StrictInt = Field(description="Maximum number of floppies supported by this guest.  ***Since:*** vSphere API 6.0 ", alias="numSupportedFloppyDevices")
    wake_on_lan_ethernet_card: Optional[List[StrictStr]] = Field(default=None, description="List of NICs supported by this guest that support Wake-On-Lan.  ***Since:*** vSphere API 6.0 ", alias="wakeOnLanEthernetCard")
    supports_pvscsi_controller_for_boot: StrictBool = Field(description="Whether or not this guest can use pvscsi as boot adapter.  ***Since:*** vSphere API 6.0 ", alias="supportsPvscsiControllerForBoot")
    disk_uuid_enabled: StrictBool = Field(description="Whether or not this guest should have disk uuid enabled by default.  ***Since:*** vSphere API 6.0 ", alias="diskUuidEnabled")
    supports_hot_plug_pci: StrictBool = Field(description="Whether or not this guest supports hot plug of PCI devices.  ***Since:*** vSphere API 6.0 ", alias="supportsHotPlugPCI")
    supports_secure_boot: Optional[StrictBool] = Field(default=None, description="Whether or not this guest supports Secure Boot.  If some of the OS releases that fall under this guest OS descriptor support Secure Boot, it is reasonable to offer the ability to enable Secure Boot. Only meaningful when virtual EFI firmware is in use.  ***Since:*** vSphere API 6.5 ", alias="supportsSecureBoot")
    default_secure_boot: Optional[StrictBool] = Field(default=None, description="Whether or not Secure Boot should be enabled by default for this guest OS.  If all OS releases that fall under this guest OS descriptor support Secure Boot and are known to operate correctly with Secure Boot enabled, it is reasonable to enable it by default. Only meaningful when virtual EFI firmware is in use.  ***Since:*** vSphere API 6.5 ", alias="defaultSecureBoot")
    persistent_memory_supported: Optional[StrictBool] = Field(default=None, description="Support of persistent memory (virtual NVDIMM device).  See also *VirtualNVDIMM*.  ***Since:*** vSphere API 6.7 ", alias="persistentMemorySupported")
    supported_min_persistent_memory_mb: Optional[StrictInt] = Field(default=None, description="Minimum persistent memory supported for this guest, in MB.  ***Since:*** vSphere API 6.7 ", alias="supportedMinPersistentMemoryMB")
    supported_max_persistent_memory_mb: Optional[StrictInt] = Field(default=None, description="Maximum persistent memory supported for this guest, in MB.  Total size of all the virtual NVDIMM devices should be less than this value.  ***Since:*** vSphere API 6.7 ", alias="supportedMaxPersistentMemoryMB")
    recommended_persistent_memory_mb: Optional[StrictInt] = Field(default=None, description="Recommended default persistent memory size for this guest, in MB.  ***Since:*** vSphere API 6.7 ", alias="recommendedPersistentMemoryMB")
    persistent_memory_hot_add_supported: Optional[StrictBool] = Field(default=None, description="Support of persistent memory hot-add operation.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryHotAddSupported")
    persistent_memory_hot_remove_supported: Optional[StrictBool] = Field(default=None, description="Support of persistent memory hot-remove operation.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryHotRemoveSupported")
    persistent_memory_cold_growth_supported: Optional[StrictBool] = Field(default=None, description="Support of virtual NVDIMM cold-growth operation.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryColdGrowthSupported")
    persistent_memory_cold_growth_granularity_mb: Optional[StrictInt] = Field(default=None, description="Virtual NVDIMM cold-growth granularity in MB.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryColdGrowthGranularityMB")
    persistent_memory_hot_growth_supported: Optional[StrictBool] = Field(default=None, description="Support of virtual NVDIMM hot-growth operation.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryHotGrowthSupported")
    persistent_memory_hot_growth_granularity_mb: Optional[StrictInt] = Field(default=None, description="Virtual NVDIMM hot-growth granularity in MB.  ***Since:*** vSphere API 6.7 ", alias="persistentMemoryHotGrowthGranularityMB")
    num_recommended_physical_sockets: Optional[StrictInt] = Field(default=None, description="Recommended number of sockets for this guest.  ***Since:*** vSphere API 6.7 ", alias="numRecommendedPhysicalSockets")
    num_recommended_cores_per_socket: Optional[StrictInt] = Field(default=None, description="Recommended number of cores per socket for this guest.  ***Since:*** vSphere API 6.7 ", alias="numRecommendedCoresPerSocket")
    vvtd_supported: Optional[BoolOption] = Field(default=None, alias="vvtdSupported")
    vbs_supported: Optional[BoolOption] = Field(default=None, alias="vbsSupported")
    vsgx_supported: Optional[BoolOption] = Field(default=None, alias="vsgxSupported")
    vsgx_remote_attestation_supported: Optional[StrictBool] = Field(default=None, description="Support for Intel Software Guard Extensions remote attestation. ", alias="vsgxRemoteAttestationSupported")
    supports_tpm20: Optional[StrictBool] = Field(default=None, description="Support for TPM 2.0.  ***Since:*** vSphere API 6.7 ", alias="supportsTPM20")
    recommended_tpm20: Optional[StrictBool] = Field(default=None, description="Support for default vTPM ", alias="recommendedTPM20")
    vwdt_supported: Optional[StrictBool] = Field(default=None, description="Support for Virtual Watchdog Timer.  ***Since:*** vSphere API 7.0 ", alias="vwdtSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GuestOsDescriptor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GuestOsDescriptor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


