# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_cpu_id_info import HostCpuIdInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostCapability(DataObject):
    """
    Specifies the capabilities of the particular host.  This set of capabilities is referenced in other parts of the API specification to indicate under what circumstances an API will throw a *NotSupported* fault. 
    """ # noqa: E501
    recursive_resource_pools_supported: StrictBool = Field(alias="recursiveResourcePoolsSupported")
    cpu_memory_resource_configuration_supported: StrictBool = Field(description="Flag indicating whether cpu and memory resource configuration is supported.  If this is set to false, *ResourcePool.UpdateConfig*, *ResourcePool.UpdateChildResourceConfiguration* cannot be used for changing the cpu/memory resource configurations.  ***Since:*** VI API 2.5 ", alias="cpuMemoryResourceConfigurationSupported")
    reboot_supported: StrictBool = Field(description="Flag indicating whether rebooting the host is supported. ", alias="rebootSupported")
    shutdown_supported: StrictBool = Field(description="Flag indicating whether the host can be powered off ", alias="shutdownSupported")
    vmotion_supported: StrictBool = Field(description="Flag indicating whether you can perform VMotion. ", alias="vmotionSupported")
    standby_supported: StrictBool = Field(description="Flag indicating whether you can put the host in a power down state, from which it can be powered up automatically.  ***Since:*** VI API 2.5 ", alias="standbySupported")
    ipmi_supported: Optional[StrictBool] = Field(default=None, description="Flag indicating whether the host supports IPMI (Intelligent Platform Management Interface).  XXX - Make ipmiSupported optional until there is a compatible hostagent.  ***Since:*** vSphere API 4.0 ", alias="ipmiSupported")
    max_supported_vms: Optional[StrictInt] = Field(default=None, description="The maximum number of virtual machines that can exist on this host.  If this capability is not set, the number of virtual machines is unlimited. ", alias="maxSupportedVMs")
    max_running_vms: Optional[StrictInt] = Field(default=None, description="The maximum number of virtual machines that can be running simultaneously on this host.  If this capability is not set, the number of virtual machines running simultaneously is unlimited. ", alias="maxRunningVMs")
    max_supported_vcpus: Optional[StrictInt] = Field(default=None, description="The maximum number of virtual CPUs supported per virtual machine.  If this capability is not set, the number is unlimited. ", alias="maxSupportedVcpus")
    max_registered_vms: Optional[StrictInt] = Field(default=None, description="The maximum number of registered virtual machines supported by the host.  If this limit is exceeded, the management agent will be at risk of running out of system resources. *configIssue* will be posted on *HostSystem* in this case.  If this capability is not set, the number is unknown.  ***Since:*** vSphere API 5.1 ", alias="maxRegisteredVMs")
    datastore_principal_supported: StrictBool = Field(description="Flag indicating whether datastore principal user is supported on the host. ", alias="datastorePrincipalSupported")
    san_supported: StrictBool = Field(description="Flag indicating whether access to SAN devices is supported. ", alias="sanSupported")
    nfs_supported: StrictBool = Field(description="Is access to NFS devices supported. ", alias="nfsSupported")
    iscsi_supported: StrictBool = Field(description="Is access to iSCSI devices supported. ", alias="iscsiSupported")
    vlan_tagging_supported: StrictBool = Field(description="Is VLAN Tagging supported. ", alias="vlanTaggingSupported")
    nic_teaming_supported: StrictBool = Field(description="Is NIC teaming supported. ", alias="nicTeamingSupported")
    high_guest_mem_supported: StrictBool = Field(description="Is high guest memory supported. ", alias="highGuestMemSupported")
    maintenance_mode_supported: StrictBool = Field(description="Is maintenance mode supported ", alias="maintenanceModeSupported")
    suspended_relocate_supported: StrictBool = Field(description="Indicates whether this host supports relocation of suspended virtual machines.  Must be true on the source and destination hosts for the relocation to work. ", alias="suspendedRelocateSupported")
    restricted_snapshot_relocate_supported: StrictBool = Field(description="Indicates whether this host supports relocation of virtual machines with snapshots.  Must be true on the source and destination hosts for the relocation to work. Even if this is true, the following conditions must hold: 1\\) All the the vm's files are in one directory prior to the relocate. 2\\) All of the vm's files will be in one directory after the relocate. 3\\) The source and destination hosts are the same product version.  ***Since:*** VI API 2.5 ", alias="restrictedSnapshotRelocateSupported")
    per_vm_swap_files: StrictBool = Field(description="Flag indicating whether virtual machine execution on this host involves a swapfile for each virtual machine.  If true, the swapfile placement for a powered-on virtual machine is advertised in its FileLayout by the *swapFile* property.  ***Since:*** VI API 2.5 ", alias="perVmSwapFiles")
    local_swap_datastore_supported: StrictBool = Field(description="Flag indicating whether the host supports selecting a datastore that that may be used to store virtual machine swapfiles.  ***Since:*** VI API 2.5 ", alias="localSwapDatastoreSupported")
    unshared_swap_v_motion_supported: StrictBool = Field(description="Flag indicating whether the host supports participating in a VMotion where the virtual machine swapfile is not visible to the destination.  ***Since:*** VI API 2.5 ", alias="unsharedSwapVMotionSupported")
    background_snapshots_supported: StrictBool = Field(description="Flag indicating whether background snapshots are supported on this host.  ***Since:*** VI API 2.5 ", alias="backgroundSnapshotsSupported")
    pre_assigned_pci_unit_numbers_supported: StrictBool = Field(description="Flag to indicate whether the server returns unit numbers in a pre-assigned range for devices on the PCI bus.  When the server supports this flag, the device unit number namespace is partitioned by device type. Different types of devices will sit in a specific range of unit numbers that may not correspond to physical slots in the pci bus but present a relative ordering of the devices with respect to other devices of the same type. Note that this does not mean that the user can set the relative ordering between device types, but only allows stable orderings between devices of the same type. The unit number will now clearly represent an ordering between devices of the same type. *VirtualDevice.unitNumber* This property is only available for devices on the pci controller.  ***Since:*** VI API 2.5 ", alias="preAssignedPCIUnitNumbersSupported")
    screenshot_supported: StrictBool = Field(description="Indicates whether the screenshot retrival over https is supported for this host's virtual machines.  If true, a screenshot can be retrieved at the HTTPS relative path _/screen?id=&lt;managed object ID of virtual machine or snapshot&gt;_. If any of the optional parameters 'top', 'left', 'bottom', and 'right' is specified, the returned image will be cropped from the rectangle with upper left corner (left, top) and bottom right corner (right - 1, bottom - 1). These values default to the top, left, bottom and right edges of the image. The client must use an authenticated session with privilege VirtualMachine.Interact.ConsoleInteract on the requested virtual machine or, in the case of a snapshot, the virtual machine associated with that snapshot.  ***Since:*** VI API 2.5 ", alias="screenshotSupported")
    scaled_screenshot_supported: StrictBool = Field(description="Indicates whether scaling is supported for screenshots retrieved over https.  If true, screenshot retrieval supports the additional optional parameters 'width' and 'height'. After cropping, the returned image will be scaled to these dimensions. If only one of these parameters is specified, default behavior is to return an image roughly proportional to the source image.  ***Since:*** VI API 2.5 ", alias="scaledScreenshotSupported")
    storage_v_motion_supported: StrictBool = Field(description="Indicates whether the storage of a powered-on virtual machine may be relocated.  ***Since:*** vSphere API 4.0 ", alias="storageVMotionSupported")
    vmotion_with_storage_v_motion_supported: StrictBool = Field(description="Indicates whether the storage of a powered-on virtual machine may be relocated while simultaneously changing the execution host of the virtual machine.  ***Since:*** vSphere API 4.0 ", alias="vmotionWithStorageVMotionSupported")
    vmotion_across_network_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the network of a powered-on virtual machine can be changed while simultaneously changing the execution host of the virtual machine.  ***Since:*** vSphere API 5.5 ", alias="vmotionAcrossNetworkSupported")
    max_num_disks_sv_motion: Optional[StrictInt] = Field(default=None, description="Maximum number of migrating disks allowed of a migrating VM during SVMotion.  If this capability is not set, then the maximum is considered to be 64.  ***Since:*** vSphere API 6.0 ", alias="maxNumDisksSVMotion")
    max_virtual_disk_desc_version_supported: Optional[StrictInt] = Field(default=None, description="Maximum version of vDiskVersion supported by this host.  If this capability is not set, then the maximum is considered to be 6. ", alias="maxVirtualDiskDescVersionSupported")
    hbr_nic_selection_supported: StrictBool = Field(description="Indicates whether a dedicated nic can be selected for vSphere Replication LWD traffic, i.e., from the primary host to the VR server.  ***Since:*** vSphere API 5.1 ", alias="hbrNicSelectionSupported")
    vr_nfc_nic_selection_supported: StrictBool = Field(description="Indicates whether a dedicated nic can be selected for vSphere Replication NFC traffic, i.e., from the VR server to the secondary host.  ***Since:*** vSphere API 6.0 ", alias="vrNfcNicSelectionSupported")
    record_replay_supported: StrictBool = Field(description="Deprecated as of vSphere API 6.0.  Indicates whether this host supports record and replay  ***Since:*** vSphere API 4.0 ", alias="recordReplaySupported")
    ft_supported: StrictBool = Field(description="Deprecated as of vSphere API 6.0.  Indicates whether this host supports Fault Tolerance There can be many reasons why a host does not support Fault Tolerance, which includes CPU compatibility, product compatibility as well as other host configuration settings.  For specific reasons, look into *HostCapability.replayCompatibilityIssues* and *HostCapability.ftCompatibilityIssues* In releases after vSphere API 5.0, vSphere Servers might not generate property collector update notifications for this property. To obtain the latest value of the property, you can use PropertyCollector methods RetrievePropertiesEx or WaitForUpdatesEx. If you use the PropertyCollector.WaitForUpdatesEx method, specify an empty string for the version parameter. Since this property is on a DataObject, an update returned by WaitForUpdatesEx may contain values for this property when some other property on the DataObject changes. If this update is a result of a call to WaitForUpdatesEx with a non-empty version parameter, the value for this property may not be current.  ***Since:*** vSphere API 4.0 ", alias="ftSupported")
    replay_unsupported_reason: Optional[StrictStr] = Field(default=None, description="Deprecated as of vSphere API 4.1, use *HostCapability.replayCompatibilityIssues*.  For a host whose CPU doesn't support replay, indicates the reason for the incompatibility.  *HostReplayUnsupportedReason_enum* represents the set of possible values.  ***Since:*** vSphere API 4.0 ", alias="replayUnsupportedReason")
    replay_compatibility_issues: Optional[List[StrictStr]] = Field(default=None, description="Deprecated as of vSphere API 6.0.  For a host which doesn't support replay, indicates all the reasons for the incompatibility.  *HostReplayUnsupportedReason_enum* lists the set of possible values.  ***Since:*** vSphere API 4.1 ", alias="replayCompatibilityIssues")
    smp_ft_supported: StrictBool = Field(description="Indicates whether this host supports smp fault tolerance  ***Since:*** vSphere API 6.0 ", alias="smpFtSupported")
    ft_compatibility_issues: Optional[List[StrictStr]] = Field(default=None, description="Deprecated as of vSphere API 6.0.  For a host which doesn't support Fault Tolerance, indicates all the reasons for the incompatibility.  *HostCapabilityFtUnsupportedReason_enum* lists the set of possible values.  ***Since:*** vSphere API 4.1 ", alias="ftCompatibilityIssues")
    smp_ft_compatibility_issues: Optional[List[StrictStr]] = Field(default=None, description="For a host which doesn't support smp fault tolerance, indicates all the reasons for the incompatibility.  *HostCapabilityFtUnsupportedReason_enum* lists the set of possible values.  ***Since:*** vSphere API 6.0 ", alias="smpFtCompatibilityIssues")
    max_vcpus_per_ft_vm: Optional[StrictInt] = Field(default=None, description="The maximum number of vCPUs allowed for a fault-tolerant virtual machine.  ***Since:*** vSphere API 6.0 ", alias="maxVcpusPerFtVm")
    login_by_ssl_thumbprint_supported: Optional[StrictBool] = Field(default=None, description="Flag indicating whether this host supports SSL thumbprint authentication  ***Since:*** vSphere API 4.0 ", alias="loginBySSLThumbprintSupported")
    clone_from_snapshot_supported: StrictBool = Field(description="Indicates whether or not cloning a virtual machine from a snapshot point is allowed.  This property must be true on the host where the virtual machine is currently residing. This property need not be true on the destination host for the clone.  See also *VirtualMachineCloneSpec.snapshot*.  ***Since:*** vSphere API 4.0 ", alias="cloneFromSnapshotSupported")
    delta_disk_backings_supported: StrictBool = Field(description="Flag indicating whether explicitly creating arbirary configurations of delta disk backings is supported.  A delta disk backing is a way to preserve a virtual disk backing at some point in time. A delta disk backing is a file backing which in turn points to the original virtual disk backing (the parent). After a delta disk backing is added, all writes go to the delta disk backing. All reads first try the delta disk backing and then try the parent backing if needed.  If this property is false, then delta disk backings can only be implicitly created through using snapshot operations and two virtual machines cannot safely share a parent disk backing.  If this property is true, then delta disk backings can be explicitly created and managed, and two virtual machines may safely share a parent disk backing.  In the context above, \"safely\" means that performing operations on one of the virtual machines will not affect the operation of the other virtual machine.  See also *VirtualDiskSparseVer1BackingInfo.parent*, *VirtualDiskSparseVer2BackingInfo.parent*, *VirtualDiskFlatVer1BackingInfo.parent*, *VirtualDiskFlatVer2BackingInfo.parent*, *VirtualDiskRawDiskMappingVer1BackingInfo.parent*, *VirtualMachine.PromoteDisks_Task*, *VirtualMachineRelocateSpec.diskMoveType*, *VirtualMachineRelocateSpecDiskLocator.diskMoveType*.  ***Since:*** vSphere API 4.0 ", alias="deltaDiskBackingsSupported")
    per_vm_network_traffic_shaping_supported: StrictBool = Field(description="Indicates whether network traffic shaping on a per virtual machine basis is supported.  ***Since:*** vSphere API 4.0 ", alias="perVMNetworkTrafficShapingSupported")
    tpm_supported: StrictBool = Field(description="Flag indicating whether this host supports the integrity measurement using a TPM device.  ***Since:*** vSphere API 4.0 ", alias="tpmSupported")
    tpm_version: Optional[StrictStr] = Field(default=None, description="TPM version if supported by this host.  ***Since:*** vSphere API 6.7 ", alias="tpmVersion")
    txt_enabled: Optional[StrictBool] = Field(default=None, description="Flag indicating whether Intel TXT is enabled on this host.  ***Since:*** vSphere API 6.7 ", alias="txtEnabled")
    supported_cpu_feature: Optional[List[HostCpuIdInfo]] = Field(default=None, description="Deprecated as of vSphere API 6.5 use *featureCapability*.  CPU feature set that is supported by the virtualization platform.  This feature set may reflect characteristics of the product capabilities and licensing. For any feature marked '-', reference the *cpuFeature* array of the host's HardwareInfo to determine the correct value.  ***Since:*** vSphere API 4.0 ", alias="supportedCpuFeature")
    virtual_exec_usage_supported: StrictBool = Field(description="Indicates whether the host supports configuring hardware virtualization (HV) support for virtual machines.  ***Since:*** vSphere API 4.0 ", alias="virtualExecUsageSupported")
    storage_iorm_supported: StrictBool = Field(description="Indicates whether the host supports storage I/O resource management.  ***Since:*** vSphere API 4.1 ", alias="storageIORMSupported")
    vm_direct_path_gen2_supported: Optional[StrictBool] = Field(default=None, description="Deprecated as of vSphere API 8.0. VMDirectPath Gen 2 is no longer supported and there is no replacement.  Indicates whether the host supports network passthrough using VMDirectPath Gen 2.  Note that this is a general capability for the host and is independent of support by a given physical NIC. If false, the reason(s) for lack of support will be provided in *HostCapability.vmDirectPathGen2UnsupportedReason* and/or in *HostCapability.vmDirectPathGen2UnsupportedReasonExtended*.  See also *PhysicalNic.vmDirectPathGen2Supported*.  ***Since:*** vSphere API 4.1 ", alias="vmDirectPathGen2Supported")
    vm_direct_path_gen2_unsupported_reason: Optional[List[StrictStr]] = Field(default=None, description="Deprecated as of vSphere API 8.0. VMDirectPath Gen 2 is no longer supported and there is no replacement.  If *HostCapability.vmDirectPathGen2Supported* is false, this array will be populated with reasons for the lack of support (chosen from *HostCapabilityVmDirectPathGen2UnsupportedReason_enum*).  If there is a reason for the lack of support that cannot be described by the available constants, *HostCapability.vmDirectPathGen2UnsupportedReasonExtended* will be populated with an additional explanation provided by the platform.  Note that this list of reasons is not guaranteed to be exhaustive.  If the reason \"hostNptIncompatibleProduct\" is provided, then that will be the only provided reason, as the host software is incapable of providing additional information.  ***Since:*** vSphere API 4.1 ", alias="vmDirectPathGen2UnsupportedReason")
    vm_direct_path_gen2_unsupported_reason_extended: Optional[StrictStr] = Field(default=None, description="Deprecated as of vSphere API 8.0. VMDirectPath Gen 2 is no longer supported and there is no replacement.  If *HostCapability.vmDirectPathGen2Supported* is false, this property may contain an explanation provided by the platform, beyond the reasons (if any) enumerated in *HostCapability.vmDirectPathGen2UnsupportedReason*.  ***Since:*** vSphere API 4.1 ", alias="vmDirectPathGen2UnsupportedReasonExtended")
    supported_vmfs_major_version: Optional[List[StrictInt]] = Field(default=None, description="List of VMFS major versions supported by the host.  ***Since:*** vSphere API 5.0 ", alias="supportedVmfsMajorVersion")
    v_storage_capable: StrictBool = Field(description="Indicates whether the host supports vStorage Hardware acceleration.  ***Since:*** vSphere API 4.1 ", alias="vStorageCapable")
    snapshot_relayout_supported: StrictBool = Field(description="Indicates whether this host supports unrestricted relocation of virtual machines with snapshots.  Only needs to be true on the destination host for the unrestricted relocation to work. The full snapshot relocation does not restrict the layout of snapshot files or disks of the virtual machine, nor its power state. If the virtual machine is powered on, a storage vmotion will be performed to relocate its snapshots and disks.  ***Since:*** vSphere API 5.0 ", alias="snapshotRelayoutSupported")
    firewall_ip_rules_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports ip address based restrictions in the firewall configuration.  ***Since:*** vSphere API 5.0 ", alias="firewallIpRulesSupported")
    service_package_info_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports package information in service configuration.  ***Since:*** vSphere API 5.0 ", alias="servicePackageInfoSupported")
    max_host_running_vms: Optional[StrictInt] = Field(default=None, description="The maximum number of virtual machines that can be run on the host.  An unset value indicates that the value could not be obtained. In contrast to *HostCapability.maxRunningVMs*, this value is the minimum of (i) the maximum number supported by the hardware and (ii) the maximum number permitted by the host license.  ***Since:*** vSphere API 5.0 ", alias="maxHostRunningVms")
    max_host_supported_vcpus: Optional[StrictInt] = Field(default=None, description="The maximum number of virtual CPUs that can be run on the host.  An unset value indicates that the value could not be obtained. In contrast to *HostCapability.maxSupportedVcpus*, this value is the minimum of (i) the maximum number supported by the hardware and (ii) the maximum number permitted by the host license.  ***Since:*** vSphere API 5.0 ", alias="maxHostSupportedVcpus")
    vmfs_datastore_mount_capable: StrictBool = Field(description="Indicates whether the host is capable of mounting/unmounting VMFS datastores.  ***Since:*** vSphere API 5.0 ", alias="vmfsDatastoreMountCapable")
    eight_plus_host_vmfs_shared_access_supported: StrictBool = Field(description="Indicates whether the host is capable of accessing a VMFS disk when there are eight or more hosts accessing the disk already.  ***Since:*** vSphere API 5.1 ", alias="eightPlusHostVmfsSharedAccessSupported")
    nested_hv_supported: StrictBool = Field(description="Indicates whether the host supports nested hardware-assisted virtualization.  ***Since:*** vSphere API 5.1 ", alias="nestedHVSupported")
    v_pmc_supported: StrictBool = Field(description="Indicates whether the host supports virtual CPU performance counters.  ***Since:*** vSphere API 5.1 ", alias="vPMCSupported")
    inter_vm_communication_through_vmci_supported: StrictBool = Field(description="Indicates whether the host supports VMCI for communication between virtual machines.  ***Since:*** vSphere API 5.1 ", alias="interVMCommunicationThroughVMCISupported")
    scheduled_hardware_upgrade_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the host supports scheduled hardware upgrades.  See also *VirtualMachineConfigInfo.scheduledHardwareUpgradeInfo*.  ***Since:*** vSphere API 5.1 ", alias="scheduledHardwareUpgradeSupported")
    feature_capabilities_supported: StrictBool = Field(description="Indicated whether the host supports feature capabilities for EVC mode.  ***Since:*** vSphere API 5.1 ", alias="featureCapabilitiesSupported")
    latency_sensitivity_supported: StrictBool = Field(description="Indicates whether the host supports latency sensitivity for the virtual machines.  ***Since:*** vSphere API 5.1 ", alias="latencySensitivitySupported")
    storage_policy_supported: Optional[StrictBool] = Field(default=None, description="Indicates that host supports Object-based Storage System and Storage-Profile based disk provisioning.  ***Since:*** vSphere API 5.5 ", alias="storagePolicySupported")
    accel3d_supported: StrictBool = Field(description="Indicates if 3D hardware acceleration for virtual machines is supported.  ***Since:*** vSphere API 5.1 ", alias="accel3dSupported")
    reliable_memory_aware: Optional[StrictBool] = Field(default=None, description="Indicates that this host uses a reliable memory aware allocation policy.  ***Since:*** vSphere API 5.5 ", alias="reliableMemoryAware")
    multiple_network_stack_instance_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the host supports Multiple Instance TCP/IP stack  ***Since:*** vSphere API 5.5 ", alias="multipleNetworkStackInstanceSupported")
    message_bus_proxy_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the message bus proxy is supported  ***Since:*** vSphere API 6.0 ", alias="messageBusProxySupported")
    vsan_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the host supports VSAN functionality.  See also *HostVsanSystem*.  ***Since:*** vSphere API 5.5 ", alias="vsanSupported")
    v_flash_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether the host supports vFlash.  ***Since:*** vSphere API 5.5 ", alias="vFlashSupported")
    host_access_manager_supported: Optional[StrictBool] = Field(default=None, description="Whether this host supports HostAccessManager for controlling direct access to the host and for better lockdown mode management.  ***Since:*** vSphere API 6.0 ", alias="hostAccessManagerSupported")
    provisioning_nic_selection_supported: StrictBool = Field(description="Indicates whether a dedicated nic can be selected for vSphere Provisioning NFC traffic.  ***Since:*** vSphere API 6.0 ", alias="provisioningNicSelectionSupported")
    nfs41_supported: Optional[StrictBool] = Field(default=None, description="Whether this host supports NFS41 file systems.  ***Since:*** vSphere API 6.0 ", alias="nfs41Supported")
    nfs41_krb5i_supported: Optional[StrictBool] = Field(default=None, description="Whether this host support NFS41 Kerberos 5\\* security type.  ***Since:*** vSphere API 6.5 ", alias="nfs41Krb5iSupported")
    turn_disk_locator_led_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether turning on/off local disk LED is supported on the host.  See also *HostStorageSystem.TurnDiskLocatorLedOn_Task*, *HostStorageSystem.TurnDiskLocatorLedOff_Task*.  ***Since:*** vSphere API 6.0 ", alias="turnDiskLocatorLedSupported")
    virtual_volume_datastore_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports VirtualVolume based Datastore.  ***Since:*** vSphere API 6.0 ", alias="virtualVolumeDatastoreSupported")
    mark_as_ssd_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether mark disk as SSD or Non-SSD is supported on the host.  See also *HostStorageSystem.MarkAsSsd_Task*, *HostStorageSystem.MarkAsNonSsd_Task*.  ***Since:*** vSphere API 6.0 ", alias="markAsSsdSupported")
    mark_as_local_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether mark disk as local or remote is supported on the host.  See also *HostStorageSystem.MarkAsLocal_Task*, *HostStorageSystem.MarkAsNonLocal_Task*.  ***Since:*** vSphere API 6.0 ", alias="markAsLocalSupported")
    smart_card_authentication_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports local two-factor user authentication using smart cards.  See also *HostActiveDirectoryAuthentication.EnableSmartCardAuthentication*.  ***Since:*** vSphere API 6.0 ", alias="smartCardAuthenticationSupported")
    p_mem_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports persistent memory.  If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 6.7 ", alias="pMemSupported")
    p_mem_snapshot_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports snapshots for VMs with virtual devices backed by persistent memory.  If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 6.7 ", alias="pMemSnapshotSupported")
    crypto_supported: Optional[StrictBool] = Field(default=None, description="Flag indicating whether Cryptographer feature is supported.  ***Since:*** vSphere API 6.5 ", alias="cryptoSupported")
    one_k_volume_apis_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports granular datastore cache update.  If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 6.5 ", alias="oneKVolumeAPIsSupported")
    gateway_on_nic_supported: Optional[StrictBool] = Field(default=None, description="Flag indicating whether default gateway can be configured on a vmkernel nic.  ***Since:*** vSphere API 6.5 ", alias="gatewayOnNicSupported")
    upit_supported: Optional[StrictBool] = Field(default=None, description="Deprecated as of vSphere API 8.0, and there is no replacement for it.  Indicate whether this host supports UPIT  ***Since:*** vSphere API 6.5 ", alias="upitSupported")
    cpu_hw_mmu_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports hardware-based MMU virtualization.  ***Since:*** vSphere API 6.5 ", alias="cpuHwMmuSupported")
    encrypted_v_motion_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypted vMotion.  ***Since:*** vSphere API 6.5 ", alias="encryptedVMotionSupported")
    encryption_change_on_add_remove_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports changing the encryption state of a virtual disk when the disk is being added or removed from a virtual machine configuration.  ***Since:*** vSphere API 6.5 ", alias="encryptionChangeOnAddRemoveSupported")
    encryption_hot_operation_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports changing the encryption state of a virtual machine, or virtual disk, while the virtual machine is powered on.  ***Since:*** vSphere API 6.5 ", alias="encryptionHotOperationSupported")
    encryption_with_snapshots_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports changing the encryption state state of a virtual machine, or virtual disk, while the virtual machine has snapshots present.  ***Since:*** vSphere API 6.5 ", alias="encryptionWithSnapshotsSupported")
    encryption_fault_tolerance_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports enabling Fault Tolerance on encrypted virtual machines.  ***Since:*** vSphere API 6.5 ", alias="encryptionFaultToleranceSupported")
    encryption_memory_save_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports suspending, or creating with-memory snapshots, encrypted virtual machines.  ***Since:*** vSphere API 6.5 ", alias="encryptionMemorySaveSupported")
    encryption_rdm_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypting RDM backed virtual disks.  ***Since:*** vSphere API 6.5 ", alias="encryptionRDMSupported")
    encryption_v_flash_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypting virtual disks with vFlash cache enabled.  ***Since:*** vSphere API 6.5 ", alias="encryptionVFlashSupported")
    encryption_cbrc_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypting virtual disks with Content Based Read Cache (digest disks) enabled.  ***Since:*** vSphere API 6.5 ", alias="encryptionCBRCSupported")
    encryption_hbr_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypting virtual disks with Host Based Replication enabled.  ***Since:*** vSphere API 6.5 ", alias="encryptionHBRSupported")
    ft_efi_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports Fault Tolerance VMs that have specified UEFI firmware.  ***Since:*** vSphere API 6.7 ", alias="ftEfiSupported")
    unmap_method_supported: Optional[StrictStr] = Field(default=None, description="Indicates which kind of VMFS unmap method is supported.  See *HostCapabilityUnmapMethodSupported_enum*  ***Since:*** vSphere API 6.7 ", alias="unmapMethodSupported")
    max_mem_mb_per_ft_vm: Optional[StrictInt] = Field(default=None, description="Indicates maximum memory allowed for Fault Tolerance virtual machine.  ***Since:*** vSphere API 6.7 ", alias="maxMemMBPerFtVm")
    virtual_mmu_usage_ignored: Optional[StrictBool] = Field(default=None, description="Indicates that *VirtualMachineFlagInfo.virtualMmuUsage* is ignored by the host, always operating as if \"on\" was selected.  ***Since:*** vSphere API 6.7 ", alias="virtualMmuUsageIgnored")
    virtual_exec_usage_ignored: Optional[StrictBool] = Field(default=None, description="Indicates that *VirtualMachineFlagInfo.virtualExecUsage* is ignored by the host, always operating as if \"hvOn\" was selected.  ***Since:*** vSphere API 6.7 ", alias="virtualExecUsageIgnored")
    vm_create_date_supported: Optional[StrictBool] = Field(default=None, description="Indicates that createDate feature is supported by the host.  ***Since:*** vSphere API 6.7 ", alias="vmCreateDateSupported")
    vmfs3_eol_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports VMFS-3 EOL.  If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 6.7 ", alias="vmfs3EOLSupported")
    ft_vmcp_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports VMCP for Fault Tolerance VMs.  ***Since:*** vSphere API 6.7 ", alias="ftVmcpSupported")
    quick_boot_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports the LoadESX feature which allows faster reboots.  See also *HostLoadEsxManager.QueryLoadEsxSupported*.  ***Since:*** vSphere API 6.7.1 ", alias="quickBootSupported")
    encrypted_ft_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports encrypted Fault Tolerance.  ***Since:*** vSphere API 7.0.2.0 ", alias="encryptedFtSupported")
    assignable_hardware_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports Assignable Hardware.  ***Since:*** vSphere API 7.0 ", alias="assignableHardwareSupported")
    suspend_to_memory_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports suspending virtual machines to memory.  ***Since:*** vSphere API 7.0.2.0 ", alias="suspendToMemorySupported")
    use_feature_reqs_for_old_hwv: Optional[StrictBool] = Field(default=None, description="Indicates whether this host uses vmFeatures for compatibility checking of old (&leq;8) virtual hardware version VMs.  ***Since:*** vSphere API 6.8.7 ", alias="useFeatureReqsForOldHWv")
    mark_perennially_reserved_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports marking specified LUN as perennially reserved.  ***Since:*** vSphere API 6.7.2 ", alias="markPerenniallyReservedSupported")
    hpp_psp_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports HPP path selection policy settings.  ***Since:*** vSphere API 7.0 ", alias="hppPspSupported")
    device_rebind_without_reboot_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether device rebind without reboot is supported.  This is the capability which enables PCI passthrough and SR-IOV configuration without reboot.  ***Since:*** vSphere API 7.0 ", alias="deviceRebindWithoutRebootSupported")
    storage_policy_change_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports storage policy change.  ***Since:*** vSphere API 7.0 ", alias="storagePolicyChangeSupported")
    precision_time_protocol_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports date time synchronization over Precision Time Protocol (PTP).  ***Since:*** vSphere API 7.0 ", alias="precisionTimeProtocolSupported")
    remote_device_v_motion_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether vMotion of a VM with remote devices attached is supported.  This applies to CD-ROM and floppy devices backed by a remote client.  ***Since:*** vSphere API 7.0 ", alias="remoteDeviceVMotionSupported")
    max_supported_vm_memory: Optional[StrictInt] = Field(default=None, description="The maximum amount of virtual memory supported per virtual machine.  If this capability is not set, the size is limited by hardware version of the virtual machine only.  ***Since:*** vSphere API 7.0 ", alias="maxSupportedVmMemory")
    ah_device_hints_supported: Optional[StrictBool] = Field(default=None, description="Indicates if the host supports Assignable Hardware device hints.  ***Since:*** vSphere API 7.0.2.0 ", alias="ahDeviceHintsSupported")
    nvme_over_tcp_supported: Optional[StrictBool] = Field(default=None, description="Indicates if access to NVMe over TCP devices is supported.  ***Since:*** vSphere API 7.0.3.0 ", alias="nvmeOverTcpSupported")
    nvme_storage_fabric_services_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether NVMe Storage Fabrics Services (StFS) are supported.  ***Since:*** vSphere API 7.0.3.0 ", alias="nvmeStorageFabricServicesSupported")
    assign_hw_pci_config_supported: Optional[StrictBool] = Field(default=None, description="Indicates if setting hardwareLabel using PciPassThrough is supported.  ***Since:*** vSphere API 7.0.2.0 ", alias="assignHwPciConfigSupported")
    time_config_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether advanced timekeeping apis are supported  ***Since:*** vSphere API 7.0.3.0 ", alias="timeConfigSupported")
    nvme_batch_operations_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether batch NVMe controller connection/disconnection is supported.  See *HostStorageSystem.ConnectNvmeControllerEx_Task* and *HostStorageSystem.DisconnectNvmeControllerEx_Task*.  ***Since:*** vSphere API 7.0.3.0 ", alias="nvmeBatchOperationsSupported")
    p_mem_failover_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports failover for VMs with virtual devices backed by persistent memory.  If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 7.0.2.0 ", alias="pMemFailoverSupported")
    host_config_encryption_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports host configuration encryption.  ***Since:*** vSphere API 7.0.2.0 ", alias="hostConfigEncryptionSupported")
    max_supported_simultaneous_threads: Optional[StrictInt] = Field(default=None, description="Max supported number of SMT (Simultaneous multithreading) threads.  If value is not specified, it should be considered as not supported. ", alias="maxSupportedSimultaneousThreads")
    ptp_config_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports PTP (Precision Time Protocol) service configuration.  See *HostPtpConfig*. If value is not specified, it should be considered as not supported.  ***Since:*** vSphere API 7.0.3.0 ", alias="ptpConfigSupported")
    max_supported_ptp_ports: Optional[StrictInt] = Field(default=None, description="Number of PTP (Precision Time Protocol) ports supported by this host (See *HostPtpConfig*).  If this capability is not set, number of PTP ports in the host is 0.  ***Since:*** vSphere API 7.0.3.0 ", alias="maxSupportedPtpPorts")
    sgx_registration_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports SGX registration. ", alias="sgxRegistrationSupported")
    p_mem_independent_snapshot_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this host supports snapshots of VMs configured with independent vNVDIMMs.  If value is not specified, it should be considered as not supported. This support does not depend on *HostCapability.pMemSnapshotSupported*.  ***Since:*** vSphere API 7.0.3.0 ", alias="pMemIndependentSnapshotSupported")
    iommu_sl_dirty_capable: Optional[StrictBool] = Field(default=None, description="Indicates whether this host's IOMMUs are capable of tracking pages written by device DMAs using dirty bits in the second-level page tables.  If this value is not specified, it should be considered as not capable. ", alias="iommuSLDirtyCapable")
    vmknic_binding_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether vmknic binding is supported over this host. ", alias="vmknicBindingSupported")
    ultralow_fixed_unmap_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether ultralow fixed unmap bandwidth is supported on this host. ", alias="ultralowFixedUnmapSupported")
    nvme_vvol_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether mounting of NVMe vvol is supported on this host. ", alias="nvmeVvolSupported")
    fpt_hotplug_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether FPT Hotplug is supported on this host. ", alias="fptHotplugSupported")
    mconnect_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether MCONNECT is supported on this host. ", alias="mconnectSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostCapability from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostCapability from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


