# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostCertificateManagerCertificateInfo(DataObject):
    """
    This data object is used to encapsulate the X509 certificate metadata.  ***Since:*** vSphere API 6.0 
    """ # noqa: E501
    kind: Optional[StrictStr] = Field(default=None, description="Certificate kind, if unset the certificate is Machine certificate The list of supported values can be found in *HostCertificateManagerCertificateKind_enum* ")
    issuer: Optional[StrictStr] = Field(default=None, description="The issuer of the certificate.  ***Since:*** vSphere API 6.0 ")
    not_before: Optional[datetime] = Field(default=None, description="The validity of the certificate.  ***Since:*** vSphere API 6.0 ", alias="notBefore")
    not_after: Optional[datetime] = Field(default=None, alias="notAfter")
    subject: Optional[StrictStr] = Field(default=None, description="The subject of the certificate.  ***Since:*** vSphere API 6.0 ")
    status: StrictStr = Field(description="The status of the certificate in vCenter Server.  The possible values for status are as described in *HostCertificateManagerCertificateInfoCertificateStatus_enum*. If queried directly from an ESX host, the property is set to *unknown*.  ***Since:*** vSphere API 6.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostCertificateManagerCertificateInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostCertificateManagerCertificateInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


