# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_file_system_mount_info import HostFileSystemMountInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostFileSystemVolumeInfo(DataObject):
    """
    The *HostFileSystemVolumeInfo* data object describes the file system volume information for the host.  A file system volume refers to a storage abstraction that allows files to be created and organized. A host can have multiple file system volumes. File system volumes are typically mounted into a file namespace that allows all files in mounted file systems to be addressable from the host.  A file system volume is backed by disk storage. It could span one or more disks but need not use an entire disk.  A file system volume by definition must be mounted on the file system in order to exist. 
    """ # noqa: E501
    volume_type_list: Optional[List[StrictStr]] = Field(default=None, description="The list of supported file system volume types. ", alias="volumeTypeList")
    mount_info: Optional[List[HostFileSystemMountInfo]] = Field(default=None, description="The list of file system volumes mounted on the host. ", alias="mountInfo")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostFileSystemVolumeInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostFileSystemVolumeInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


