# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.host_host_bus_adapter import HostHostBusAdapter
from vmware_vi.models.host_internet_scsi_hba_authentication_capabilities import HostInternetScsiHbaAuthenticationCapabilities
from vmware_vi.models.host_internet_scsi_hba_authentication_properties import HostInternetScsiHbaAuthenticationProperties
from vmware_vi.models.host_internet_scsi_hba_digest_capabilities import HostInternetScsiHbaDigestCapabilities
from vmware_vi.models.host_internet_scsi_hba_digest_properties import HostInternetScsiHbaDigestProperties
from vmware_vi.models.host_internet_scsi_hba_discovery_capabilities import HostInternetScsiHbaDiscoveryCapabilities
from vmware_vi.models.host_internet_scsi_hba_discovery_properties import HostInternetScsiHbaDiscoveryProperties
from vmware_vi.models.host_internet_scsi_hba_ip_capabilities import HostInternetScsiHbaIPCapabilities
from vmware_vi.models.host_internet_scsi_hba_ip_properties import HostInternetScsiHbaIPProperties
from vmware_vi.models.host_internet_scsi_hba_network_binding_support_type_enum import HostInternetScsiHbaNetworkBindingSupportTypeEnum
from vmware_vi.models.host_internet_scsi_hba_param_value import HostInternetScsiHbaParamValue
from vmware_vi.models.host_internet_scsi_hba_send_target import HostInternetScsiHbaSendTarget
from vmware_vi.models.host_internet_scsi_hba_static_target import HostInternetScsiHbaStaticTarget
from vmware_vi.models.option_def import OptionDef
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostInternetScsiHba(HostHostBusAdapter):
    """
    This data object type describes the iSCSI host bus adapter interface. 
    """ # noqa: E501
    is_software_based: StrictBool = Field(description="True if this host bus adapter is a software based initiator utilizing the hosting system's existing TCP/IP network connection ", alias="isSoftwareBased")
    can_be_disabled: Optional[StrictBool] = Field(default=None, description="Can this adapter be disabled  ***Since:*** vSphere API 5.0 ", alias="canBeDisabled")
    network_binding_support: Optional[HostInternetScsiHbaNetworkBindingSupportTypeEnum] = Field(default=None, alias="networkBindingSupport")
    discovery_capabilities: HostInternetScsiHbaDiscoveryCapabilities = Field(alias="discoveryCapabilities")
    discovery_properties: HostInternetScsiHbaDiscoveryProperties = Field(alias="discoveryProperties")
    authentication_capabilities: HostInternetScsiHbaAuthenticationCapabilities = Field(alias="authenticationCapabilities")
    authentication_properties: HostInternetScsiHbaAuthenticationProperties = Field(alias="authenticationProperties")
    digest_capabilities: Optional[HostInternetScsiHbaDigestCapabilities] = Field(default=None, alias="digestCapabilities")
    digest_properties: Optional[HostInternetScsiHbaDigestProperties] = Field(default=None, alias="digestProperties")
    ip_capabilities: HostInternetScsiHbaIPCapabilities = Field(alias="ipCapabilities")
    ip_properties: HostInternetScsiHbaIPProperties = Field(alias="ipProperties")
    supported_advanced_options: Optional[List[OptionDef]] = Field(default=None, description="A list of supported key/value pair advanced options for the host bus adapter including their type information.  ***Since:*** vSphere API 4.0 ", alias="supportedAdvancedOptions")
    advanced_options: Optional[List[HostInternetScsiHbaParamValue]] = Field(default=None, description="A list of the current options settings for the host bus adapter.  ***Since:*** vSphere API 4.0 ", alias="advancedOptions")
    i_scsi_name: StrictStr = Field(description="The iSCSI name of this host bus adapter. ", alias="iScsiName")
    i_scsi_alias: Optional[StrictStr] = Field(default=None, description="The iSCSI alias of this host bus adapter. ", alias="iScsiAlias")
    configured_send_target: Optional[List[HostInternetScsiHbaSendTarget]] = Field(default=None, description="The configured iSCSI send target entries. ", alias="configuredSendTarget")
    configured_static_target: Optional[List[HostInternetScsiHbaStaticTarget]] = Field(default=None, description="The configured iSCSI static target entries. ", alias="configuredStaticTarget")
    max_speed_mb: Optional[StrictInt] = Field(default=None, description="The maximum supported link speed of the port in megabits per second. ", alias="maxSpeedMb")
    current_speed_mb: Optional[StrictInt] = Field(default=None, description="The Current operating link speed of the port in megabits per second. ", alias="currentSpeedMb")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostInternetScsiHba from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostInternetScsiHba from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


