# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import SecretStr, StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostInternetScsiHbaAuthenticationProperties(DataObject):
    """
    The authentication settings for this host bus adapter or target. 
    """ # noqa: E501
    chap_auth_enabled: StrictBool = Field(description="True if CHAP is currently enabled ", alias="chapAuthEnabled")
    chap_name: Optional[StrictStr] = Field(default=None, description="The CHAP user name if enabled ", alias="chapName")
    chap_secret: Optional[SecretStr] = Field(default=None, description="The CHAP secret if enabled ", alias="chapSecret")
    chap_authentication_type: Optional[StrictStr] = Field(default=None, description="The preference for CHAP or non-CHAP protocol if CHAP is enabled  ***Since:*** vSphere API 4.0 ", alias="chapAuthenticationType")
    chap_inherited: Optional[StrictBool] = Field(default=None, description="CHAP settings are inherited  ***Since:*** vSphere API 4.0 ", alias="chapInherited")
    mutual_chap_name: Optional[StrictStr] = Field(default=None, description="When Mutual-CHAP is enabled, the user name that target needs to use to authenticate with the initiator  ***Since:*** vSphere API 4.0 ", alias="mutualChapName")
    mutual_chap_secret: Optional[SecretStr] = Field(default=None, description="When Mutual-CHAP is enabled, the secret that target needs to use to authenticate with the initiator  ***Since:*** vSphere API 4.0 ", alias="mutualChapSecret")
    mutual_chap_authentication_type: Optional[StrictStr] = Field(default=None, description="The preference for CHAP or non-CHAP protocol if CHAP is enabled  ***Since:*** vSphere API 4.0 ", alias="mutualChapAuthenticationType")
    mutual_chap_inherited: Optional[StrictBool] = Field(default=None, description="Mutual-CHAP settings are inherited  ***Since:*** vSphere API 4.0 ", alias="mutualChapInherited")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostInternetScsiHbaAuthenticationProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostInternetScsiHbaAuthenticationProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


