# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostInternetScsiHbaDiscoveryProperties(DataObject):
    """
    The discovery settings for this host bus adapter.  At least one discovery mode must always be active. Multiple modes may be active at the same time. 
    """ # noqa: E501
    i_sns_discovery_enabled: StrictBool = Field(description="True if iSNS is currently enabled ", alias="iSnsDiscoveryEnabled")
    i_sns_discovery_method: Optional[StrictStr] = Field(default=None, description="The iSNS discovery method in use when iSNS is enabled.  Must be one of the values of *InternetScsiSnsDiscoveryMethod_enum* ", alias="iSnsDiscoveryMethod")
    i_sns_host: Optional[StrictStr] = Field(default=None, description="For STATIC iSNS, this is the iSNS server address ", alias="iSnsHost")
    slp_discovery_enabled: StrictBool = Field(description="True if SLP is enabled ", alias="slpDiscoveryEnabled")
    slp_discovery_method: Optional[StrictStr] = Field(default=None, description="The current SLP discovery method when SLP is enabled.  Must be one of the values of *SlpDiscoveryMethod_enum* ", alias="slpDiscoveryMethod")
    slp_host: Optional[StrictStr] = Field(default=None, description="When the SLP discovery method is set to MANUAL, this property reflects the hostname, and optionally port number of the SLP DA. ", alias="slpHost")
    static_target_discovery_enabled: StrictBool = Field(description="True if static target discovery is enabled ", alias="staticTargetDiscoveryEnabled")
    send_targets_discovery_enabled: StrictBool = Field(description="True if send targets discovery is enabled ", alias="sendTargetsDiscoveryEnabled")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostInternetScsiHbaDiscoveryProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostInternetScsiHbaDiscoveryProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


