# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_internet_scsi_hba_authentication_properties import HostInternetScsiHbaAuthenticationProperties
from vmware_vi.models.host_internet_scsi_hba_digest_properties import HostInternetScsiHbaDigestProperties
from vmware_vi.models.host_internet_scsi_hba_param_value import HostInternetScsiHbaParamValue
from vmware_vi.models.option_def import OptionDef
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostInternetScsiHbaSendTarget(DataObject):
    """
    The iSCSI send target. 
    """ # noqa: E501
    address: StrictStr = Field(description="The IP address or hostname of the storage device. ")
    port: Optional[StrictInt] = Field(default=None, description="The TCP port of the storage device.  If not specified, the standard default of 3260 is used. ")
    authentication_properties: Optional[HostInternetScsiHbaAuthenticationProperties] = Field(default=None, alias="authenticationProperties")
    digest_properties: Optional[HostInternetScsiHbaDigestProperties] = Field(default=None, alias="digestProperties")
    supported_advanced_options: Optional[List[OptionDef]] = Field(default=None, description="A list of supported key/value pair advanced options for the host bus adapter including their type information.  ***Since:*** vSphere API 4.0 ", alias="supportedAdvancedOptions")
    advanced_options: Optional[List[HostInternetScsiHbaParamValue]] = Field(default=None, description="A list of the current options settings for the host bus adapter.  ***Since:*** vSphere API 4.0 ", alias="advancedOptions")
    parent: Optional[StrictStr] = Field(default=None, description="The device name of the host bus adapter from which settings can be inherited.  ***Since:*** vSphere API 4.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostInternetScsiHbaSendTarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostInternetScsiHbaSendTarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


