# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostIpRouteEntry(DataObject):
    """
    IpRouteEntry.  Routing entries are individual static routes which combined with the default route form all of the routing rules for a host.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    network: StrictStr = Field(description="Network of the routing entry Of the format \"10.20.120.0\" or \"2001:db8::1428:57\"  ***Since:*** vSphere API 4.0 ")
    prefix_length: StrictInt = Field(description="Prefix length of the network (this is the 22 in 10.20.120.0/22)  ***Since:*** vSphere API 4.0 ", alias="prefixLength")
    gateway: StrictStr = Field(description="Gateway for the routing entry  ***Since:*** vSphere API 4.0 ")
    device_name: Optional[StrictStr] = Field(default=None, description="If available the property indicates the device associated with the routing entry.  This property can only be read from the server. It will be ignored if set by the client.  ***Since:*** vSphere API 4.1 ", alias="deviceName")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostIpRouteEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostIpRouteEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


