# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.fault_tolerance_config_info import FaultToleranceConfigInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostLowLevelProvisioningManagerVmRecoveryInfo(DataObject):
    """
    Virtual machine information that can be used for recovery, for example, to decide whether to register a virtual machine with a server if the virtual machine is currently unregistered.  This data object does not contain a complete virtual machine configuration, but a subset of information available from *VirtualMachineConfigInfo*, all of which are available via virtual machine configuration files.  The documentation for each property in this data object describes the property in *VirtualMachineConfigInfo* that contains the same information if available.  ***Since:*** vSphere API 5.1 
    """ # noqa: E501
    version: StrictStr = Field(description="The hardware version of this virtual machine.  Same as *VirtualMachineConfigInfo.version*.  ***Since:*** vSphere API 5.1 ")
    bios_uuid: StrictStr = Field(description="128-bit SMBIOS UUID of this virtual machine.  Same as *VirtualMachineConfigInfo.uuid*.  ***Since:*** vSphere API 5.1 ", alias="biosUUID")
    instance_uuid: StrictStr = Field(description="VirtualCenter-specific 128-bit UUID of this virtual machine.  Same as *VirtualMachineConfigInfo.instanceUuid*.  ***Since:*** vSphere API 5.1 ", alias="instanceUUID")
    ft_info: Optional[FaultToleranceConfigInfo] = Field(default=None, alias="ftInfo")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostLowLevelProvisioningManagerVmRecoveryInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostLowLevelProvisioningManagerVmRecoveryInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


