# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostMountInfo(DataObject):
    """
    The *HostMountInfo* data object provides information related to a configured mount point.  This object does not include information about the mounted file system. (See *HostFileSystemMountInfo*.) 
    """ # noqa: E501
    path: Optional[StrictStr] = Field(default=None, description="Local file path where file system volume is mounted, if applicable.  This path identifies the file system volume from the point of view of the host. ")
    access_mode: StrictStr = Field(description="Access mode to the underlying file system for this host. ", alias="accessMode")
    mounted: Optional[StrictBool] = Field(default=None, description="The mount state of this mount point.  For a discovered volume, which is mounted, this is true. When this value is unset, the default value is true.  ***Since:*** vSphere API 5.0 ")
    accessible: Optional[StrictBool] = Field(default=None, description="Flag that indicates if the datastore is currently accessible from the host.  For the case of a standalone host, this property has the same value as *DatastoreSummary*.*DatastoreSummary.accessible*. You can use the *DatastoreSummary* property if the *HostMountInfo* property is not set. The VirtualCenter Server will always make sure the *DatastoreSummary* property is set correctly.  ***Since:*** VI API 2.5 ")
    inaccessible_reason: Optional[StrictStr] = Field(default=None, description="This optional property for inaccessible reason is reported only if a datastore becomes inaccessible as reported by *HostMountInfo.accessible* and *DatastoreSummary*.*DatastoreSummary.accessible*.  The values for inaccessible reason are defined in the enum *HostMountInfoInaccessibleReason_enum* This helps to determine host specific reason for datastore inaccessibility. If the datastore becomes accessible following an inaccessible condition, the property *HostMountInfo.inaccessibleReason* will be unset.  ***Since:*** vSphere API 5.1 ", alias="inaccessibleReason")
    vmknic_name: Optional[StrictStr] = Field(default=None, description="The name of the vmknic used during mount.  Populated by the vmk control layer if the NAS volume is mounted successfully with a vmknic binding. ", alias="vmknicName")
    vmknic_active: Optional[StrictBool] = Field(default=None, description="Indicates whether vmknic is active or inactive.  This field will be populated by vmk control layer during NAS volume mount, and will be set to true if the vmknic binding is active. ", alias="vmknicActive")
    mount_failed_reason: Optional[StrictStr] = Field(default=None, description="The optional property which gives the reason for mount operation failure of NFS datastore.  This field is applicable for only those mounts for which retry mount operation is configured. The values for the mount failed reason are defined in the enum *HostMountInfoMountFailedReason_enum*. If mount operation on NFS volume succeeds in the retry, then the property *HostMountInfo.mountFailedReason* will be unset. ", alias="mountFailedReason")
    num_tcp_connections: Optional[StrictInt] = Field(default=None, description="Maintained for each Host, it indicates the total number of TCP connections for the NAS datastore ", alias="numTcpConnections")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostMountInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostMountInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


