# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.host_multipath_info_logical_unit_policy import HostMultipathInfoLogicalUnitPolicy
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostMultipathInfoHppLogicalUnitPolicy(HostMultipathInfoLogicalUnitPolicy):
    """
    The *HostMultipathInfoHppLogicalUnitPolicy* data object describes a multipathing policy for a HPP claimed logical unit and its configuration.  ***Since:*** vSphere API 7.0 
    """ # noqa: E501
    bytes: Optional[StrictInt] = Field(default=None, description="Byte count on the paths will be used as criteria to switch path for the device.  Allowed values 1 to (100\\*1024\\*1024) Default Value 10\\*1024\\*1024  ***Since:*** vSphere API 7.0 ")
    iops: Optional[StrictInt] = Field(default=None, description="IOPS count on the paths will be used as criteria to switch path for the device.  Allowed values 1 to 10000 Default Value 1000  ***Since:*** vSphere API 7.0 ")
    path: Optional[StrictStr] = Field(default=None, description="The preferred path for the given device.  If no prefered path is specified by the user, algorithem at ESX side will choose the random possible path.  ***Since:*** vSphere API 7.0 ")
    latency_eval_time: Optional[StrictInt] = Field(default=None, description="This value can control at what interval (in ms) the latency of paths should be evaluated.  Allowed values 10000 to (300 \\* 1000) in ms Default Value 30 \\* 1000  ***Since:*** vSphere API 7.0 ", alias="latencyEvalTime")
    sampling_ios_per_path: Optional[StrictInt] = Field(default=None, description="This value will control how many sample IOs should be issued on each path to calculate latency of the path.  Allowed values 16 to 160 Default Value 16  ***Since:*** vSphere API 7.0 ", alias="samplingIosPerPath")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostMultipathInfoHppLogicalUnitPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostMultipathInfoHppLogicalUnitPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


