# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostNatServiceNameServiceSpec(DataObject):
    """
    This data object type specifies the information for the name servers.  ***Since:*** VI API 2.5 
    """ # noqa: E501
    dns_auto_detect: StrictBool = Field(description="The flag to indicate whether or not the DNS server should be automatically detected or specified explicitly.  ***Since:*** VI API 2.5 ", alias="dnsAutoDetect")
    dns_policy: StrictStr = Field(description="The policy to use when multiple DNS addresses are available on the host.  ***Since:*** VI API 2.5 ", alias="dnsPolicy")
    dns_retries: StrictInt = Field(description="The number of retries before giving up on a DNS request from a virtual network.  ***Since:*** VI API 2.5 ", alias="dnsRetries")
    dns_timeout: StrictInt = Field(description="The time (in seconds) before retrying a DNS request to an external network.  ***Since:*** VI API 2.5 ", alias="dnsTimeout")
    dns_name_server: Optional[List[StrictStr]] = Field(default=None, description="The list of DNS servers.  ***Since:*** VI API 2.5 ", alias="dnsNameServer")
    nbds_timeout: StrictInt = Field(description="The time (in seconds) allotted for queries to the NetBIOS Datagram Server (NBDS).  ***Since:*** VI API 2.5 ", alias="nbdsTimeout")
    nbns_retries: StrictInt = Field(description="Number of retries for each query to the NBNS.  ***Since:*** VI API 2.5 ", alias="nbnsRetries")
    nbns_timeout: StrictInt = Field(description="The time (in seconds) allotted for queries to the NBNS.  ***Since:*** VI API 2.5 ", alias="nbnsTimeout")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostNatServiceNameServiceSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostNatServiceNameServiceSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


