# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_host_bus_adapter import HostHostBusAdapter
from vmware_vi.models.host_nvme_controller import HostNvmeController
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostNvmeTopologyInterface(DataObject):
    """
    This data object describes the NVME interface that is associated with a list of connected NVME controllers.  ***Since:*** vSphere API 7.0 
    """ # noqa: E501
    key: StrictStr = Field(description="The identifier for the NVME interface.  ***Since:*** vSphere API 7.0 ")
    adapter: HostHostBusAdapter
    connected_controller: Optional[List[HostNvmeController]] = Field(default=None, description="The list of connected NVME controllers.  This list can be empty if am NVME interface is not connected to any controllers. Each NvmeController object contains a list of its attached NVME namespaces in *HostNvmeController.attachedNamespace*.  ***Since:*** vSphere API 7.0 ", alias="connectedController")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostNvmeTopologyInterface from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostNvmeTopologyInterface from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


