# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_plug_store_topology_device import HostPlugStoreTopologyDevice
from vmware_vi.models.host_plug_store_topology_path import HostPlugStoreTopologyPath
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostPlugStoreTopologyPlugin(DataObject):
    """
    This data object type represents a Plugin in the plug store architecture.  A Plugin claims a set of paths and groups them into Devices.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    key: StrictStr = Field(description="The identifier of the plugin.  ***Since:*** vSphere API 4.0 ")
    name: StrictStr = Field(description="The name of the plugin.  ***Since:*** vSphere API 4.0 ")
    device: Optional[List[HostPlugStoreTopologyDevice]] = Field(default=None, description="The set of devices formed by this plugin.  ***Since:*** vSphere API 4.0 ")
    claimed_path: Optional[List[HostPlugStoreTopologyPath]] = Field(default=None, description="The set of paths claimed by this plugin.  Not every claimed path will necessarily appear as part of a Device. Claimed paths will only appear under Devices if the device identifier of the path matches up with the device identifier exposed by the Device.  ***Since:*** vSphere API 4.0 ", alias="claimedPath")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostPlugStoreTopologyPlugin from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostPlugStoreTopologyPlugin from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


