# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_network_policy import HostNetworkPolicy
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostPortGroupSpec(DataObject):
    """
    This data object type describes the PortGroup specification representing the properties on a PortGroup that can be configured. 
    """ # noqa: E501
    name: StrictStr = Field(description="The name of the port group. ")
    vlan_id: StrictInt = Field(description="The VLAN ID for ports using this port group.  Possible values: - A value of 0 specifies that you do not want the port group associated   with a VLAN. - A value from 1 to 4094 specifies a VLAN ID for the port group. - A value of 4095 specifies that the port group should use trunk mode,   which allows the guest operating system to manage its own VLAN tags. ", alias="vlanId")
    vswitch_name: StrictStr = Field(description="The identifier of the virtual switch on which this port group is located. ", alias="vswitchName")
    policy: HostNetworkPolicy
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostPortGroupSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostPortGroupSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


