# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_apply_profile import HostApplyProfile
from vmware_vi.models.localizable_message import LocalizableMessage
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostProfileManagerCompositionValidationResultResultElement(DataObject):
    """
    The host profile composition validation result for a specific target host profile.  ***Since:*** vSphere API 6.5 
    """ # noqa: E501
    target: ManagedObjectReference
    status: StrictStr = Field(description="The composition validation status.  See *HostProfileManagerCompositionValidationResultResultElementStatus_enum* for details of supported values.  ***Since:*** vSphere API 6.5 ")
    errors: Optional[List[LocalizableMessage]] = Field(default=None, description="The composition validation errors.  ***Since:*** vSphere API 6.5 ")
    source_diff_for_to_be_merged: Optional[HostApplyProfile] = Field(default=None, alias="sourceDiffForToBeMerged")
    target_diff_for_to_be_merged: Optional[HostApplyProfile] = Field(default=None, alias="targetDiffForToBeMerged")
    to_be_added: Optional[HostApplyProfile] = Field(default=None, alias="toBeAdded")
    to_be_deleted: Optional[HostApplyProfile] = Field(default=None, alias="toBeDeleted")
    to_be_disabled: Optional[HostApplyProfile] = Field(default=None, alias="toBeDisabled")
    to_be_enabled: Optional[HostApplyProfile] = Field(default=None, alias="toBeEnabled")
    to_be_reenable_cc: Optional[HostApplyProfile] = Field(default=None, alias="toBeReenableCC")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostProfileManagerCompositionValidationResultResultElement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostProfileManagerCompositionValidationResultResultElement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


