# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_apply_profile import HostApplyProfile
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.method_fault import MethodFault
from vmware_vi.models.profile_update_failed_update_failure import ProfileUpdateFailedUpdateFailure
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostProfileValidationFailureInfo(DataObject):
    """
    This defines the validation result for the host profile.  ***Since:*** vSphere API 6.7 
    """ # noqa: E501
    name: StrictStr = Field(description="The name of host profile to be validated.  ***Since:*** vSphere API 6.7 ")
    annotation: StrictStr = Field(description="Host profile annotation at update.  ***Since:*** vSphere API 6.7 ")
    update_type: StrictStr = Field(description="Host profile update type.  See the enumerate class <code>UpdateType</code> above for the valid values.  ***Since:*** vSphere API 6.7 ", alias="updateType")
    host: Optional[ManagedObjectReference] = None
    apply_profile: Optional[HostApplyProfile] = Field(default=None, alias="applyProfile")
    failures: Optional[List[ProfileUpdateFailedUpdateFailure]] = Field(default=None, description="List of failures in the host profile configuration.  ***Since:*** vSphere API 6.7 ")
    faults: Optional[List[MethodFault]] = Field(default=None, description="The <code>MethodFault</code>s happened at validation.  ***Since:*** vSphere API 6.7 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostProfileValidationFailureInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostProfileValidationFailureInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


