# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_ip_config import HostIpConfig
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostPtpConfigPtpPort(DataObject):
    """
    Configuration of a PTP port, a logical entity providing an interface to the network for sending and receiving PTP messages with timestamping.  ***Since:*** vSphere API 7.0.3.0 
    """ # noqa: E501
    index: StrictInt = Field(description="Index into the list of PTP ports.  Supported values are in the range 0 through *HostCapability.maxSupportedPtpPorts*-1.  ***Since:*** vSphere API 7.0.3.0 ")
    device_type: Optional[StrictStr] = Field(default=None, description="Type of network device to be used with this port.  See *HostPtpConfigDeviceType_enum* for supported values. A device type of *none* indicates that this port is inactive.  ***Since:*** vSphere API 7.0.3.0 ", alias="deviceType")
    device: Optional[StrictStr] = Field(default=None, description="Name of PTP capable network device to be used with this port.  Supported values depend on the type of network device used. For *virtualNic* this field is the name of a valid virtual NIC. See *HostVirtualNic*. For *pciPassthruNic* this field is a valid PCI device ID composed of \"bus:slot.function\", enabled for PCI passthru. See *HostPciPassthruInfo*. For *none* this field is ignored.  ***Since:*** vSphere API 7.0.3.0 ")
    ip_config: Optional[HostIpConfig] = Field(default=None, alias="ipConfig")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostPtpConfigPtpPort from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostPtpConfigPtpPort from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


