# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_service_source_package import HostServiceSourcePackage
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostService(DataObject):
    """
    Data object that describes a single service that runs on the host. 
    """ # noqa: E501
    key: StrictStr = Field(description="Brief identifier for the service. ")
    label: StrictStr = Field(description="Display label for the service. ")
    required: StrictBool = Field(description="Flag indicating whether the service is required and cannot be disabled. ")
    uninstallable: StrictBool = Field(description="Deprecated this flag is unimplemented and will always be set to false.  Flag indicating whether the service can be uninstalled. ")
    running: StrictBool = Field(description="Flag indicating whether the service is currently running. ")
    ruleset: Optional[List[StrictStr]] = Field(default=None, description="List of firewall rulesets used by this service.  Must come from the list of rulesets in *HostFirewallInfo.ruleset*. ")
    policy: StrictStr = Field(description="Service activation policy.  See also *HostServicePolicy_enum*. ")
    source_package: Optional[HostServiceSourcePackage] = Field(default=None, alias="sourcePackage")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostService from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostService from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


