# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostSharedGpuCapabilities(DataObject):
    """
    Capability vector indicating the available shared graphics features.  ***Since:*** vSphere API 6.7 
    """ # noqa: E501
    vgpu: StrictStr = Field(description="Name of a particular VGPU available as a shared GPU device.  See also *VirtualMachinePciSharedGpuPassthroughInfo*.  ***Since:*** vSphere API 6.7 ")
    disk_snapshot_supported: StrictBool = Field(description="Indicates whether the GPU plugin on this host is capable of disk-only snapshots when VM is not powered off.  Disk Snaphosts on powered off VM are always supported.  ***Since:*** vSphere API 6.7 ", alias="diskSnapshotSupported")
    memory_snapshot_supported: StrictBool = Field(description="Indicates whether the GPU plugin on this host is capable of memory snapshots.  ***Since:*** vSphere API 6.7 ", alias="memorySnapshotSupported")
    suspend_supported: StrictBool = Field(description="Indicates whether the GPU plugin on this host is capable of suspend-resume.  ***Since:*** vSphere API 6.7 ", alias="suspendSupported")
    migrate_supported: StrictBool = Field(description="Indicates whether the GPU plugin on this host is capable of migration.  ***Since:*** vSphere API 6.7 ", alias="migrateSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostSharedGpuCapabilities from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostSharedGpuCapabilities from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


