# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_host_bus_adapter import HostHostBusAdapter
from vmware_vi.models.host_multipath_info import HostMultipathInfo
from vmware_vi.models.host_nvme_topology import HostNvmeTopology
from vmware_vi.models.host_plug_store_topology import HostPlugStoreTopology
from vmware_vi.models.host_scsi_topology import HostScsiTopology
from vmware_vi.models.scsi_lun import ScsiLun
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostStorageDeviceInfo(DataObject):
    """
    This data object type describes the storage subsystem configuration. 
    """ # noqa: E501
    host_bus_adapter: Optional[List[HostHostBusAdapter]] = Field(default=None, description="The list of host bus adapters available on the host. ", alias="hostBusAdapter")
    scsi_lun: Optional[List[ScsiLun]] = Field(default=None, description="The list of SCSI logical units available on the host. ", alias="scsiLun")
    scsi_topology: Optional[HostScsiTopology] = Field(default=None, alias="scsiTopology")
    nvme_topology: Optional[HostNvmeTopology] = Field(default=None, alias="nvmeTopology")
    multipath_info: Optional[HostMultipathInfo] = Field(default=None, alias="multipathInfo")
    plug_store_topology: Optional[HostPlugStoreTopology] = Field(default=None, alias="plugStoreTopology")
    software_internet_scsi_enabled: StrictBool = Field(description="Indicates if the software iSCSI initiator is enabled on this system ", alias="softwareInternetScsiEnabled")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostStorageDeviceInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostStorageDeviceInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


