# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostVMotionManagerSrcInstantCloneResult(DataObject):
    """
    The result of an InstantClone InitiateSource task.  Contains the timestamp value at the time of different operations.  ***Since:*** vSphere API 7.0 
    """ # noqa: E501
    start_time: Optional[StrictInt] = Field(default=None, description="Time stamp at the start of the InstantClone operation at the source VM.  ***Since:*** vSphere API 7.0 ", alias="startTime")
    quiesce_time: Optional[StrictInt] = Field(default=None, description="Time stamp when the source VM enters quiesce state.  ***Since:*** vSphere API 7.0 ", alias="quiesceTime")
    quiesce_done_time: Optional[StrictInt] = Field(default=None, description="Time stamp when the source VM successfully quiesces.  ***Since:*** vSphere API 7.0 ", alias="quiesceDoneTime")
    resume_done_time: Optional[StrictInt] = Field(default=None, description="Time stamp when the source VM completes resuming.  ***Since:*** vSphere API 7.0 ", alias="resumeDoneTime")
    end_time: Optional[StrictInt] = Field(default=None, description="Time stamp when the migration completes on the source VM.  ***Since:*** vSphere API 7.0 ", alias="endTime")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostVMotionManagerSrcInstantCloneResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostVMotionManagerSrcInstantCloneResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


