# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.distributed_virtual_switch_port_connection import DistributedVirtualSwitchPortConnection
from vmware_vi.models.host_virtual_nic_opaque_network_spec import HostVirtualNicOpaqueNetworkSpec
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostVirtualNicConnection(DataObject):
    """
    DataObject which provides a level of indirection when identifying VirtualNics during configuration.  This dataObject lets users specify a VirtualNic in terms of the portgroup/Dv Port the Virtual NIC is connected to. This is useful in cases where VirtualNic will be created as part of a configuration operation and the created VirtualNic is referred to in some other part of configuration. e.g: for configuring VMotion  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    portgroup: Optional[StrictStr] = Field(default=None, description="Name of the portgroup to which the virtual nic is connected to.  If this parameter is set, use a virtual nic connected to a legacy portgroup.  ***Since:*** vSphere API 4.0 ")
    dv_port: Optional[DistributedVirtualSwitchPortConnection] = Field(default=None, alias="dvPort")
    op_network: Optional[HostVirtualNicOpaqueNetworkSpec] = Field(default=None, alias="opNetwork")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostVirtualNicConnection from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostVirtualNicConnection from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


