# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.host_event import HostEvent
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HostWwnChangedEvent(HostEvent):
    """
    This event records a change in a host's WWN (World Wide Name).  ***Since:*** VI API 2.5 
    """ # noqa: E501
    old_node_wwns: Optional[List[StrictInt]] = Field(default=None, description="The old node WWN.  ***Since:*** VI API 2.5 ", alias="oldNodeWwns")
    old_port_wwns: Optional[List[StrictInt]] = Field(default=None, description="The old port WWN.  ***Since:*** VI API 2.5 ", alias="oldPortWwns")
    new_node_wwns: Optional[List[StrictInt]] = Field(default=None, description="The new node WWN.  ***Since:*** VI API 2.5 ", alias="newNodeWwns")
    new_port_wwns: Optional[List[StrictInt]] = Field(default=None, description="The new port WWN.  ***Since:*** VI API 2.5 ", alias="newPortWwns")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HostWwnChangedEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HostWwnChangedEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


