# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class HttpNfcLeaseManifestEntry(DataObject):
    """
    Provides a manifest for downloaded (exported) files and disks.  ***Since:*** vSphere API 4.1 
    """ # noqa: E501
    key: StrictStr = Field(description="Key used to match this entry with the corresponding *HttpNfcLeaseDeviceUrl* entry in *HttpNfcLease.info*.  ***Since:*** vSphere API 4.1 ")
    sha1: StrictStr = Field(description="SHA-1 checksum of the data stream sent from the server.  This can be used to verify that the bytes received by the client match those sent by the HttpNfc server.  ***Since:*** vSphere API 4.1 ")
    checksum: Optional[StrictStr] = Field(default=None, description="Checksum of the data stream sent/recieved by host.  See *HttpNfcLeaseManifestEntryChecksumType_enum* for used algoritm.  ***Since:*** vSphere API 6.7 ")
    checksum_type: Optional[StrictStr] = Field(default=None, description="Algorithm used to produce checksum in respective property.  See *HttpNfcLeaseManifestEntryChecksumType_enum* for supported algorithms.  ***Since:*** vSphere API 6.7 ", alias="checksumType")
    size: StrictInt = Field(description="Size of the downloaded file.  ***Since:*** vSphere API 4.1 ")
    disk: StrictBool = Field(description="True if the downloaded file is a virtual disk backing.  ***Since:*** vSphere API 4.1 ")
    capacity: Optional[StrictInt] = Field(default=None, description="The capacity of the disk, if the file is a virtual disk backing.  ***Since:*** vSphere API 4.1 ")
    populated_size: Optional[StrictInt] = Field(default=None, description="The populated size of the disk, if the file is a virtual disk backing.  ***Since:*** vSphere API 4.1 ", alias="populatedSize")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of HttpNfcLeaseManifestEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of HttpNfcLeaseManifestEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


