# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.guest_authentication import GuestAuthentication
from vmware_vi.models.guest_file_attributes import GuestFileAttributes
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class InitiateFileTransferToGuestRequestType(BaseModel):
    """
    The parameters of *GuestFileManager.InitiateFileTransferToGuest*. 
    """ # noqa: E501
    vm: ManagedObjectReference
    auth: GuestAuthentication
    guest_file_path: StrictStr = Field(description="The complete destination path in the guest to transfer the file from the client. It cannot be a path to a directory or a symbolic link. ", alias="guestFilePath")
    file_attributes: GuestFileAttributes = Field(alias="fileAttributes")
    file_size: StrictInt = Field(description="Size of the file to transfer to the guest in bytes. ", alias="fileSize")
    overwrite: StrictBool = Field(description="If set, the destination file is clobbered. ")
    __properties: ClassVar[List[str]] = ["vm", "auth", "guestFilePath", "fileAttributes", "fileSize", "overwrite"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InitiateFileTransferToGuestRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of vm
        if self.vm:
            _dict['vm'] = self.vm.to_dict()
        # override the default output from pydantic by calling `to_dict()` of auth
        if self.auth:
            _dict['auth'] = self.auth.to_dict()
        # override the default output from pydantic by calling `to_dict()` of file_attributes
        if self.file_attributes:
            _dict['fileAttributes'] = self.file_attributes.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of InitiateFileTransferToGuestRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "vm": ManagedObjectReference.from_dict(obj.get("vm")) if obj.get("vm") is not None else None,
            "auth": GuestAuthentication.from_dict(obj.get("auth")) if obj.get("auth") is not None else None,
            "guestFilePath": obj.get("guestFilePath"),
            "fileAttributes": GuestFileAttributes.from_dict(obj.get("fileAttributes")) if obj.get("fileAttributes") is not None else None,
            "fileSize": obj.get("fileSize"),
            "overwrite": obj.get("overwrite")
        })
        return _obj


