# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.insufficient_resources_fault import InsufficientResourcesFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class InsufficientVFlashResourcesFault(InsufficientResourcesFault):
    """
    Insufficient vFlash resource to consume  ***Since:*** vSphere API 5.5 
    """ # noqa: E501
    free_space_in_mb: Optional[StrictInt] = Field(default=None, description="The vFlash resource available capacity in MB.  ***Since:*** vSphere API 6.0 ", alias="freeSpaceInMB")
    free_space: StrictInt = Field(description="The vFlash resource available capacity in bytes.  ***Since:*** vSphere API 5.5 ", alias="freeSpace")
    requested_space_in_mb: Optional[StrictInt] = Field(default=None, description="The vFlash resource amount requested in MB.  ***Since:*** vSphere API 6.0 ", alias="requestedSpaceInMB")
    requested_space: StrictInt = Field(description="The vFlash resource amount requested in bytes.  ***Since:*** vSphere API 5.5 ", alias="requestedSpace")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InsufficientVFlashResourcesFault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of InsufficientVFlashResourcesFault from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


