# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class InventoryDescription(DataObject):
    """
    Data object to capture all information needed to describe a sample inventory.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    num_hosts: StrictInt = Field(description="The number of hosts.  ***Since:*** vSphere API 4.0 ", alias="numHosts")
    num_virtual_machines: StrictInt = Field(description="The number of virtual machines.  ***Since:*** vSphere API 4.0 ", alias="numVirtualMachines")
    num_resource_pools: Optional[StrictInt] = Field(default=None, description="The number of resource pools.  Default value is equal to numHosts  ***Since:*** vSphere API 4.0 ", alias="numResourcePools")
    num_clusters: Optional[StrictInt] = Field(default=None, description="The number of clusters.  Default value is equal to numHosts/5.  ***Since:*** vSphere API 4.0 ", alias="numClusters")
    num_cpu_dev: Optional[StrictInt] = Field(default=None, description="The number cpu devices per host.  Default value is 4.  ***Since:*** vSphere API 4.0 ", alias="numCpuDev")
    num_net_dev: Optional[StrictInt] = Field(default=None, description="The number network devices per host.  Default value is 2.  ***Since:*** vSphere API 4.0 ", alias="numNetDev")
    num_disk_dev: Optional[StrictInt] = Field(default=None, description="The number disk devices per host.  Default value is 10.  ***Since:*** vSphere API 4.0 ", alias="numDiskDev")
    numv_cpu_dev: Optional[StrictInt] = Field(default=None, description="The number cpu devices per vm.  Default value is 2.  ***Since:*** vSphere API 4.0 ", alias="numvCpuDev")
    numv_net_dev: Optional[StrictInt] = Field(default=None, description="The number network devices per vm.  Default value is 1.  ***Since:*** vSphere API 4.0 ", alias="numvNetDev")
    numv_disk_dev: Optional[StrictInt] = Field(default=None, description="The number disk devices per vm.  Default value is 4.  ***Since:*** vSphere API 4.0 ", alias="numvDiskDev")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InventoryDescription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of InventoryDescription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


