# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union

from vmware_vi.models.vim_fault import VimFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class IscsiFault(VimFault):
    """
    Base class for faults that can be thrown while invoking iSCSI management operations.  ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','IscsiFaultInvalidVnic': 'IscsiFaultInvalidVnic','IscsiFaultPnicInUse': 'IscsiFaultPnicInUse','IscsiFaultVnicAlreadyBound': 'IscsiFaultVnicAlreadyBound','IscsiFaultVnicHasActivePaths': 'IscsiFaultVnicHasActivePaths','IscsiFaultVnicHasMultipleUplinks': 'IscsiFaultVnicHasMultipleUplinks','IscsiFaultVnicHasNoUplinks': 'IscsiFaultVnicHasNoUplinks','IscsiFaultVnicHasWrongUplink': 'IscsiFaultVnicHasWrongUplink','IscsiFaultVnicInUse': 'IscsiFaultVnicInUse','IscsiFaultVnicIsLastPath': 'IscsiFaultVnicIsLastPath','IscsiFaultVnicNotBound': 'IscsiFaultVnicNotBound','IscsiFaultVnicNotFound': 'IscsiFaultVnicNotFound'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of IscsiFault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of IscsiFault from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("IscsiFault failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.iscsi_fault_invalid_vnic import IscsiFaultInvalidVnic
from vmware_vi.models.iscsi_fault_pnic_in_use import IscsiFaultPnicInUse
from vmware_vi.models.iscsi_fault_vnic_already_bound import IscsiFaultVnicAlreadyBound
from vmware_vi.models.iscsi_fault_vnic_has_active_paths import IscsiFaultVnicHasActivePaths
from vmware_vi.models.iscsi_fault_vnic_has_multiple_uplinks import IscsiFaultVnicHasMultipleUplinks
from vmware_vi.models.iscsi_fault_vnic_has_no_uplinks import IscsiFaultVnicHasNoUplinks
from vmware_vi.models.iscsi_fault_vnic_has_wrong_uplink import IscsiFaultVnicHasWrongUplink
from vmware_vi.models.iscsi_fault_vnic_in_use import IscsiFaultVnicInUse
from vmware_vi.models.iscsi_fault_vnic_is_last_path import IscsiFaultVnicIsLastPath
from vmware_vi.models.iscsi_fault_vnic_not_bound import IscsiFaultVnicNotBound
from vmware_vi.models.iscsi_fault_vnic_not_found import IscsiFaultVnicNotFound
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
# TODO: Rewrite to not use raise_errors
IscsiFault.model_rebuild(raise_errors=False)

