# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class LocalizationManagerMessageCatalog(DataObject):
    """
    Description of an available message catalog  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    module_name: StrictStr = Field(description="The module or extension that publishes this catalog.  The moduleName will be empty for the core catalogs for the VirtualCenter server itself.  ***Since:*** vSphere API 4.0 ", alias="moduleName")
    catalog_name: StrictStr = Field(description="The name of the catalog.  ***Since:*** vSphere API 4.0 ", alias="catalogName")
    locale: StrictStr = Field(description="The locale for the catalog.  ***Since:*** vSphere API 4.0 ")
    catalog_uri: StrictStr = Field(description="The URI (relative to the connection URL for the VirtualCenter server itself) from which the catalog can be downloaded.  The caller will need to augment this with a scheme and authority (host and port) to make a complete URL.  ***Since:*** vSphere API 4.0 ", alias="catalogUri")
    last_modified: Optional[datetime] = Field(default=None, description="The last-modified time of the catalog file, if available  ***Since:*** vSphere API 4.0 ", alias="lastModified")
    md5sum: Optional[StrictStr] = Field(default=None, description="The checksum of the catalog file, if available  ***Since:*** vSphere API 4.0 ")
    version: Optional[StrictStr] = Field(default=None, description="The version of the catalog file, if available The format is dot-separated version string, e.g.  \"1.2.3\".  ***Since:*** vSphere API 5.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of LocalizationManagerMessageCatalog from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of LocalizationManagerMessageCatalog from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


