# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union

from pydantic import Field
from vmware_vi.models.any import Any
from vmware_vi.models.localizable_message import LocalizableMessage
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class MethodFault(Any):
    """
    The base data object type for all the object model faults that an application might handle. 
    """ # noqa: E501
    fault_cause: Optional[MethodFault] = Field(default=None, alias="faultCause")
    fault_message: Optional[List[LocalizableMessage]] = Field(default=None, description="Message which has details about the error Message can also contain a key to message catalog which can be used to generate better localized messages.  ***Since:*** vSphere API 4.0 ", alias="faultMessage")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','ActiveDirectoryFault': 'ActiveDirectoryFault','ActiveVMsBlockingEVC': 'ActiveVMsBlockingEVC','AdminDisabled': 'AdminDisabled','AdminNotDisabled': 'AdminNotDisabled','AffinityConfigured': 'AffinityConfigured','AgentInstallFailed': 'AgentInstallFailed','AlreadyBeingManaged': 'AlreadyBeingManaged','AlreadyConnected': 'AlreadyConnected','AlreadyExists': 'AlreadyExists','AlreadyUpgraded': 'AlreadyUpgraded','AnswerFileUpdateFailed': 'AnswerFileUpdateFailed','ApplicationQuiesceFault': 'ApplicationQuiesceFault','AuthMinimumAdminPermission': 'AuthMinimumAdminPermission','BackupBlobReadFailure': 'BackupBlobReadFailure','BackupBlobWriteFailure': 'BackupBlobWriteFailure','BlockedByFirewall': 'BlockedByFirewall','CAMServerRefusedConnection': 'CAMServerRefusedConnection','CannotAccessFile': 'CannotAccessFile','CannotAccessLocalSource': 'CannotAccessLocalSource','CannotAccessNetwork': 'CannotAccessNetwork','CannotAccessVmComponent': 'CannotAccessVmComponent','CannotAccessVmConfig': 'CannotAccessVmConfig','CannotAccessVmDevice': 'CannotAccessVmDevice','CannotAccessVmDisk': 'CannotAccessVmDisk','CannotAddHostWithFTVmAsStandalone': 'CannotAddHostWithFTVmAsStandalone','CannotAddHostWithFTVmToDifferentCluster': 'CannotAddHostWithFTVmToDifferentCluster','CannotAddHostWithFTVmToNonHACluster': 'CannotAddHostWithFTVmToNonHACluster','CannotChangeDrsBehaviorForFtSecondary': 'CannotChangeDrsBehaviorForFtSecondary','CannotChangeHaSettingsForFtSecondary': 'CannotChangeHaSettingsForFtSecondary','CannotChangeVsanClusterUuid': 'CannotChangeVsanClusterUuid','CannotChangeVsanNodeUuid': 'CannotChangeVsanNodeUuid','CannotComputeFTCompatibleHosts': 'CannotComputeFTCompatibleHosts','CannotCreateFile': 'CannotCreateFile','CannotDecryptPasswords': 'CannotDecryptPasswords','CannotDeleteFile': 'CannotDeleteFile','CannotDisableDrsOnClustersWithVApps': 'CannotDisableDrsOnClustersWithVApps','CannotDisableSnapshot': 'CannotDisableSnapshot','CannotDisconnectHostWithFaultToleranceVm': 'CannotDisconnectHostWithFaultToleranceVm','CannotEnableVmcpForCluster': 'CannotEnableVmcpForCluster','CannotModifyConfigCpuRequirements': 'CannotModifyConfigCpuRequirements','CannotMoveFaultToleranceVm': 'CannotMoveFaultToleranceVm','CannotMoveHostWithFaultToleranceVm': 'CannotMoveHostWithFaultToleranceVm','CannotMoveVmWithDeltaDisk': 'CannotMoveVmWithDeltaDisk','CannotMoveVmWithNativeDeltaDisk': 'CannotMoveVmWithNativeDeltaDisk','CannotMoveVsanEnabledHost': 'CannotMoveVsanEnabledHost','CannotPlaceWithoutPrerequisiteMoves': 'CannotPlaceWithoutPrerequisiteMoves','CannotPowerOffVmInCluster': 'CannotPowerOffVmInCluster','CannotReconfigureVsanWhenHaEnabled': 'CannotReconfigureVsanWhenHaEnabled','CannotUseNetwork': 'CannotUseNetwork','ClockSkew': 'ClockSkew','CloneFromSnapshotNotSupported': 'CloneFromSnapshotNotSupported','CollectorAddressUnset': 'CollectorAddressUnset','ConcurrentAccess': 'ConcurrentAccess','ConflictingConfiguration': 'ConflictingConfiguration','ConflictingDatastoreFound': 'ConflictingDatastoreFound','ConnectedIso': 'ConnectedIso','CpuCompatibilityUnknown': 'CpuCompatibilityUnknown','CpuHotPlugNotSupported': 'CpuHotPlugNotSupported','CpuIncompatible': 'CpuIncompatible','CpuIncompatible1ECX': 'CpuIncompatible1ECX','CpuIncompatible81EDX': 'CpuIncompatible81EDX','CustomizationFault': 'CustomizationFault','CustomizationPending': 'CustomizationPending','DVPortNotSupported': 'DVPortNotSupported','DasConfigFault': 'DasConfigFault','DatabaseError': 'DatabaseError','DatacenterMismatch': 'DatacenterMismatch','DatastoreNotWritableOnHost': 'DatastoreNotWritableOnHost','DeltaDiskFormatNotSupported': 'DeltaDiskFormatNotSupported','DestinationSwitchFull': 'DestinationSwitchFull','DestinationVsanDisabled': 'DestinationVsanDisabled','DeviceBackingNotSupported': 'DeviceBackingNotSupported','DeviceControllerNotSupported': 'DeviceControllerNotSupported','DeviceHotPlugNotSupported': 'DeviceHotPlugNotSupported','DeviceNotFound': 'DeviceNotFound','DeviceNotSupported': 'DeviceNotSupported','DeviceUnsupportedForVmPlatform': 'DeviceUnsupportedForVmPlatform','DeviceUnsupportedForVmVersion': 'DeviceUnsupportedForVmVersion','DigestNotSupported': 'DigestNotSupported','DirectoryNotEmpty': 'DirectoryNotEmpty','DisableAdminNotSupported': 'DisableAdminNotSupported','DisallowedChangeByService': 'DisallowedChangeByService','DisallowedDiskModeChange': 'DisallowedDiskModeChange','DisallowedMigrationDeviceAttached': 'DisallowedMigrationDeviceAttached','DisallowedOperationOnFailoverHost': 'DisallowedOperationOnFailoverHost','DisconnectedHostsBlockingEVC': 'DisconnectedHostsBlockingEVC','DiskHasPartitions': 'DiskHasPartitions','DiskIsLastRemainingNonSSD': 'DiskIsLastRemainingNonSSD','DiskIsNonLocal': 'DiskIsNonLocal','DiskIsUSB': 'DiskIsUSB','DiskMoveTypeNotSupported': 'DiskMoveTypeNotSupported','DiskNotSupported': 'DiskNotSupported','DiskTooSmall': 'DiskTooSmall','DomainNotFound': 'DomainNotFound','DrsDisabledOnVm': 'DrsDisabledOnVm','DrsVmotionIncompatibleFault': 'DrsVmotionIncompatibleFault','DuplicateDisks': 'DuplicateDisks','DuplicateName': 'DuplicateName','DuplicateVsanNetworkInterface': 'DuplicateVsanNetworkInterface','DvsApplyOperationFault': 'DvsApplyOperationFault','DvsFault': 'DvsFault','DvsNotAuthorized': 'DvsNotAuthorized','DvsOperationBulkFault': 'DvsOperationBulkFault','DvsScopeViolated': 'DvsScopeViolated','EVCAdmissionFailed': 'EVCAdmissionFailed','EVCAdmissionFailedCPUFeaturesForMode': 'EVCAdmissionFailedCPUFeaturesForMode','EVCAdmissionFailedCPUModel': 'EVCAdmissionFailedCPUModel','EVCAdmissionFailedCPUModelForMode': 'EVCAdmissionFailedCPUModelForMode','EVCAdmissionFailedCPUVendor': 'EVCAdmissionFailedCPUVendor','EVCAdmissionFailedCPUVendorUnknown': 'EVCAdmissionFailedCPUVendorUnknown','EVCAdmissionFailedHostDisconnected': 'EVCAdmissionFailedHostDisconnected','EVCAdmissionFailedHostSoftware': 'EVCAdmissionFailedHostSoftware','EVCAdmissionFailedHostSoftwareForMode': 'EVCAdmissionFailedHostSoftwareForMode','EVCAdmissionFailedVmActive': 'EVCAdmissionFailedVmActive','EVCConfigFault': 'EVCConfigFault','EVCModeIllegalByVendor': 'EVCModeIllegalByVendor','EVCModeUnsupportedByHosts': 'EVCModeUnsupportedByHosts','EVCUnsupportedByHostHardware': 'EVCUnsupportedByHostHardware','EVCUnsupportedByHostSoftware': 'EVCUnsupportedByHostSoftware','EightHostLimitViolated': 'EightHostLimitViolated','EncryptionKeyRequired': 'EncryptionKeyRequired','ExpiredAddonLicense': 'ExpiredAddonLicense','ExpiredEditionLicense': 'ExpiredEditionLicense','ExpiredFeatureLicense': 'ExpiredFeatureLicense','ExtendedFault': 'ExtendedFault','FailToEnableSPBM': 'FailToEnableSPBM','FailToLockFaultToleranceVMs': 'FailToLockFaultToleranceVMs','FaultToleranceAntiAffinityViolated': 'FaultToleranceAntiAffinityViolated','FaultToleranceCannotEditMem': 'FaultToleranceCannotEditMem','FaultToleranceCpuIncompatible': 'FaultToleranceCpuIncompatible','FaultToleranceNeedsThickDisk': 'FaultToleranceNeedsThickDisk','FaultToleranceNotLicensed': 'FaultToleranceNotLicensed','FaultToleranceNotSameBuild': 'FaultToleranceNotSameBuild','FaultTolerancePrimaryPowerOnNotAttempted': 'FaultTolerancePrimaryPowerOnNotAttempted','FaultToleranceVmNotDasProtected': 'FaultToleranceVmNotDasProtected','FcoeFault': 'FcoeFault','FcoeFaultPnicHasNoPortSet': 'FcoeFaultPnicHasNoPortSet','FeatureRequirementsNotMet': 'FeatureRequirementsNotMet','FileAlreadyExists': 'FileAlreadyExists','FileBackedPortNotSupported': 'FileBackedPortNotSupported','FileFault': 'FileFault','FileLocked': 'FileLocked','FileNameTooLong': 'FileNameTooLong','FileNotFound': 'FileNotFound','FileNotWritable': 'FileNotWritable','FileTooLarge': 'FileTooLarge','FilesystemQuiesceFault': 'FilesystemQuiesceFault','FilterInUse': 'FilterInUse','FtIssuesOnHost': 'FtIssuesOnHost','FullStorageVMotionNotSupported': 'FullStorageVMotionNotSupported','GatewayConnectFault': 'GatewayConnectFault','GatewayHostNotReachable': 'GatewayHostNotReachable','GatewayNotFound': 'GatewayNotFound','GatewayNotReachable': 'GatewayNotReachable','GatewayOperationRefused': 'GatewayOperationRefused','GatewayToHostAuthFault': 'GatewayToHostAuthFault','GatewayToHostConnectFault': 'GatewayToHostConnectFault','GatewayToHostTrustVerifyFault': 'GatewayToHostTrustVerifyFault','GenericDrsFault': 'GenericDrsFault','GenericVmConfigFault': 'GenericVmConfigFault','GuestAuthenticationChallenge': 'GuestAuthenticationChallenge','GuestComponentsOutOfDate': 'GuestComponentsOutOfDate','GuestMultipleMappings': 'GuestMultipleMappings','GuestOperationsFault': 'GuestOperationsFault','GuestOperationsUnavailable': 'GuestOperationsUnavailable','GuestPermissionDenied': 'GuestPermissionDenied','GuestProcessNotFound': 'GuestProcessNotFound','GuestRegistryFault': 'GuestRegistryFault','GuestRegistryKeyAlreadyExists': 'GuestRegistryKeyAlreadyExists','GuestRegistryKeyFault': 'GuestRegistryKeyFault','GuestRegistryKeyHasSubkeys': 'GuestRegistryKeyHasSubkeys','GuestRegistryKeyInvalid': 'GuestRegistryKeyInvalid','GuestRegistryKeyParentVolatile': 'GuestRegistryKeyParentVolatile','GuestRegistryValueFault': 'GuestRegistryValueFault','GuestRegistryValueNotFound': 'GuestRegistryValueNotFound','HAErrorsAtDest': 'HAErrorsAtDest','HeterogenousHostsBlockingEVC': 'HeterogenousHostsBlockingEVC','HostAccessRestrictedToManagementServer': 'HostAccessRestrictedToManagementServer','HostCommunication': 'HostCommunication','HostConfigFailed': 'HostConfigFailed','HostConfigFault': 'HostConfigFault','HostConnectFault': 'HostConnectFault','HostHasComponentFailure': 'HostHasComponentFailure','HostInDomain': 'HostInDomain','HostIncompatibleForFaultTolerance': 'HostIncompatibleForFaultTolerance','HostIncompatibleForRecordReplay': 'HostIncompatibleForRecordReplay','HostInventoryFull': 'HostInventoryFull','HostNotConnected': 'HostNotConnected','HostNotReachable': 'HostNotReachable','HostPowerOpFailed': 'HostPowerOpFailed','HostSpecificationOperationFailed': 'HostSpecificationOperationFailed','HotSnapshotMoveNotSupported': 'HotSnapshotMoveNotSupported','HttpFault': 'HttpFault','IDEDiskNotSupported': 'IDEDiskNotSupported','IORMNotSupportedHostOnDatastore': 'IORMNotSupportedHostOnDatastore','ImportHostAddFailure': 'ImportHostAddFailure','ImportOperationBulkFault': 'ImportOperationBulkFault','InUseFeatureManipulationDisallowed': 'InUseFeatureManipulationDisallowed','InaccessibleDatastore': 'InaccessibleDatastore','InaccessibleFTMetadataDatastore': 'InaccessibleFTMetadataDatastore','InaccessibleVFlashSource': 'InaccessibleVFlashSource','IncompatibleDefaultDevice': 'IncompatibleDefaultDevice','IncompatibleHostForFtSecondary': 'IncompatibleHostForFtSecondary','IncompatibleHostForVmReplication': 'IncompatibleHostForVmReplication','IncompatibleSetting': 'IncompatibleSetting','IncorrectFileType': 'IncorrectFileType','IncorrectHostInformation': 'IncorrectHostInformation','IndependentDiskVMotionNotSupported': 'IndependentDiskVMotionNotSupported','InsufficientAgentVmsDeployed': 'InsufficientAgentVmsDeployed','InsufficientCpuResourcesFault': 'InsufficientCpuResourcesFault','InsufficientDisks': 'InsufficientDisks','InsufficientFailoverResourcesFault': 'InsufficientFailoverResourcesFault','InsufficientGraphicsResourcesFault': 'InsufficientGraphicsResourcesFault','InsufficientHostCapacityFault': 'InsufficientHostCapacityFault','InsufficientHostCpuCapacityFault': 'InsufficientHostCpuCapacityFault','InsufficientHostMemoryCapacityFault': 'InsufficientHostMemoryCapacityFault','InsufficientMemoryResourcesFault': 'InsufficientMemoryResourcesFault','InsufficientNetworkCapacity': 'InsufficientNetworkCapacity','InsufficientNetworkResourcePoolCapacity': 'InsufficientNetworkResourcePoolCapacity','InsufficientPerCpuCapacity': 'InsufficientPerCpuCapacity','InsufficientResourcesFault': 'InsufficientResourcesFault','InsufficientStandbyCpuResource': 'InsufficientStandbyCpuResource','InsufficientStandbyMemoryResource': 'InsufficientStandbyMemoryResource','InsufficientStandbyResource': 'InsufficientStandbyResource','InsufficientStorageIops': 'InsufficientStorageIops','InsufficientStorageSpace': 'InsufficientStorageSpace','InsufficientVFlashResourcesFault': 'InsufficientVFlashResourcesFault','InvalidAffinitySettingFault': 'InvalidAffinitySettingFault','InvalidArgument': 'InvalidArgument','InvalidBmcRole': 'InvalidBmcRole','InvalidBundle': 'InvalidBundle','InvalidCAMCertificate': 'InvalidCAMCertificate','InvalidCAMServer': 'InvalidCAMServer','InvalidClientCertificate': 'InvalidClientCertificate','InvalidCollectorVersion': 'InvalidCollectorVersion','InvalidController': 'InvalidController','InvalidDasConfigArgument': 'InvalidDasConfigArgument','InvalidDasRestartPriorityForFtVm': 'InvalidDasRestartPriorityForFtVm','InvalidDatastore': 'InvalidDatastore','InvalidDatastorePath': 'InvalidDatastorePath','InvalidDatastoreState': 'InvalidDatastoreState','InvalidDeviceBacking': 'InvalidDeviceBacking','InvalidDeviceOperation': 'InvalidDeviceOperation','InvalidDeviceSpec': 'InvalidDeviceSpec','InvalidDiskFormat': 'InvalidDiskFormat','InvalidDrsBehaviorForFtVm': 'InvalidDrsBehaviorForFtVm','InvalidEditionLicense': 'InvalidEditionLicense','InvalidEvent': 'InvalidEvent','InvalidFolder': 'InvalidFolder','InvalidFormat': 'InvalidFormat','InvalidGuestLogin': 'InvalidGuestLogin','InvalidHostConnectionState': 'InvalidHostConnectionState','InvalidHostName': 'InvalidHostName','InvalidHostState': 'InvalidHostState','InvalidIndexArgument': 'InvalidIndexArgument','InvalidIpfixConfig': 'InvalidIpfixConfig','InvalidIpmiLoginInfo': 'InvalidIpmiLoginInfo','InvalidIpmiMacAddress': 'InvalidIpmiMacAddress','InvalidLicense': 'InvalidLicense','InvalidLocale': 'InvalidLocale','InvalidLogin': 'InvalidLogin','InvalidName': 'InvalidName','InvalidNasCredentials': 'InvalidNasCredentials','InvalidNetworkInType': 'InvalidNetworkInType','InvalidNetworkResource': 'InvalidNetworkResource','InvalidOperationOnSecondaryVm': 'InvalidOperationOnSecondaryVm','InvalidPowerState': 'InvalidPowerState','InvalidPrivilege': 'InvalidPrivilege','InvalidProfileReferenceHost': 'InvalidProfileReferenceHost','InvalidProperty': 'InvalidProperty','InvalidPropertyType': 'InvalidPropertyType','InvalidPropertyValue': 'InvalidPropertyValue','InvalidRequest': 'InvalidRequest','InvalidResourcePoolStructureFault': 'InvalidResourcePoolStructureFault','InvalidSnapshotFormat': 'InvalidSnapshotFormat','InvalidState': 'InvalidState','InvalidType': 'InvalidType','InvalidVmConfig': 'InvalidVmConfig','InvalidVmState': 'InvalidVmState','InventoryHasStandardAloneHosts': 'InventoryHasStandardAloneHosts','IpHostnameGeneratorError': 'IpHostnameGeneratorError','IscsiFault': 'IscsiFault','IscsiFaultInvalidVnic': 'IscsiFaultInvalidVnic','IscsiFaultPnicInUse': 'IscsiFaultPnicInUse','IscsiFaultVnicAlreadyBound': 'IscsiFaultVnicAlreadyBound','IscsiFaultVnicHasActivePaths': 'IscsiFaultVnicHasActivePaths','IscsiFaultVnicHasMultipleUplinks': 'IscsiFaultVnicHasMultipleUplinks','IscsiFaultVnicHasNoUplinks': 'IscsiFaultVnicHasNoUplinks','IscsiFaultVnicHasWrongUplink': 'IscsiFaultVnicHasWrongUplink','IscsiFaultVnicInUse': 'IscsiFaultVnicInUse','IscsiFaultVnicIsLastPath': 'IscsiFaultVnicIsLastPath','IscsiFaultVnicNotBound': 'IscsiFaultVnicNotBound','IscsiFaultVnicNotFound': 'IscsiFaultVnicNotFound','KeyNotFound': 'KeyNotFound','LargeRDMConversionNotSupported': 'LargeRDMConversionNotSupported','LargeRDMNotSupportedOnDatastore': 'LargeRDMNotSupportedOnDatastore','LegacyNetworkInterfaceInUse': 'LegacyNetworkInterfaceInUse','LicenseAssignmentFailed': 'LicenseAssignmentFailed','LicenseDowngradeDisallowed': 'LicenseDowngradeDisallowed','LicenseEntityNotFound': 'LicenseEntityNotFound','LicenseExpired': 'LicenseExpired','LicenseKeyEntityMismatch': 'LicenseKeyEntityMismatch','LicenseRestricted': 'LicenseRestricted','LicenseServerUnavailable': 'LicenseServerUnavailable','LicenseSourceUnavailable': 'LicenseSourceUnavailable','LimitExceeded': 'LimitExceeded','LinuxVolumeNotClean': 'LinuxVolumeNotClean','LogBundlingFailed': 'LogBundlingFailed','MaintenanceModeFileMove': 'MaintenanceModeFileMove','ManagedObjectNotFound': 'ManagedObjectNotFound','MemoryFileFormatNotSupportedByDatastore': 'MemoryFileFormatNotSupportedByDatastore','MemoryHotPlugNotSupported': 'MemoryHotPlugNotSupported','MemorySizeNotRecommended': 'MemorySizeNotRecommended','MemorySizeNotSupported': 'MemorySizeNotSupported','MemorySizeNotSupportedByDatastore': 'MemorySizeNotSupportedByDatastore','MemorySnapshotOnIndependentDisk': 'MemorySnapshotOnIndependentDisk','MethodAlreadyDisabledFault': 'MethodAlreadyDisabledFault','MethodDisabled': 'MethodDisabled','MethodNotFound': 'MethodNotFound','MigrationDisabled': 'MigrationDisabled','MigrationFault': 'MigrationFault','MigrationFeatureNotSupported': 'MigrationFeatureNotSupported','MigrationNotReady': 'MigrationNotReady','MismatchedBundle': 'MismatchedBundle','MismatchedNetworkPolicies': 'MismatchedNetworkPolicies','MismatchedVMotionNetworkNames': 'MismatchedVMotionNetworkNames','MissingBmcSupport': 'MissingBmcSupport','MissingController': 'MissingController','MissingIpPool': 'MissingIpPool','MissingLinuxCustResources': 'MissingLinuxCustResources','MissingNetworkIpConfig': 'MissingNetworkIpConfig','MissingPowerOffConfiguration': 'MissingPowerOffConfiguration','MissingPowerOnConfiguration': 'MissingPowerOnConfiguration','MissingWindowsCustResources': 'MissingWindowsCustResources','MksConnectionLimitReached': 'MksConnectionLimitReached','MountError': 'MountError','MultiWriterNotSupported': 'MultiWriterNotSupported','MultipleCertificatesVerifyFault': 'MultipleCertificatesVerifyFault','MultipleSnapshotsNotSupported': 'MultipleSnapshotsNotSupported','NamespaceFull': 'NamespaceFull','NamespaceLimitReached': 'NamespaceLimitReached','NamespaceWriteProtected': 'NamespaceWriteProtected','NasConfigFault': 'NasConfigFault','NasConnectionLimitReached': 'NasConnectionLimitReached','NasSessionCredentialConflict': 'NasSessionCredentialConflict','NasVolumeNotMounted': 'NasVolumeNotMounted','NetworkCopyFault': 'NetworkCopyFault','NetworkDisruptedAndConfigRolledBack': 'NetworkDisruptedAndConfigRolledBack','NetworkInaccessible': 'NetworkInaccessible','NetworksMayNotBeTheSame': 'NetworksMayNotBeTheSame','NicSettingMismatch': 'NicSettingMismatch','NoActiveHostInCluster': 'NoActiveHostInCluster','NoAvailableIp': 'NoAvailableIp','NoClientCertificate': 'NoClientCertificate','NoCompatibleDatastore': 'NoCompatibleDatastore','NoCompatibleHardAffinityHost': 'NoCompatibleHardAffinityHost','NoCompatibleHost': 'NoCompatibleHost','NoCompatibleHostWithAccessToDevice': 'NoCompatibleHostWithAccessToDevice','NoCompatibleSoftAffinityHost': 'NoCompatibleSoftAffinityHost','NoConnectedDatastore': 'NoConnectedDatastore','NoDiskFound': 'NoDiskFound','NoDiskSpace': 'NoDiskSpace','NoDisksToCustomize': 'NoDisksToCustomize','NoGateway': 'NoGateway','NoGuestHeartbeat': 'NoGuestHeartbeat','NoHost': 'NoHost','NoHostSuitableForFtSecondary': 'NoHostSuitableForFtSecondary','NoLicenseServerConfigured': 'NoLicenseServerConfigured','NoPeerHostFound': 'NoPeerHostFound','NoPermission': 'NoPermission','NoPermissionOnAD': 'NoPermissionOnAD','NoPermissionOnHost': 'NoPermissionOnHost','NoPermissionOnNasVolume': 'NoPermissionOnNasVolume','NoSubjectName': 'NoSubjectName','NoVcManagedIpConfigured': 'NoVcManagedIpConfigured','NoVirtualNic': 'NoVirtualNic','NoVmInVApp': 'NoVmInVApp','NonADUserRequired': 'NonADUserRequired','NonHomeRDMVMotionNotSupported': 'NonHomeRDMVMotionNotSupported','NonPersistentDisksNotSupported': 'NonPersistentDisksNotSupported','NonVmwareOuiMacNotSupportedHost': 'NonVmwareOuiMacNotSupportedHost','NotADirectory': 'NotADirectory','NotAFile': 'NotAFile','NotAuthenticated': 'NotAuthenticated','NotEnoughCpus': 'NotEnoughCpus','NotEnoughLicenses': 'NotEnoughLicenses','NotEnoughLogicalCpus': 'NotEnoughLogicalCpus','NotFound': 'NotFound','NotImplemented': 'NotImplemented','NotSupported': 'NotSupported','NotSupportedDeviceForFT': 'NotSupportedDeviceForFT','NotSupportedHost': 'NotSupportedHost','NotSupportedHostForChecksum': 'NotSupportedHostForChecksum','NotSupportedHostForVFlash': 'NotSupportedHostForVFlash','NotSupportedHostForVmcp': 'NotSupportedHostForVmcp','NotSupportedHostForVmemFile': 'NotSupportedHostForVmemFile','NotSupportedHostForVsan': 'NotSupportedHostForVsan','NotSupportedHostInCluster': 'NotSupportedHostInCluster','NotSupportedHostInDvs': 'NotSupportedHostInDvs','NotSupportedHostInHACluster': 'NotSupportedHostInHACluster','NotUserConfigurableProperty': 'NotUserConfigurableProperty','NumVirtualCoresPerSocketNotSupported': 'NumVirtualCoresPerSocketNotSupported','NumVirtualCpusExceedsLimit': 'NumVirtualCpusExceedsLimit','NumVirtualCpusIncompatible': 'NumVirtualCpusIncompatible','NumVirtualCpusNotSupported': 'NumVirtualCpusNotSupported','OperationDisabledByGuest': 'OperationDisabledByGuest','OperationDisallowedOnHost': 'OperationDisallowedOnHost','OperationNotSupportedByGuest': 'OperationNotSupportedByGuest','OutOfBounds': 'OutOfBounds','OvfAttribute': 'OvfAttribute','OvfConnectedDevice': 'OvfConnectedDevice','OvfConnectedDeviceFloppy': 'OvfConnectedDeviceFloppy','OvfConnectedDeviceIso': 'OvfConnectedDeviceIso','OvfConstraint': 'OvfConstraint','OvfConsumerCallbackFault': 'OvfConsumerCallbackFault','OvfConsumerCommunicationError': 'OvfConsumerCommunicationError','OvfConsumerFault': 'OvfConsumerFault','OvfConsumerInvalidSection': 'OvfConsumerInvalidSection','OvfConsumerPowerOnFault': 'OvfConsumerPowerOnFault','OvfConsumerUndeclaredSection': 'OvfConsumerUndeclaredSection','OvfConsumerUndefinedPrefix': 'OvfConsumerUndefinedPrefix','OvfConsumerValidationFault': 'OvfConsumerValidationFault','OvfCpuCompatibility': 'OvfCpuCompatibility','OvfCpuCompatibilityCheckNotSupported': 'OvfCpuCompatibilityCheckNotSupported','OvfDiskMappingNotFound': 'OvfDiskMappingNotFound','OvfDiskOrderConstraint': 'OvfDiskOrderConstraint','OvfDuplicateElement': 'OvfDuplicateElement','OvfDuplicatedElementBoundary': 'OvfDuplicatedElementBoundary','OvfDuplicatedPropertyIdExport': 'OvfDuplicatedPropertyIdExport','OvfDuplicatedPropertyIdImport': 'OvfDuplicatedPropertyIdImport','OvfElement': 'OvfElement','OvfElementInvalidValue': 'OvfElementInvalidValue','OvfExport': 'OvfExport','OvfExportFailed': 'OvfExportFailed','OvfFault': 'OvfFault','OvfHardwareCheck': 'OvfHardwareCheck','OvfHardwareExport': 'OvfHardwareExport','OvfHostResourceConstraint': 'OvfHostResourceConstraint','OvfHostValueNotParsed': 'OvfHostValueNotParsed','OvfImport': 'OvfImport','OvfImportFailed': 'OvfImportFailed','OvfInternalError': 'OvfInternalError','OvfInvalidPackage': 'OvfInvalidPackage','OvfInvalidValue': 'OvfInvalidValue','OvfInvalidValueConfiguration': 'OvfInvalidValueConfiguration','OvfInvalidValueEmpty': 'OvfInvalidValueEmpty','OvfInvalidValueFormatMalformed': 'OvfInvalidValueFormatMalformed','OvfInvalidValueReference': 'OvfInvalidValueReference','OvfInvalidVmName': 'OvfInvalidVmName','OvfMappedOsId': 'OvfMappedOsId','OvfMissingAttribute': 'OvfMissingAttribute','OvfMissingElement': 'OvfMissingElement','OvfMissingElementNormalBoundary': 'OvfMissingElementNormalBoundary','OvfMissingHardware': 'OvfMissingHardware','OvfNetworkMappingNotSupported': 'OvfNetworkMappingNotSupported','OvfNoHostNic': 'OvfNoHostNic','OvfNoSpaceOnController': 'OvfNoSpaceOnController','OvfNoSupportedHardwareFamily': 'OvfNoSupportedHardwareFamily','OvfProperty': 'OvfProperty','OvfPropertyExport': 'OvfPropertyExport','OvfPropertyNetwork': 'OvfPropertyNetwork','OvfPropertyNetworkExport': 'OvfPropertyNetworkExport','OvfPropertyQualifier': 'OvfPropertyQualifier','OvfPropertyQualifierDuplicate': 'OvfPropertyQualifierDuplicate','OvfPropertyQualifierIgnored': 'OvfPropertyQualifierIgnored','OvfPropertyType': 'OvfPropertyType','OvfPropertyValue': 'OvfPropertyValue','OvfSystemFault': 'OvfSystemFault','OvfToXmlUnsupportedElement': 'OvfToXmlUnsupportedElement','OvfUnableToExportDisk': 'OvfUnableToExportDisk','OvfUnexpectedElement': 'OvfUnexpectedElement','OvfUnknownDevice': 'OvfUnknownDevice','OvfUnknownDeviceBacking': 'OvfUnknownDeviceBacking','OvfUnknownEntity': 'OvfUnknownEntity','OvfUnsupportedAttribute': 'OvfUnsupportedAttribute','OvfUnsupportedAttributeValue': 'OvfUnsupportedAttributeValue','OvfUnsupportedDeviceBackingInfo': 'OvfUnsupportedDeviceBackingInfo','OvfUnsupportedDeviceBackingOption': 'OvfUnsupportedDeviceBackingOption','OvfUnsupportedDeviceExport': 'OvfUnsupportedDeviceExport','OvfUnsupportedDiskProvisioning': 'OvfUnsupportedDiskProvisioning','OvfUnsupportedElement': 'OvfUnsupportedElement','OvfUnsupportedElementValue': 'OvfUnsupportedElementValue','OvfUnsupportedPackage': 'OvfUnsupportedPackage','OvfUnsupportedSection': 'OvfUnsupportedSection','OvfUnsupportedSubType': 'OvfUnsupportedSubType','OvfUnsupportedType': 'OvfUnsupportedType','OvfWrongElement': 'OvfWrongElement','OvfWrongNamespace': 'OvfWrongNamespace','OvfXmlFormat': 'OvfXmlFormat','PasswordExpired': 'PasswordExpired','PatchAlreadyInstalled': 'PatchAlreadyInstalled','PatchBinariesNotFound': 'PatchBinariesNotFound','PatchInstallFailed': 'PatchInstallFailed','PatchIntegrityError': 'PatchIntegrityError','PatchMetadataCorrupted': 'PatchMetadataCorrupted','PatchMetadataInvalid': 'PatchMetadataInvalid','PatchMetadataNotFound': 'PatchMetadataNotFound','PatchMissingDependencies': 'PatchMissingDependencies','PatchNotApplicable': 'PatchNotApplicable','PatchSuperseded': 'PatchSuperseded','PhysCompatRDMNotSupported': 'PhysCompatRDMNotSupported','PlatformConfigFault': 'PlatformConfigFault','PowerOnFtSecondaryFailed': 'PowerOnFtSecondaryFailed','PowerOnFtSecondaryTimedout': 'PowerOnFtSecondaryTimedout','ProfileUpdateFailed': 'ProfileUpdateFailed','QuarantineModeFault': 'QuarantineModeFault','QuestionPending': 'QuestionPending','QuiesceDatastoreIOForHAFailed': 'QuiesceDatastoreIOForHAFailed','RDMConversionNotSupported': 'RDMConversionNotSupported','RDMNotPreserved': 'RDMNotPreserved','RDMNotSupported': 'RDMNotSupported','RDMNotSupportedOnDatastore': 'RDMNotSupportedOnDatastore','RDMPointsToInaccessibleDisk': 'RDMPointsToInaccessibleDisk','RawDiskNotSupported': 'RawDiskNotSupported','ReadHostResourcePoolTreeFailed': 'ReadHostResourcePoolTreeFailed','ReadOnlyDisksWithLegacyDestination': 'ReadOnlyDisksWithLegacyDestination','RebootRequired': 'RebootRequired','RecordReplayDisabled': 'RecordReplayDisabled','RemoteDeviceNotSupported': 'RemoteDeviceNotSupported','RemoveFailed': 'RemoveFailed','ReplicationConfigFault': 'ReplicationConfigFault','ReplicationDiskConfigFault': 'ReplicationDiskConfigFault','ReplicationFault': 'ReplicationFault','ReplicationIncompatibleWithFT': 'ReplicationIncompatibleWithFT','ReplicationInvalidOptions': 'ReplicationInvalidOptions','ReplicationNotSupportedOnHost': 'ReplicationNotSupportedOnHost','ReplicationVmConfigFault': 'ReplicationVmConfigFault','ReplicationVmFault': 'ReplicationVmFault','ReplicationVmInProgressFault': 'ReplicationVmInProgressFault','RequestCanceled': 'RequestCanceled','ResourceInUse': 'ResourceInUse','ResourceNotAvailable': 'ResourceNotAvailable','RestrictedByAdministrator': 'RestrictedByAdministrator','RestrictedVersion': 'RestrictedVersion','RollbackFailure': 'RollbackFailure','RuleViolation': 'RuleViolation','RuntimeFault': 'RuntimeFault','SSLDisabledFault': 'SSLDisabledFault','SSLVerifyFault': 'SSLVerifyFault','SSPIChallenge': 'SSPIChallenge','SecondaryVmAlreadyDisabled': 'SecondaryVmAlreadyDisabled','SecondaryVmAlreadyEnabled': 'SecondaryVmAlreadyEnabled','SecondaryVmAlreadyRegistered': 'SecondaryVmAlreadyRegistered','SecondaryVmNotRegistered': 'SecondaryVmNotRegistered','SecurityError': 'SecurityError','SharedBusControllerNotSupported': 'SharedBusControllerNotSupported','ShrinkDiskFault': 'ShrinkDiskFault','SnapshotCloneNotSupported': 'SnapshotCloneNotSupported','SnapshotCopyNotSupported': 'SnapshotCopyNotSupported','SnapshotDisabled': 'SnapshotDisabled','SnapshotFault': 'SnapshotFault','SnapshotIncompatibleDeviceInVm': 'SnapshotIncompatibleDeviceInVm','SnapshotLocked': 'SnapshotLocked','SnapshotMoveFromNonHomeNotSupported': 'SnapshotMoveFromNonHomeNotSupported','SnapshotMoveNotSupported': 'SnapshotMoveNotSupported','SnapshotMoveToNonHomeNotSupported': 'SnapshotMoveToNonHomeNotSupported','SnapshotNoChange': 'SnapshotNoChange','SnapshotRevertIssue': 'SnapshotRevertIssue','SoftRuleVioCorrectionDisallowed': 'SoftRuleVioCorrectionDisallowed','SoftRuleVioCorrectionImpact': 'SoftRuleVioCorrectionImpact','SolutionUserRequired': 'SolutionUserRequired','SsdDiskNotAvailable': 'SsdDiskNotAvailable','StorageDrsCannotMoveDiskInMultiWriterMode': 'StorageDrsCannotMoveDiskInMultiWriterMode','StorageDrsCannotMoveFTVm': 'StorageDrsCannotMoveFTVm','StorageDrsCannotMoveIndependentDisk': 'StorageDrsCannotMoveIndependentDisk','StorageDrsCannotMoveManuallyPlacedSwapFile': 'StorageDrsCannotMoveManuallyPlacedSwapFile','StorageDrsCannotMoveManuallyPlacedVm': 'StorageDrsCannotMoveManuallyPlacedVm','StorageDrsCannotMoveSharedDisk': 'StorageDrsCannotMoveSharedDisk','StorageDrsCannotMoveTemplate': 'StorageDrsCannotMoveTemplate','StorageDrsCannotMoveVmInUserFolder': 'StorageDrsCannotMoveVmInUserFolder','StorageDrsCannotMoveVmWithMountedCDROM': 'StorageDrsCannotMoveVmWithMountedCDROM','StorageDrsCannotMoveVmWithNoFilesInLayout': 'StorageDrsCannotMoveVmWithNoFilesInLayout','StorageDrsDatacentersCannotShareDatastore': 'StorageDrsDatacentersCannotShareDatastore','StorageDrsDisabledOnVm': 'StorageDrsDisabledOnVm','StorageDrsHbrDiskNotMovable': 'StorageDrsHbrDiskNotMovable','StorageDrsHmsMoveInProgress': 'StorageDrsHmsMoveInProgress','StorageDrsHmsUnreachable': 'StorageDrsHmsUnreachable','StorageDrsIolbDisabledInternally': 'StorageDrsIolbDisabledInternally','StorageDrsRelocateDisabled': 'StorageDrsRelocateDisabled','StorageDrsStaleHmsCollection': 'StorageDrsStaleHmsCollection','StorageDrsUnableToMoveFiles': 'StorageDrsUnableToMoveFiles','StorageVMotionNotSupported': 'StorageVMotionNotSupported','StorageVmotionIncompatible': 'StorageVmotionIncompatible','SuspendedRelocateNotSupported': 'SuspendedRelocateNotSupported','SwapDatastoreNotWritableOnHost': 'SwapDatastoreNotWritableOnHost','SwapDatastoreUnset': 'SwapDatastoreUnset','SwapPlacementOverrideNotSupported': 'SwapPlacementOverrideNotSupported','SwitchIpUnset': 'SwitchIpUnset','SwitchNotInUpgradeMode': 'SwitchNotInUpgradeMode','SystemError': 'SystemError','TaskInProgress': 'TaskInProgress','ThirdPartyLicenseAssignmentFailed': 'ThirdPartyLicenseAssignmentFailed','Timedout': 'Timedout','TooManyConcurrentNativeClones': 'TooManyConcurrentNativeClones','TooManyConsecutiveOverrides': 'TooManyConsecutiveOverrides','TooManyDevices': 'TooManyDevices','TooManyDisksOnLegacyHost': 'TooManyDisksOnLegacyHost','TooManyGuestLogons': 'TooManyGuestLogons','TooManyHosts': 'TooManyHosts','TooManyNativeCloneLevels': 'TooManyNativeCloneLevels','TooManyNativeClonesOnFile': 'TooManyNativeClonesOnFile','TooManySnapshotLevels': 'TooManySnapshotLevels','ToolsAlreadyUpgraded': 'ToolsAlreadyUpgraded','ToolsAutoUpgradeNotSupported': 'ToolsAutoUpgradeNotSupported','ToolsImageCopyFailed': 'ToolsImageCopyFailed','ToolsImageNotAvailable': 'ToolsImageNotAvailable','ToolsImageSignatureCheckFailed': 'ToolsImageSignatureCheckFailed','ToolsInstallationInProgress': 'ToolsInstallationInProgress','ToolsUnavailable': 'ToolsUnavailable','ToolsUpgradeCancelled': 'ToolsUpgradeCancelled','UnSupportedDatastoreForVFlash': 'UnSupportedDatastoreForVFlash','UncommittedUndoableDisk': 'UncommittedUndoableDisk','UnconfiguredPropertyValue': 'UnconfiguredPropertyValue','UncustomizableGuest': 'UncustomizableGuest','UnexpectedCustomizationFault': 'UnexpectedCustomizationFault','UnexpectedFault': 'UnexpectedFault','UnrecognizedHost': 'UnrecognizedHost','UnsharedSwapVMotionNotSupported': 'UnsharedSwapVMotionNotSupported','UnsupportedDatastore': 'UnsupportedDatastore','UnsupportedGuest': 'UnsupportedGuest','UnsupportedVimApiVersion': 'UnsupportedVimApiVersion','UnsupportedVmxLocation': 'UnsupportedVmxLocation','UnusedVirtualDiskBlocksNotScrubbed': 'UnusedVirtualDiskBlocksNotScrubbed','UserNotFound': 'UserNotFound','VAppConfigFault': 'VAppConfigFault','VAppNotRunning': 'VAppNotRunning','VAppOperationInProgress': 'VAppOperationInProgress','VAppPropertyFault': 'VAppPropertyFault','VAppTaskInProgress': 'VAppTaskInProgress','VFlashCacheHotConfigNotSupported': 'VFlashCacheHotConfigNotSupported','VFlashModuleNotSupported': 'VFlashModuleNotSupported','VFlashModuleVersionIncompatible': 'VFlashModuleVersionIncompatible','VMINotSupported': 'VMINotSupported','VMOnConflictDVPort': 'VMOnConflictDVPort','VMOnVirtualIntranet': 'VMOnVirtualIntranet','VMotionAcrossNetworkNotSupported': 'VMotionAcrossNetworkNotSupported','VMotionInterfaceIssue': 'VMotionInterfaceIssue','VMotionLinkCapacityLow': 'VMotionLinkCapacityLow','VMotionLinkDown': 'VMotionLinkDown','VMotionNotConfigured': 'VMotionNotConfigured','VMotionNotLicensed': 'VMotionNotLicensed','VMotionNotSupported': 'VMotionNotSupported','VMotionProtocolIncompatible': 'VMotionProtocolIncompatible','VimFault': 'VimFault','VirtualDiskBlocksNotFullyProvisioned': 'VirtualDiskBlocksNotFullyProvisioned','VirtualDiskModeNotSupported': 'VirtualDiskModeNotSupported','VirtualEthernetCardNotSupported': 'VirtualEthernetCardNotSupported','VirtualHardwareCompatibilityIssue': 'VirtualHardwareCompatibilityIssue','VirtualHardwareVersionNotSupported': 'VirtualHardwareVersionNotSupported','VmAlreadyExistsInDatacenter': 'VmAlreadyExistsInDatacenter','VmConfigFault': 'VmConfigFault','VmConfigIncompatibleForFaultTolerance': 'VmConfigIncompatibleForFaultTolerance','VmConfigIncompatibleForRecordReplay': 'VmConfigIncompatibleForRecordReplay','VmFaultToleranceConfigIssue': 'VmFaultToleranceConfigIssue','VmFaultToleranceConfigIssueWrapper': 'VmFaultToleranceConfigIssueWrapper','VmFaultToleranceInvalidFileBacking': 'VmFaultToleranceInvalidFileBacking','VmFaultToleranceIssue': 'VmFaultToleranceIssue','VmFaultToleranceOpIssuesList': 'VmFaultToleranceOpIssuesList','VmFaultToleranceTooManyFtVcpusOnHost': 'VmFaultToleranceTooManyFtVcpusOnHost','VmFaultToleranceTooManyVMsOnHost': 'VmFaultToleranceTooManyVMsOnHost','VmHostAffinityRuleViolation': 'VmHostAffinityRuleViolation','VmLimitLicense': 'VmLimitLicense','VmMetadataManagerFault': 'VmMetadataManagerFault','VmMonitorIncompatibleForFaultTolerance': 'VmMonitorIncompatibleForFaultTolerance','VmPowerOnDisabled': 'VmPowerOnDisabled','VmSmpFaultToleranceTooManyVMsOnHost': 'VmSmpFaultToleranceTooManyVMsOnHost','VmToolsUpgradeFault': 'VmToolsUpgradeFault','VmValidateMaxDevice': 'VmValidateMaxDevice','VmWwnConflict': 'VmWwnConflict','VmfsAlreadyMounted': 'VmfsAlreadyMounted','VmfsAmbiguousMount': 'VmfsAmbiguousMount','VmfsMountFault': 'VmfsMountFault','VmotionInterfaceNotEnabled': 'VmotionInterfaceNotEnabled','VolumeEditorError': 'VolumeEditorError','VramLimitLicense': 'VramLimitLicense','VsanClusterUuidMismatch': 'VsanClusterUuidMismatch','VsanDiskFault': 'VsanDiskFault','VsanFault': 'VsanFault','VsanIncompatibleDiskMapping': 'VsanIncompatibleDiskMapping','VspanDestPortConflict': 'VspanDestPortConflict','VspanPortConflict': 'VspanPortConflict','VspanPortMoveFault': 'VspanPortMoveFault','VspanPortPromiscChangeFault': 'VspanPortPromiscChangeFault','VspanPortgroupPromiscChangeFault': 'VspanPortgroupPromiscChangeFault','VspanPortgroupTypeChangeFault': 'VspanPortgroupTypeChangeFault','VspanPromiscuousPortNotSupported': 'VspanPromiscuousPortNotSupported','VspanSameSessionPortConflict': 'VspanSameSessionPortConflict','WakeOnLanNotSupported': 'WakeOnLanNotSupported','WakeOnLanNotSupportedByVmotionNIC': 'WakeOnLanNotSupportedByVmotionNIC','WillLoseHAProtection': 'WillLoseHAProtection','WillModifyConfigCpuRequirements': 'WillModifyConfigCpuRequirements','WillResetSnapshotDirectory': 'WillResetSnapshotDirectory','WipeDiskFault': 'WipeDiskFault'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of MethodFault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of MethodFault from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("MethodFault failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.active_directory_fault import ActiveDirectoryFault
from vmware_vi.models.active_vms_blocking_evc import ActiveVMsBlockingEVC
from vmware_vi.models.admin_disabled import AdminDisabled
from vmware_vi.models.admin_not_disabled import AdminNotDisabled
from vmware_vi.models.affinity_configured import AffinityConfigured
from vmware_vi.models.agent_install_failed import AgentInstallFailed
from vmware_vi.models.already_being_managed import AlreadyBeingManaged
from vmware_vi.models.already_connected import AlreadyConnected
from vmware_vi.models.already_exists import AlreadyExists
from vmware_vi.models.already_upgraded import AlreadyUpgraded
from vmware_vi.models.answer_file_update_failed import AnswerFileUpdateFailed
from vmware_vi.models.application_quiesce_fault import ApplicationQuiesceFault
from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.auth_minimum_admin_permission import AuthMinimumAdminPermission
from vmware_vi.models.backup_blob_read_failure import BackupBlobReadFailure
from vmware_vi.models.backup_blob_write_failure import BackupBlobWriteFailure
from vmware_vi.models.blocked_by_firewall import BlockedByFirewall
from vmware_vi.models.cam_server_refused_connection import CAMServerRefusedConnection
from vmware_vi.models.cannot_access_file import CannotAccessFile
from vmware_vi.models.cannot_access_local_source import CannotAccessLocalSource
from vmware_vi.models.cannot_access_network import CannotAccessNetwork
from vmware_vi.models.cannot_access_vm_component import CannotAccessVmComponent
from vmware_vi.models.cannot_access_vm_config import CannotAccessVmConfig
from vmware_vi.models.cannot_access_vm_device import CannotAccessVmDevice
from vmware_vi.models.cannot_access_vm_disk import CannotAccessVmDisk
from vmware_vi.models.cannot_add_host_with_ftvm_as_standalone import CannotAddHostWithFTVmAsStandalone
from vmware_vi.models.cannot_add_host_with_ftvm_to_different_cluster import CannotAddHostWithFTVmToDifferentCluster
from vmware_vi.models.cannot_add_host_with_ftvm_to_non_ha_cluster import CannotAddHostWithFTVmToNonHACluster
from vmware_vi.models.cannot_change_drs_behavior_for_ft_secondary import CannotChangeDrsBehaviorForFtSecondary
from vmware_vi.models.cannot_change_ha_settings_for_ft_secondary import CannotChangeHaSettingsForFtSecondary
from vmware_vi.models.cannot_change_vsan_cluster_uuid import CannotChangeVsanClusterUuid
from vmware_vi.models.cannot_change_vsan_node_uuid import CannotChangeVsanNodeUuid
from vmware_vi.models.cannot_compute_ft_compatible_hosts import CannotComputeFTCompatibleHosts
from vmware_vi.models.cannot_create_file import CannotCreateFile
from vmware_vi.models.cannot_decrypt_passwords import CannotDecryptPasswords
from vmware_vi.models.cannot_delete_file import CannotDeleteFile
from vmware_vi.models.cannot_disable_drs_on_clusters_with_v_apps import CannotDisableDrsOnClustersWithVApps
from vmware_vi.models.cannot_disable_snapshot import CannotDisableSnapshot
from vmware_vi.models.cannot_disconnect_host_with_fault_tolerance_vm import CannotDisconnectHostWithFaultToleranceVm
from vmware_vi.models.cannot_enable_vmcp_for_cluster import CannotEnableVmcpForCluster
from vmware_vi.models.cannot_modify_config_cpu_requirements import CannotModifyConfigCpuRequirements
from vmware_vi.models.cannot_move_fault_tolerance_vm import CannotMoveFaultToleranceVm
from vmware_vi.models.cannot_move_host_with_fault_tolerance_vm import CannotMoveHostWithFaultToleranceVm
from vmware_vi.models.cannot_move_vm_with_delta_disk import CannotMoveVmWithDeltaDisk
from vmware_vi.models.cannot_move_vm_with_native_delta_disk import CannotMoveVmWithNativeDeltaDisk
from vmware_vi.models.cannot_move_vsan_enabled_host import CannotMoveVsanEnabledHost
from vmware_vi.models.cannot_place_without_prerequisite_moves import CannotPlaceWithoutPrerequisiteMoves
from vmware_vi.models.cannot_power_off_vm_in_cluster import CannotPowerOffVmInCluster
from vmware_vi.models.cannot_reconfigure_vsan_when_ha_enabled import CannotReconfigureVsanWhenHaEnabled
from vmware_vi.models.cannot_use_network import CannotUseNetwork
from vmware_vi.models.clock_skew import ClockSkew
from vmware_vi.models.clone_from_snapshot_not_supported import CloneFromSnapshotNotSupported
from vmware_vi.models.collector_address_unset import CollectorAddressUnset
from vmware_vi.models.concurrent_access import ConcurrentAccess
from vmware_vi.models.conflicting_configuration import ConflictingConfiguration
from vmware_vi.models.conflicting_datastore_found import ConflictingDatastoreFound
from vmware_vi.models.connected_iso import ConnectedIso
from vmware_vi.models.cpu_compatibility_unknown import CpuCompatibilityUnknown
from vmware_vi.models.cpu_hot_plug_not_supported import CpuHotPlugNotSupported
from vmware_vi.models.cpu_incompatible import CpuIncompatible
from vmware_vi.models.cpu_incompatible1_ecx import CpuIncompatible1ECX
from vmware_vi.models.cpu_incompatible81_edx import CpuIncompatible81EDX
from vmware_vi.models.customization_fault import CustomizationFault
from vmware_vi.models.customization_pending import CustomizationPending
from vmware_vi.models.das_config_fault import DasConfigFault
from vmware_vi.models.database_error import DatabaseError
from vmware_vi.models.datacenter_mismatch import DatacenterMismatch
from vmware_vi.models.datastore_not_writable_on_host import DatastoreNotWritableOnHost
from vmware_vi.models.delta_disk_format_not_supported import DeltaDiskFormatNotSupported
from vmware_vi.models.destination_switch_full import DestinationSwitchFull
from vmware_vi.models.destination_vsan_disabled import DestinationVsanDisabled
from vmware_vi.models.device_backing_not_supported import DeviceBackingNotSupported
from vmware_vi.models.device_controller_not_supported import DeviceControllerNotSupported
from vmware_vi.models.device_hot_plug_not_supported import DeviceHotPlugNotSupported
from vmware_vi.models.device_not_found import DeviceNotFound
from vmware_vi.models.device_not_supported import DeviceNotSupported
from vmware_vi.models.device_unsupported_for_vm_platform import DeviceUnsupportedForVmPlatform
from vmware_vi.models.device_unsupported_for_vm_version import DeviceUnsupportedForVmVersion
from vmware_vi.models.digest_not_supported import DigestNotSupported
from vmware_vi.models.directory_not_empty import DirectoryNotEmpty
from vmware_vi.models.disable_admin_not_supported import DisableAdminNotSupported
from vmware_vi.models.disallowed_change_by_service import DisallowedChangeByService
from vmware_vi.models.disallowed_disk_mode_change import DisallowedDiskModeChange
from vmware_vi.models.disallowed_migration_device_attached import DisallowedMigrationDeviceAttached
from vmware_vi.models.disallowed_operation_on_failover_host import DisallowedOperationOnFailoverHost
from vmware_vi.models.disconnected_hosts_blocking_evc import DisconnectedHostsBlockingEVC
from vmware_vi.models.disk_has_partitions import DiskHasPartitions
from vmware_vi.models.disk_is_last_remaining_non_ssd import DiskIsLastRemainingNonSSD
from vmware_vi.models.disk_is_non_local import DiskIsNonLocal
from vmware_vi.models.disk_is_usb import DiskIsUSB
from vmware_vi.models.disk_move_type_not_supported import DiskMoveTypeNotSupported
from vmware_vi.models.disk_not_supported import DiskNotSupported
from vmware_vi.models.disk_too_small import DiskTooSmall
from vmware_vi.models.domain_not_found import DomainNotFound
from vmware_vi.models.drs_disabled_on_vm import DrsDisabledOnVm
from vmware_vi.models.drs_vmotion_incompatible_fault import DrsVmotionIncompatibleFault
from vmware_vi.models.duplicate_disks import DuplicateDisks
from vmware_vi.models.duplicate_name import DuplicateName
from vmware_vi.models.duplicate_vsan_network_interface import DuplicateVsanNetworkInterface
from vmware_vi.models.dv_port_not_supported import DVPortNotSupported
from vmware_vi.models.dvs_apply_operation_fault import DvsApplyOperationFault
from vmware_vi.models.dvs_fault import DvsFault
from vmware_vi.models.dvs_not_authorized import DvsNotAuthorized
from vmware_vi.models.dvs_operation_bulk_fault import DvsOperationBulkFault
from vmware_vi.models.dvs_scope_violated import DvsScopeViolated
from vmware_vi.models.eight_host_limit_violated import EightHostLimitViolated
from vmware_vi.models.encryption_key_required import EncryptionKeyRequired
from vmware_vi.models.evc_admission_failed import EVCAdmissionFailed
from vmware_vi.models.evc_admission_failed_cpu_features_for_mode import EVCAdmissionFailedCPUFeaturesForMode
from vmware_vi.models.evc_admission_failed_cpu_model import EVCAdmissionFailedCPUModel
from vmware_vi.models.evc_admission_failed_cpu_model_for_mode import EVCAdmissionFailedCPUModelForMode
from vmware_vi.models.evc_admission_failed_cpu_vendor import EVCAdmissionFailedCPUVendor
from vmware_vi.models.evc_admission_failed_cpu_vendor_unknown import EVCAdmissionFailedCPUVendorUnknown
from vmware_vi.models.evc_admission_failed_host_disconnected import EVCAdmissionFailedHostDisconnected
from vmware_vi.models.evc_admission_failed_host_software import EVCAdmissionFailedHostSoftware
from vmware_vi.models.evc_admission_failed_host_software_for_mode import EVCAdmissionFailedHostSoftwareForMode
from vmware_vi.models.evc_admission_failed_vm_active import EVCAdmissionFailedVmActive
from vmware_vi.models.evc_config_fault import EVCConfigFault
from vmware_vi.models.evc_mode_illegal_by_vendor import EVCModeIllegalByVendor
from vmware_vi.models.evc_mode_unsupported_by_hosts import EVCModeUnsupportedByHosts
from vmware_vi.models.evc_unsupported_by_host_hardware import EVCUnsupportedByHostHardware
from vmware_vi.models.evc_unsupported_by_host_software import EVCUnsupportedByHostSoftware
from vmware_vi.models.expired_addon_license import ExpiredAddonLicense
from vmware_vi.models.expired_edition_license import ExpiredEditionLicense
from vmware_vi.models.expired_feature_license import ExpiredFeatureLicense
from vmware_vi.models.extended_fault import ExtendedFault
from vmware_vi.models.fail_to_enable_spbm import FailToEnableSPBM
from vmware_vi.models.fail_to_lock_fault_tolerance_vms import FailToLockFaultToleranceVMs
from vmware_vi.models.fault_tolerance_anti_affinity_violated import FaultToleranceAntiAffinityViolated
from vmware_vi.models.fault_tolerance_cannot_edit_mem import FaultToleranceCannotEditMem
from vmware_vi.models.fault_tolerance_cpu_incompatible import FaultToleranceCpuIncompatible
from vmware_vi.models.fault_tolerance_needs_thick_disk import FaultToleranceNeedsThickDisk
from vmware_vi.models.fault_tolerance_not_licensed import FaultToleranceNotLicensed
from vmware_vi.models.fault_tolerance_not_same_build import FaultToleranceNotSameBuild
from vmware_vi.models.fault_tolerance_primary_power_on_not_attempted import FaultTolerancePrimaryPowerOnNotAttempted
from vmware_vi.models.fault_tolerance_vm_not_das_protected import FaultToleranceVmNotDasProtected
from vmware_vi.models.fcoe_fault import FcoeFault
from vmware_vi.models.fcoe_fault_pnic_has_no_port_set import FcoeFaultPnicHasNoPortSet
from vmware_vi.models.feature_requirements_not_met import FeatureRequirementsNotMet
from vmware_vi.models.file_already_exists import FileAlreadyExists
from vmware_vi.models.file_backed_port_not_supported import FileBackedPortNotSupported
from vmware_vi.models.file_fault import FileFault
from vmware_vi.models.file_locked import FileLocked
from vmware_vi.models.file_name_too_long import FileNameTooLong
from vmware_vi.models.file_not_found import FileNotFound
from vmware_vi.models.file_not_writable import FileNotWritable
from vmware_vi.models.file_too_large import FileTooLarge
from vmware_vi.models.filesystem_quiesce_fault import FilesystemQuiesceFault
from vmware_vi.models.filter_in_use import FilterInUse
from vmware_vi.models.ft_issues_on_host import FtIssuesOnHost
from vmware_vi.models.full_storage_v_motion_not_supported import FullStorageVMotionNotSupported
from vmware_vi.models.gateway_connect_fault import GatewayConnectFault
from vmware_vi.models.gateway_host_not_reachable import GatewayHostNotReachable
from vmware_vi.models.gateway_not_found import GatewayNotFound
from vmware_vi.models.gateway_not_reachable import GatewayNotReachable
from vmware_vi.models.gateway_operation_refused import GatewayOperationRefused
from vmware_vi.models.gateway_to_host_auth_fault import GatewayToHostAuthFault
from vmware_vi.models.gateway_to_host_connect_fault import GatewayToHostConnectFault
from vmware_vi.models.gateway_to_host_trust_verify_fault import GatewayToHostTrustVerifyFault
from vmware_vi.models.generic_drs_fault import GenericDrsFault
from vmware_vi.models.generic_vm_config_fault import GenericVmConfigFault
from vmware_vi.models.guest_authentication_challenge import GuestAuthenticationChallenge
from vmware_vi.models.guest_components_out_of_date import GuestComponentsOutOfDate
from vmware_vi.models.guest_multiple_mappings import GuestMultipleMappings
from vmware_vi.models.guest_operations_fault import GuestOperationsFault
from vmware_vi.models.guest_operations_unavailable import GuestOperationsUnavailable
from vmware_vi.models.guest_permission_denied import GuestPermissionDenied
from vmware_vi.models.guest_process_not_found import GuestProcessNotFound
from vmware_vi.models.guest_registry_fault import GuestRegistryFault
from vmware_vi.models.guest_registry_key_already_exists import GuestRegistryKeyAlreadyExists
from vmware_vi.models.guest_registry_key_fault import GuestRegistryKeyFault
from vmware_vi.models.guest_registry_key_has_subkeys import GuestRegistryKeyHasSubkeys
from vmware_vi.models.guest_registry_key_invalid import GuestRegistryKeyInvalid
from vmware_vi.models.guest_registry_key_parent_volatile import GuestRegistryKeyParentVolatile
from vmware_vi.models.guest_registry_value_fault import GuestRegistryValueFault
from vmware_vi.models.guest_registry_value_not_found import GuestRegistryValueNotFound
from vmware_vi.models.ha_errors_at_dest import HAErrorsAtDest
from vmware_vi.models.heterogenous_hosts_blocking_evc import HeterogenousHostsBlockingEVC
from vmware_vi.models.host_access_restricted_to_management_server import HostAccessRestrictedToManagementServer
from vmware_vi.models.host_communication import HostCommunication
from vmware_vi.models.host_config_failed import HostConfigFailed
from vmware_vi.models.host_config_fault import HostConfigFault
from vmware_vi.models.host_connect_fault import HostConnectFault
from vmware_vi.models.host_has_component_failure import HostHasComponentFailure
from vmware_vi.models.host_in_domain import HostInDomain
from vmware_vi.models.host_incompatible_for_fault_tolerance import HostIncompatibleForFaultTolerance
from vmware_vi.models.host_incompatible_for_record_replay import HostIncompatibleForRecordReplay
from vmware_vi.models.host_inventory_full import HostInventoryFull
from vmware_vi.models.host_not_connected import HostNotConnected
from vmware_vi.models.host_not_reachable import HostNotReachable
from vmware_vi.models.host_power_op_failed import HostPowerOpFailed
from vmware_vi.models.host_specification_operation_failed import HostSpecificationOperationFailed
from vmware_vi.models.hot_snapshot_move_not_supported import HotSnapshotMoveNotSupported
from vmware_vi.models.http_fault import HttpFault
from vmware_vi.models.ide_disk_not_supported import IDEDiskNotSupported
from vmware_vi.models.import_host_add_failure import ImportHostAddFailure
from vmware_vi.models.import_operation_bulk_fault import ImportOperationBulkFault
from vmware_vi.models.in_use_feature_manipulation_disallowed import InUseFeatureManipulationDisallowed
from vmware_vi.models.inaccessible_datastore import InaccessibleDatastore
from vmware_vi.models.inaccessible_ft_metadata_datastore import InaccessibleFTMetadataDatastore
from vmware_vi.models.inaccessible_v_flash_source import InaccessibleVFlashSource
from vmware_vi.models.incompatible_default_device import IncompatibleDefaultDevice
from vmware_vi.models.incompatible_host_for_ft_secondary import IncompatibleHostForFtSecondary
from vmware_vi.models.incompatible_host_for_vm_replication import IncompatibleHostForVmReplication
from vmware_vi.models.incompatible_setting import IncompatibleSetting
from vmware_vi.models.incorrect_file_type import IncorrectFileType
from vmware_vi.models.incorrect_host_information import IncorrectHostInformation
from vmware_vi.models.independent_disk_v_motion_not_supported import IndependentDiskVMotionNotSupported
from vmware_vi.models.insufficient_agent_vms_deployed import InsufficientAgentVmsDeployed
from vmware_vi.models.insufficient_cpu_resources_fault import InsufficientCpuResourcesFault
from vmware_vi.models.insufficient_disks import InsufficientDisks
from vmware_vi.models.insufficient_failover_resources_fault import InsufficientFailoverResourcesFault
from vmware_vi.models.insufficient_graphics_resources_fault import InsufficientGraphicsResourcesFault
from vmware_vi.models.insufficient_host_capacity_fault import InsufficientHostCapacityFault
from vmware_vi.models.insufficient_host_cpu_capacity_fault import InsufficientHostCpuCapacityFault
from vmware_vi.models.insufficient_host_memory_capacity_fault import InsufficientHostMemoryCapacityFault
from vmware_vi.models.insufficient_memory_resources_fault import InsufficientMemoryResourcesFault
from vmware_vi.models.insufficient_network_capacity import InsufficientNetworkCapacity
from vmware_vi.models.insufficient_network_resource_pool_capacity import InsufficientNetworkResourcePoolCapacity
from vmware_vi.models.insufficient_per_cpu_capacity import InsufficientPerCpuCapacity
from vmware_vi.models.insufficient_resources_fault import InsufficientResourcesFault
from vmware_vi.models.insufficient_standby_cpu_resource import InsufficientStandbyCpuResource
from vmware_vi.models.insufficient_standby_memory_resource import InsufficientStandbyMemoryResource
from vmware_vi.models.insufficient_standby_resource import InsufficientStandbyResource
from vmware_vi.models.insufficient_storage_iops import InsufficientStorageIops
from vmware_vi.models.insufficient_storage_space import InsufficientStorageSpace
from vmware_vi.models.insufficient_v_flash_resources_fault import InsufficientVFlashResourcesFault
from vmware_vi.models.invalid_affinity_setting_fault import InvalidAffinitySettingFault
from vmware_vi.models.invalid_argument import InvalidArgument
from vmware_vi.models.invalid_bmc_role import InvalidBmcRole
from vmware_vi.models.invalid_bundle import InvalidBundle
from vmware_vi.models.invalid_cam_certificate import InvalidCAMCertificate
from vmware_vi.models.invalid_cam_server import InvalidCAMServer
from vmware_vi.models.invalid_client_certificate import InvalidClientCertificate
from vmware_vi.models.invalid_collector_version import InvalidCollectorVersion
from vmware_vi.models.invalid_controller import InvalidController
from vmware_vi.models.invalid_das_config_argument import InvalidDasConfigArgument
from vmware_vi.models.invalid_das_restart_priority_for_ft_vm import InvalidDasRestartPriorityForFtVm
from vmware_vi.models.invalid_datastore import InvalidDatastore
from vmware_vi.models.invalid_datastore_path import InvalidDatastorePath
from vmware_vi.models.invalid_datastore_state import InvalidDatastoreState
from vmware_vi.models.invalid_device_backing import InvalidDeviceBacking
from vmware_vi.models.invalid_device_operation import InvalidDeviceOperation
from vmware_vi.models.invalid_device_spec import InvalidDeviceSpec
from vmware_vi.models.invalid_disk_format import InvalidDiskFormat
from vmware_vi.models.invalid_drs_behavior_for_ft_vm import InvalidDrsBehaviorForFtVm
from vmware_vi.models.invalid_edition_license import InvalidEditionLicense
from vmware_vi.models.invalid_event import InvalidEvent
from vmware_vi.models.invalid_folder import InvalidFolder
from vmware_vi.models.invalid_format import InvalidFormat
from vmware_vi.models.invalid_guest_login import InvalidGuestLogin
from vmware_vi.models.invalid_host_connection_state import InvalidHostConnectionState
from vmware_vi.models.invalid_host_name import InvalidHostName
from vmware_vi.models.invalid_host_state import InvalidHostState
from vmware_vi.models.invalid_index_argument import InvalidIndexArgument
from vmware_vi.models.invalid_ipfix_config import InvalidIpfixConfig
from vmware_vi.models.invalid_ipmi_login_info import InvalidIpmiLoginInfo
from vmware_vi.models.invalid_ipmi_mac_address import InvalidIpmiMacAddress
from vmware_vi.models.invalid_license import InvalidLicense
from vmware_vi.models.invalid_locale import InvalidLocale
from vmware_vi.models.invalid_login import InvalidLogin
from vmware_vi.models.invalid_name import InvalidName
from vmware_vi.models.invalid_nas_credentials import InvalidNasCredentials
from vmware_vi.models.invalid_network_in_type import InvalidNetworkInType
from vmware_vi.models.invalid_network_resource import InvalidNetworkResource
from vmware_vi.models.invalid_operation_on_secondary_vm import InvalidOperationOnSecondaryVm
from vmware_vi.models.invalid_power_state import InvalidPowerState
from vmware_vi.models.invalid_privilege import InvalidPrivilege
from vmware_vi.models.invalid_profile_reference_host import InvalidProfileReferenceHost
from vmware_vi.models.invalid_property import InvalidProperty
from vmware_vi.models.invalid_property_type import InvalidPropertyType
from vmware_vi.models.invalid_property_value import InvalidPropertyValue
from vmware_vi.models.invalid_request import InvalidRequest
from vmware_vi.models.invalid_resource_pool_structure_fault import InvalidResourcePoolStructureFault
from vmware_vi.models.invalid_snapshot_format import InvalidSnapshotFormat
from vmware_vi.models.invalid_state import InvalidState
from vmware_vi.models.invalid_type import InvalidType
from vmware_vi.models.invalid_vm_config import InvalidVmConfig
from vmware_vi.models.invalid_vm_state import InvalidVmState
from vmware_vi.models.inventory_has_standard_alone_hosts import InventoryHasStandardAloneHosts
from vmware_vi.models.iorm_not_supported_host_on_datastore import IORMNotSupportedHostOnDatastore
from vmware_vi.models.ip_hostname_generator_error import IpHostnameGeneratorError
from vmware_vi.models.iscsi_fault import IscsiFault
from vmware_vi.models.iscsi_fault_invalid_vnic import IscsiFaultInvalidVnic
from vmware_vi.models.iscsi_fault_pnic_in_use import IscsiFaultPnicInUse
from vmware_vi.models.iscsi_fault_vnic_already_bound import IscsiFaultVnicAlreadyBound
from vmware_vi.models.iscsi_fault_vnic_has_active_paths import IscsiFaultVnicHasActivePaths
from vmware_vi.models.iscsi_fault_vnic_has_multiple_uplinks import IscsiFaultVnicHasMultipleUplinks
from vmware_vi.models.iscsi_fault_vnic_has_no_uplinks import IscsiFaultVnicHasNoUplinks
from vmware_vi.models.iscsi_fault_vnic_has_wrong_uplink import IscsiFaultVnicHasWrongUplink
from vmware_vi.models.iscsi_fault_vnic_in_use import IscsiFaultVnicInUse
from vmware_vi.models.iscsi_fault_vnic_is_last_path import IscsiFaultVnicIsLastPath
from vmware_vi.models.iscsi_fault_vnic_not_bound import IscsiFaultVnicNotBound
from vmware_vi.models.iscsi_fault_vnic_not_found import IscsiFaultVnicNotFound
from vmware_vi.models.key_not_found import KeyNotFound
from vmware_vi.models.large_rdm_conversion_not_supported import LargeRDMConversionNotSupported
from vmware_vi.models.large_rdm_not_supported_on_datastore import LargeRDMNotSupportedOnDatastore
from vmware_vi.models.legacy_network_interface_in_use import LegacyNetworkInterfaceInUse
from vmware_vi.models.license_assignment_failed import LicenseAssignmentFailed
from vmware_vi.models.license_downgrade_disallowed import LicenseDowngradeDisallowed
from vmware_vi.models.license_entity_not_found import LicenseEntityNotFound
from vmware_vi.models.license_expired import LicenseExpired
from vmware_vi.models.license_key_entity_mismatch import LicenseKeyEntityMismatch
from vmware_vi.models.license_restricted import LicenseRestricted
from vmware_vi.models.license_server_unavailable import LicenseServerUnavailable
from vmware_vi.models.license_source_unavailable import LicenseSourceUnavailable
from vmware_vi.models.limit_exceeded import LimitExceeded
from vmware_vi.models.linux_volume_not_clean import LinuxVolumeNotClean
from vmware_vi.models.log_bundling_failed import LogBundlingFailed
from vmware_vi.models.maintenance_mode_file_move import MaintenanceModeFileMove
from vmware_vi.models.managed_object_not_found import ManagedObjectNotFound
from vmware_vi.models.memory_file_format_not_supported_by_datastore import MemoryFileFormatNotSupportedByDatastore
from vmware_vi.models.memory_hot_plug_not_supported import MemoryHotPlugNotSupported
from vmware_vi.models.memory_size_not_recommended import MemorySizeNotRecommended
from vmware_vi.models.memory_size_not_supported import MemorySizeNotSupported
from vmware_vi.models.memory_size_not_supported_by_datastore import MemorySizeNotSupportedByDatastore
from vmware_vi.models.memory_snapshot_on_independent_disk import MemorySnapshotOnIndependentDisk
from vmware_vi.models.method_already_disabled_fault import MethodAlreadyDisabledFault
from vmware_vi.models.method_disabled import MethodDisabled
from vmware_vi.models.method_not_found import MethodNotFound
from vmware_vi.models.migration_disabled import MigrationDisabled
from vmware_vi.models.migration_fault import MigrationFault
from vmware_vi.models.migration_feature_not_supported import MigrationFeatureNotSupported
from vmware_vi.models.migration_not_ready import MigrationNotReady
from vmware_vi.models.mismatched_bundle import MismatchedBundle
from vmware_vi.models.mismatched_network_policies import MismatchedNetworkPolicies
from vmware_vi.models.mismatched_v_motion_network_names import MismatchedVMotionNetworkNames
from vmware_vi.models.missing_bmc_support import MissingBmcSupport
from vmware_vi.models.missing_controller import MissingController
from vmware_vi.models.missing_ip_pool import MissingIpPool
from vmware_vi.models.missing_linux_cust_resources import MissingLinuxCustResources
from vmware_vi.models.missing_network_ip_config import MissingNetworkIpConfig
from vmware_vi.models.missing_power_off_configuration import MissingPowerOffConfiguration
from vmware_vi.models.missing_power_on_configuration import MissingPowerOnConfiguration
from vmware_vi.models.missing_windows_cust_resources import MissingWindowsCustResources
from vmware_vi.models.mks_connection_limit_reached import MksConnectionLimitReached
from vmware_vi.models.mount_error import MountError
from vmware_vi.models.multi_writer_not_supported import MultiWriterNotSupported
from vmware_vi.models.multiple_certificates_verify_fault import MultipleCertificatesVerifyFault
from vmware_vi.models.multiple_snapshots_not_supported import MultipleSnapshotsNotSupported
from vmware_vi.models.namespace_full import NamespaceFull
from vmware_vi.models.namespace_limit_reached import NamespaceLimitReached
from vmware_vi.models.namespace_write_protected import NamespaceWriteProtected
from vmware_vi.models.nas_config_fault import NasConfigFault
from vmware_vi.models.nas_connection_limit_reached import NasConnectionLimitReached
from vmware_vi.models.nas_session_credential_conflict import NasSessionCredentialConflict
from vmware_vi.models.nas_volume_not_mounted import NasVolumeNotMounted
from vmware_vi.models.network_copy_fault import NetworkCopyFault
from vmware_vi.models.network_disrupted_and_config_rolled_back import NetworkDisruptedAndConfigRolledBack
from vmware_vi.models.network_inaccessible import NetworkInaccessible
from vmware_vi.models.networks_may_not_be_the_same import NetworksMayNotBeTheSame
from vmware_vi.models.nic_setting_mismatch import NicSettingMismatch
from vmware_vi.models.no_active_host_in_cluster import NoActiveHostInCluster
from vmware_vi.models.no_available_ip import NoAvailableIp
from vmware_vi.models.no_client_certificate import NoClientCertificate
from vmware_vi.models.no_compatible_datastore import NoCompatibleDatastore
from vmware_vi.models.no_compatible_hard_affinity_host import NoCompatibleHardAffinityHost
from vmware_vi.models.no_compatible_host import NoCompatibleHost
from vmware_vi.models.no_compatible_host_with_access_to_device import NoCompatibleHostWithAccessToDevice
from vmware_vi.models.no_compatible_soft_affinity_host import NoCompatibleSoftAffinityHost
from vmware_vi.models.no_connected_datastore import NoConnectedDatastore
from vmware_vi.models.no_disk_found import NoDiskFound
from vmware_vi.models.no_disk_space import NoDiskSpace
from vmware_vi.models.no_disks_to_customize import NoDisksToCustomize
from vmware_vi.models.no_gateway import NoGateway
from vmware_vi.models.no_guest_heartbeat import NoGuestHeartbeat
from vmware_vi.models.no_host import NoHost
from vmware_vi.models.no_host_suitable_for_ft_secondary import NoHostSuitableForFtSecondary
from vmware_vi.models.no_license_server_configured import NoLicenseServerConfigured
from vmware_vi.models.no_peer_host_found import NoPeerHostFound
from vmware_vi.models.no_permission import NoPermission
from vmware_vi.models.no_permission_on_ad import NoPermissionOnAD
from vmware_vi.models.no_permission_on_host import NoPermissionOnHost
from vmware_vi.models.no_permission_on_nas_volume import NoPermissionOnNasVolume
from vmware_vi.models.no_subject_name import NoSubjectName
from vmware_vi.models.no_vc_managed_ip_configured import NoVcManagedIpConfigured
from vmware_vi.models.no_virtual_nic import NoVirtualNic
from vmware_vi.models.no_vm_in_v_app import NoVmInVApp
from vmware_vi.models.non_ad_user_required import NonADUserRequired
from vmware_vi.models.non_home_rdmv_motion_not_supported import NonHomeRDMVMotionNotSupported
from vmware_vi.models.non_persistent_disks_not_supported import NonPersistentDisksNotSupported
from vmware_vi.models.non_vmware_oui_mac_not_supported_host import NonVmwareOuiMacNotSupportedHost
from vmware_vi.models.not_a_directory import NotADirectory
from vmware_vi.models.not_a_file import NotAFile
from vmware_vi.models.not_authenticated import NotAuthenticated
from vmware_vi.models.not_enough_cpus import NotEnoughCpus
from vmware_vi.models.not_enough_licenses import NotEnoughLicenses
from vmware_vi.models.not_enough_logical_cpus import NotEnoughLogicalCpus
from vmware_vi.models.not_found import NotFound
from vmware_vi.models.not_implemented import NotImplemented
from vmware_vi.models.not_supported import NotSupported
from vmware_vi.models.not_supported_device_for_ft import NotSupportedDeviceForFT
from vmware_vi.models.not_supported_host import NotSupportedHost
from vmware_vi.models.not_supported_host_for_checksum import NotSupportedHostForChecksum
from vmware_vi.models.not_supported_host_for_v_flash import NotSupportedHostForVFlash
from vmware_vi.models.not_supported_host_for_vmcp import NotSupportedHostForVmcp
from vmware_vi.models.not_supported_host_for_vmem_file import NotSupportedHostForVmemFile
from vmware_vi.models.not_supported_host_for_vsan import NotSupportedHostForVsan
from vmware_vi.models.not_supported_host_in_cluster import NotSupportedHostInCluster
from vmware_vi.models.not_supported_host_in_dvs import NotSupportedHostInDvs
from vmware_vi.models.not_supported_host_in_ha_cluster import NotSupportedHostInHACluster
from vmware_vi.models.not_user_configurable_property import NotUserConfigurableProperty
from vmware_vi.models.num_virtual_cores_per_socket_not_supported import NumVirtualCoresPerSocketNotSupported
from vmware_vi.models.num_virtual_cpus_exceeds_limit import NumVirtualCpusExceedsLimit
from vmware_vi.models.num_virtual_cpus_incompatible import NumVirtualCpusIncompatible
from vmware_vi.models.num_virtual_cpus_not_supported import NumVirtualCpusNotSupported
from vmware_vi.models.operation_disabled_by_guest import OperationDisabledByGuest
from vmware_vi.models.operation_disallowed_on_host import OperationDisallowedOnHost
from vmware_vi.models.operation_not_supported_by_guest import OperationNotSupportedByGuest
from vmware_vi.models.out_of_bounds import OutOfBounds
from vmware_vi.models.ovf_attribute import OvfAttribute
from vmware_vi.models.ovf_connected_device import OvfConnectedDevice
from vmware_vi.models.ovf_connected_device_floppy import OvfConnectedDeviceFloppy
from vmware_vi.models.ovf_connected_device_iso import OvfConnectedDeviceIso
from vmware_vi.models.ovf_constraint import OvfConstraint
from vmware_vi.models.ovf_consumer_callback_fault import OvfConsumerCallbackFault
from vmware_vi.models.ovf_consumer_communication_error import OvfConsumerCommunicationError
from vmware_vi.models.ovf_consumer_fault import OvfConsumerFault
from vmware_vi.models.ovf_consumer_invalid_section import OvfConsumerInvalidSection
from vmware_vi.models.ovf_consumer_power_on_fault import OvfConsumerPowerOnFault
from vmware_vi.models.ovf_consumer_undeclared_section import OvfConsumerUndeclaredSection
from vmware_vi.models.ovf_consumer_undefined_prefix import OvfConsumerUndefinedPrefix
from vmware_vi.models.ovf_consumer_validation_fault import OvfConsumerValidationFault
from vmware_vi.models.ovf_cpu_compatibility import OvfCpuCompatibility
from vmware_vi.models.ovf_cpu_compatibility_check_not_supported import OvfCpuCompatibilityCheckNotSupported
from vmware_vi.models.ovf_disk_mapping_not_found import OvfDiskMappingNotFound
from vmware_vi.models.ovf_disk_order_constraint import OvfDiskOrderConstraint
from vmware_vi.models.ovf_duplicate_element import OvfDuplicateElement
from vmware_vi.models.ovf_duplicated_element_boundary import OvfDuplicatedElementBoundary
from vmware_vi.models.ovf_duplicated_property_id_export import OvfDuplicatedPropertyIdExport
from vmware_vi.models.ovf_duplicated_property_id_import import OvfDuplicatedPropertyIdImport
from vmware_vi.models.ovf_element import OvfElement
from vmware_vi.models.ovf_element_invalid_value import OvfElementInvalidValue
from vmware_vi.models.ovf_export import OvfExport
from vmware_vi.models.ovf_export_failed import OvfExportFailed
from vmware_vi.models.ovf_fault import OvfFault
from vmware_vi.models.ovf_hardware_check import OvfHardwareCheck
from vmware_vi.models.ovf_hardware_export import OvfHardwareExport
from vmware_vi.models.ovf_host_resource_constraint import OvfHostResourceConstraint
from vmware_vi.models.ovf_host_value_not_parsed import OvfHostValueNotParsed
from vmware_vi.models.ovf_import import OvfImport
from vmware_vi.models.ovf_import_failed import OvfImportFailed
from vmware_vi.models.ovf_internal_error import OvfInternalError
from vmware_vi.models.ovf_invalid_package import OvfInvalidPackage
from vmware_vi.models.ovf_invalid_value import OvfInvalidValue
from vmware_vi.models.ovf_invalid_value_configuration import OvfInvalidValueConfiguration
from vmware_vi.models.ovf_invalid_value_empty import OvfInvalidValueEmpty
from vmware_vi.models.ovf_invalid_value_format_malformed import OvfInvalidValueFormatMalformed
from vmware_vi.models.ovf_invalid_value_reference import OvfInvalidValueReference
from vmware_vi.models.ovf_invalid_vm_name import OvfInvalidVmName
from vmware_vi.models.ovf_mapped_os_id import OvfMappedOsId
from vmware_vi.models.ovf_missing_attribute import OvfMissingAttribute
from vmware_vi.models.ovf_missing_element import OvfMissingElement
from vmware_vi.models.ovf_missing_element_normal_boundary import OvfMissingElementNormalBoundary
from vmware_vi.models.ovf_missing_hardware import OvfMissingHardware
from vmware_vi.models.ovf_network_mapping_not_supported import OvfNetworkMappingNotSupported
from vmware_vi.models.ovf_no_host_nic import OvfNoHostNic
from vmware_vi.models.ovf_no_space_on_controller import OvfNoSpaceOnController
from vmware_vi.models.ovf_no_supported_hardware_family import OvfNoSupportedHardwareFamily
from vmware_vi.models.ovf_property import OvfProperty
from vmware_vi.models.ovf_property_export import OvfPropertyExport
from vmware_vi.models.ovf_property_network import OvfPropertyNetwork
from vmware_vi.models.ovf_property_network_export import OvfPropertyNetworkExport
from vmware_vi.models.ovf_property_qualifier import OvfPropertyQualifier
from vmware_vi.models.ovf_property_qualifier_duplicate import OvfPropertyQualifierDuplicate
from vmware_vi.models.ovf_property_qualifier_ignored import OvfPropertyQualifierIgnored
from vmware_vi.models.ovf_property_type import OvfPropertyType
from vmware_vi.models.ovf_property_value import OvfPropertyValue
from vmware_vi.models.ovf_system_fault import OvfSystemFault
from vmware_vi.models.ovf_to_xml_unsupported_element import OvfToXmlUnsupportedElement
from vmware_vi.models.ovf_unable_to_export_disk import OvfUnableToExportDisk
from vmware_vi.models.ovf_unexpected_element import OvfUnexpectedElement
from vmware_vi.models.ovf_unknown_device import OvfUnknownDevice
from vmware_vi.models.ovf_unknown_device_backing import OvfUnknownDeviceBacking
from vmware_vi.models.ovf_unknown_entity import OvfUnknownEntity
from vmware_vi.models.ovf_unsupported_attribute import OvfUnsupportedAttribute
from vmware_vi.models.ovf_unsupported_attribute_value import OvfUnsupportedAttributeValue
from vmware_vi.models.ovf_unsupported_device_backing_info import OvfUnsupportedDeviceBackingInfo
from vmware_vi.models.ovf_unsupported_device_backing_option import OvfUnsupportedDeviceBackingOption
from vmware_vi.models.ovf_unsupported_device_export import OvfUnsupportedDeviceExport
from vmware_vi.models.ovf_unsupported_disk_provisioning import OvfUnsupportedDiskProvisioning
from vmware_vi.models.ovf_unsupported_element import OvfUnsupportedElement
from vmware_vi.models.ovf_unsupported_element_value import OvfUnsupportedElementValue
from vmware_vi.models.ovf_unsupported_package import OvfUnsupportedPackage
from vmware_vi.models.ovf_unsupported_section import OvfUnsupportedSection
from vmware_vi.models.ovf_unsupported_sub_type import OvfUnsupportedSubType
from vmware_vi.models.ovf_unsupported_type import OvfUnsupportedType
from vmware_vi.models.ovf_wrong_element import OvfWrongElement
from vmware_vi.models.ovf_wrong_namespace import OvfWrongNamespace
from vmware_vi.models.ovf_xml_format import OvfXmlFormat
from vmware_vi.models.password_expired import PasswordExpired
from vmware_vi.models.patch_already_installed import PatchAlreadyInstalled
from vmware_vi.models.patch_binaries_not_found import PatchBinariesNotFound
from vmware_vi.models.patch_install_failed import PatchInstallFailed
from vmware_vi.models.patch_integrity_error import PatchIntegrityError
from vmware_vi.models.patch_metadata_corrupted import PatchMetadataCorrupted
from vmware_vi.models.patch_metadata_invalid import PatchMetadataInvalid
from vmware_vi.models.patch_metadata_not_found import PatchMetadataNotFound
from vmware_vi.models.patch_missing_dependencies import PatchMissingDependencies
from vmware_vi.models.patch_not_applicable import PatchNotApplicable
from vmware_vi.models.patch_superseded import PatchSuperseded
from vmware_vi.models.phys_compat_rdm_not_supported import PhysCompatRDMNotSupported
from vmware_vi.models.platform_config_fault import PlatformConfigFault
from vmware_vi.models.power_on_ft_secondary_failed import PowerOnFtSecondaryFailed
from vmware_vi.models.power_on_ft_secondary_timedout import PowerOnFtSecondaryTimedout
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.profile_update_failed import ProfileUpdateFailed
from vmware_vi.models.quarantine_mode_fault import QuarantineModeFault
from vmware_vi.models.question_pending import QuestionPending
from vmware_vi.models.quiesce_datastore_io_for_ha_failed import QuiesceDatastoreIOForHAFailed
from vmware_vi.models.raw_disk_not_supported import RawDiskNotSupported
from vmware_vi.models.rdm_conversion_not_supported import RDMConversionNotSupported
from vmware_vi.models.rdm_not_preserved import RDMNotPreserved
from vmware_vi.models.rdm_not_supported import RDMNotSupported
from vmware_vi.models.rdm_not_supported_on_datastore import RDMNotSupportedOnDatastore
from vmware_vi.models.rdm_points_to_inaccessible_disk import RDMPointsToInaccessibleDisk
from vmware_vi.models.read_host_resource_pool_tree_failed import ReadHostResourcePoolTreeFailed
from vmware_vi.models.read_only_disks_with_legacy_destination import ReadOnlyDisksWithLegacyDestination
from vmware_vi.models.reboot_required import RebootRequired
from vmware_vi.models.record_replay_disabled import RecordReplayDisabled
from vmware_vi.models.remote_device_not_supported import RemoteDeviceNotSupported
from vmware_vi.models.remove_failed import RemoveFailed
from vmware_vi.models.replication_config_fault import ReplicationConfigFault
from vmware_vi.models.replication_disk_config_fault import ReplicationDiskConfigFault
from vmware_vi.models.replication_fault import ReplicationFault
from vmware_vi.models.replication_incompatible_with_ft import ReplicationIncompatibleWithFT
from vmware_vi.models.replication_invalid_options import ReplicationInvalidOptions
from vmware_vi.models.replication_not_supported_on_host import ReplicationNotSupportedOnHost
from vmware_vi.models.replication_vm_config_fault import ReplicationVmConfigFault
from vmware_vi.models.replication_vm_fault import ReplicationVmFault
from vmware_vi.models.replication_vm_in_progress_fault import ReplicationVmInProgressFault
from vmware_vi.models.request_canceled import RequestCanceled
from vmware_vi.models.resource_in_use import ResourceInUse
from vmware_vi.models.resource_not_available import ResourceNotAvailable
from vmware_vi.models.restricted_by_administrator import RestrictedByAdministrator
from vmware_vi.models.restricted_version import RestrictedVersion
from vmware_vi.models.rollback_failure import RollbackFailure
from vmware_vi.models.rule_violation import RuleViolation
from vmware_vi.models.runtime_fault import RuntimeFault
from vmware_vi.models.secondary_vm_already_disabled import SecondaryVmAlreadyDisabled
from vmware_vi.models.secondary_vm_already_enabled import SecondaryVmAlreadyEnabled
from vmware_vi.models.secondary_vm_already_registered import SecondaryVmAlreadyRegistered
from vmware_vi.models.secondary_vm_not_registered import SecondaryVmNotRegistered
from vmware_vi.models.security_error import SecurityError
from vmware_vi.models.shared_bus_controller_not_supported import SharedBusControllerNotSupported
from vmware_vi.models.shrink_disk_fault import ShrinkDiskFault
from vmware_vi.models.snapshot_clone_not_supported import SnapshotCloneNotSupported
from vmware_vi.models.snapshot_copy_not_supported import SnapshotCopyNotSupported
from vmware_vi.models.snapshot_disabled import SnapshotDisabled
from vmware_vi.models.snapshot_fault import SnapshotFault
from vmware_vi.models.snapshot_incompatible_device_in_vm import SnapshotIncompatibleDeviceInVm
from vmware_vi.models.snapshot_locked import SnapshotLocked
from vmware_vi.models.snapshot_move_from_non_home_not_supported import SnapshotMoveFromNonHomeNotSupported
from vmware_vi.models.snapshot_move_not_supported import SnapshotMoveNotSupported
from vmware_vi.models.snapshot_move_to_non_home_not_supported import SnapshotMoveToNonHomeNotSupported
from vmware_vi.models.snapshot_no_change import SnapshotNoChange
from vmware_vi.models.snapshot_revert_issue import SnapshotRevertIssue
from vmware_vi.models.soft_rule_vio_correction_disallowed import SoftRuleVioCorrectionDisallowed
from vmware_vi.models.soft_rule_vio_correction_impact import SoftRuleVioCorrectionImpact
from vmware_vi.models.solution_user_required import SolutionUserRequired
from vmware_vi.models.ssd_disk_not_available import SsdDiskNotAvailable
from vmware_vi.models.ssl_disabled_fault import SSLDisabledFault
from vmware_vi.models.ssl_verify_fault import SSLVerifyFault
from vmware_vi.models.sspi_challenge import SSPIChallenge
from vmware_vi.models.storage_drs_cannot_move_disk_in_multi_writer_mode import StorageDrsCannotMoveDiskInMultiWriterMode
from vmware_vi.models.storage_drs_cannot_move_ftvm import StorageDrsCannotMoveFTVm
from vmware_vi.models.storage_drs_cannot_move_independent_disk import StorageDrsCannotMoveIndependentDisk
from vmware_vi.models.storage_drs_cannot_move_manually_placed_swap_file import StorageDrsCannotMoveManuallyPlacedSwapFile
from vmware_vi.models.storage_drs_cannot_move_manually_placed_vm import StorageDrsCannotMoveManuallyPlacedVm
from vmware_vi.models.storage_drs_cannot_move_shared_disk import StorageDrsCannotMoveSharedDisk
from vmware_vi.models.storage_drs_cannot_move_template import StorageDrsCannotMoveTemplate
from vmware_vi.models.storage_drs_cannot_move_vm_in_user_folder import StorageDrsCannotMoveVmInUserFolder
from vmware_vi.models.storage_drs_cannot_move_vm_with_mounted_cdrom import StorageDrsCannotMoveVmWithMountedCDROM
from vmware_vi.models.storage_drs_cannot_move_vm_with_no_files_in_layout import StorageDrsCannotMoveVmWithNoFilesInLayout
from vmware_vi.models.storage_drs_datacenters_cannot_share_datastore import StorageDrsDatacentersCannotShareDatastore
from vmware_vi.models.storage_drs_disabled_on_vm import StorageDrsDisabledOnVm
from vmware_vi.models.storage_drs_hbr_disk_not_movable import StorageDrsHbrDiskNotMovable
from vmware_vi.models.storage_drs_hms_move_in_progress import StorageDrsHmsMoveInProgress
from vmware_vi.models.storage_drs_hms_unreachable import StorageDrsHmsUnreachable
from vmware_vi.models.storage_drs_iolb_disabled_internally import StorageDrsIolbDisabledInternally
from vmware_vi.models.storage_drs_relocate_disabled import StorageDrsRelocateDisabled
from vmware_vi.models.storage_drs_stale_hms_collection import StorageDrsStaleHmsCollection
from vmware_vi.models.storage_drs_unable_to_move_files import StorageDrsUnableToMoveFiles
from vmware_vi.models.storage_v_motion_not_supported import StorageVMotionNotSupported
from vmware_vi.models.storage_vmotion_incompatible import StorageVmotionIncompatible
from vmware_vi.models.suspended_relocate_not_supported import SuspendedRelocateNotSupported
from vmware_vi.models.swap_datastore_not_writable_on_host import SwapDatastoreNotWritableOnHost
from vmware_vi.models.swap_datastore_unset import SwapDatastoreUnset
from vmware_vi.models.swap_placement_override_not_supported import SwapPlacementOverrideNotSupported
from vmware_vi.models.switch_ip_unset import SwitchIpUnset
from vmware_vi.models.switch_not_in_upgrade_mode import SwitchNotInUpgradeMode
from vmware_vi.models.system_error import SystemError
from vmware_vi.models.task_in_progress import TaskInProgress
from vmware_vi.models.third_party_license_assignment_failed import ThirdPartyLicenseAssignmentFailed
from vmware_vi.models.timedout import Timedout
from vmware_vi.models.too_many_concurrent_native_clones import TooManyConcurrentNativeClones
from vmware_vi.models.too_many_consecutive_overrides import TooManyConsecutiveOverrides
from vmware_vi.models.too_many_devices import TooManyDevices
from vmware_vi.models.too_many_disks_on_legacy_host import TooManyDisksOnLegacyHost
from vmware_vi.models.too_many_guest_logons import TooManyGuestLogons
from vmware_vi.models.too_many_hosts import TooManyHosts
from vmware_vi.models.too_many_native_clone_levels import TooManyNativeCloneLevels
from vmware_vi.models.too_many_native_clones_on_file import TooManyNativeClonesOnFile
from vmware_vi.models.too_many_snapshot_levels import TooManySnapshotLevels
from vmware_vi.models.tools_already_upgraded import ToolsAlreadyUpgraded
from vmware_vi.models.tools_auto_upgrade_not_supported import ToolsAutoUpgradeNotSupported
from vmware_vi.models.tools_image_copy_failed import ToolsImageCopyFailed
from vmware_vi.models.tools_image_not_available import ToolsImageNotAvailable
from vmware_vi.models.tools_image_signature_check_failed import ToolsImageSignatureCheckFailed
from vmware_vi.models.tools_installation_in_progress import ToolsInstallationInProgress
from vmware_vi.models.tools_unavailable import ToolsUnavailable
from vmware_vi.models.tools_upgrade_cancelled import ToolsUpgradeCancelled
from vmware_vi.models.un_supported_datastore_for_v_flash import UnSupportedDatastoreForVFlash
from vmware_vi.models.uncommitted_undoable_disk import UncommittedUndoableDisk
from vmware_vi.models.unconfigured_property_value import UnconfiguredPropertyValue
from vmware_vi.models.uncustomizable_guest import UncustomizableGuest
from vmware_vi.models.unexpected_customization_fault import UnexpectedCustomizationFault
from vmware_vi.models.unexpected_fault import UnexpectedFault
from vmware_vi.models.unrecognized_host import UnrecognizedHost
from vmware_vi.models.unshared_swap_v_motion_not_supported import UnsharedSwapVMotionNotSupported
from vmware_vi.models.unsupported_datastore import UnsupportedDatastore
from vmware_vi.models.unsupported_guest import UnsupportedGuest
from vmware_vi.models.unsupported_vim_api_version import UnsupportedVimApiVersion
from vmware_vi.models.unsupported_vmx_location import UnsupportedVmxLocation
from vmware_vi.models.unused_virtual_disk_blocks_not_scrubbed import UnusedVirtualDiskBlocksNotScrubbed
from vmware_vi.models.user_not_found import UserNotFound
from vmware_vi.models.v_app_config_fault import VAppConfigFault
from vmware_vi.models.v_app_not_running import VAppNotRunning
from vmware_vi.models.v_app_operation_in_progress import VAppOperationInProgress
from vmware_vi.models.v_app_property_fault import VAppPropertyFault
from vmware_vi.models.v_app_task_in_progress import VAppTaskInProgress
from vmware_vi.models.v_flash_cache_hot_config_not_supported import VFlashCacheHotConfigNotSupported
from vmware_vi.models.v_flash_module_not_supported import VFlashModuleNotSupported
from vmware_vi.models.v_flash_module_version_incompatible import VFlashModuleVersionIncompatible
from vmware_vi.models.v_motion_across_network_not_supported import VMotionAcrossNetworkNotSupported
from vmware_vi.models.v_motion_interface_issue import VMotionInterfaceIssue
from vmware_vi.models.v_motion_link_capacity_low import VMotionLinkCapacityLow
from vmware_vi.models.v_motion_link_down import VMotionLinkDown
from vmware_vi.models.v_motion_not_configured import VMotionNotConfigured
from vmware_vi.models.v_motion_not_licensed import VMotionNotLicensed
from vmware_vi.models.v_motion_not_supported import VMotionNotSupported
from vmware_vi.models.v_motion_protocol_incompatible import VMotionProtocolIncompatible
from vmware_vi.models.vim_fault import VimFault
from vmware_vi.models.virtual_disk_blocks_not_fully_provisioned import VirtualDiskBlocksNotFullyProvisioned
from vmware_vi.models.virtual_disk_mode_not_supported import VirtualDiskModeNotSupported
from vmware_vi.models.virtual_ethernet_card_not_supported import VirtualEthernetCardNotSupported
from vmware_vi.models.virtual_hardware_compatibility_issue import VirtualHardwareCompatibilityIssue
from vmware_vi.models.virtual_hardware_version_not_supported import VirtualHardwareVersionNotSupported
from vmware_vi.models.vm_already_exists_in_datacenter import VmAlreadyExistsInDatacenter
from vmware_vi.models.vm_config_fault import VmConfigFault
from vmware_vi.models.vm_config_incompatible_for_fault_tolerance import VmConfigIncompatibleForFaultTolerance
from vmware_vi.models.vm_config_incompatible_for_record_replay import VmConfigIncompatibleForRecordReplay
from vmware_vi.models.vm_fault_tolerance_config_issue import VmFaultToleranceConfigIssue
from vmware_vi.models.vm_fault_tolerance_config_issue_wrapper import VmFaultToleranceConfigIssueWrapper
from vmware_vi.models.vm_fault_tolerance_invalid_file_backing import VmFaultToleranceInvalidFileBacking
from vmware_vi.models.vm_fault_tolerance_issue import VmFaultToleranceIssue
from vmware_vi.models.vm_fault_tolerance_op_issues_list import VmFaultToleranceOpIssuesList
from vmware_vi.models.vm_fault_tolerance_too_many_ft_vcpus_on_host import VmFaultToleranceTooManyFtVcpusOnHost
from vmware_vi.models.vm_fault_tolerance_too_many_vms_on_host import VmFaultToleranceTooManyVMsOnHost
from vmware_vi.models.vm_host_affinity_rule_violation import VmHostAffinityRuleViolation
from vmware_vi.models.vm_limit_license import VmLimitLicense
from vmware_vi.models.vm_metadata_manager_fault import VmMetadataManagerFault
from vmware_vi.models.vm_monitor_incompatible_for_fault_tolerance import VmMonitorIncompatibleForFaultTolerance
from vmware_vi.models.vm_power_on_disabled import VmPowerOnDisabled
from vmware_vi.models.vm_smp_fault_tolerance_too_many_vms_on_host import VmSmpFaultToleranceTooManyVMsOnHost
from vmware_vi.models.vm_tools_upgrade_fault import VmToolsUpgradeFault
from vmware_vi.models.vm_validate_max_device import VmValidateMaxDevice
from vmware_vi.models.vm_wwn_conflict import VmWwnConflict
from vmware_vi.models.vmfs_already_mounted import VmfsAlreadyMounted
from vmware_vi.models.vmfs_ambiguous_mount import VmfsAmbiguousMount
from vmware_vi.models.vmfs_mount_fault import VmfsMountFault
from vmware_vi.models.vmi_not_supported import VMINotSupported
from vmware_vi.models.vmon_conflict_dv_port import VMOnConflictDVPort
from vmware_vi.models.vmon_virtual_intranet import VMOnVirtualIntranet
from vmware_vi.models.vmotion_interface_not_enabled import VmotionInterfaceNotEnabled
from vmware_vi.models.volume_editor_error import VolumeEditorError
from vmware_vi.models.vram_limit_license import VramLimitLicense
from vmware_vi.models.vsan_cluster_uuid_mismatch import VsanClusterUuidMismatch
from vmware_vi.models.vsan_disk_fault import VsanDiskFault
from vmware_vi.models.vsan_fault import VsanFault
from vmware_vi.models.vsan_incompatible_disk_mapping import VsanIncompatibleDiskMapping
from vmware_vi.models.vspan_dest_port_conflict import VspanDestPortConflict
from vmware_vi.models.vspan_port_conflict import VspanPortConflict
from vmware_vi.models.vspan_port_move_fault import VspanPortMoveFault
from vmware_vi.models.vspan_port_promisc_change_fault import VspanPortPromiscChangeFault
from vmware_vi.models.vspan_portgroup_promisc_change_fault import VspanPortgroupPromiscChangeFault
from vmware_vi.models.vspan_portgroup_type_change_fault import VspanPortgroupTypeChangeFault
from vmware_vi.models.vspan_promiscuous_port_not_supported import VspanPromiscuousPortNotSupported
from vmware_vi.models.vspan_same_session_port_conflict import VspanSameSessionPortConflict
from vmware_vi.models.wake_on_lan_not_supported import WakeOnLanNotSupported
from vmware_vi.models.wake_on_lan_not_supported_by_vmotion_nic import WakeOnLanNotSupportedByVmotionNIC
from vmware_vi.models.will_lose_ha_protection import WillLoseHAProtection
from vmware_vi.models.will_modify_config_cpu_requirements import WillModifyConfigCpuRequirements
from vmware_vi.models.will_reset_snapshot_directory import WillResetSnapshotDirectory
from vmware_vi.models.wipe_disk_fault import WipeDiskFault
# TODO: Rewrite to not use raise_errors
MethodFault.model_rebuild(raise_errors=False)

