# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class NetIpStackInfoNetToMedia(DataObject):
    """
    Information from an IP stack about known mappings betwwen an IP address and the underlying physical address it maps to as learned by: IPv4: Address Resolution Protocol (ARP) RFC 826 IPv6: Neighbor Discovery Protocol (NDP) RFC 4861  ***Since:*** vSphere API 4.1 
    """ # noqa: E501
    ip_address: StrictStr = Field(description="A Unicast IP address of another system directly reachable w/o routing.  IPv4 address is specified using dotted decimal notation. For example, \"192.0.2.1\". IPv6 addresses are 128-bit addresses represented as eight fields of up to four hexadecimal digits. A colon separates each field (:). For example, 2001:DB8:101::230:6eff:fe04:d9ff. The address can also consist of the symbol '::' to represent multiple 16-bit groups of contiguous 0's only once in an address as described in RFC 2373.  ***Since:*** vSphere API 4.1 ", alias="ipAddress")
    physical_address: StrictStr = Field(description="The media-dependent of the address or empty string if not yet learned.  For Ethernet interfaces this is a MAC address reported in the format: XX:XX:XX:XX:XX:XX where XX are hexadecimal numbers.  ***Since:*** vSphere API 4.1 ", alias="physicalAddress")
    device: StrictStr = Field(description="The value will be the name of the interface as reported by the operating system.  ***Since:*** vSphere API 4.1 ")
    type: StrictStr = Field(description="The type/state of this entry as reported by the IP stack.  See *NetIpStackInfoEntryType_enum* for values.  ***Since:*** vSphere API 4.1 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of NetIpStackInfoNetToMedia from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of NetIpStackInfoNetToMedia from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


