# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.nvdimm_health_info import NvdimmHealthInfo
from vmware_vi.models.nvdimm_region_info import NvdimmRegionInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class NvdimmDimmInfo(DataObject):
    """
    Get detailed information of a nvdimm  ***Since:*** vSphere API 6.7 
    """ # noqa: E501
    dimm_handle: StrictInt = Field(description="Unique device identifier  ***Since:*** vSphere API 6.7 ", alias="dimmHandle")
    health_info: NvdimmHealthInfo = Field(alias="healthInfo")
    total_capacity: StrictInt = Field(description="Total capacity of NVDIMM in bytes  ***Since:*** vSphere API 6.7 ", alias="totalCapacity")
    persistent_capacity: StrictInt = Field(description="Total persistent capacity in DIMM (in bytes)  ***Since:*** vSphere API 6.7 ", alias="persistentCapacity")
    available_persistent_capacity: StrictInt = Field(description="Persistent Capacity in DIMM currently not allocated  ***Since:*** vSphere API 6.7 ", alias="availablePersistentCapacity")
    volatile_capacity: StrictInt = Field(description="Total volatile capacity in DIMM (in bytes)  ***Since:*** vSphere API 6.7 ", alias="volatileCapacity")
    available_volatile_capacity: StrictInt = Field(description="Volatile capacity in DIMM currently not allocated  ***Since:*** vSphere API 6.7 ", alias="availableVolatileCapacity")
    block_capacity: StrictInt = Field(description="Total block capacity in DIMM (in bytes)  ***Since:*** vSphere API 6.7 ", alias="blockCapacity")
    region_info: Optional[List[NvdimmRegionInfo]] = Field(default=None, description="NVDIMM region information.  List of regions in the NVDIMM. These regions may or maynot be a part of an interleave set.  ***Since:*** vSphere API 6.7 ", alias="regionInfo")
    representation_string: StrictStr = Field(description="NVDIMM Representation string which is a sequence of numbers to uniquely identify the DIMM.  ***Since:*** vSphere API 6.7 ", alias="representationString")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of NvdimmDimmInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of NvdimmDimmInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


