# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class NvdimmHealthInfo(DataObject):
    """
    \\\\brief NVDIMM health information  ***Since:*** vSphere API 6.7 
    """ # noqa: E501
    health_status: StrictStr = Field(description="Device health status.  ***Since:*** vSphere API 6.7 ", alias="healthStatus")
    health_information: StrictStr = Field(description="Health status description.  ***Since:*** vSphere API 6.7 ", alias="healthInformation")
    state_flag_info: Optional[List[StrictStr]] = Field(default=None, description="State flag information.  This information is the cumulation of state flags of all the NVDIMM region state flags. It must be one or more of *NvdimmNvdimmHealthInfoState_enum*  ***Since:*** vSphere API 6.7 ", alias="stateFlagInfo")
    dimm_temperature: StrictInt = Field(description="Current Nvdimm temperature in degree Celsius.  ***Since:*** vSphere API 6.7 ", alias="dimmTemperature")
    dimm_temperature_threshold: StrictInt = Field(description="Nvdimm temperature threshold.  Default value is 0, indicating threshold has not reached, if set to 1, reached threshold limit.  ***Since:*** vSphere API 6.7 ", alias="dimmTemperatureThreshold")
    spare_blocks_percentage: StrictInt = Field(description="Percentage of spare capavity as a percentage of factory configured space (valid range 0 to 100)  ***Since:*** vSphere API 6.7 ", alias="spareBlocksPercentage")
    spare_block_threshold: StrictInt = Field(description="Spare block threshold.  Default value is 0, indicating threshold has not reached, if set to 1, reached threshold limit.  ***Since:*** vSphere API 6.7 ", alias="spareBlockThreshold")
    dimm_lifespan_percentage: StrictInt = Field(description="Lifespan of Nvdimm as percentage.  100% = Warranted life span has reached.  ***Since:*** vSphere API 6.7 ", alias="dimmLifespanPercentage")
    es_temperature: Optional[StrictInt] = Field(default=None, description="Energy source current temperature in degree Celsius.  Default value is 0, indicating there is no energy source for these nvdimms.  ***Since:*** vSphere API 6.7 ", alias="esTemperature")
    es_temperature_threshold: Optional[StrictInt] = Field(default=None, description="Energy source temperature threshold.  Default value is 0, indicating threshold has not reached, if set to 1, reached threshold limit.  ***Since:*** vSphere API 6.7 ", alias="esTemperatureThreshold")
    es_lifespan_percentage: Optional[StrictInt] = Field(default=None, description="Lifespan of Energy source as percentage.  100% = Warranted life span has reached. Default value is 0, indicating there is no energy source.  ***Since:*** vSphere API 6.7 ", alias="esLifespanPercentage")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of NvdimmHealthInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of NvdimmHealthInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


