# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.ovf_file import OvfFile
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class OvfCreateDescriptorParams(DataObject):
    """
    Collection of parameters for createDescriptor  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    ovf_files: Optional[List[OvfFile]] = Field(default=None, description="Contains information about the files of the entity, if they have already been downloaded.  Needed to construct the References section of the descriptor.  OvfFile is a positive list of files to include in the export. An Empty list will do no filtering.  ***Since:*** vSphere API 4.0 ", alias="ovfFiles")
    name: Optional[StrictStr] = Field(default=None, description="The ovf:id to use for the top-level OVF Entity.  If unset, the entity's product name is used if available. Otherwise, the VI entity name is used.  ***Since:*** vSphere API 4.0 ")
    description: Optional[StrictStr] = Field(default=None, description="The contents of the Annontation section of the top-level OVF Entity.  If unset, any existing annotation on the entity is left unchanged.  ***Since:*** vSphere API 4.0 ")
    include_image_files: Optional[StrictBool] = Field(default=None, description="Controls whether attached image files should be included in the descriptor.  This applies to image files attached to VirtualCdrom and VirtualFloppy.  ***Since:*** vSphere API 4.1 ", alias="includeImageFiles")
    export_option: Optional[List[StrictStr]] = Field(default=None, description="An optional argument for modifying the export process.  The option is used to control what extra information that will be included in the OVF descriptor.  To get a list of supported keywords see *OvfManager.ovfExportOption*. Unknown options will be ignored by the server.  ***Since:*** vSphere API 5.1 ", alias="exportOption")
    snapshot: Optional[ManagedObjectReference] = None
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OvfCreateDescriptorParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of OvfCreateDescriptorParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


