# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.method_fault import MethodFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class OvfCreateDescriptorResult(DataObject):
    """
    The result of creating the OVF descriptor for the entity.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    ovf_descriptor: StrictStr = Field(description="The OVF descriptor for the entity.  ***Since:*** vSphere API 4.0 ", alias="ovfDescriptor")
    error: Optional[List[MethodFault]] = Field(default=None, description="Errors that happened during processing.  For example, unknown or unsupported devices could be found (in which case this array will contain one or more instances of Unsupported-/UnknownDevice).  ***Since:*** vSphere API 4.0 ")
    warning: Optional[List[MethodFault]] = Field(default=None, description="Non-fatal warnings from the processing.  The result will be valid, but the user may choose to reject it based on these warnings.  ***Since:*** vSphere API 4.0 ")
    include_image_files: Optional[StrictBool] = Field(default=None, description="Returns true if there are ISO or Floppy images attached to one or more VMs.  ***Since:*** vSphere API 4.1 ", alias="includeImageFiles")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OvfCreateDescriptorResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of OvfCreateDescriptorResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


