# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PerfInterval(DataObject):
    """
    This data object type contains metadata about a performance interval. - For VirtualCenter Server systems, instances of this data object are   referred to as &#147;historical intervals&#148; because they control   how data collected from the ESX systems will be aggregated and stored   in the database. - For ESX system, this data object is typically referred to simply as the   &#147;interval&#148; or &#147;performance interval&#148; because ESX   does not aggregate statistical data.     For ESX systems, a single instance of this data object exists. It cannot be modified. It has these properties: <table border=\"1\"width=\"100%\"> <tr> <th>key</th> <th>samplingPeriod</th> <th>length</th> <th>name</th> <th>level</th> <th>enabled</th> </tr> <tr> <td>1</td> <td>300</td> <td>129600</td> <td>PastDay</td> <td>null</td> <td>true</td> </tr> </table>  VirtualCenter Server system provides four instances of this data object by default, that apply globally to all system entities.  **Example Collection Levels**   VirtualCenter Server uses the specifications configured in its historical intervals to collect metrics from the ESX systems that it manages. The quantity of data collected depends on the level settings for the server, and the level associated with a specific counter. Both factors may change from one version of the products to the next. In general, the lower the number, the smaller the amount of data collected. For VirtualCenter Server 2.5, for example, the levels 1 through 4 collected data as follows: 1. Basic counters defined with \"average\" *rollup type* for CPU, Memory,    Disk, and Network; plus counters for System Uptime, System Heartbeat,    and DRS (Distributed Resource Scheduler, tracked in the    \"clusterServices\" group). Does not include counters for devices. 2. Counters defined with \"average,\" \"summation,\" and \"latest\" *rollup types* for CPU,    Memory, Disk, and Network; plus counters for System Uptime, System    Heartbeat, and DRS (clusterServices). Does not include counters for    devices. 3. Counters defined with \"average,\" \"summmation,\" and \"latest\" *rollup types* for CPU,    Memory, Disk, Network, and all devices; plus counters for System    Uptime, System Heartbeat, and DRS (clusterServices). 4. All counters defined for all entities and devices, for every *rollup type*, including    &#147;minimum&#148; and &#147;maximum&#46;&#148;      Default properties for the four built-in historical intervals include: <table border=\"1\"width=\"100%\"> <tr> <th>key</th> <th>samplingPeriod</th> <th>length</th> <th>name</th> <th>level</th> <th>enabled</th> </tr> <tr> <td>1</td> <td>300</td> <td>86400</td> <td>Past&nbsp;day</td> <td>1</td> <td>true</td> </tr> <tr> <td>2</td> <td>1800</td> <td>604800</td> <td>Past&nbsp;week</td> <td>1</td> <td>true</td> </tr> <tr> <td>3</td> <td>7200</td> <td>2592000</td> <td>Past&nbsp;month</td> <td>1</td> <td>true</td> </tr> <tr> <td>4</td> <td>86400</td> <td>31536000</td> <td>Past&nbsp;year</td> <td>1</td> <td>true</td> </tr> </table>  All values are in seconds. The default setting for vCenter Server is level 1, which retains sampled statistical data as follows: - 5-minute samples for the past day - 30-minute samples for the past week - 2-hour samples for the past month - 1-day samples for the past year     Data older than a year is purged from the vCenter Server database.  Prior to version 2&#46;5 of the API, this data object could be used in conjunction with the *PerformanceManager.CreatePerfInterval* operation, to define new, custom historical intervals. That operation has been deprecated: Adding and deleting objects of this type is no longer supported. However, the default historical intervals can be enabled or disabled, and can be modified within certain limits (with the *PerformanceManager.UpdatePerfInterval* operation)&#46; 
    """ # noqa: E501
    key: StrictInt = Field(description="A unique identifier for the interval.  ***Since:*** VI API 2.5 ")
    sampling_period: StrictInt = Field(description="Number of seconds that data is sampled for this interval.  The real-time samplingPeriod is 20 seconds. ", alias="samplingPeriod")
    name: StrictStr = Field(description="The name of the historical interval.  A localized string that provides a name for the interval. Names include: - \"Past Day\" - \"Past Week\" - \"Past Month\" - \"Past Year\"    The name is not meaningful in terms of system behavior. That is, the interval named &#147;Past Week&#148; works as it does because of its length, level, and so on, not because of the value of this string. ")
    length: StrictInt = Field(description="Number of seconds that the statistics corresponding to this interval are kept on the system. ")
    level: Optional[StrictInt] = Field(default=None, description="Statistics collection level for this historical interval.  vCenter Server will aggregate only those statistics that match the value of this property for this historical interval. For ESX, the value of this property is null. For vCenter Server, the value will be a number from 1 to 4.  ***Since:*** VI API 2.5 ")
    enabled: StrictBool = Field(description="Indicates whether the interval is enabled (true) or disabled (false).  Disabling a historical interval prevents vCenter Server from collecting metrics for that interval and all higher (longer) intervals.  For example, disabling the \"Past Month\" interval disables both \"Past Month\" and \"Past Year\" intervals. The system will aggregate and retain performance data using the \"Past Day\" and \"Past Week\" intervals only.  ***Since:*** VI API 2.5 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PerfInterval from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PerfInterval from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


