# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PerformanceManagerCounterLevelMapping(DataObject):
    """
    *PerformanceManagerCounterLevelMapping* class captures the counter and level mapping.  Any counter has two aspects: aggregate value or the per-device value. For example, cpu.usage.average on a host is an aggregate counter and cpu.usage.average on pcpus in a host is a per-device counters. There is a need to be able to specify different levels for the two versions. Currently, all per-device stats are collected at level greater than or equal to 3.  In order to be able to configure the level of collections for aggregate and per-device counters we have two optional level fields. *PerformanceManagerCounterLevelMapping* is used to update the levels for a counter.  ***Since:*** vSphere API 4.1 
    """ # noqa: E501
    counter_id: StrictInt = Field(description="The counter Id  ***Since:*** vSphere API 4.1 ", alias="counterId")
    aggregate_level: Optional[StrictInt] = Field(default=None, description="Level for the aggregate counter.  If not set then the value is not changed when updateCounterLevelMapping is called.  ***Since:*** vSphere API 4.1 ", alias="aggregateLevel")
    per_device_level: Optional[StrictInt] = Field(default=None, description="Level for the per device counter.  If not set then the value is not changed when updateCounterLevelMapping is called.  ***Since:*** vSphere API 4.1 ", alias="perDeviceLevel")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PerformanceManagerCounterLevelMapping from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PerformanceManagerCounterLevelMapping from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


