# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.placement_affinity_rule import PlacementAffinityRule
from vmware_vi.models.placement_spec import PlacementSpec
from vmware_vi.models.storage_drs_placement_rank_vm_spec import StorageDrsPlacementRankVmSpec
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PlacementRankSpec(DataObject):
    """
    PlacementRankSpec encapsulates all of the inputs passed to the *StorageResourceManager.RankForPlacement* method.  ***Since:*** vSphere API 6.0 
    """ # noqa: E501
    specs: List[PlacementSpec] = Field(description="List of VM placement specifications for ranking clusters  ***Since:*** vSphere API 6.0 ")
    clusters: List[ManagedObjectReference] = Field(description="List of candidate clusters for the placement request  ***Since:*** vSphere API 6.0  Refers instances of *ClusterComputeResource*. ")
    rules: Optional[List[PlacementAffinityRule]] = Field(default=None, description="List of affinity rules for the placement request  ***Since:*** vSphere API 6.0 ")
    placement_rank_by_vm: Optional[List[StorageDrsPlacementRankVmSpec]] = Field(default=None, description="List of preferred clusters for individual VM placement requests  ***Since:*** vSphere API 6.0 ", alias="placementRankByVm")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PlacementRankSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PlacementRankSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


