# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.any import Any
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.extended_element_description import ExtendedElementDescription
from vmware_vi.models.profile_parameter_metadata_parameter_relation_metadata import ProfileParameterMetadataParameterRelationMetadata
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ProfileParameterMetadata(DataObject):
    """
    The *ProfileParameterMetadata* data object represents the metadata information for expressions, policy options, and host-specific configuration data.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    id: ExtendedElementDescription
    type: StrictStr = Field(description="Type of the parameter.  ***Since:*** vSphere API 4.0 ")
    optional: StrictBool = Field(description="Whether the parameter is optional.  ***Since:*** vSphere API 4.0 ")
    default_value: Optional[Any] = Field(default=None, alias="defaultValue")
    hidden: Optional[StrictBool] = Field(default=None, description="Whether the parameter will not be displayed in UI.  ***Since:*** vSphere API 6.5 ")
    security_sensitive: Optional[StrictBool] = Field(default=None, description="Whether the parameter is security sensitive.  ***Since:*** vSphere API 6.5 ", alias="securitySensitive")
    read_only: Optional[StrictBool] = Field(default=None, description="Indicates that the parameter value is read-only.  ***Since:*** vSphere API 6.5 ", alias="readOnly")
    parameter_relations: Optional[List[ProfileParameterMetadataParameterRelationMetadata]] = Field(default=None, description="Relations with other profile or parameters.  ***Since:*** vSphere API 6.7 ", alias="parameterRelations")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProfileParameterMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ProfileParameterMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


