# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ProfilePropertyPath(DataObject):
    """
    The *ProfilePropertyPath* data object represents the path to a profile, policy option, or specific parameter.  If <code>profilePath</code>, <code>policyId</code>, and <code>parameterId</code> are all specified, the combination of the three identifies a particular parameter. If only <code>profilePath</code> and <code>policyId</code> are specified, the combination identifies a specific profile policy option. If just the <code>profilePath</code> is specified, the data object identifies a profile instance.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    profile_path: StrictStr = Field(description="Complete path to the leaf profile, relative to the root of the host profile document.  ***Since:*** vSphere API 4.0 ", alias="profilePath")
    policy_id: Optional[StrictStr] = Field(default=None, description="Policy identifier.  ***Since:*** vSphere API 4.0 ", alias="policyId")
    parameter_id: Optional[StrictStr] = Field(default=None, description="Key for a parameter in the policy specified by <code>policyId</code>.  See *PolicyOption*.*PolicyOption.parameter* and *KeyAnyValue.key*.  ***Since:*** vSphere API 5.1 ", alias="parameterId")
    policy_option_id: Optional[StrictStr] = Field(default=None, description="Policy option identifier.  ***Since:*** vSphere API 6.7 ", alias="policyOptionId")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProfilePropertyPath from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ProfilePropertyPath from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


