# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel
from pydantic import Field
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class QueryVMotionCompatibilityExRequestType(BaseModel):
    """
    The parameters of *VirtualMachineProvisioningChecker.QueryVMotionCompatibilityEx_Task*. 
    """ # noqa: E501
    vm: List[ManagedObjectReference] = Field(description="The set of virtual machines to analyze for compatibility. All virtual machines are assumed to be powered-on for the purposes of this operation.  Refers instances of *VirtualMachine*. ")
    host: List[ManagedObjectReference] = Field(description="The set of hosts to analyze for compatibility. All hosts are assumed to be connected and not in maintenance mode for the purposes of this operation.  Refers instances of *HostSystem*. ")
    __properties: ClassVar[List[str]] = ["vm", "host"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of QueryVMotionCompatibilityExRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in vm (list)
        _items = []
        if self.vm:
            for _item in self.vm:
                if _item:
                    _items.append(_item.to_dict())
            _dict['vm'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in host (list)
        _items = []
        if self.host:
            for _item in self.host:
                if _item:
                    _items.append(_item.to_dict())
            _dict['host'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of QueryVMotionCompatibilityExRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "vm": [ManagedObjectReference.from_dict(_item) for _item in obj.get("vm")] if obj.get("vm") is not None else None,
            "host": [ManagedObjectReference.from_dict(_item) for _item in obj.get("host")] if obj.get("host") is not None else None
        })
        return _obj


