# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from vmware_vi.models.host_apply_profile import HostApplyProfile
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class RetrieveHostCustomizationsForProfileRequestType(BaseModel):
    """
    The parameters of *HostProfileManager.RetrieveHostCustomizationsForProfile*. 
    """ # noqa: E501
    hosts: Optional[List[ManagedObjectReference]] = Field(default=None, description="Hosts with which the answer files are associated.  ***Required privileges:*** Profile.Edit  Refers instances of *HostSystem*. ")
    apply_profile: HostApplyProfile = Field(alias="applyProfile")
    __properties: ClassVar[List[str]] = ["hosts", "applyProfile"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RetrieveHostCustomizationsForProfileRequestType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in hosts (list)
        _items = []
        if self.hosts:
            for _item in self.hosts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['hosts'] = _items
        # override the default output from pydantic by calling `to_dict()` of apply_profile
        if self.apply_profile:
            _dict['applyProfile'] = self.apply_profile.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of RetrieveHostCustomizationsForProfileRequestType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hosts": [ManagedObjectReference.from_dict(_item) for _item in obj.get("hosts")] if obj.get("hosts") is not None else None,
            "applyProfile": HostApplyProfile.from_dict(obj.get("applyProfile")) if obj.get("applyProfile") is not None else None
        })
        return _obj


