# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.virtual_disk_anti_affinity_rule_spec import VirtualDiskAntiAffinityRuleSpec
from vmware_vi.models.virtual_disk_rule_spec import VirtualDiskRuleSpec
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class StorageDrsVmConfigInfo(DataObject):
    """
    Storage DRS configuration for a single virtual machine.  This makes it possible to override the default behavior for an individual virtual machine.  ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    vm: Optional[ManagedObjectReference] = None
    enabled: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether or not VirtualCenter is allowed to perform any storage migration or initial placement recommendations for this virtual machine on the pod *StoragePod*.  If this flag is false, the virtual machine is effectively excluded from storage DRS.  If no individual DRS specification exists for a virtual machine, this property defaults to true.  ***Since:*** vSphere API 5.0 ")
    behavior: Optional[StrictStr] = Field(default=None, description="Specifies the particular storage DRS behavior for this virtual machine.  For supported values, see *StorageDrsPodConfigInfoBehavior_enum*.  ***Since:*** vSphere API 5.0 ")
    intra_vm_affinity: Optional[StrictBool] = Field(default=None, description="Specifies whether or not to have the affinity rule for the virtual disks of this virtual machine.  If not set, the default value is derived from the pod-wide default *StorageDrsPodConfigInfo.defaultIntraVmAffinity*.  ***Since:*** vSphere API 5.0 ", alias="intraVmAffinity")
    intra_vm_anti_affinity: Optional[VirtualDiskAntiAffinityRuleSpec] = Field(default=None, alias="intraVmAntiAffinity")
    virtual_disk_rules: Optional[List[VirtualDiskRuleSpec]] = Field(default=None, description="List of the virtual disk rules that can be overridden/created.  ***Since:*** vSphere API 6.7 ", alias="virtualDiskRules")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of StorageDrsVmConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of StorageDrsVmConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


