# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictFloat, StrictInt
from pydantic import Field
from vmware_vi.models.cluster_action import ClusterAction
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.virtual_machine_relocate_spec import VirtualMachineRelocateSpec
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class StorageMigrationAction(ClusterAction):
    """
    Describes a single storage migration action.  The storage migration action applies either to a virtual machine or a set of virtual disks.  ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    vm: ManagedObjectReference
    relocate_spec: VirtualMachineRelocateSpec = Field(alias="relocateSpec")
    source: ManagedObjectReference
    destination: ManagedObjectReference
    size_transferred: StrictInt = Field(description="The amount of data to be transferred.  Unit: KB.  ***Since:*** vSphere API 5.0 ", alias="sizeTransferred")
    space_util_src_before: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Space utilization on the source datastore before storage migration.  Unit: percentage. For example, if set to 70.0, space utilization is 70%. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="spaceUtilSrcBefore")
    space_util_dst_before: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Space utilization on the destination datastore before storage migration.  Unit: percentage. For example, if set to 70.0, space utilization is 70%. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="spaceUtilDstBefore")
    space_util_src_after: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Expected space utilization on the source datastore after storage migration.  Unit: percentage. For example, if set to 70.0, space utilization is 70%. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="spaceUtilSrcAfter")
    space_util_dst_after: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Expected space utilization on the destination datastore after storage migration.  Unit: percentage. For example, if set to 70.0, space utilization is 70%. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="spaceUtilDstAfter")
    io_latency_src_before: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="I/O latency on the source datastore before storage migration.  Unit: millisecond. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="ioLatencySrcBefore")
    io_latency_dst_before: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="I/O latency on the destination datastore before storage migration.  Unit: millisecond. If not set, the value is not available.  ***Since:*** vSphere API 5.0 ", alias="ioLatencyDstBefore")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of StorageMigrationAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of StorageMigrationAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


