# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.managed_by_info import ManagedByInfo
from vmware_vi.models.v_app_entity_config_info import VAppEntityConfigInfo
from vmware_vi.models.vm_config_info import VmConfigInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VAppConfigInfo(VmConfigInfo):
    """
    Configuration of a vApp container.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    entity_config: Optional[List[VAppEntityConfigInfo]] = Field(default=None, description="Configuration of sub-entities (virtual machine or vApp).  ***Since:*** vSphere API 4.0 ", alias="entityConfig")
    annotation: StrictStr = Field(description="Description for the vApp.  ***Since:*** vSphere API 4.0 ")
    instance_uuid: Optional[StrictStr] = Field(default=None, description="vCenter-specific 128-bit UUID of a vApp, represented as a hexademical string.  This identifier is used by vCenter to uniquely identify all vApp instances.  ***Since:*** vSphere API 4.1 ", alias="instanceUuid")
    managed_by: Optional[ManagedByInfo] = Field(default=None, alias="managedBy")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VAppConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VAppConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


