# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VAppIPAssignmentInfo(DataObject):
    """
    The IPAssignmentInfo class specifies how the guest software gets configured with IP addresses, including protocol type (IPv4 or IPv6) and the life-time of those IP addresses.  A vApp/virtual machine can either use DHCP to acquire an IP configuration, or it can acquire its IP configuration through the use of the vSphere platform using the OVF environment's properties. The latter is a known as OVF-environment-assigned IP configuration.  Guest software can be constructed to support DHCP , OVF assigned IP configuration, or both. The supportedAssignmentScheme property lists the supported schemes. This is typically specified by the author of a vApp.  The deployer / operator of a vApp, specifies what IP allocation policy should be used: - Using DHCP, if the vApp and deployed network supports it - Transient Assignment, if the vApp supports OVF-assigned IP   configuration and the network has an IP range configured. - Fixed Assignment, if the vApp supports OVF-assigned IP   configuration. - Fixed Allocated, if the vApp supports OVF-assigned IP   configuration and the network has an IP range configured.    Transient and fixed assignment differs in the life time of the IP allocation. For transient, IP addresses are automatically assigned on power-on and released on power-off. For fixed, the IP addresses are explicitly specified by the deployer and does not change between a power-on/power-off. Fixed allocated is a hybrid of transient and fixed assignment. IP addresses are allocated at first power-on and remain allocated on power-off.  The IPAssignment settings are global to a deployment. Thus, if a vApp or virtual machine is part of another vApp, then the settings are ignored, and the ones for the top-most vApp container is used.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    supported_allocation_scheme: Optional[List[StrictStr]] = Field(default=None, description="Specifies the IP allocation schemes supported by the guest software.  When updating this field, an empty array will be interpreted as no changes. An array of the form \\[\"\"\\] will clear all settings. Otherwise, the supplied value will overwrite the current setting.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ", alias="supportedAllocationScheme")
    ip_allocation_policy: Optional[StrictStr] = Field(default=None, description="Specifies how IP allocation should be managed by the VI platform.  This is typically specified by the deployer. The set of valid options for the policy is based on the capabilities of the vApp software, as specified by the supportedAllocationSchemes property.  Reconfigure privilege: VApp.InstanceConfig  ***Since:*** vSphere API 4.0 ", alias="ipAllocationPolicy")
    supported_ip_protocol: Optional[List[StrictStr]] = Field(default=None, description="Specifies the IP protocols supported by the guest software.  When updating this field, an empty array will be interpreted as no changes. An array of the form \\[\"\"\\] will clear all settings. Otherwise, the supplied value will overwrite the current setting.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ", alias="supportedIpProtocol")
    ip_protocol: Optional[StrictStr] = Field(default=None, description="Specifies the chosen IP protocol for this deployment.  This must be one of the values in the supportedIpProtocol field.  Reconfigure privilege: VApp.InstanceConfig  ***Since:*** vSphere API 4.0 ", alias="ipProtocol")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VAppIPAssignmentInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VAppIPAssignmentInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


