# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.vm_config_fault import VmConfigFault
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VAppPropertyFault(VmConfigFault):
    """
    The base fault for all vApp property configuration issues  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    id: StrictStr = Field(description="The fully-qualified id of the property, including instance and class identifiers.  ***Since:*** vSphere API 4.0 ")
    category: StrictStr = Field(description="The user-readable category  ***Since:*** vSphere API 4.0 ")
    label: StrictStr = Field(description="The user-readable label  ***Since:*** vSphere API 4.0 ")
    type: StrictStr = Field(description="The type specified for the property  ***Since:*** vSphere API 4.0 ")
    value: StrictStr = Field(description="The value of the property  ***Since:*** vSphere API 4.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','InvalidNetworkInType': 'InvalidNetworkInType','InvalidPropertyType': 'InvalidPropertyType','InvalidPropertyValue': 'InvalidPropertyValue','MissingIpPool': 'MissingIpPool','MissingNetworkIpConfig': 'MissingNetworkIpConfig','NoAvailableIp': 'NoAvailableIp','NoVcManagedIpConfigured': 'NoVcManagedIpConfigured','NotUserConfigurableProperty': 'NotUserConfigurableProperty','UnconfiguredPropertyValue': 'UnconfiguredPropertyValue'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VAppPropertyFault from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VAppPropertyFault from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("VAppPropertyFault failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.invalid_network_in_type import InvalidNetworkInType
from vmware_vi.models.invalid_property_type import InvalidPropertyType
from vmware_vi.models.invalid_property_value import InvalidPropertyValue
from vmware_vi.models.missing_ip_pool import MissingIpPool
from vmware_vi.models.missing_network_ip_config import MissingNetworkIpConfig
from vmware_vi.models.no_available_ip import NoAvailableIp
from vmware_vi.models.no_vc_managed_ip_configured import NoVcManagedIpConfigured
from vmware_vi.models.not_user_configurable_property import NotUserConfigurableProperty
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.unconfigured_property_value import UnconfiguredPropertyValue
# TODO: Rewrite to not use raise_errors
VAppPropertyFault.model_rebuild(raise_errors=False)

