# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import SecretStr, StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VAppPropertyInfo(DataObject):
    """
    A vApp Property description, including deployment values  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    key: StrictInt = Field(description="A unique integer key for the property.  ***Since:*** vSphere API 4.0 ")
    class_id: Optional[StrictStr] = Field(default=None, description="class name for this property  Valid values for classId: Any string except any white-space characters  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ", alias="classId")
    instance_id: Optional[StrictStr] = Field(default=None, description="class name for this property  Valid values for instanceId: Any string except any white-space characters  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ", alias="instanceId")
    id: Optional[StrictStr] = Field(default=None, description="Name of property.  In the OVF environment, the property is listed as \\[classId.\\]id\\[.instanceId\\]. The \\[classId.\\]name\\[.instanceId\\] must be unique.  This field cannot be empty for a property. Thus, it must be specified at creation and cannot be set to the empty string.  Valid values for id: Any string except any white-space characters  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ")
    category: Optional[StrictStr] = Field(default=None, description="A user-visible description the category the property belongs to.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ")
    label: Optional[StrictStr] = Field(default=None, description="The display name for the property.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ")
    type: Optional[StrictStr] = Field(default=None, description="Describes the valid format of the property.  A type must be one of: - string : A generic string. Max length 65535 (64k). - string(x..) : A string with minimum character length x. - string(..y) : A string with maximum character length y. - string(x..y) : A string with minimum character length x and maximum   character length y. - string\\[\"choice1\", \"choice2\", \"choice3\"\\] : A set of choices. \" inside a choice   must be either \\\\\" or ' e.g \"start\\\\\"middle\\\\\"end\" or \"start'middle'end\" and   a \\\\ inside a string choice must be encoded as \\\\\\\\ e.g. \"start\\\\\\\\end\". - int : An integer value. Is semantically equivalent to   int(-2147483648..2147483647) e.g. signed int32. - int(x..y): An integer value with a minimum size x and a maximum size y.   For example int(0..255) is a number between 0 and 255 both incl. This is   also a way to specify that the number must be a uint8. There is always a lower   and lower bound. Max number of digits is 100 including any sign. If exported to OVF the   value will be truncated to max of uint64 or int64. - real : IEEE 8-byte floating-point value. - real(x..y) : IEEE 8-byte floating-point value with a minimum size x and a   maximum size y. For example real(-1.5..1.5) must be a number between -1.5 and 1.5.   Because of the nature of float some conversions can truncate the value.   Real must be encoded according to CIM:   RealValue = \\[ \"+\" | \"-\" } \\*decimalDigit \".\" 1\\*decimalDigit   \\[ (\"e\" | \"E\" ) \\[ \"+\" | \"-\" \\] 1\\*decimalDigit \\] \\] - boolean : A boolean. The value can be True or False - password : A generic string. Max length 65535 (64k). - password(x..) : A string with minimum character length x. - password(..y) : A string with maximum character length y. - password(x..y) : A string with minimum character length x and maximum   character length y. - ip : An IPv4 address in dot-decimal notation or an IPv6 address in   colon-hexadecimal notation. - ip:network : An IP address in dot-notation (IPv4) and colon-hexadecimal (IPv6)   on a particular network. The behavior of this type depends on the   ipAllocationPolicy. See below. - expression: The default value specifies an expression that is calculated   by the system.    For properties of type 'password', the value field and default value field will always be returned as an empty string when queried. Thus, it is a write-only property. Typically, a client application will also render these as a text field with hidden text and double prompting.    An expression follows the general patterns of either ${arg} or ${cmd:arg}. The list of supported expressions are listed below: - ${&lt;name&gt;} : This expression evaluates to the same value as the named   property in the parent vApp. A parent vApp is the   first vApp in the ancestry chain (resource pools are   skipped). If no parent vApp exists or the property is   not defined on the parent vApp, the expression   evaluates to the empty value. - ${subnet:&lt;network&gt;} : The subnet value of the given network. - ${netmask:&lt;network&gt;} : The netmask value of the given network. - ${gateway:&lt;network&gt;} : The gateway value of the given network. - ${autoIp:&lt;network&gt;} : An auto-assigned network address on the given   network - ${net:&lt;network&gt;} : The name of the network - ${domainName:&lt;network&gt;} : The DNS domain name, e.g., vmware.com, of   the given network. - ${searchPath:&lt;network&gt;} : The DNS search path, e.g.,   eng.vmware.com;vmware.com, of the given   network. - ${hostPrefix:&lt;network&gt;}: The host prefix on a given network, e.g.,   \"voe-\" - ${dns:network}: A comma-separated string of configured network addresses - ${httpProxy:network}: The hostname:port for a proxy on the network - ${vimIp:} : The IP address of the VIM API provider server. This would   typical be an ESX Server or VirtualCenter Server.    A vApp will fail to start if any of the properties cannot be computed. For example, if a property reference a gateway on a network, for which is has not been specified. The value of the computed computation is assigned to the 'value' field upon start of the vApp or virtual machine. The value is cleared once the vApp or virtual machine is not-running.  The system provides three ways of specifying IP addresses: - ip, - ip:network type, - ${ip:network} expression.    The _ip_ types are typically used to specify an IP addressed to an external system. Thus, these are not used by a virtual ethernet adapter within the guest itself. Both the ip:network expression and the ${ip:network} expression are intended as a way to obtain an IP address for a virtual machine in a vApp.  The behavior of ip:network type is controlled by the ipAssignPolicy, as described in the following table: <table> <tr> <td>**Policy**</td> <td>ip:&lt;network&gt; type</td> </tr> <tr> <td>DHCP</td> <td>The user is not prompted to enter a value. The variable is set to the empty string during power-on, and later updated with the IP value reported by the guest software. </td> </tr> <tr> <td>Transient</td> <td>The user is not prompted to enter a value. An IP address is allocated by the platform and is assigned to the variable which is available to the guest. The IP address is released at power-off.</td> </tr> <tr> <td>Fixed</td> <td>The user is prompted to enter a value. This value is available to the guest.</td> </tr> <tr> <td>Fixed Allocated</td> <td>The user is not prompted to enter a value. An IP address is allocated by the platform and is assigned to the variable which is available to the guest. The IP address remains allocated at power-off, and are only released if the property is deleted or the vApp is destroyed.</td> </tr> </table>  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ")
    type_reference: Optional[StrictStr] = Field(default=None, description="Contains extra configuration data depending on the property type.  For types that refer to network names the type reference is the managed object reference of the network.  ***Since:*** vSphere API 5.1 ", alias="typeReference")
    user_configurable: Optional[StrictBool] = Field(default=None, description="Whether the property is user-configurable or a system property.  This is not used if the type is expression.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ", alias="userConfigurable")
    default_value: Optional[SecretStr] = Field(default=None, description="This either contains the default value of a field (used if value is empty string), or the expression if the type is \"expression\".  See comment for the  ***Since:*** vSphere API 4.0 ", alias="defaultValue")
    value: Optional[SecretStr] = Field(default=None, description="The value of the field at deployment time.  For expressions, this will contain the value that has been computed.  Reconfigure privilege: VApp.InstanceConfig  ***Since:*** vSphere API 4.0 ")
    description: Optional[StrictStr] = Field(default=None, description="A description of the field.  Reconfigure privilege: VApp.ApplicationConfig  ***Since:*** vSphere API 4.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VAppPropertyInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VAppPropertyInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


