# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.dvs_config_spec import DVSConfigSpec
from vmware_vi.models.link_discovery_protocol_config import LinkDiscoveryProtocolConfig
from vmware_vi.models.v_mware_dvs_pvlan_config_spec import VMwareDVSPvlanConfigSpec
from vmware_vi.models.v_mware_dvs_vspan_config_spec import VMwareDVSVspanConfigSpec
from vmware_vi.models.v_mware_ipfix_config import VMwareIpfixConfig
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VMwareDVSConfigSpec(DVSConfigSpec):
    """
    This class defines the VMware specific configuration for DistributedVirtualSwitch.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    pvlan_config_spec: Optional[List[VMwareDVSPvlanConfigSpec]] = Field(default=None, description="The PVLAN configuration specification.  A *VMwareDVSPvlanMapEntry* that has the same value for *VMwareDVSPvlanMapEntry.primaryVlanId* and *VMwareDVSPvlanMapEntry.secondaryVlanId* is referred to as a primary PVLAN entry. Otherwise, the *VMwareDVSPvlanMapEntry* is referred to as a secondary PVLAN entry.  The *VMwareDVSPvlanMapEntry.pvlanType* of a primary PVLAN entry must be *promiscuous*. A secondary PVLAN entry can have a *VMwareDVSPvlanMapEntry.pvlanType* of either *community* or *isolated*.  Primary PVLAN entries must be explicitly added. If there is no primary PVLAN entry corresponding to the *VMwareDVSPvlanMapEntry.primaryVlanId* of a secondary PVLAN entry, a fault is thrown.  While deleting a primary PVLAN entry, any associated secondary PVLAN entries must be explicitly deleted.  ***Since:*** vSphere API 4.0 ", alias="pvlanConfigSpec")
    vspan_config_spec: Optional[List[VMwareDVSVspanConfigSpec]] = Field(default=None, description="The Distributed Port Mirroring configuration specification.  The VSPAN sessions in the array cannot be of the same key.  ***Since:*** vSphere API 5.0 ", alias="vspanConfigSpec")
    max_mtu: Optional[StrictInt] = Field(default=None, description="The maximum MTU in the switch.  ***Since:*** vSphere API 4.0 ", alias="maxMtu")
    link_discovery_protocol_config: Optional[LinkDiscoveryProtocolConfig] = Field(default=None, alias="linkDiscoveryProtocolConfig")
    ipfix_config: Optional[VMwareIpfixConfig] = Field(default=None, alias="ipfixConfig")
    lacp_api_version: Optional[StrictStr] = Field(default=None, description="The Link Aggregation Control Protocol group version in the switch.  See *VMwareDvsLacpApiVersion_enum* for valid values.  ***Since:*** vSphere API 5.5 ", alias="lacpApiVersion")
    multicast_filtering_mode: Optional[StrictStr] = Field(default=None, description="The Multicast Filtering mode in the switch.  See *VMwareDvsMulticastFilteringMode_enum* for valid values.  ***Since:*** vSphere API 6.0 ", alias="multicastFilteringMode")
    network_offload_spec_id: Optional[StrictStr] = Field(default=None, description="Indicate the ID of NetworkOffloadSpec used in the switch.  Unset it when network offload is not allowed when creating a switch. Use ID \"None\" to change network offload from allowed to not allowed. ", alias="networkOffloadSpecId")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VMwareDVSConfigSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VMwareDVSConfigSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


