# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.v_mware_dvs_lag_ipfix_config import VMwareDvsLagIpfixConfig
from vmware_vi.models.v_mware_dvs_lag_vlan_config import VMwareDvsLagVlanConfig
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VMwareDvsLacpGroupConfig(DataObject):
    """
    This class defines VMware specific multiple IEEE 802.3ad Dynamic Link Aggregation Control Protocol groups.  ***Since:*** vSphere API 5.5 
    """ # noqa: E501
    key: Optional[StrictStr] = Field(default=None, description="The generated key as the identifier for the Link Aggregation group.  ***Since:*** vSphere API 5.5 ")
    name: Optional[StrictStr] = Field(default=None, description="The display name.  ***Since:*** vSphere API 5.5 ")
    mode: Optional[StrictStr] = Field(default=None, description="The mode of Link Aggregation Control Protocol.  See *VMwareUplinkLacpMode_enum* for valid values.  ***Since:*** vSphere API 5.5 ")
    uplink_num: Optional[StrictInt] = Field(default=None, description="The number of uplink ports.  ***Since:*** vSphere API 5.5 ", alias="uplinkNum")
    loadbalance_algorithm: Optional[StrictStr] = Field(default=None, description="Load balance policy.  See *VMwareDvsLacpLoadBalanceAlgorithm_enum* for valid values.  ***Since:*** vSphere API 5.5 ", alias="loadbalanceAlgorithm")
    vlan: Optional[VMwareDvsLagVlanConfig] = None
    ipfix: Optional[VMwareDvsLagIpfixConfig] = None
    uplink_name: Optional[List[StrictStr]] = Field(default=None, description="Names for the Uplink Ports in the group.  This property is ignored in an update operation.  ***Since:*** vSphere API 5.5 ", alias="uplinkName")
    uplink_port_key: Optional[List[StrictStr]] = Field(default=None, description="Keys for the Uplink Ports in the group.  This property is ignored in an update operation.  ***Since:*** vSphere API 5.5 ", alias="uplinkPortKey")
    timeout_mode: Optional[StrictStr] = Field(default=None, description="The timeout mode of LACP group.  See *VMwareUplinkLacpTimeoutMode_enum* for valid values.  ***Since:*** vSphere API 7.0.2.0 ", alias="timeoutMode")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VMwareDvsLacpGroupConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VMwareDvsLacpGroupConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


