# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.bool_policy import BoolPolicy
from vmware_vi.models.dv_port_setting import DVPortSetting
from vmware_vi.models.dvs_mac_management_policy import DVSMacManagementPolicy
from vmware_vi.models.dvs_security_policy import DVSSecurityPolicy
from vmware_vi.models.int_policy import IntPolicy
from vmware_vi.models.v_mware_uplink_lacp_policy import VMwareUplinkLacpPolicy
from vmware_vi.models.vmware_distributed_virtual_switch_vlan_spec import VmwareDistributedVirtualSwitchVlanSpec
from vmware_vi.models.vmware_uplink_port_teaming_policy import VmwareUplinkPortTeamingPolicy
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VMwareDVSPortSetting(DVPortSetting):
    """
    This class defines the VMware specific configuration for DistributedVirtualPort.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    vlan: Optional[VmwareDistributedVirtualSwitchVlanSpec] = None
    qos_tag: Optional[IntPolicy] = Field(default=None, alias="qosTag")
    uplink_teaming_policy: Optional[VmwareUplinkPortTeamingPolicy] = Field(default=None, alias="uplinkTeamingPolicy")
    security_policy: Optional[DVSSecurityPolicy] = Field(default=None, alias="securityPolicy")
    ipfix_enabled: Optional[BoolPolicy] = Field(default=None, alias="ipfixEnabled")
    tx_uplink: Optional[BoolPolicy] = Field(default=None, alias="txUplink")
    lacp_policy: Optional[VMwareUplinkLacpPolicy] = Field(default=None, alias="lacpPolicy")
    mac_management_policy: Optional[DVSMacManagementPolicy] = Field(default=None, alias="macManagementPolicy")
    vni: Optional[IntPolicy] = Field(default=None, alias="VNI")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VMwareDVSPortSetting from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VMwareDVSPortSetting from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


