# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VMwareVspanPort(DataObject):
    """
    This class defines the ports, uplink ports name, vlans and IP addresses participating in a Distributed Port Mirroring session.  See *VMwareVspanSession*.  ***Since:*** vSphere API 5.0 
    """ # noqa: E501
    port_key: Optional[List[StrictStr]] = Field(default=None, description="Individual ports to participate in the Distributed Port Mirroring session.  ***Since:*** vSphere API 5.0 ", alias="portKey")
    uplink_port_name: Optional[List[StrictStr]] = Field(default=None, description="Uplink ports used as destination ports to participate in the Distributed Port Mirroring session.  A fault will be raised if uplinkPortName is used as source ports in any Distributed Port Mirroring session.  ***Since:*** vSphere API 5.0 ", alias="uplinkPortName")
    wildcard_port_connectee_type: Optional[List[StrictStr]] = Field(default=None, description="Wild card specification for source ports participating in the Distributed Port Mirroring session.  See *DistributedVirtualSwitchPortConnecteeConnecteeType_enum* for valid values. Any port that has a connectee of the specified type has its receive traffic mirrored. A fault will be raised if wildcards are specified as destination ports or source ports mirroring traffic on the transmit side. It is to be not used.  ***Since:*** vSphere API 5.0 ", alias="wildcardPortConnecteeType")
    vlans: Optional[List[StrictInt]] = Field(default=None, description="Vlan Ids for ingress source of Remote Mirror destination session.  ***Since:*** vSphere API 5.1 ")
    ip_address: Optional[List[StrictStr]] = Field(default=None, description="IP address for the destination of encapsulated remote mirror source session, IPv4 address is specified using dotted decimal notation.  For example, \"192.0.2.1\". IPv6 addresses are 128-bit addresses represented as eight fields of up to four hexadecimal digits. A colon separates each field (:). For example, 2001:DB8:101::230:6eff:fe04:d9ff.  ***Since:*** vSphere API 5.1 ", alias="ipAddress")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VMwareVspanPort from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VMwareVspanPort from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


