# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictStr
from pydantic import Field
from vmware_vi.models.int_option import IntOption
from vmware_vi.models.virtual_device_option import VirtualDeviceOption
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualControllerOption(VirtualDeviceOption):
    """
    The VirtualControllerOption data object type contains information about a virtual controller type. 
    """ # noqa: E501
    devices: IntOption
    supported_device: Optional[List[StrictStr]] = Field(default=None, description="Array of supported device options for this controller. ", alias="supportedDevice")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','ParaVirtualSCSIControllerOption': 'ParaVirtualSCSIControllerOption','VirtualAHCIControllerOption': 'VirtualAHCIControllerOption','VirtualBusLogicControllerOption': 'VirtualBusLogicControllerOption','VirtualIDEControllerOption': 'VirtualIDEControllerOption','VirtualLsiLogicControllerOption': 'VirtualLsiLogicControllerOption','VirtualLsiLogicSASControllerOption': 'VirtualLsiLogicSASControllerOption','VirtualNVDIMMControllerOption': 'VirtualNVDIMMControllerOption','VirtualNVMEControllerOption': 'VirtualNVMEControllerOption','VirtualPCIControllerOption': 'VirtualPCIControllerOption','VirtualPS2ControllerOption': 'VirtualPS2ControllerOption','VirtualSATAControllerOption': 'VirtualSATAControllerOption','VirtualSCSIControllerOption': 'VirtualSCSIControllerOption','VirtualSIOControllerOption': 'VirtualSIOControllerOption','VirtualUSBControllerOption': 'VirtualUSBControllerOption','VirtualUSBXHCIControllerOption': 'VirtualUSBXHCIControllerOption'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VirtualControllerOption from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VirtualControllerOption from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("VirtualControllerOption failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.para_virtual_scsi_controller_option import ParaVirtualSCSIControllerOption
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.virtual_ahci_controller_option import VirtualAHCIControllerOption
from vmware_vi.models.virtual_bus_logic_controller_option import VirtualBusLogicControllerOption
from vmware_vi.models.virtual_ide_controller_option import VirtualIDEControllerOption
from vmware_vi.models.virtual_lsi_logic_controller_option import VirtualLsiLogicControllerOption
from vmware_vi.models.virtual_lsi_logic_sas_controller_option import VirtualLsiLogicSASControllerOption
from vmware_vi.models.virtual_nvdimm_controller_option import VirtualNVDIMMControllerOption
from vmware_vi.models.virtual_nvme_controller_option import VirtualNVMEControllerOption
from vmware_vi.models.virtual_pci_controller_option import VirtualPCIControllerOption
from vmware_vi.models.virtual_ps2_controller_option import VirtualPS2ControllerOption
from vmware_vi.models.virtual_sata_controller_option import VirtualSATAControllerOption
from vmware_vi.models.virtual_scsi_controller_option import VirtualSCSIControllerOption
from vmware_vi.models.virtual_sio_controller_option import VirtualSIOControllerOption
from vmware_vi.models.virtual_usb_controller_option import VirtualUSBControllerOption
from vmware_vi.models.virtual_usbxhci_controller_option import VirtualUSBXHCIControllerOption
# TODO: Rewrite to not use raise_errors
VirtualControllerOption.model_rebuild(raise_errors=False)

