# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.crypto_key_id import CryptoKeyId
from vmware_vi.models.virtual_device_file_backing_info import VirtualDeviceFileBackingInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualDiskFlatVer2BackingInfo(VirtualDeviceFileBackingInfo):
    """
    This data object type contains information about backing a virtual disk using a virtual disk file on the host, in the flat file format used by VMware Server, ESX Server 2.x, and ESX Server 3.x.  Flat disks are allocated when created, unlike sparse disks, which grow as needed. 
    """ # noqa: E501
    disk_mode: StrictStr = Field(description="The disk persistence mode.  Valid modes are: - *persistent* - *independent_persistent* - *independent_nonpersistent* - *nonpersistent* - *undoable* - *append*    See also *VirtualDiskMode_enum*. ", alias="diskMode")
    split: Optional[StrictBool] = Field(default=None, description="Flag to indicate the type of virtual disk file: split or monolithic.  If true, the virtual disk is stored in multiple files, each 2GB. On ESX this property is ignored when creating new disks or editing existing disks. This property is always false for disks created on ESX. When an existing split disk such as those created by VMware Server is added to a virtual machine on ESX, the property will be set to true when retrieved from *VirtualMachineConfigInfo*. ")
    write_through: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether writes should go directly to the file system or should be buffered. ", alias="writeThrough")
    thin_provisioned: Optional[StrictBool] = Field(default=None, description="Flag to indicate to the underlying filesystem, whether the virtual disk backing file should be allocated lazily (using thin provisioning). This flag is only used for file systems that support configuring the provisioning policy on a per file basis, such as VMFS3.  When specified as part of a *VirtualMachineConfigSpec*, this property applies only when creating a new virtual disk; it is ignored when editing an existing virtual disk.  see *DatastoreCapability.perFileThinProvisioningSupported* ", alias="thinProvisioned")
    eagerly_scrub: Optional[StrictBool] = Field(default=None, description="Flag to indicate to the underlying filesystem whether the virtual disk backing file should be scrubbed completely at this time.  Virtual disks on some filesystems like VMFS3 are zeroed-out lazily so that disk creation time doesn't take too long. However, clustering applications and features like Fault Tolerance require that the virtual disk be completely scrubbed. This setting allows controlling the scrubbing policy on a per-disk basis.  If this flag is unset or set to false when creating a new disk, the disk scrubbing policy will be decided by the filesystem. If this flag is unset or set to false when editing an existing disk, it is ignored. When returned as part of a *VirtualMachineConfigInfo*, this property may be unset if its value is unknown.  ***Since:*** vSphere API 4.0 ", alias="eagerlyScrub")
    uuid: Optional[StrictStr] = Field(default=None, description="Disk UUID for the virtual disk, if available.  ***Since:*** VI API 2.5 ")
    content_id: Optional[StrictStr] = Field(default=None, description="Content ID of the virtual disk file, if available.  A content ID indicates the logical contents of the disk backing and its parents.  This property is only guaranteed to be up to date if this disk backing is not currently being written to by any virtual machine.  The only supported operation is comparing if two content IDs are equal or not. The guarantee provided by the content ID is that if two disk backings have the same content ID and are not currently being written to, then reads issued from the guest operating system to those disk backings will return the same data.  ***Since:*** vSphere API 4.0 ", alias="contentId")
    change_id: Optional[StrictStr] = Field(default=None, description="The change ID of the virtual disk for the corresponding snapshot or virtual machine.  This can be used to track incremental changes to a virtual disk. See *VirtualMachine.QueryChangedDiskAreas*.  ***Since:*** vSphere API 4.0 ", alias="changeId")
    parent: Optional[VirtualDiskFlatVer2BackingInfo] = None
    delta_disk_format: Optional[StrictStr] = Field(default=None, description="The format of the delta disk.  This field is valid only for a delta disk.  See *DeltaDiskFormat* for the supported formats. If not specified, the default value used is *redoLogFormat*.  If *nativeFormat* is specified and the datastore does not support this format or the parent is on a different datastore, *DeltaDiskFormatNotSupported* is thrown.  vSphere server does not support relocation of virtual machines with *nativeFormat*. An exception is thrown for such requests.  ***Since:*** vSphere API 5.0 ", alias="deltaDiskFormat")
    digest_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether the disk backing has digest file enabled.  ***Since:*** vSphere API 5.0 ", alias="digestEnabled")
    delta_grain_size: Optional[StrictInt] = Field(default=None, description="Grain size in kB for a delta disk of format type seSparseFormat.  The default size is 4 kB. This setting is used to specify the grain size of *Flex-SE* delta disks when the base disk is of type FlatVer2BackingInfo. The *DeltaDiskFormat* must also be set to seSparseFormat.  ***Since:*** vSphere API 5.1 ", alias="deltaGrainSize")
    delta_disk_format_variant: Optional[StrictStr] = Field(default=None, description="The delta disk format variant, if applicable.  This field is valid only for a delta disk and may specify more detailed information for the delta disk format specified in *deltaDiskFormat*.  If *redoLogFormat* is specified for the *deltaDiskFormat*, see *DeltaDiskFormatVariant* for the supported formats. If this is not specified for *redoLogFormat*, the default value used is *vmfsSparseVariant*.  For other delta disk formats, this currently remains unspecified.  ***Since:*** vSphere API 6.0 ", alias="deltaDiskFormatVariant")
    sharing: Optional[StrictStr] = Field(default=None, description="The sharing mode of the virtual disk.  See *VirtualDiskSharing_enum*. The default value is no sharing.  ***Since:*** vSphere API 6.0 ")
    key_id: Optional[CryptoKeyId] = Field(default=None, alias="keyId")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualDiskFlatVer2BackingInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualDiskFlatVer2BackingInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj

# TODO: Rewrite to not use raise_errors
VirtualDiskFlatVer2BackingInfo.model_rebuild(raise_errors=False)

