# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.virtual_device_file_backing_info import VirtualDeviceFileBackingInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualDiskRawDiskMappingVer1BackingInfo(VirtualDeviceFileBackingInfo):
    """
    This data object type contains information about backing a virtual disk using a raw device mapping.  Supported for ESX Server 2.5 and 3.x. 
    """ # noqa: E501
    lun_uuid: Optional[StrictStr] = Field(default=None, description="Unique identifier of the LUN accessed by the raw disk mapping. ", alias="lunUuid")
    device_name: Optional[StrictStr] = Field(default=None, description="The host-specific device the LUN is being accessed through.  If the target LUN is not available on the host then it is empty. For example, this could happen if it has accidentally been masked out. ", alias="deviceName")
    compatibility_mode: Optional[StrictStr] = Field(default=None, description="The compatibility mode of the raw disk mapping (RDM).  This must be specified when a new virtual disk with an RDM backing is created. On subsequent virtual machine reconfigurations, this property should be handled as follows, depending on the version of the host:  On ESX Server 2.5, the compatibility mode of an RDM backing is a characteristic of the virtual machine's configuration. When reconfiguring a virtual machine that currently uses a virtual disk backed by an RDM, the compatibility mode of that backing may be modified. When reconfiguring a virtual machine to add an existing virtual disk backed by an RDM, the compatibility mode of that backing may be specified. If left unspecified it defaults to \"physicalMode\".  On ESX Server 3.x, the compatibility mode of an RDM backing is a characteristic of the RDM itself. Once the RDM is created, its compatibility mode cannot be changed by reconfiguring the virtual machine. When reconfiguring a virtual machine to add an existing virtual disk backed by an RDM, the compatibility mode of that backing must be left unspecified.  See also *VirtualDiskCompatibilityMode_enum*. ", alias="compatibilityMode")
    disk_mode: Optional[StrictStr] = Field(default=None, description="The disk mode.  Valid values are: - *persistent* - *independent_persistent* - *independent_nonpersistent* - *nonpersistent* - *undoable* - *append*    Disk modes are only supported when the raw disk mapping is using virtual compatibility mode.  See also *VirtualDiskMode_enum*. ", alias="diskMode")
    uuid: Optional[StrictStr] = Field(default=None, description="Disk UUID for the virtual disk, if available.  Disk UUID is not available if the raw disk mapping is in physical compatibility mode.  ***Since:*** VI API 2.5 ")
    content_id: Optional[StrictStr] = Field(default=None, description="Content ID of the virtual disk file, if available.  A content ID indicates the logical contents of the disk backing and its parents.  This property is only guaranteed to be up to date if this disk backing is not currently being written to by any virtual machine.  The only supported operation is comparing if two content IDs are equal or not. The guarantee provided by the content ID is that if two disk backings have the same content ID and are not currently being written to, then reads issued from the guest operating system to those disk backings will return the same data.  ***Since:*** vSphere API 4.0 ", alias="contentId")
    change_id: Optional[StrictStr] = Field(default=None, description="The change ID of the virtual disk for the corresponding snapshot or virtual machine.  This can be used to track incremental changes to a virtual disk. See *VirtualMachine.QueryChangedDiskAreas*.  ***Since:*** vSphere API 4.0 ", alias="changeId")
    parent: Optional[VirtualDiskRawDiskMappingVer1BackingInfo] = None
    delta_disk_format: Optional[StrictStr] = Field(default=None, description="The format of the delta disk.  This field is valid only for a delta disk.  See *DeltaDiskFormat* for the supported formats. The default value used for VM with hardware version 8 and lower is *redoLogFormat*. The default value used for VM with hardware version 9 and higher is *seSparseFormat*.  *nativeFormat* is not supported for bask disk of type RawDiskMappingVer1BackingInfo.  ***Since:*** vSphere API 6.7 ", alias="deltaDiskFormat")
    delta_grain_size: Optional[StrictInt] = Field(default=None, description="Grain size in kB for a delta disk of format type seSparseFormat.  The default size is 4 kB. The grain size of *Flex-SE* delta disks when the base disk is of type RawDiskMappingVer1BackingInfo. The *DeltaDiskFormat* must also be set to seSparseFormat.  ***Since:*** vSphere API 6.7 ", alias="deltaGrainSize")
    sharing: Optional[StrictStr] = Field(default=None, description="The sharing mode of the virtual disk.  See *VirtualDiskSharing_enum*. The default value is no sharing.  ***Since:*** vSphere API 6.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualDiskRawDiskMappingVer1BackingInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualDiskRawDiskMappingVer1BackingInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj

# TODO: Rewrite to not use raise_errors
VirtualDiskRawDiskMappingVer1BackingInfo.model_rebuild(raise_errors=False)

