# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.bool_option import BoolOption
from vmware_vi.models.choice_option import ChoiceOption
from vmware_vi.models.virtual_device_file_backing_option import VirtualDeviceFileBackingOption
from vmware_vi.models.virtual_disk_delta_disk_formats_supported import VirtualDiskDeltaDiskFormatsSupported
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualDiskSeSparseBackingOption(VirtualDeviceFileBackingOption):
    """
    Backing options for virtual disks that use the space efficient sparse format.  Space for Flex-SE disks is allocated on demand and optimizations are applied to achieve additional space savings.  ***Since:*** vSphere API 5.1 
    """ # noqa: E501
    disk_mode: ChoiceOption = Field(alias="diskMode")
    write_through: BoolOption = Field(alias="writeThrough")
    growable: StrictBool = Field(description="Indicates whether or not this disk backing can be extended to larger sizes through a reconfigure operation.  If set to true, reconfiguring this virtual disk with a *VirtualDisk.capacityInKB* value greater than its current value will grow the disk to the newly specified size.  ***Since:*** vSphere API 5.1 ")
    hot_growable: StrictBool = Field(description="Indicates whether or not this disk backing can be extended to larger sizes through a reconfigure operation while the virtual machine is powered on.  If set to true, reconfiguring this virtual disk with a *VirtualDisk.capacityInKB* value greater than its current value will grow the disk to the newly specified size while the virtual machine is powered on.  ***Since:*** vSphere API 5.1 ", alias="hotGrowable")
    uuid: StrictBool = Field(description="Flag to indicate whether this backing supports disk UUID property.  ***Since:*** vSphere API 5.1 ")
    delta_disk_formats_supported: List[VirtualDiskDeltaDiskFormatsSupported] = Field(description="Delta disk formats supported for each datastore type.  ***Since:*** vSphere API 5.1 ", alias="deltaDiskFormatsSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualDiskSeSparseBackingOption from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualDiskSeSparseBackingOption from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


