# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualDiskVFlashCacheConfigInfo(DataObject):
    """
    Data object describes the vFlash cache configuration on this virtual disk.  ***Since:*** vSphere API 5.5 
    """ # noqa: E501
    v_flash_module: Optional[StrictStr] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Name of vFlash module which manages the cache.  If not specified, default setting *HostVFlashManagerVFlashCacheConfigSpec.defaultVFlashModule* will be used.  ***Since:*** vSphere API 5.5 ", alias="vFlashModule")
    reservation_in_mb: Optional[StrictInt] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Amount of vFlash resource that is guaranteed available to the cache.  If not specified, default reservation will be used.  ***Since:*** vSphere API 5.5 ", alias="reservationInMB")
    cache_consistency_type: Optional[StrictStr] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Cache data consistency types after a crash.  See *VirtualDiskVFlashCacheConfigInfoCacheConsistencyType_enum* for supported types. If not specified, the default value used is *strong*  ***Since:*** vSphere API 5.5 ", alias="cacheConsistencyType")
    cache_mode: Optional[StrictStr] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Cache modes.  See *VirtualDiskVFlashCacheConfigInfoCacheMode_enum* for supported modes. If not specified, the default value used is *write_thru*.  ***Since:*** vSphere API 5.5 ", alias="cacheMode")
    block_size_in_kb: Optional[StrictInt] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Cache block size.  This parameter allows the user to control how much data gets cached on a single access to the VMDK. Max block size is 1MB. Default is 4KB.  ***Since:*** vSphere API 5.5 ", alias="blockSizeInKB")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualDiskVFlashCacheConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualDiskVFlashCacheConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


