# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineCapability(DataObject):
    """
    This data object type contains information about the operation/capabilities of a virtual machine 
    """ # noqa: E501
    snapshot_operations_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports snapshot operations. ", alias="snapshotOperationsSupported")
    multiple_snapshots_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports multiple snapshots.  This value is not set when the virtual machine is unavailable, for instance, when it is being created or deleted. ", alias="multipleSnapshotsSupported")
    snapshot_config_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports snapshot config. ", alias="snapshotConfigSupported")
    powered_off_snapshots_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports snapshot operations in poweredOff state.  This flag doesn't affect vim.VirtualMachine.GetSnapshot, which is always supported. ", alias="poweredOffSnapshotsSupported")
    memory_snapshots_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports memory snapshots. ", alias="memorySnapshotsSupported")
    revert_to_snapshot_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports reverting to a snapshot. ", alias="revertToSnapshotSupported")
    quiesced_snapshots_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports quiesced snapshots. ", alias="quiescedSnapshotsSupported")
    disable_snapshots_supported: StrictBool = Field(description="Deprecated as of vSphere API 4.0. The value returned from the server is always false.  Indicates whether or not snapshots can be disabled.  ***Since:*** VI API 2.5 ", alias="disableSnapshotsSupported")
    lock_snapshots_supported: StrictBool = Field(description="Indicates whether or not the snapshot tree can be locked.  ***Since:*** VI API 2.5 ", alias="lockSnapshotsSupported")
    console_preferences_supported: StrictBool = Field(description="Indicates whether console preferences can be set for this virtual machine. ", alias="consolePreferencesSupported")
    cpu_feature_mask_supported: StrictBool = Field(description="Indicates whether CPU feature requirements masks can be set for this virtual machine.  Masking for hardware version 9 and newer virtual machines is controlled by *VirtualMachineCapability.featureRequirementSupported*. ", alias="cpuFeatureMaskSupported")
    s1_acpi_management_supported: StrictBool = Field(description="Indicates whether or not a virtual machine supports ACPI S1 settings management. ", alias="s1AcpiManagementSupported")
    setting_screen_resolution_supported: StrictBool = Field(description="Indicates whether of not this virtual machine supports setting the screen resolution of the console window.  This capability depends on the guest operating system configured for this virtual machine. ", alias="settingScreenResolutionSupported")
    tools_auto_update_supported: StrictBool = Field(description="Supports tools auto-update. ", alias="toolsAutoUpdateSupported")
    vm_npiv_wwn_supported: StrictBool = Field(description="Supports virtual machine NPIV WWN.  ***Since:*** VI API 2.5 ", alias="vmNpivWwnSupported")
    npiv_wwn_on_non_rdm_vm_supported: StrictBool = Field(description="Supports assigning NPIV WWN to virtual machines that don't have RDM disks.  ***Since:*** VI API 2.5 ", alias="npivWwnOnNonRdmVmSupported")
    vm_npiv_wwn_disable_supported: StrictBool = Field(description="Indicates whether the NPIV disabling operation is supported the virtual machine.  ***Since:*** vSphere API 4.0 ", alias="vmNpivWwnDisableSupported")
    vm_npiv_wwn_update_supported: StrictBool = Field(description="Indicates whether the update of NPIV WWNs are supported on the virtual machine.  ***Since:*** vSphere API 4.0 ", alias="vmNpivWwnUpdateSupported")
    swap_placement_supported: StrictBool = Field(description="Flag indicating whether the virtual machine has a configurable *swapfile placement policy*.  ***Since:*** VI API 2.5 ", alias="swapPlacementSupported")
    tools_sync_time_supported: StrictBool = Field(description="Indicates whether asking tools to sync time with the host is supported.  ***Since:*** VI API 2.5 ", alias="toolsSyncTimeSupported")
    virtual_mmu_usage_supported: StrictBool = Field(description="Indicates whether or not the use of nested page table hardware support can be explicitly set.  ***Since:*** VI API 2.5 ", alias="virtualMmuUsageSupported")
    disk_shares_supported: StrictBool = Field(description="Indicates whether resource settings for disks can be applied to this virtual machine.  ***Since:*** VI API 2.5 ", alias="diskSharesSupported")
    boot_options_supported: StrictBool = Field(description="Indicates whether boot options can be configured for this virtual machine.  ***Since:*** VI API 2.5 ", alias="bootOptionsSupported")
    boot_retry_options_supported: StrictBool = Field(description="Indicates whether automatic boot retry can be configured for this virtual machine.  ***Since:*** vSphere API 4.1 ", alias="bootRetryOptionsSupported")
    setting_video_ram_size_supported: StrictBool = Field(description="Flag indicating whether the video ram size of this virtual machine can be configured.  ***Since:*** VI API 2.5 ", alias="settingVideoRamSizeSupported")
    setting_display_topology_supported: StrictBool = Field(description="Indicates whether of not this virtual machine supports setting the display topology of the console window.  This capability depends on the guest operating system configured for this virtual machine.  ***Since:*** vSphere API 4.0 ", alias="settingDisplayTopologySupported")
    record_replay_supported: StrictBool = Field(description="Deprecated as of vSphere API 6.0.  Indicates whether record and replay functionality is supported on this virtual machine.  ***Since:*** vSphere API 4.0 ", alias="recordReplaySupported")
    change_tracking_supported: StrictBool = Field(description="Indicates that change tracking is supported for virtual disks of this virtual machine.  However, even if change tracking is supported, it might not be available for all disks of the virtual machine. For example, passthru raw disk mappings or disks backed by any Ver1BackingInfo cannot be tracked.  ***Since:*** vSphere API 4.0 ", alias="changeTrackingSupported")
    multiple_cores_per_socket_supported: StrictBool = Field(description="Indicates whether multiple virtual cores per socket is supported on this VM.  ***Since:*** vSphere API 5.0 ", alias="multipleCoresPerSocketSupported")
    host_based_replication_supported: StrictBool = Field(description="Indicates that host based replication is supported on this virtual machine.  However, even if host based replication is supported, it might not be available for all disk types. For example, passthru raw disk mappings can not be replicated.  ***Since:*** vSphere API 5.0 ", alias="hostBasedReplicationSupported")
    guest_auto_lock_supported: StrictBool = Field(description="Indicates whether features like guest OS auto-lock and MKS connection controls are supported for this virtual machine.  ***Since:*** vSphere API 5.0 ", alias="guestAutoLockSupported")
    memory_reservation_lock_supported: StrictBool = Field(description="Indicates whether *memoryReservationLockedToMax* may be set to true for this virtual machine.  ***Since:*** vSphere API 5.0 ", alias="memoryReservationLockSupported")
    feature_requirement_supported: StrictBool = Field(description="Indicates whether featureRequirement feature is supported.  ***Since:*** vSphere API 5.1 ", alias="featureRequirementSupported")
    powered_on_monitor_type_change_supported: StrictBool = Field(description="Indicates whether a monitor type change is supported while this virtual machine is in the poweredOn state.  ***Since:*** vSphere API 5.1 ", alias="poweredOnMonitorTypeChangeSupported")
    se_sparse_disk_supported: StrictBool = Field(description="Indicates whether this virtual machine supports the Flex-SE (space-efficient, sparse) format for virtual disks.  ***Since:*** vSphere API 5.1 ", alias="seSparseDiskSupported")
    nested_hv_supported: StrictBool = Field(description="Indicates whether this virtual machine supports nested hardware-assisted virtualization.  ***Since:*** vSphere API 5.1 ", alias="nestedHVSupported")
    v_pmc_supported: StrictBool = Field(description="Indicates whether this virtual machine supports virtualized CPU performance counters.  ***Since:*** vSphere API 5.1 ", alias="vPMCSupported")
    secure_boot_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether secureBoot is supported for this virtual machine.  ***Since:*** vSphere API 6.5 ", alias="secureBootSupported")
    per_vm_evc_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this virtual machine supports Per-VM EVC mode.  ***Since:*** vSphere API 6.7 ", alias="perVmEvcSupported")
    virtual_mmu_usage_ignored: Optional[StrictBool] = Field(default=None, description="Indicates that *VirtualMachineFlagInfo.virtualMmuUsage* is ignored by this virtual machine, always operating as if \"on\" was selected.  ***Since:*** vSphere API 6.7 ", alias="virtualMmuUsageIgnored")
    virtual_exec_usage_ignored: Optional[StrictBool] = Field(default=None, description="Indicates that *VirtualMachineFlagInfo.virtualExecUsage* is ignored by this virtual machine, always operating as if \"hvOn\" was selected.  ***Since:*** vSphere API 6.7 ", alias="virtualExecUsageIgnored")
    disk_only_snapshot_on_suspended_vm_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this virtual machine supports creating disk-only snapshots in suspended state.  If this capability is not set, the snapshot of a virtual machine in suspended state will always include memory.  ***Since:*** vSphere API 6.7 ", alias="diskOnlySnapshotOnSuspendedVMSupported")
    suspend_to_memory_supported: Optional[StrictBool] = Field(default=None, description="Indicates whether this virtual machine supports suspending to memory.  ***Since:*** vSphere API 7.0.2.0 ", alias="suspendToMemorySupported")
    tools_sync_time_allow_supported: Optional[StrictBool] = Field(default=None, description="Indicates support for allowing or disallowing all tools time sync with host.  ***Since:*** vSphere API 7.0.1.0 ", alias="toolsSyncTimeAllowSupported")
    sev_supported: Optional[StrictBool] = Field(default=None, description="Indicates support for AMD-SEV (Secure Encrypted Virtualization).  SEV is supported when set to true, and unsupported otherwise.  ***Since:*** vSphere API 7.0.1.0 ", alias="sevSupported")
    pmem_failover_supported: Optional[StrictBool] = Field(default=None, description="Indicates support for failover to a dfferent host on VM's with pmem.  Failover is supported when set to true, and unsupported otherwise.  ***Since:*** vSphere API 7.0.2.0 ", alias="pmemFailoverSupported")
    require_sgx_attestation_supported: Optional[StrictBool] = Field(default=None, description="Whether the VM supports requiring SGX remote attestation. ", alias="requireSgxAttestationSupported")
    change_mode_disks_supported: Optional[StrictBool] = Field(default=None, description="Indicates support for change mode on virtual disks ", alias="changeModeDisksSupported")
    vendor_device_group_supported: Optional[StrictBool] = Field(default=None, description="Indicates support for Vendor Device Groups ", alias="vendorDeviceGroupSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineCapability from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineCapability from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


