# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import StrictBool, StrictBytes, StrictInt, StrictStr
from pydantic import Field
from typing_extensions import Annotated
from vmware_vi.models.crypto_key_id import CryptoKeyId
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.fault_tolerance_config_info import FaultToleranceConfigInfo
from vmware_vi.models.host_cpu_id_info import HostCpuIdInfo
from vmware_vi.models.latency_sensitivity import LatencySensitivity
from vmware_vi.models.managed_by_info import ManagedByInfo
from vmware_vi.models.option_value import OptionValue
from vmware_vi.models.replication_config_spec import ReplicationConfigSpec
from vmware_vi.models.resource_allocation_info import ResourceAllocationInfo
from vmware_vi.models.scheduled_hardware_upgrade_info import ScheduledHardwareUpgradeInfo
from vmware_vi.models.tools_config_info import ToolsConfigInfo
from vmware_vi.models.virtual_hardware import VirtualHardware
from vmware_vi.models.virtual_machine_affinity_info import VirtualMachineAffinityInfo
from vmware_vi.models.virtual_machine_boot_options import VirtualMachineBootOptions
from vmware_vi.models.virtual_machine_config_info_datastore_url_pair import VirtualMachineConfigInfoDatastoreUrlPair
from vmware_vi.models.virtual_machine_config_info_overhead_info import VirtualMachineConfigInfoOverheadInfo
from vmware_vi.models.virtual_machine_console_preferences import VirtualMachineConsolePreferences
from vmware_vi.models.virtual_machine_content_library_item_info import VirtualMachineContentLibraryItemInfo
from vmware_vi.models.virtual_machine_default_power_op_info import VirtualMachineDefaultPowerOpInfo
from vmware_vi.models.virtual_machine_file_info import VirtualMachineFileInfo
from vmware_vi.models.virtual_machine_flag_info import VirtualMachineFlagInfo
from vmware_vi.models.virtual_machine_fork_config_info import VirtualMachineForkConfigInfo
from vmware_vi.models.virtual_machine_guest_integrity_info import VirtualMachineGuestIntegrityInfo
from vmware_vi.models.virtual_machine_guest_monitoring_mode_info import VirtualMachineGuestMonitoringModeInfo
from vmware_vi.models.virtual_machine_network_shaper_info import VirtualMachineNetworkShaperInfo
from vmware_vi.models.virtual_machine_sgx_info import VirtualMachineSgxInfo
from vmware_vi.models.virtual_machine_vcpu_config import VirtualMachineVcpuConfig
from vmware_vi.models.virtual_machine_virtual_device_groups import VirtualMachineVirtualDeviceGroups
from vmware_vi.models.virtual_machine_virtual_device_swap import VirtualMachineVirtualDeviceSwap
from vmware_vi.models.virtual_machine_virtual_numa_info import VirtualMachineVirtualNumaInfo
from vmware_vi.models.virtual_machine_virtual_p_mem import VirtualMachineVirtualPMem
from vmware_vi.models.vm_config_info import VmConfigInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineConfigInfo(DataObject):
    """
    The ConfigInfo data object type encapsulates the configuration settings and virtual hardware for a virtual machine.  This type holds all the information that is present in the .vmx configuration file for the virtual machine. 
    """ # noqa: E501
    change_version: StrictStr = Field(description="The changeVersion is a unique identifier for a given version of the configuration.  Each change to the configuration updates this value. This is typically implemented as an ever increasing count or a time-stamp. However, a client should always treat this as an opaque string. ", alias="changeVersion")
    modified: datetime = Field(description="Last time a virtual machine's configuration was modified. ")
    name: StrictStr = Field(description="Display name of the virtual machine.  Any / (slash), \\\\ (backslash), character used in this name element is escaped. Similarly, any % (percent) character used in this name element is escaped, unless it is used to start an escape sequence. A slash is escaped as %2F or %2f. A backslash is escaped as %5C or %5c, and a percent is escaped as %25. ")
    guest_full_name: StrictStr = Field(description="This is the full name of the guest operating system for the virtual machine.  For example: Windows 2000 Professional.  See also *VirtualMachineConfigInfo.alternateGuestName*. ", alias="guestFullName")
    version: StrictStr = Field(description="The version string for this virtual machine. ")
    uuid: StrictStr = Field(description="128-bit SMBIOS UUID of a virtual machine represented as a hexadecimal string in \"12345678-abcd-1234-cdef-123456789abc\" format. ")
    create_date: Optional[datetime] = Field(default=None, description="Time the virtual machine's configuration was created.  ***Since:*** vSphere API 6.7 ", alias="createDate")
    instance_uuid: Optional[StrictStr] = Field(default=None, description="VirtualCenter-specific 128-bit UUID of a virtual machine, represented as a hexademical string.  This identifier is used by VirtualCenter to uniquely identify all virtual machine instances, including those that may share the same SMBIOS UUID.  ***Since:*** vSphere API 4.0 ", alias="instanceUuid")
    npiv_node_world_wide_name: Optional[List[StrictInt]] = Field(default=None, description="A 64-bit node WWN (World Wide Name).  These WWNs are paired with the *VirtualMachineConfigInfo.npivPortWorldWideName* to be used by the NPIV VPORTs instantiated for the virtual machine on the physical HBAs of the host. A pair of node and port WWNs serves as a unique identifier in accessing a LUN, so that it can be monitored or controlled by the storage administrator.  If this property contains a single node WWN, the same node WWN is used to pair with all port WWNs listed in *VirtualMachineConfigInfo.npivPortWorldWideName*. If this property or *VirtualMachineConfigInfo.npivPortWorldWideName* is empty or unset, NPIV WWN is disabled for the virtual machine.  ***Since:*** VI API 2.5 ", alias="npivNodeWorldWideName")
    npiv_port_world_wide_name: Optional[List[StrictInt]] = Field(default=None, description="A 64-bit port WWN (World Wide Name).  For detail description on WWN, see *VirtualMachineConfigInfo.npivNodeWorldWideName*.  ***Since:*** VI API 2.5 ", alias="npivPortWorldWideName")
    npiv_world_wide_name_type: Optional[StrictStr] = Field(default=None, description="The source that provides/generates the assigned WWNs.  See also *VirtualMachineConfigInfoNpivWwnType_enum*.  ***Since:*** VI API 2.5 ", alias="npivWorldWideNameType")
    npiv_desired_node_wwns: Optional[Annotated[int, Field(le=32767, strict=True, ge=-32768)]] = Field(default=None, description="The NPIV node WWNs to be extended from the original list of WWN nummbers.  This property should be set to desired number which is an aggregate of existing plus new numbers. Desired Node WWNs should always be greater than the existing number of node WWNs  ***Since:*** vSphere API 4.0 ", alias="npivDesiredNodeWwns")
    npiv_desired_port_wwns: Optional[Annotated[int, Field(le=32767, strict=True, ge=-32768)]] = Field(default=None, description="The NPIV port WWNs to be extended from the original list of WWN nummbers.  This property should be set to desired number which is an aggregate of existing plus new numbers. Desired Node WWNs should always be greater than the existing number of port WWNs  ***Since:*** vSphere API 4.0 ", alias="npivDesiredPortWwns")
    npiv_temporary_disabled: Optional[StrictBool] = Field(default=None, description="This property is used to enable or disable the NPIV capability on a desired virtual machine on a temporary basis.  When this property is set NPIV Vport will not be instantiated by the VMX process of the Virtual Machine. When this property is set port WWNs and node WWNs in the VM configuration are preserved.  ***Since:*** vSphere API 4.0 ", alias="npivTemporaryDisabled")
    npiv_on_non_rdm_disks: Optional[StrictBool] = Field(default=None, description="This property is used to check whether the NPIV can be enabled on the Virtual machine with non-rdm disks in the configuration, so this is potentially not enabling npiv on vmfs disks.  Also this property is used to check whether RDM is required to generate WWNs for a virtual machine.  ***Since:*** vSphere API 4.0 ", alias="npivOnNonRdmDisks")
    location_id: Optional[StrictStr] = Field(default=None, description="Hash incorporating the virtual machine's config file location and the UUID of the host assigned to run the virtual machine. ", alias="locationId")
    template: StrictBool = Field(description="Flag indicating whether or not a virtual machine is a template. ")
    guest_id: StrictStr = Field(description="Guest operating system configured on a virtual machine.  This is a guest identifier that can be used to access the *GuestOsDescriptor* list for information about default configuration. For more information on possible values, see *VirtualMachineGuestOsIdentifier*. ", alias="guestId")
    alternate_guest_name: StrictStr = Field(description="Used as display name for the operating system if guestId is `other` or `other-64`.  See also *VirtualMachineConfigInfo.guestFullName*.  ***Since:*** VI API 2.5 ", alias="alternateGuestName")
    annotation: Optional[StrictStr] = Field(default=None, description="Description for the virtual machine. ")
    files: VirtualMachineFileInfo
    tools: Optional[ToolsConfigInfo] = None
    flags: VirtualMachineFlagInfo
    console_preferences: Optional[VirtualMachineConsolePreferences] = Field(default=None, alias="consolePreferences")
    default_power_ops: VirtualMachineDefaultPowerOpInfo = Field(alias="defaultPowerOps")
    reboot_power_off: Optional[StrictBool] = Field(default=None, description="Whether the next reboot will result in a power off. ", alias="rebootPowerOff")
    hardware: VirtualHardware
    vcpu_config: Optional[List[VirtualMachineVcpuConfig]] = Field(default=None, description="Vcpu configuration.  The <code>vcpuConfig</code> array is indexed by vcpu number.  ***Since:*** vSphere API 7.0 ", alias="vcpuConfig")
    cpu_allocation: Optional[ResourceAllocationInfo] = Field(default=None, alias="cpuAllocation")
    memory_allocation: Optional[ResourceAllocationInfo] = Field(default=None, alias="memoryAllocation")
    latency_sensitivity: Optional[LatencySensitivity] = Field(default=None, alias="latencySensitivity")
    memory_hot_add_enabled: Optional[StrictBool] = Field(default=None, description="Whether memory can be added while this virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="memoryHotAddEnabled")
    cpu_hot_add_enabled: Optional[StrictBool] = Field(default=None, description="Whether virtual processors can be added while this virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="cpuHotAddEnabled")
    cpu_hot_remove_enabled: Optional[StrictBool] = Field(default=None, description="Whether virtual processors can be removed while this virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="cpuHotRemoveEnabled")
    hot_plug_memory_limit: Optional[StrictInt] = Field(default=None, description="The maximum amount of memory, in MB, than can be added to a running virtual machine.  This value is determined by the virtual machine and is specified only if *VirtualMachineConfigInfo.memoryHotAddEnabled* is set to true.  ***Since:*** vSphere API 4.0 ", alias="hotPlugMemoryLimit")
    hot_plug_memory_increment_size: Optional[StrictInt] = Field(default=None, description="Memory, in MB that can be added to a running virtual machine must be in increments of this value and needs be a multiple of this value.  This value is determined by the virtual machine and is specified only if *VirtualMachineConfigSpec.memoryHotAddEnabled* has been set to true.  ***Since:*** vSphere API 4.0 ", alias="hotPlugMemoryIncrementSize")
    cpu_affinity: Optional[VirtualMachineAffinityInfo] = Field(default=None, alias="cpuAffinity")
    memory_affinity: Optional[VirtualMachineAffinityInfo] = Field(default=None, alias="memoryAffinity")
    network_shaper: Optional[VirtualMachineNetworkShaperInfo] = Field(default=None, alias="networkShaper")
    extra_config: Optional[List[OptionValue]] = Field(default=None, description="Additional configuration information for the virtual machine. ", alias="extraConfig")
    cpu_feature_mask: Optional[List[HostCpuIdInfo]] = Field(default=None, description="Specifies CPU feature compatibility masks that override the defaults from the *GuestOsDescriptor* of the virtual machine's guest OS.  As of vSphere API 6.5 *FeatureMask* is the recommended method for masking virtual machines with hardware version 9 and above (newer). They can be viewed via *featureMask*. ", alias="cpuFeatureMask")
    datastore_url: Optional[List[VirtualMachineConfigInfoDatastoreUrlPair]] = Field(default=None, description="Enumerates the set of datastores that this virtual machine is stored on, as well as the URL identification for each of these.  Changes to datastores do not generate property updates on this property. However, when this property is retrieved it returns the current datastore information. ", alias="datastoreUrl")
    swap_placement: Optional[StrictStr] = Field(default=None, description="Virtual machine swapfile placement policy.  This will be unset if the virtual machine's *swapPlacementSupported* capability is false. If swapPlacementSupported is true, the default policy is \"inherit\".  See also *VirtualMachineConfigInfoSwapPlacementType_enum*.  ***Since:*** VI API 2.5 ", alias="swapPlacement")
    boot_options: Optional[VirtualMachineBootOptions] = Field(default=None, alias="bootOptions")
    ft_info: Optional[FaultToleranceConfigInfo] = Field(default=None, alias="ftInfo")
    rep_config: Optional[ReplicationConfigSpec] = Field(default=None, alias="repConfig")
    v_app_config: Optional[VmConfigInfo] = Field(default=None, alias="vAppConfig")
    v_asserts_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether user-configured virtual asserts will be triggered during virtual machine replay.  ***Since:*** vSphere API 4.0 ", alias="vAssertsEnabled")
    change_tracking_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether changed block tracking for this VM's disks is active.  ***Since:*** vSphere API 4.0 ", alias="changeTrackingEnabled")
    firmware: Optional[StrictStr] = Field(default=None, description="Information about firmware type for this Virtual Machine.  Possible values are described in *GuestOsDescriptorFirmwareType_enum* When creating a new VM: \\- If vim.vm.FlagInfo.vbsEnabled is set to <code>true</code> and this property is set to <code>bios</code>, error is returned. \\- If this property is unset and vim.vm.FlagInfo.vbsEnabled is set to <code>true</code>, this property is set to <code>efi</code>.  ***Since:*** vSphere API 5.0 ")
    max_mks_connections: Optional[StrictInt] = Field(default=None, description="Indicates the maximum number of active remote display connections that the virtual machine will support.  ***Since:*** vSphere API 5.0 ", alias="maxMksConnections")
    guest_auto_lock_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether the guest operating system will logout any active sessions whenever there are no remote display connections open to the virtual machine.  ***Since:*** vSphere API 5.0 ", alias="guestAutoLockEnabled")
    managed_by: Optional[ManagedByInfo] = Field(default=None, alias="managedBy")
    memory_reservation_locked_to_max: Optional[StrictBool] = Field(default=None, description="If set true, memory resource reservation for this virtual machine will always be equal to the virtual machine's memory size; increases in memory size will be rejected when a corresponding reservation increase is not possible.  ***Since:*** vSphere API 5.0 ", alias="memoryReservationLockedToMax")
    initial_overhead: Optional[VirtualMachineConfigInfoOverheadInfo] = Field(default=None, alias="initialOverhead")
    nested_hv_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether this VM is configured to use nested hardware-assisted virtualization.  ***Since:*** vSphere API 5.1 ", alias="nestedHVEnabled")
    v_pmc_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether this VM have vurtual CPU performance counters enabled.  ***Since:*** vSphere API 5.1 ", alias="vPMCEnabled")
    scheduled_hardware_upgrade_info: Optional[ScheduledHardwareUpgradeInfo] = Field(default=None, alias="scheduledHardwareUpgradeInfo")
    fork_config_info: Optional[VirtualMachineForkConfigInfo] = Field(default=None, alias="forkConfigInfo")
    v_flash_cache_reservation: Optional[StrictInt] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Specifies the total vFlash resource reservation for the vFlash caches associated with this VM's virtual disks, in bytes.  This reservation must be allocated to power on the VM. See *VirtualMachineRuntimeInfo.vFlashCacheAllocation* for allocated reservation when VM is powered on.  ***Since:*** vSphere API 5.5 ", alias="vFlashCacheReservation")
    vmx_config_checksum: Optional[Union[StrictBytes, StrictStr]] = Field(default=None, description="A checksum of vmx config file.  ***Since:*** vSphere API 6.0 ", alias="vmxConfigChecksum")
    message_bus_tunnel_enabled: Optional[StrictBool] = Field(default=None, description="Whether to allow tunneling of clients from the guest VM into the common message bus on the host network.  ***Since:*** vSphere API 6.0 ", alias="messageBusTunnelEnabled")
    vm_storage_object_id: Optional[StrictStr] = Field(default=None, description="Virtual Machine Object Identifier.  With Object-based Storage systems, Virtual Machine home directory is backed by an object. This identifier will be set only if VM directory resided on object-based storage systems.  ***Since:*** vSphere API 6.0 ", alias="vmStorageObjectId")
    swap_storage_object_id: Optional[StrictStr] = Field(default=None, description="Virtual Machine Swap Object Identifier.  With Object-based Storage systems, VM's Swap is backed by an object. This identifier will be set only if VM swap resided on object-based storage systems.  ***Since:*** vSphere API 6.0 ", alias="swapStorageObjectId")
    key_id: Optional[CryptoKeyId] = Field(default=None, alias="keyId")
    guest_integrity_info: Optional[VirtualMachineGuestIntegrityInfo] = Field(default=None, alias="guestIntegrityInfo")
    migrate_encryption: Optional[StrictStr] = Field(default=None, description="An enum describing whether encrypted vMotion is required for this VM.  See *VirtualMachineConfigSpecEncryptedVMotionModes_enum* for allowed values. This defaults to opportunistic for a regular VM, and will be set to required for an encrypted VM.  ***Since:*** vSphere API 6.5 ", alias="migrateEncryption")
    sgx_info: Optional[VirtualMachineSgxInfo] = Field(default=None, alias="sgxInfo")
    content_lib_item_info: Optional[VirtualMachineContentLibraryItemInfo] = Field(default=None, alias="contentLibItemInfo")
    ft_encryption_mode: Optional[StrictStr] = Field(default=None, description="An enum describing whether encrypted Fault Tolerance is required for this VM.  See *VirtualMachineConfigSpecEncryptedFtModes_enum* for allowed values. \\- This defaults to opportunistic for a regular VM, and will be set to required for an encrypted VM. \\- If this property is unset, the mode of encrypted Fault Tolerance will be set to opportunistic.  ***Since:*** vSphere API 7.0.2.0 ", alias="ftEncryptionMode")
    guest_monitoring_mode_info: Optional[VirtualMachineGuestMonitoringModeInfo] = Field(default=None, alias="guestMonitoringModeInfo")
    sev_enabled: Optional[StrictBool] = Field(default=None, description="SEV (Secure Encrypted Virtualization) enabled or not.  SEV is enabled when set to true, and disabled otherwise.  ***Since:*** vSphere API 7.0.1.0 ", alias="sevEnabled")
    numa_info: Optional[VirtualMachineVirtualNumaInfo] = Field(default=None, alias="numaInfo")
    pmem_failover_enabled: Optional[StrictBool] = Field(default=None, description="Property to indicate PMem HA failover configuration.  \\- When set to TRUE, VMs configured to use PMem will be failed over to other hosts by HA, but the data in NVDIMM is not persistent. \\- When set to FALSE, VMs configured to use PMem will not be failed over to other hosts by HA. Property is currently only applicable to VMs with NVDimms and will fail to set True if vPMem disks are present.  ***Since:*** vSphere API 7.0.2.0 ", alias="pmemFailoverEnabled")
    vmx_stats_collection_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether VMXStats Collection is enabled/disabled.  \\- If TRUE, VMXStats is enabled for the VM and a scoreboard file is created to store stats for various VMX components. \\- If FALSE, VMXStats is disabled for the VM and there is no scoreboard file created. ", alias="vmxStatsCollectionEnabled")
    vm_op_notification_to_app_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether operation notification to applications is enabled/disabled.  \\- When set to TRUE, application running inside the VM will be notified of operations for which they have registered. \\- If unset or FALSE, new applications are not allowed to register for notifications and RPCs will no longer be supported from already registered applications.  ***Since:*** vSphere API 7.0.3.0 ", alias="vmOpNotificationToAppEnabled")
    vm_op_notification_timeout: Optional[StrictInt] = Field(default=None, description="Operation notification timeout in seconds.  \\- Specifies the maximum time the application can take to prepare for the operation after its been notified. This value is used only if *VirtualMachineConfigInfo.vmOpNotificationToAppEnabled* is set to TRUE. \\- If *VirtualMachineConfigInfo.vmOpNotificationTimeout* is unset, then it defaults to cluster/host timeout. ", alias="vmOpNotificationTimeout")
    device_swap: Optional[VirtualMachineVirtualDeviceSwap] = Field(default=None, alias="deviceSwap")
    pmem: Optional[VirtualMachineVirtualPMem] = None
    device_groups: Optional[VirtualMachineVirtualDeviceGroups] = Field(default=None, alias="deviceGroups")
    fixed_passthru_hot_plug_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether support to add and remove fixed passthrough devices when the VM is running is enabled.  When the virtual machine is powered on, this indicates if support for hot adding and removing fixed passthrough devices was enabled prior to power on. Otherwise, it indicates whether it will be enabled when the VM is powered on. NOTE: When setting this to true, the memory reservation should be equal to the guest memory size or the option to reserve all guest memory should be selected. If unset, the current value is left unchanged. ", alias="fixedPassthruHotPlugEnabled")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


