# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_object_reference import ManagedObjectReference
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineConfigOptionDescriptor(DataObject):
    """
    Contains the definition of a unique key that can be used to retrieve a configOption object. 
    """ # noqa: E501
    key: StrictStr = Field(description="A unique key used to identify a configOption object in this *EnvironmentBrowser*. ")
    description: Optional[StrictStr] = Field(default=None, description="A description of the configOption object. ")
    host: Optional[List[ManagedObjectReference]] = Field(default=None, description="List of hosts to which this descriptor applies.  List of hosts is not set when descriptor is returned from *Datacenter.queryDatacenterConfigOptionDescriptor*.  Refers instances of *HostSystem*. ")
    create_supported: StrictBool = Field(description="Indicates whether the associated set of configuration options can be used for virtual machine creation on a given host or cluster.  ***Since:*** vSphere API 4.0 ", alias="createSupported")
    default_config_option: StrictBool = Field(description="Indicates whether the associated set of virtual machine configuration options is the default one for a given host or cluster.  Latest version is marked as default unless other version is specified via *ComputeResourceConfigInfo.defaultHardwareVersionKey* or *DatacenterConfigInfo.defaultHardwareVersionKey*. If this setting is TRUE, virtual machine creates will use the associated set of configuration options, unless a config version is explicitly specified in the *ConfigSpec*.  ***Since:*** vSphere API 4.0 ", alias="defaultConfigOption")
    run_supported: StrictBool = Field(description="Indicates whether the associated set of configuration options can be used to power on a virtual machine on a given host or cluster.  ***Since:*** vSphere API 5.1 ", alias="runSupported")
    upgrade_supported: StrictBool = Field(description="Indicates whether the associated set of configuration options can be used as a virtual hardware upgrade target.  ***Since:*** vSphere API 5.1 ", alias="upgradeSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineConfigOptionDescriptor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineConfigOptionDescriptor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


