# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional

from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.virtual_machine_file_layout_ex_disk_layout import VirtualMachineFileLayoutExDiskLayout
from vmware_vi.models.virtual_machine_file_layout_ex_file_info import VirtualMachineFileLayoutExFileInfo
from vmware_vi.models.virtual_machine_file_layout_ex_snapshot_layout import VirtualMachineFileLayoutExSnapshotLayout
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineFileLayoutEx(DataObject):
    """
    Detailed description of files that make up a virtual machine on disk.  The file layout is broken into 4 major sections: - Configuration: Files stored in the configuration directory - Log: Files stored in the log directory - Disk: Files stored relative to a disk configuration file - Snapshot: Stored in the snapshot directory    Often the same directory is used for configuration, log, disk and snapshots.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    file: Optional[List[VirtualMachineFileLayoutExFileInfo]] = Field(default=None, description="Information about all the files that constitute the virtual machine including configuration files, disks, swap file, suspend file, log files, core files, memory file etc.  *VirtualMachineFileLayoutExFileType_enum* lists the different file-types that make a virtual machine.  ***Since:*** vSphere API 4.0 ")
    disk: Optional[List[VirtualMachineFileLayoutExDiskLayout]] = Field(default=None, description="Layout of each virtual disk attached to the virtual machine.  For a virtual machine with snaphots, this property gives only those disks that are attached to it at the current point of running.  ***Since:*** vSphere API 4.0 ")
    snapshot: Optional[List[VirtualMachineFileLayoutExSnapshotLayout]] = Field(default=None, description="Layout of each snapshot of the virtual machine.  ***Since:*** vSphere API 4.0 ")
    timestamp: datetime = Field(description="Time when values in this structure were last updated.  ***Since:*** vSphere API 4.0 ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineFileLayoutEx from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineFileLayoutEx from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


