# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineFlagInfo(DataObject):
    """
    The FlagInfo data object type encapsulates the flag settings for a virtual machine.  These properties are optional since the same structure is used to change the values during an edit or create operation. 
    """ # noqa: E501
    disable_acceleration: Optional[StrictBool] = Field(default=None, description="Flag to turn off video acceleration for a virtual machine console window. ", alias="disableAcceleration")
    enable_logging: Optional[StrictBool] = Field(default=None, description="Flag to enable logging for a virtual machine. ", alias="enableLogging")
    use_toe: Optional[StrictBool] = Field(default=None, description="Flag to specify whether or not to use TOE (TCP/IP Offloading). ", alias="useToe")
    run_with_debug_info: Optional[StrictBool] = Field(default=None, description="Deprecated as of VI API 2.5, use *VirtualMachineFlagInfo.monitorType*.  Flag to specify whether or not to run in debug mode. ", alias="runWithDebugInfo")
    monitor_type: Optional[StrictStr] = Field(default=None, description="vmx process type.  See *VirtualMachineFlagInfoMonitorType_enum* for possible values for this property.  ***Since:*** VI API 2.5 ", alias="monitorType")
    ht_sharing: Optional[StrictStr] = Field(default=None, description="Deprecated as of vSphere API 6.7.  Specifies how the VCPUs of a virtual machine are allowed to share physical cores on a hyperthreaded system.  Two VCPUs are \"sharing\" a core if they are both running on logical CPUs of the core at the same time.  See also *VirtualMachineHtSharing_enum*. ", alias="htSharing")
    snapshot_disabled: Optional[StrictBool] = Field(default=None, description="Deprecated as of vSphere API 4.0. The flag is ignored by the server.  Flag to specify whether snapshots are disabled for this virtual machine.  ***Since:*** VI API 2.5 ", alias="snapshotDisabled")
    snapshot_locked: Optional[StrictBool] = Field(default=None, description="Flag to specify whether the snapshot tree is locked for this virtual machine.  ***Since:*** VI API 2.5 ", alias="snapshotLocked")
    disk_uuid_enabled: Optional[StrictBool] = Field(default=None, description="Indicates whether disk UUIDs are being used by this virtual machine.  If this flag is set to false, disk UUIDs are not exposed to the guest.  Since products before ESX 3.1 do not support disk UUIDs, moving virtual machines from a platform that supports UUID to a platform that does not support UUIDs could result in unspecified guest behavior. For virtual machines where the ability to move to older platforms is important, this flag should be set to false. If the value is unset, the behavior 'false' will be used.  ***Since:*** VI API 2.5 ", alias="diskUuidEnabled")
    virtual_mmu_usage: Optional[StrictStr] = Field(default=None, description="Indicates whether or not the system will try to use nested page table hardware support, if available.  By default, VMware software will determine whether or not to use nested page table hardware support based on various factors such as the guest operating system type and the physical hardware. Certain workloads can benefit from explicitly turning nested page table hardware support on or off; this can be set using nptUsage flag. If the value is unset, the value will default to automatic.  *VirtualMachineFlagInfoVirtualMmuUsage_enum* represents the set of possible values.  ***Since:*** VI API 2.5 ", alias="virtualMmuUsage")
    virtual_exec_usage: Optional[StrictStr] = Field(default=None, description="Indicates whether or not the system will try to use Hardware Virtualization (HV) support for instruction virtualization, if available.  By default, VMware software will determine whether or not to use hardware virtualization support based on various factors such as the guest operating system type and the physical hardware. Certain workloads can benefit from explicitly turning hardware virtualization support on or off. If the value is unset, the value will default to hvAuto.  *VirtualMachineFlagInfoVirtualExecUsage_enum* represents the set of possible values.  New processors can enable two hardware acceleration technologies for virtualization, one for instruction virtualization and the other for MMU virtualization. Intel names its hardware-assisted instruction virtualization as VT, and its hardware-assisted MMU virtualization as EPT. AMD calls them as AMD-V and RVI, respectively. For details on these technologies, please refer to documents from the processor vendors.  *VirtualMachineFlagInfo.virtualExecUsage* controls instruction virtualization; while *VirtualMachineFlagInfo.virtualMmuUsage* controls MMU virtualization. \"On\" allows hardware acceleration, while \"off\" only allows software solution.  There are four meaningful combinations.  (hvAuto, automatic) - The host chooses which feature to use. (hvOn, on) - Use both VT/AMD-V and EPT/RVI. (hvOn, off) - Use VT/AMD-V but do not use EPT/RVI. (hvOff, off) - Do not use any of these hardware acceleration technologies.  ***Since:*** vSphere API 4.0 ", alias="virtualExecUsage")
    snapshot_power_off_behavior: Optional[StrictStr] = Field(default=None, description="Specifies the power-off behavior for a virtual machine that has a snapshot.  If the value is unset, the behavior 'powerOff' will be used.  See also *VirtualMachinePowerOffBehavior_enum*.  ***Since:*** VI API 2.5 ", alias="snapshotPowerOffBehavior")
    record_replay_enabled: Optional[StrictBool] = Field(default=None, description="Deprecated as of vSphere API 6.0.  Flag to specify whether record and replay operations are allowed for this virtual machine.  If this flag is set to 'true', instruction virtualization will use hardware virtualization (HV) support. I.e., virtualExecUsage will be set to 'hvOn'. If this flag is set to 'false' for a virtual machine that already has a recording, replay will be disallowed, though the recording will be preserved. If the value is unset, the behavior 'false' will be used.  ***Since:*** vSphere API 4.0 ", alias="recordReplayEnabled")
    fault_tolerance_type: Optional[StrictStr] = Field(default=None, description="Indicates the type of fault tolerance type the virtual machine is configured to use.  *VirtualMachineFaultToleranceType_enum* represents the set of possible values.  ***Since:*** vSphere API 6.0 ", alias="faultToleranceType")
    cbrc_cache_enabled: Optional[StrictBool] = Field(default=None, description="Flag to specify whether common CBRC digest cache is enabled for this virtual machine.  The common CBRC cache is shared between the hot added disks in the VM. If this flag is set to 'true' the VM will allocate a commont digest cache on power on.  ***Since:*** vSphere API 6.5 ", alias="cbrcCacheEnabled")
    vvtd_enabled: Optional[StrictBool] = Field(default=None, description="Flag to specify if Intel Virtualization Technology for Directed I/O is enabled for this virtual machine.  When creating a new VM: \\- If vim.vm.FlagInfo.vbsEnabled is set to <code>true</code>, and this flag is set to <code>false</code> error is returned. \\- If this flag is unset and vim.vm.FlagInfo.vbsEnabled is set to <code>true</code>, the value of this flag is set to <code>true</code>.  ***Since:*** vSphere API 6.7 ", alias="vvtdEnabled")
    vbs_enabled: Optional[StrictBool] = Field(default=None, description="Flag to specify if Virtualization-based security is enabled for this virtual machine.  If set to <code>true</code> when creating a new VM, the following VM properties might be modified automatically: \\- If vim.vm.FlagInfo.vvtdEnabled is not set to <code>false</code>, it is set to <code>true</code>. Else error is returned. \\- If vim.vm.ConfigSpec.nestedHVEnabled is not set to <code>false</code>, it is set to <code>true</code>. Else error is returned. \\- If vim.vm.BootOptions.efiSecureBootEnabled is not set to <code>false</code>, it is set to <code>true</code>. Else error is returned. \\- If vim.vm.firmware is not set to <code>bios</code>, it is set to <code>efi</code>. Else error is returned.  ***Since:*** vSphere API 6.7 ", alias="vbsEnabled")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineFlagInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineFlagInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


