# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineForkConfigInfo(DataObject):
    """
    This data object describes the fork configuration of this virtual machine.  ***Since:*** vSphere API 6.0 
    """ # noqa: E501
    parent_enabled: Optional[StrictBool] = Field(default=None, description="Flag to indicate whether this virtual machine is a parent enabled virtual machine.  If this vm is not a parent enabled vm this property will be unset. When set into the vim.vm.ConfigSpec this flag will be ignored.  ***Since:*** vSphere API 6.0 ", alias="parentEnabled")
    child_fork_group_id: Optional[StrictStr] = Field(default=None, description="The fork group ID identifies the parent group of which this child VirtualMachine is a child.  Applicable for child VirtualMachines only.  ***Since:*** vSphere API 6.0 ", alias="childForkGroupId")
    parent_fork_group_id: Optional[StrictStr] = Field(default=None, description="The fork group ID identifies the parent group which this VirtualMachine belongs to.  Applicable for parent VirtualMachines only.  ***Since:*** vSphere API 6.5 ", alias="parentForkGroupId")
    child_type: Optional[StrictStr] = Field(default=None, description="The flag to indicate the fork child type.  For a persistent child virtual machine, once it is powered on, it will become a linked clone of its parent and this flag will be set to 'none'.  See also *VirtualMachineForkConfigInfoChildType_enum*.  ***Since:*** vSphere API 6.0 ", alias="childType")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineForkConfigInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineForkConfigInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


