# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import SecretStr, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineMksTicket(DataObject):
    """
    Deprecated as of vSphere API 4.1, use *VirtualMachineTicket* instead.  This data object contains the information needed to establish an MKS (mouse-keyboard-screen) connection to a running virtual machine. 
    """ # noqa: E501
    ticket: SecretStr = Field(description="The ticket name.  This is used as the username and password for the MKS connection. ")
    cfg_file: StrictStr = Field(description="The name of the configuration file for the virtual machine. ", alias="cfgFile")
    host: Optional[StrictStr] = Field(default=None, description="The host with which to establish a connection.  If the host is not specified, it is assumed that the requesting entity knows the appropriate host with which to connect. ")
    port: Optional[StrictInt] = Field(default=None, description="The port number to use.  If the port is not specified, it is assumed that the requesting entity knows the appropriate port to use when making a new connection. ")
    ssl_thumbprint: Optional[StrictStr] = Field(default=None, description="The expected thumbprint of the SSL cert of the host to which we are connecting.  ***Since:*** VI API 2.5 ", alias="sslThumbprint")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineMksTicket from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineMksTicket from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


