# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictInt
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.managed_entity_status_enum import ManagedEntityStatusEnum
from vmware_vi.models.virtual_machine_quick_stats_memory_tier_stats import VirtualMachineQuickStatsMemoryTierStats
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineQuickStats(DataObject):
    """
    A set of statistics that are typically updated with near real-time regularity.  This data object type does not support notification, for scalability reasons. Therefore, changes in QuickStats do not generate property collector updates. To monitor statistics values, use the statistics and alarms modules instead. 
    """ # noqa: E501
    overall_cpu_usage: Optional[StrictInt] = Field(default=None, description="Basic CPU performance statistics, in MHz.  Valid while the virtual machine is running. ", alias="overallCpuUsage")
    overall_cpu_demand: Optional[StrictInt] = Field(default=None, description="Basic CPU performance statistics, in MHz.  Valid while the virtual machine is running.  ***Since:*** vSphere API 4.0 ", alias="overallCpuDemand")
    overall_cpu_readiness: Optional[StrictInt] = Field(default=None, description="Percentage of time that the virtual machine was ready, but could not get scheduled to run on the physical CPU.  Valid while the virtual machine is running.  ***Since:*** vSphere API 7.0 ", alias="overallCpuReadiness")
    guest_memory_usage: Optional[StrictInt] = Field(default=None, description="Guest memory utilization statistics, in MB.  This is also known as active guest memory. The number can be between 0 and the configured memory size of the virtual machine. Valid while the virtual machine is running. ", alias="guestMemoryUsage")
    host_memory_usage: Optional[StrictInt] = Field(default=None, description="Host memory utilization statistics, in MB.  This is also known as consumed host memory. This is between 0 and the configured resource limit. Valid while the virtual machine is running. This includes the overhead memory of the VM. ", alias="hostMemoryUsage")
    guest_heartbeat_status: ManagedEntityStatusEnum = Field(alias="guestHeartbeatStatus")
    distributed_cpu_entitlement: Optional[StrictInt] = Field(default=None, description="This is the amount of CPU resource, in MHz, that this VM is entitled to, as calculated by DRS.  Valid only for a VM managed by DRS. ", alias="distributedCpuEntitlement")
    distributed_memory_entitlement: Optional[StrictInt] = Field(default=None, description="This is the amount of memory, in MB, that this VM is entitled to, as calculated by DRS.  Valid only for a VM managed by DRS. ", alias="distributedMemoryEntitlement")
    static_cpu_entitlement: Optional[StrictInt] = Field(default=None, description="The static CPU resource entitlement for a virtual machine.  This value is calculated based on this virtual machine's resource reservations, shares and limit, and doesn't take into account current usage. This is the worst case CPU allocation for this virtual machine, that is, the amount of CPU resource this virtual machine would receive if all virtual machines running in the cluster went to maximum consumption. Units are MHz.  ***Since:*** vSphere API 4.0 ", alias="staticCpuEntitlement")
    static_memory_entitlement: Optional[StrictInt] = Field(default=None, description="The static memory resource entitlement for a virtual machine.  This value is calculated based on this virtual machine's resource reservations, shares and limit, and doesn't take into account current usage. This is the worst case memory allocation for this virtual machine, that is, the amount of memory this virtual machine would receive if all virtual machines running in the cluster went to maximum consumption. Units are MB.  ***Since:*** vSphere API 4.0 ", alias="staticMemoryEntitlement")
    granted_memory: Optional[StrictInt] = Field(default=None, description="Amount of host physical memory that is mapped for a virtual machine, in MB.  The number can be between 0 and the configured memory size of the virtual machine. Valid while the virtual machine is running.  ***Since:*** vSphere API 7.0 ", alias="grantedMemory")
    private_memory: Optional[StrictInt] = Field(default=None, description="The portion of memory, in MB, that is granted to this VM from non-shared host memory.  ***Since:*** vSphere API 4.0 ", alias="privateMemory")
    shared_memory: Optional[StrictInt] = Field(default=None, description="The portion of memory, in MB, that is granted to this VM from host memory that is shared between VMs.  ***Since:*** vSphere API 4.0 ", alias="sharedMemory")
    swapped_memory: Optional[StrictInt] = Field(default=None, description="The portion of memory, in MB, that is granted to this VM from the host's swap space.  This is a sign that there is memory pressure on the host.  ***Since:*** vSphere API 4.0 ", alias="swappedMemory")
    ballooned_memory: Optional[StrictInt] = Field(default=None, description="The size of the balloon driver in the VM, in MB.  The host will inflate the balloon driver to reclaim physical memory from the VM. This is a sign that there is memory pressure on the host.  ***Since:*** vSphere API 4.0 ", alias="balloonedMemory")
    consumed_overhead_memory: Optional[StrictInt] = Field(default=None, description="The amount of consumed overhead memory, in MB, for this VM.  ***Since:*** vSphere API 4.0 ", alias="consumedOverheadMemory")
    ft_log_bandwidth: Optional[StrictInt] = Field(default=None, description="The network bandwidth used for logging between the primary and secondary fault tolerance VMs.  The unit is kilobytes per second.  ***Since:*** vSphere API 4.0 ", alias="ftLogBandwidth")
    ft_secondary_latency: Optional[StrictInt] = Field(default=None, description="The amount of time in wallclock that the VCPU of the secondary fault tolerance VM is behind the VCPU of the primary VM.  The unit is millisecond.  ***Since:*** vSphere API 4.0 ", alias="ftSecondaryLatency")
    ft_latency_status: Optional[ManagedEntityStatusEnum] = Field(default=None, alias="ftLatencyStatus")
    compressed_memory: Optional[StrictInt] = Field(default=None, description="The amount of compressed memory currently consumed by VM, in Kb.  ***Since:*** vSphere API 4.1 ", alias="compressedMemory")
    uptime_seconds: Optional[StrictInt] = Field(default=None, description="The system uptime of the VM in seconds.  ***Since:*** vSphere API 4.1 ", alias="uptimeSeconds")
    ssd_swapped_memory: Optional[StrictInt] = Field(default=None, description="The amount of memory swapped to fast disk device such as SSD, in KB.  ***Since:*** vSphere API 5.0 ", alias="ssdSwappedMemory")
    active_memory: Optional[StrictInt] = Field(default=None, description="The amount of memory that was recently touched by the VM, in MB.  ***Since:*** vSphere API 7.0.3.0 ", alias="activeMemory")
    memory_tier_stats: Optional[List[VirtualMachineQuickStatsMemoryTierStats]] = Field(default=None, description="Stats for each physical memory tier.  A physical memory tier consists of one or more logical memory tiers of the same *HostMemoryTierType_enum*. For example, the logical tiers can be tier0 (DRAM), tier1 (DRAM), and tier2 (PMEM), while the physical tiers are just DRAM and PMEM.  ***Since:*** vSphere API 7.0.3.0 ", alias="memoryTierStats")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineQuickStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineQuickStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


