# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
import re  # noqa: F401
from enum import Enum



try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class VirtualMachineRelocateDiskMoveOptionsEnum(str, Enum):
    """
    Specifies how a virtual disk is moved or copied to a datastore.  In all cases after the move or copy the virtual machine's current running point will be placed on the target datastore. The current running point is defined as the disk backing which the virtual machine is currently writing to. This end state can be achieved in multiple ways, and the supported options are described in this enumeration.  These options are only relevant when the backing of the specified disk is a *file backing*.  Since disk backings may become shared as the result of either a *clone operation* or a *relocate operation*, *VirtualMachine.PromoteDisks_Task* has been provided as a way to unshare such disk backings.  See also *VirtualDiskSparseVer1BackingInfo.parent*, *VirtualDiskSparseVer2BackingInfo.parent*, *VirtualDiskFlatVer1BackingInfo.parent*, *VirtualDiskFlatVer2BackingInfo.parent*, *VirtualDiskRawDiskMappingVer1BackingInfo.parent*, *VirtualMachineRelocateSpec.diskMoveType*, *VirtualMachineRelocateSpecDiskLocator.diskMoveType*.  Possible values: - `moveAllDiskBackingsAndAllowSharing`: All of the virtual disk's backings should be moved to the new datastore.      If a disk backing is not the child-most backing of this virtual machine,   and there exists a read-only disk backing with the same content ID   on the target datastore, then this disk backing may not be copied. Instead   it is acceptable to attach to the read-only disk backing at the target   datastore. A read-only disk backing is defined as a virtual disk   backing which no virtual machine is currently writing to.      See also *VirtualDiskSparseVer1BackingInfo.contentId*, *VirtualDiskSparseVer2BackingInfo.contentId*, *VirtualDiskFlatVer1BackingInfo.contentId*, *VirtualDiskFlatVer2BackingInfo.contentId*, *VirtualDiskRawDiskMappingVer1BackingInfo.contentId*. - `moveAllDiskBackingsAndDisallowSharing`: All of the virtual disk's backings should be moved to the new datastore.      It is not acceptable to attach to a disk backing with the same content ID   on the destination datastore. During a *clone operation* any delta disk backings will be consolidated. - `moveChildMostDiskBacking`: Move only the child-most disk backing.      Any parent disk backings should   be left in their current locations.      This option only differs from *moveAllDiskBackingsAndAllowSharing* and   *moveAllDiskBackingsAndDisallowSharing* when the virtual   disk has a parent backing.      Note that in the case of a *clone operation*,   this means that the parent disks will now be shared. This is safe as any   parent disks are always read-only.   Note that in the case of a *VirtualMachine.RelocateVM_Task* operation,   only the virtual disks in the current virtual machine configuration are moved. - `createNewChildDiskBacking`: Create a new child disk backing on the destination datastore.      None of the   virtual disk's existing files should be moved from their current locations.      Note that in the case of a *clone operation*,   this means that the original virtual machine's disks are now all being shared.   This is only safe if the clone was taken from a snapshot point, because   snapshot points are always read-only. Thus for a clone this   option is only valid *when cloning from a snapshot*.   createNewChildDiskBacking is not a supported operation for   *VirtualMachine.RelocateVM_Task* operations unless all disks are moving. - `moveAllDiskBackingsAndConsolidate`: All of the virtual disk's backings should be moved to the new datastore.      During a *clone operation* or a   *VirtualMachine.MigrateVM_Task*, any delta disk backings will be   consolidated.      ***Since:*** vSphere API 5.1  ***Since:*** vSphere API 4.0 
    """

    """
    allowed enum values
    """
    MOVEALLDISKBACKINGSANDALLOWSHARING = 'moveAllDiskBackingsAndAllowSharing'
    MOVEALLDISKBACKINGSANDDISALLOWSHARING = 'moveAllDiskBackingsAndDisallowSharing'
    MOVECHILDMOSTDISKBACKING = 'moveChildMostDiskBacking'
    CREATENEWCHILDDISKBACKING = 'createNewChildDiskBacking'
    MOVEALLDISKBACKINGSANDCONSOLIDATE = 'moveAllDiskBackingsAndConsolidate'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineRelocateDiskMoveOptionsEnum from a JSON string"""
        return cls(json.loads(json_str))


