# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.data_object import DataObject
from vmware_vi.models.host_feature_mask import HostFeatureMask
from vmware_vi.models.managed_object_reference import ManagedObjectReference
from vmware_vi.models.virtual_machine_connection_state_enum import VirtualMachineConnectionStateEnum
from vmware_vi.models.virtual_machine_device_runtime_info import VirtualMachineDeviceRuntimeInfo
from vmware_vi.models.virtual_machine_fault_tolerance_state_enum import VirtualMachineFaultToleranceStateEnum
from vmware_vi.models.virtual_machine_feature_requirement import VirtualMachineFeatureRequirement
from vmware_vi.models.virtual_machine_power_state_enum import VirtualMachinePowerStateEnum
from vmware_vi.models.virtual_machine_question_info import VirtualMachineQuestionInfo
from vmware_vi.models.virtual_machine_record_replay_state_enum import VirtualMachineRecordReplayStateEnum
from vmware_vi.models.virtual_machine_runtime_info_das_protection_state import VirtualMachineRuntimeInfoDasProtectionState
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineRuntimeInfo(DataObject):
    """
    The RuntimeInfo data object type provides information about the execution state and history of a virtual machine. 
    """ # noqa: E501
    device: Optional[List[VirtualMachineDeviceRuntimeInfo]] = Field(default=None, description="Per-device runtime info.  This array will be empty if the host software does not provide runtime info for any of the device types currently in use by the virtual machine. In releases after vSphere API 5.0, vSphere Servers might not generate property collector update notifications for this property. To obtain the latest value of the property, you can use PropertyCollector methods RetrievePropertiesEx or WaitForUpdatesEx. If you use the PropertyCollector.WaitForUpdatesEx method, specify an empty string for the version parameter. Since this property is on a DataObject, an update returned by WaitForUpdatesEx may contain values for this property when some other property on the DataObject changes. If this update is a result of a call to WaitForUpdatesEx with a non-empty version parameter, the value for this property may not be current.  ***Since:*** vSphere API 4.1 ")
    host: Optional[ManagedObjectReference] = None
    connection_state: VirtualMachineConnectionStateEnum = Field(alias="connectionState")
    power_state: VirtualMachinePowerStateEnum = Field(alias="powerState")
    vm_failover_in_progress: Optional[StrictBool] = Field(default=None, description="Represents if the vm is currently being failed over by FDM  ***Since:*** vSphere API 7.0.2.0 ", alias="vmFailoverInProgress")
    fault_tolerance_state: VirtualMachineFaultToleranceStateEnum = Field(alias="faultToleranceState")
    das_vm_protection: Optional[VirtualMachineRuntimeInfoDasProtectionState] = Field(default=None, alias="dasVmProtection")
    tools_installer_mounted: StrictBool = Field(description="Flag to indicate whether or not the VMware Tools installer is mounted as a CD-ROM. ", alias="toolsInstallerMounted")
    suspend_time: Optional[datetime] = Field(default=None, description="The timestamp when the virtual machine was most recently suspended.  This property is updated every time the virtual machine is suspended. ", alias="suspendTime")
    boot_time: Optional[datetime] = Field(default=None, description="The timestamp when the virtual machine was most recently powered on.  This property is updated when the virtual machine is powered on from the poweredOff state, and is cleared when the virtual machine is powered off. This property is not updated when a virtual machine is resumed from a suspended state. ", alias="bootTime")
    suspend_interval: Optional[StrictInt] = Field(default=None, description="The total time the virtual machine has been suspended since it was initially powered on.  This time excludes the current period, if the virtual machine is currently suspended. This property is updated when the virtual machine resumes, and is reset to zero when the virtual machine is powered off. ", alias="suspendInterval")
    question: Optional[VirtualMachineQuestionInfo] = None
    memory_overhead: Optional[StrictInt] = Field(default=None, description="Deprecated as of vSphere API 4.1, use the *PerformanceManager* memory overhead counter to get this value.  The amount of memory resource (in bytes) that will be used by the virtual machine above its guest memory requirements.  This value is set if and only if the virtual machine is registered on a host that supports memory resource allocation features.  For powered off VMs, this is the minimum overhead required to power on the VM on the registered host.  For powered on VMs, this is the current overhead reservation, a value which is almost always larger than the minimum overhead, and which grows with time.  See also *HostSystem.QueryMemoryOverheadEx*. ", alias="memoryOverhead")
    max_cpu_usage: Optional[StrictInt] = Field(default=None, description="Current upper-bound on CPU usage.  The upper-bound is based on the host the virtual machine is current running on, as well as limits configured on the virtual machine itself or any parent resource pool. Valid while the virtual machine is running. In releases after vSphere API 5.0, vSphere Servers might not generate property collector update notifications for this property. To obtain the latest value of the property, you can use PropertyCollector methods RetrievePropertiesEx or WaitForUpdatesEx. If you use the PropertyCollector.WaitForUpdatesEx method, specify an empty string for the version parameter. Since this property is on a DataObject, an update returned by WaitForUpdatesEx may contain values for this property when some other property on the DataObject changes. If this update is a result of a call to WaitForUpdatesEx with a non-empty version parameter, the value for this property may not be current. ", alias="maxCpuUsage")
    max_memory_usage: Optional[StrictInt] = Field(default=None, description="Current upper-bound on memory usage.  The upper-bound is based on memory configuration of the virtual machine, as well as limits configured on the virtual machine itself or any parent resource pool. Valid while the virtual machine is running. In releases after vSphere API 5.0, vSphere Servers might not generate property collector update notifications for this property. To obtain the latest value of the property, you can use PropertyCollector methods RetrievePropertiesEx or WaitForUpdatesEx. If you use the PropertyCollector.WaitForUpdatesEx method, specify an empty string for the version parameter. Since this property is on a DataObject, an update returned by WaitForUpdatesEx may contain values for this property when some other property on the DataObject changes. If this update is a result of a call to WaitForUpdatesEx with a non-empty version parameter, the value for this property may not be current. ", alias="maxMemoryUsage")
    num_mks_connections: StrictInt = Field(description="Number of active MKS connections to this virtual machine. ", alias="numMksConnections")
    record_replay_state: VirtualMachineRecordReplayStateEnum = Field(alias="recordReplayState")
    clean_power_off: Optional[StrictBool] = Field(default=None, description="For a powered off virtual machine, indicates whether the virtual machine's last shutdown was an orderly power off or not.  Unset if the virtual machine is running or suspended.  ***Since:*** vSphere API 4.0 ", alias="cleanPowerOff")
    need_secondary_reason: Optional[StrictStr] = Field(default=None, description="If set, indicates the reason the virtual machine needs a secondary.  ***Since:*** vSphere API 4.0 ", alias="needSecondaryReason")
    online_standby: StrictBool = Field(description="This property indicates whether the guest has gone into one of the s1, s2 or s3 standby modes, false indicates the guest is awake.  ***Since:*** vSphere API 5.1 ", alias="onlineStandby")
    min_required_evc_mode_key: Optional[StrictStr] = Field(default=None, description="For a powered-on or suspended virtual machine in a cluster with Enhanced VMotion Compatibility (EVC) enabled, this identifies the least-featured EVC mode (among those for the appropriate CPU vendor) that could admit the virtual machine.  See *EVCMode*. Until vSphere 6.5, this property will be unset if the virtual machine is powered off or is not in an EVC cluster.  This property may be used as a general indicator of the CPU feature baseline currently in use by the virtual machine. However, the virtual machine may be suppressing some of the features present in the CPU feature baseline of the indicated mode, either explicitly (in the virtual machine's configured *cpuFeatureMask*) or implicitly (in the default masks for the *GuestOsDescriptor* appropriate for the virtual machine's configured guest OS).  ***Since:*** vSphere API 4.1 ", alias="minRequiredEVCModeKey")
    consolidation_needed: StrictBool = Field(description="Whether any disk of the virtual machine requires consolidation.  This can happen for example when a snapshot is deleted but its associated disk is not committed back to the base disk. Use *VirtualMachine.ConsolidateVMDisks_Task* to consolidate if needed.  ***Since:*** vSphere API 5.0 ", alias="consolidationNeeded")
    offline_feature_requirement: Optional[List[VirtualMachineFeatureRequirement]] = Field(default=None, description="These requirements must have equivalent host capabilities *HostConfigInfo.featureCapability* in order to power on.  ***Since:*** vSphere API 5.1 ", alias="offlineFeatureRequirement")
    feature_requirement: Optional[List[VirtualMachineFeatureRequirement]] = Field(default=None, description="These requirements must have equivalent host capabilities *HostConfigInfo.featureCapability* in order to power on, resume, or migrate to the host.  ***Since:*** vSphere API 5.1 ", alias="featureRequirement")
    feature_mask: Optional[List[HostFeatureMask]] = Field(default=None, description="The masks applied to an individual virtual machine as a result of its configuration.  ***Since:*** vSphere API 5.1 ", alias="featureMask")
    v_flash_cache_allocation: Optional[StrictInt] = Field(default=None, description="Deprecated since vSphere 7.0 because vFlash Read Cache end of availability.  Specifies the total allocated vFlash resource for the vFlash caches associated with VM's VMDKs when VM is powered on, in bytes.  ***Since:*** vSphere API 5.5 ", alias="vFlashCacheAllocation")
    paused: Optional[StrictBool] = Field(default=None, description="Whether the virtual machine is paused, or not.  ***Since:*** vSphere API 6.0 ")
    snapshot_in_background: Optional[StrictBool] = Field(default=None, description="Whether a snapshot operation is in progress in the background, or not.  ***Since:*** vSphere API 6.0 ", alias="snapshotInBackground")
    quiesced_fork_parent: Optional[StrictBool] = Field(default=None, description="This flag indicates whether a parent virtual machine is in a fork ready state.  A persistent instant clone child can be created only when this flag is true. While a non-persistent instant clone child can be created independent of this flag, it can only be powered on if this flag is true.  ***Since:*** vSphere API 6.0 ", alias="quiescedForkParent")
    instant_clone_frozen: Optional[StrictBool] = Field(default=None, description="Whether the virtual machine is frozen for instant clone, or not.  ***Since:*** vSphere API 6.7 ", alias="instantCloneFrozen")
    crypto_state: Optional[StrictStr] = Field(default=None, description="Encryption state of the virtual machine.  Valid values are enumerated by the *CryptoState* type.  ***Since:*** vSphere API 6.7 ", alias="cryptoState")
    suspended_to_memory: Optional[StrictBool] = Field(default=None, description="Whether the virtual machine is suspended to memory, or not.  ***Since:*** vSphere API 7.0.2.0 ", alias="suspendedToMemory")
    op_notification_timeout: Optional[StrictInt] = Field(default=None, description="Operation notification timeout in seconds.  Specifies the maximum time duration the application may take to prepare for the operation after it has been notified. This property is set only for powered on VMs. ", alias="opNotificationTimeout")
    iommu_active: Optional[StrictBool] = Field(default=None, description="Indicates whether there is active IOMMU domain in the current VM. ", alias="iommuActive")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineRuntimeInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineRuntimeInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


