# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictBool, StrictInt, StrictStr
from pydantic import Field
from vmware_vi.models.virtual_machine_target_info import VirtualMachineTargetInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualMachineSgxTargetInfo(VirtualMachineTargetInfo):
    """
    Description of Intel Software Guard Extensions information.  ***Since:*** vSphere API 7.0 
    """ # noqa: E501
    max_epc_size: StrictInt = Field(description="Maximum size, in bytes, of EPC available on the compute resource.  ***Since:*** vSphere API 7.0 ", alias="maxEpcSize")
    flc_modes: Optional[List[StrictStr]] = Field(default=None, description="FLC modes available in the compute resource.  The set of possible values are described in *VirtualMachineSgxInfoFlcModes_enum*.  ***Since:*** vSphere API 7.0 ", alias="flcModes")
    le_pub_key_hashes: Optional[List[StrictStr]] = Field(default=None, description="Public key hashes of the provider launch enclaves available in the compute resource.  ***Since:*** vSphere API 7.0 ", alias="lePubKeyHashes")
    require_attestation_supported: Optional[StrictBool] = Field(default=None, description="Whether the host/cluster supports requiring SGX remote attestation. ", alias="requireAttestationSupported")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualMachineSgxTargetInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualMachineSgxTargetInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


