# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import StrictStr
from pydantic import Field
from typing_extensions import Annotated
from vmware_vi.models.virtual_device_device_backing_info import VirtualDeviceDeviceBackingInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VirtualPCIPassthroughDeviceBackingInfo(VirtualDeviceDeviceBackingInfo):
    """
    The VirtualPCIPassthrough.DeviceBackingInfo data object type contains information about the backing that maps the virtual device onto a physical device.  ***Since:*** vSphere API 4.0 
    """ # noqa: E501
    id: StrictStr = Field(description="The name ID of this PCI, composed of \"bus:slot.function\".  ***Since:*** vSphere API 4.0 ")
    device_id: StrictStr = Field(description="The device ID of this PCI.  You must use the device ID retrieved from the vSphere host (*HostPciDevice*.deviceId), converted as is to a string.  ***Since:*** vSphere API 4.0 ", alias="deviceId")
    system_id: StrictStr = Field(description="The ID of the system the PCI device is attached to.  ***Since:*** vSphere API 4.0 ", alias="systemId")
    vendor_id: Annotated[int, Field(le=32767, strict=True, ge=-32768)] = Field(description="The vendor ID for this PCI device.  You must use the vendor ID retrieved from the vSphere host (*HostPciDevice*.vendorId).  ***Since:*** vSphere API 4.0 ", alias="vendorId")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VirtualPCIPassthroughDeviceBackingInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VirtualPCIPassthroughDeviceBackingInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_typeName": obj.get("_typeName")
        })
        return _obj


