# coding: utf-8

"""
    Virtual Infrastructure JSON API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 8.0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Union
from pydantic import StrictBool
from pydantic import Field
from vmware_vi.models.event import Event
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VmEvent(Event):
    """
    These are virtual machine events. 
    """ # noqa: E501
    template: StrictBool = Field(description="Indicates whether or not the virtual machine is marked as a template. ")
    __properties: ClassVar[List[str]] = ["_typeName"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[List[str]] = '_typeName'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ArrayOfAnyURI': 'ArrayOfURI','ArrayOfBase64Binary': 'ArrayOfBinary','ArrayOfPropertyPath': 'ArrayOfPropPath','MethodName': 'PrimitiveMethodName','PropertyPath': 'PrimitivePropPath','TypeName': 'PrimitiveTypeName','anyURI': 'PrimitiveURI','base64Binary': 'PrimitiveBinary','boolean': 'PrimitiveBoolean','byte': 'PrimitiveByte','dateTime': 'PrimitiveDateTime','double': 'PrimitiveDouble','float': 'PrimitiveFloat','int': 'PrimitiveInt','long': 'PrimitiveLong','short': 'PrimitiveShort','string': 'PrimitiveString','CustomizationEvent': 'CustomizationEvent','CustomizationFailed': 'CustomizationFailed','CustomizationLinuxIdentityFailed': 'CustomizationLinuxIdentityFailed','CustomizationNetworkSetupFailed': 'CustomizationNetworkSetupFailed','CustomizationStartedEvent': 'CustomizationStartedEvent','CustomizationSucceeded': 'CustomizationSucceeded','CustomizationSysprepFailed': 'CustomizationSysprepFailed','CustomizationUnknownFailure': 'CustomizationUnknownFailure','DrsRuleComplianceEvent': 'DrsRuleComplianceEvent','DrsRuleViolationEvent': 'DrsRuleViolationEvent','DrsSoftRuleViolationEvent': 'DrsSoftRuleViolationEvent','DrsVmMigratedEvent': 'DrsVmMigratedEvent','DrsVmPoweredOnEvent': 'DrsVmPoweredOnEvent','MigrationErrorEvent': 'MigrationErrorEvent','MigrationEvent': 'MigrationEvent','MigrationHostErrorEvent': 'MigrationHostErrorEvent','MigrationHostWarningEvent': 'MigrationHostWarningEvent','MigrationResourceErrorEvent': 'MigrationResourceErrorEvent','MigrationResourceWarningEvent': 'MigrationResourceWarningEvent','MigrationWarningEvent': 'MigrationWarningEvent','NoMaintenanceModeDrsRecommendationForVM': 'NoMaintenanceModeDrsRecommendationForVM','NotEnoughResourcesToStartVmEvent': 'NotEnoughResourcesToStartVmEvent','VmAcquiredMksTicketEvent': 'VmAcquiredMksTicketEvent','VmAcquiredTicketEvent': 'VmAcquiredTicketEvent','VmAutoRenameEvent': 'VmAutoRenameEvent','VmBeingClonedEvent': 'VmBeingClonedEvent','VmBeingClonedNoFolderEvent': 'VmBeingClonedNoFolderEvent','VmBeingCreatedEvent': 'VmBeingCreatedEvent','VmBeingDeployedEvent': 'VmBeingDeployedEvent','VmBeingHotMigratedEvent': 'VmBeingHotMigratedEvent','VmBeingMigratedEvent': 'VmBeingMigratedEvent','VmBeingRelocatedEvent': 'VmBeingRelocatedEvent','VmCloneEvent': 'VmCloneEvent','VmCloneFailedEvent': 'VmCloneFailedEvent','VmClonedEvent': 'VmClonedEvent','VmConfigMissingEvent': 'VmConfigMissingEvent','VmConnectedEvent': 'VmConnectedEvent','VmCreatedEvent': 'VmCreatedEvent','VmDasBeingResetEvent': 'VmDasBeingResetEvent','VmDasBeingResetWithScreenshotEvent': 'VmDasBeingResetWithScreenshotEvent','VmDasResetFailedEvent': 'VmDasResetFailedEvent','VmDasUpdateErrorEvent': 'VmDasUpdateErrorEvent','VmDasUpdateOkEvent': 'VmDasUpdateOkEvent','VmDateRolledBackEvent': 'VmDateRolledBackEvent','VmDeployFailedEvent': 'VmDeployFailedEvent','VmDeployedEvent': 'VmDeployedEvent','VmDisconnectedEvent': 'VmDisconnectedEvent','VmDiscoveredEvent': 'VmDiscoveredEvent','VmDiskFailedEvent': 'VmDiskFailedEvent','VmEmigratingEvent': 'VmEmigratingEvent','VmEndRecordingEvent': 'VmEndRecordingEvent','VmEndReplayingEvent': 'VmEndReplayingEvent','VmFailedMigrateEvent': 'VmFailedMigrateEvent','VmFailedRelayoutEvent': 'VmFailedRelayoutEvent','VmFailedRelayoutOnVmfs2DatastoreEvent': 'VmFailedRelayoutOnVmfs2DatastoreEvent','VmFailedStartingSecondaryEvent': 'VmFailedStartingSecondaryEvent','VmFailedToPowerOffEvent': 'VmFailedToPowerOffEvent','VmFailedToPowerOnEvent': 'VmFailedToPowerOnEvent','VmFailedToRebootGuestEvent': 'VmFailedToRebootGuestEvent','VmFailedToResetEvent': 'VmFailedToResetEvent','VmFailedToShutdownGuestEvent': 'VmFailedToShutdownGuestEvent','VmFailedToStandbyGuestEvent': 'VmFailedToStandbyGuestEvent','VmFailedToSuspendEvent': 'VmFailedToSuspendEvent','VmFailedUpdatingSecondaryConfig': 'VmFailedUpdatingSecondaryConfig','VmFailoverFailed': 'VmFailoverFailed','VmFaultToleranceStateChangedEvent': 'VmFaultToleranceStateChangedEvent','VmFaultToleranceTurnedOffEvent': 'VmFaultToleranceTurnedOffEvent','VmFaultToleranceVmTerminatedEvent': 'VmFaultToleranceVmTerminatedEvent','VmGuestOSCrashedEvent': 'VmGuestOSCrashedEvent','VmGuestRebootEvent': 'VmGuestRebootEvent','VmGuestShutdownEvent': 'VmGuestShutdownEvent','VmGuestStandbyEvent': 'VmGuestStandbyEvent','VmInstanceUuidAssignedEvent': 'VmInstanceUuidAssignedEvent','VmInstanceUuidChangedEvent': 'VmInstanceUuidChangedEvent','VmInstanceUuidConflictEvent': 'VmInstanceUuidConflictEvent','VmMacAssignedEvent': 'VmMacAssignedEvent','VmMacChangedEvent': 'VmMacChangedEvent','VmMacConflictEvent': 'VmMacConflictEvent','VmMaxFTRestartCountReached': 'VmMaxFTRestartCountReached','VmMaxRestartCountReached': 'VmMaxRestartCountReached','VmMessageErrorEvent': 'VmMessageErrorEvent','VmMessageEvent': 'VmMessageEvent','VmMessageWarningEvent': 'VmMessageWarningEvent','VmMigratedEvent': 'VmMigratedEvent','VmNoCompatibleHostForSecondaryEvent': 'VmNoCompatibleHostForSecondaryEvent','VmNoNetworkAccessEvent': 'VmNoNetworkAccessEvent','VmOrphanedEvent': 'VmOrphanedEvent','VmPowerOffOnIsolationEvent': 'VmPowerOffOnIsolationEvent','VmPoweredOffEvent': 'VmPoweredOffEvent','VmPoweredOnEvent': 'VmPoweredOnEvent','VmPoweringOnWithCustomizedDVPortEvent': 'VmPoweringOnWithCustomizedDVPortEvent','VmPrimaryFailoverEvent': 'VmPrimaryFailoverEvent','VmReconfiguredEvent': 'VmReconfiguredEvent','VmRegisteredEvent': 'VmRegisteredEvent','VmRelayoutSuccessfulEvent': 'VmRelayoutSuccessfulEvent','VmRelayoutUpToDateEvent': 'VmRelayoutUpToDateEvent','VmReloadFromPathEvent': 'VmReloadFromPathEvent','VmReloadFromPathFailedEvent': 'VmReloadFromPathFailedEvent','VmRelocateFailedEvent': 'VmRelocateFailedEvent','VmRelocateSpecEvent': 'VmRelocateSpecEvent','VmRelocatedEvent': 'VmRelocatedEvent','VmRemoteConsoleConnectedEvent': 'VmRemoteConsoleConnectedEvent','VmRemoteConsoleDisconnectedEvent': 'VmRemoteConsoleDisconnectedEvent','VmRemovedEvent': 'VmRemovedEvent','VmRenamedEvent': 'VmRenamedEvent','VmRequirementsExceedCurrentEVCModeEvent': 'VmRequirementsExceedCurrentEVCModeEvent','VmResettingEvent': 'VmResettingEvent','VmResourcePoolMovedEvent': 'VmResourcePoolMovedEvent','VmResourceReallocatedEvent': 'VmResourceReallocatedEvent','VmRestartedOnAlternateHostEvent': 'VmRestartedOnAlternateHostEvent','VmResumingEvent': 'VmResumingEvent','VmSecondaryAddedEvent': 'VmSecondaryAddedEvent','VmSecondaryDisabledBySystemEvent': 'VmSecondaryDisabledBySystemEvent','VmSecondaryDisabledEvent': 'VmSecondaryDisabledEvent','VmSecondaryEnabledEvent': 'VmSecondaryEnabledEvent','VmSecondaryStartedEvent': 'VmSecondaryStartedEvent','VmShutdownOnIsolationEvent': 'VmShutdownOnIsolationEvent','VmStartRecordingEvent': 'VmStartRecordingEvent','VmStartReplayingEvent': 'VmStartReplayingEvent','VmStartingEvent': 'VmStartingEvent','VmStartingSecondaryEvent': 'VmStartingSecondaryEvent','VmStaticMacConflictEvent': 'VmStaticMacConflictEvent','VmStoppingEvent': 'VmStoppingEvent','VmSuspendedEvent': 'VmSuspendedEvent','VmSuspendingEvent': 'VmSuspendingEvent','VmTimedoutStartingSecondaryEvent': 'VmTimedoutStartingSecondaryEvent','VmUnsupportedStartingEvent': 'VmUnsupportedStartingEvent','VmUpgradeCompleteEvent': 'VmUpgradeCompleteEvent','VmUpgradeFailedEvent': 'VmUpgradeFailedEvent','VmUpgradingEvent': 'VmUpgradingEvent','VmUuidAssignedEvent': 'VmUuidAssignedEvent','VmUuidChangedEvent': 'VmUuidChangedEvent','VmUuidConflictEvent': 'VmUuidConflictEvent','VmWwnAssignedEvent': 'VmWwnAssignedEvent','VmWwnChangedEvent': 'VmWwnChangedEvent','VmWwnConflictEvent': 'VmWwnConflictEvent'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VmEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Union[Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self, Self]:
        """Create an instance of VmEvent from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("VmEvent failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from vmware_vi.models.array_of_binary import ArrayOfBinary
from vmware_vi.models.array_of_prop_path import ArrayOfPropPath
from vmware_vi.models.array_of_uri import ArrayOfURI
from vmware_vi.models.customization_event import CustomizationEvent
from vmware_vi.models.customization_failed import CustomizationFailed
from vmware_vi.models.customization_linux_identity_failed import CustomizationLinuxIdentityFailed
from vmware_vi.models.customization_network_setup_failed import CustomizationNetworkSetupFailed
from vmware_vi.models.customization_started_event import CustomizationStartedEvent
from vmware_vi.models.customization_succeeded import CustomizationSucceeded
from vmware_vi.models.customization_sysprep_failed import CustomizationSysprepFailed
from vmware_vi.models.customization_unknown_failure import CustomizationUnknownFailure
from vmware_vi.models.drs_rule_compliance_event import DrsRuleComplianceEvent
from vmware_vi.models.drs_rule_violation_event import DrsRuleViolationEvent
from vmware_vi.models.drs_soft_rule_violation_event import DrsSoftRuleViolationEvent
from vmware_vi.models.drs_vm_migrated_event import DrsVmMigratedEvent
from vmware_vi.models.drs_vm_powered_on_event import DrsVmPoweredOnEvent
from vmware_vi.models.migration_error_event import MigrationErrorEvent
from vmware_vi.models.migration_event import MigrationEvent
from vmware_vi.models.migration_host_error_event import MigrationHostErrorEvent
from vmware_vi.models.migration_host_warning_event import MigrationHostWarningEvent
from vmware_vi.models.migration_resource_error_event import MigrationResourceErrorEvent
from vmware_vi.models.migration_resource_warning_event import MigrationResourceWarningEvent
from vmware_vi.models.migration_warning_event import MigrationWarningEvent
from vmware_vi.models.no_maintenance_mode_drs_recommendation_for_vm import NoMaintenanceModeDrsRecommendationForVM
from vmware_vi.models.not_enough_resources_to_start_vm_event import NotEnoughResourcesToStartVmEvent
from vmware_vi.models.primitive_binary import PrimitiveBinary
from vmware_vi.models.primitive_boolean import PrimitiveBoolean
from vmware_vi.models.primitive_byte import PrimitiveByte
from vmware_vi.models.primitive_date_time import PrimitiveDateTime
from vmware_vi.models.primitive_double import PrimitiveDouble
from vmware_vi.models.primitive_float import PrimitiveFloat
from vmware_vi.models.primitive_int import PrimitiveInt
from vmware_vi.models.primitive_long import PrimitiveLong
from vmware_vi.models.primitive_method_name import PrimitiveMethodName
from vmware_vi.models.primitive_prop_path import PrimitivePropPath
from vmware_vi.models.primitive_short import PrimitiveShort
from vmware_vi.models.primitive_string import PrimitiveString
from vmware_vi.models.primitive_type_name import PrimitiveTypeName
from vmware_vi.models.primitive_uri import PrimitiveURI
from vmware_vi.models.vm_acquired_mks_ticket_event import VmAcquiredMksTicketEvent
from vmware_vi.models.vm_acquired_ticket_event import VmAcquiredTicketEvent
from vmware_vi.models.vm_auto_rename_event import VmAutoRenameEvent
from vmware_vi.models.vm_being_cloned_event import VmBeingClonedEvent
from vmware_vi.models.vm_being_cloned_no_folder_event import VmBeingClonedNoFolderEvent
from vmware_vi.models.vm_being_created_event import VmBeingCreatedEvent
from vmware_vi.models.vm_being_deployed_event import VmBeingDeployedEvent
from vmware_vi.models.vm_being_hot_migrated_event import VmBeingHotMigratedEvent
from vmware_vi.models.vm_being_migrated_event import VmBeingMigratedEvent
from vmware_vi.models.vm_being_relocated_event import VmBeingRelocatedEvent
from vmware_vi.models.vm_clone_event import VmCloneEvent
from vmware_vi.models.vm_clone_failed_event import VmCloneFailedEvent
from vmware_vi.models.vm_cloned_event import VmClonedEvent
from vmware_vi.models.vm_config_missing_event import VmConfigMissingEvent
from vmware_vi.models.vm_connected_event import VmConnectedEvent
from vmware_vi.models.vm_created_event import VmCreatedEvent
from vmware_vi.models.vm_das_being_reset_event import VmDasBeingResetEvent
from vmware_vi.models.vm_das_being_reset_with_screenshot_event import VmDasBeingResetWithScreenshotEvent
from vmware_vi.models.vm_das_reset_failed_event import VmDasResetFailedEvent
from vmware_vi.models.vm_das_update_error_event import VmDasUpdateErrorEvent
from vmware_vi.models.vm_das_update_ok_event import VmDasUpdateOkEvent
from vmware_vi.models.vm_date_rolled_back_event import VmDateRolledBackEvent
from vmware_vi.models.vm_deploy_failed_event import VmDeployFailedEvent
from vmware_vi.models.vm_deployed_event import VmDeployedEvent
from vmware_vi.models.vm_disconnected_event import VmDisconnectedEvent
from vmware_vi.models.vm_discovered_event import VmDiscoveredEvent
from vmware_vi.models.vm_disk_failed_event import VmDiskFailedEvent
from vmware_vi.models.vm_emigrating_event import VmEmigratingEvent
from vmware_vi.models.vm_end_recording_event import VmEndRecordingEvent
from vmware_vi.models.vm_end_replaying_event import VmEndReplayingEvent
from vmware_vi.models.vm_failed_migrate_event import VmFailedMigrateEvent
from vmware_vi.models.vm_failed_relayout_event import VmFailedRelayoutEvent
from vmware_vi.models.vm_failed_relayout_on_vmfs2_datastore_event import VmFailedRelayoutOnVmfs2DatastoreEvent
from vmware_vi.models.vm_failed_starting_secondary_event import VmFailedStartingSecondaryEvent
from vmware_vi.models.vm_failed_to_power_off_event import VmFailedToPowerOffEvent
from vmware_vi.models.vm_failed_to_power_on_event import VmFailedToPowerOnEvent
from vmware_vi.models.vm_failed_to_reboot_guest_event import VmFailedToRebootGuestEvent
from vmware_vi.models.vm_failed_to_reset_event import VmFailedToResetEvent
from vmware_vi.models.vm_failed_to_shutdown_guest_event import VmFailedToShutdownGuestEvent
from vmware_vi.models.vm_failed_to_standby_guest_event import VmFailedToStandbyGuestEvent
from vmware_vi.models.vm_failed_to_suspend_event import VmFailedToSuspendEvent
from vmware_vi.models.vm_failed_updating_secondary_config import VmFailedUpdatingSecondaryConfig
from vmware_vi.models.vm_failover_failed import VmFailoverFailed
from vmware_vi.models.vm_fault_tolerance_state_changed_event import VmFaultToleranceStateChangedEvent
from vmware_vi.models.vm_fault_tolerance_turned_off_event import VmFaultToleranceTurnedOffEvent
from vmware_vi.models.vm_fault_tolerance_vm_terminated_event import VmFaultToleranceVmTerminatedEvent
from vmware_vi.models.vm_guest_os_crashed_event import VmGuestOSCrashedEvent
from vmware_vi.models.vm_guest_reboot_event import VmGuestRebootEvent
from vmware_vi.models.vm_guest_shutdown_event import VmGuestShutdownEvent
from vmware_vi.models.vm_guest_standby_event import VmGuestStandbyEvent
from vmware_vi.models.vm_instance_uuid_assigned_event import VmInstanceUuidAssignedEvent
from vmware_vi.models.vm_instance_uuid_changed_event import VmInstanceUuidChangedEvent
from vmware_vi.models.vm_instance_uuid_conflict_event import VmInstanceUuidConflictEvent
from vmware_vi.models.vm_mac_assigned_event import VmMacAssignedEvent
from vmware_vi.models.vm_mac_changed_event import VmMacChangedEvent
from vmware_vi.models.vm_mac_conflict_event import VmMacConflictEvent
from vmware_vi.models.vm_max_ft_restart_count_reached import VmMaxFTRestartCountReached
from vmware_vi.models.vm_max_restart_count_reached import VmMaxRestartCountReached
from vmware_vi.models.vm_message_error_event import VmMessageErrorEvent
from vmware_vi.models.vm_message_event import VmMessageEvent
from vmware_vi.models.vm_message_warning_event import VmMessageWarningEvent
from vmware_vi.models.vm_migrated_event import VmMigratedEvent
from vmware_vi.models.vm_no_compatible_host_for_secondary_event import VmNoCompatibleHostForSecondaryEvent
from vmware_vi.models.vm_no_network_access_event import VmNoNetworkAccessEvent
from vmware_vi.models.vm_orphaned_event import VmOrphanedEvent
from vmware_vi.models.vm_power_off_on_isolation_event import VmPowerOffOnIsolationEvent
from vmware_vi.models.vm_powered_off_event import VmPoweredOffEvent
from vmware_vi.models.vm_powered_on_event import VmPoweredOnEvent
from vmware_vi.models.vm_powering_on_with_customized_dv_port_event import VmPoweringOnWithCustomizedDVPortEvent
from vmware_vi.models.vm_primary_failover_event import VmPrimaryFailoverEvent
from vmware_vi.models.vm_reconfigured_event import VmReconfiguredEvent
from vmware_vi.models.vm_registered_event import VmRegisteredEvent
from vmware_vi.models.vm_relayout_successful_event import VmRelayoutSuccessfulEvent
from vmware_vi.models.vm_relayout_up_to_date_event import VmRelayoutUpToDateEvent
from vmware_vi.models.vm_reload_from_path_event import VmReloadFromPathEvent
from vmware_vi.models.vm_reload_from_path_failed_event import VmReloadFromPathFailedEvent
from vmware_vi.models.vm_relocate_failed_event import VmRelocateFailedEvent
from vmware_vi.models.vm_relocate_spec_event import VmRelocateSpecEvent
from vmware_vi.models.vm_relocated_event import VmRelocatedEvent
from vmware_vi.models.vm_remote_console_connected_event import VmRemoteConsoleConnectedEvent
from vmware_vi.models.vm_remote_console_disconnected_event import VmRemoteConsoleDisconnectedEvent
from vmware_vi.models.vm_removed_event import VmRemovedEvent
from vmware_vi.models.vm_renamed_event import VmRenamedEvent
from vmware_vi.models.vm_requirements_exceed_current_evc_mode_event import VmRequirementsExceedCurrentEVCModeEvent
from vmware_vi.models.vm_resetting_event import VmResettingEvent
from vmware_vi.models.vm_resource_pool_moved_event import VmResourcePoolMovedEvent
from vmware_vi.models.vm_resource_reallocated_event import VmResourceReallocatedEvent
from vmware_vi.models.vm_restarted_on_alternate_host_event import VmRestartedOnAlternateHostEvent
from vmware_vi.models.vm_resuming_event import VmResumingEvent
from vmware_vi.models.vm_secondary_added_event import VmSecondaryAddedEvent
from vmware_vi.models.vm_secondary_disabled_by_system_event import VmSecondaryDisabledBySystemEvent
from vmware_vi.models.vm_secondary_disabled_event import VmSecondaryDisabledEvent
from vmware_vi.models.vm_secondary_enabled_event import VmSecondaryEnabledEvent
from vmware_vi.models.vm_secondary_started_event import VmSecondaryStartedEvent
from vmware_vi.models.vm_shutdown_on_isolation_event import VmShutdownOnIsolationEvent
from vmware_vi.models.vm_start_recording_event import VmStartRecordingEvent
from vmware_vi.models.vm_start_replaying_event import VmStartReplayingEvent
from vmware_vi.models.vm_starting_event import VmStartingEvent
from vmware_vi.models.vm_starting_secondary_event import VmStartingSecondaryEvent
from vmware_vi.models.vm_static_mac_conflict_event import VmStaticMacConflictEvent
from vmware_vi.models.vm_stopping_event import VmStoppingEvent
from vmware_vi.models.vm_suspended_event import VmSuspendedEvent
from vmware_vi.models.vm_suspending_event import VmSuspendingEvent
from vmware_vi.models.vm_timedout_starting_secondary_event import VmTimedoutStartingSecondaryEvent
from vmware_vi.models.vm_unsupported_starting_event import VmUnsupportedStartingEvent
from vmware_vi.models.vm_upgrade_complete_event import VmUpgradeCompleteEvent
from vmware_vi.models.vm_upgrade_failed_event import VmUpgradeFailedEvent
from vmware_vi.models.vm_upgrading_event import VmUpgradingEvent
from vmware_vi.models.vm_uuid_assigned_event import VmUuidAssignedEvent
from vmware_vi.models.vm_uuid_changed_event import VmUuidChangedEvent
from vmware_vi.models.vm_uuid_conflict_event import VmUuidConflictEvent
from vmware_vi.models.vm_wwn_assigned_event import VmWwnAssignedEvent
from vmware_vi.models.vm_wwn_changed_event import VmWwnChangedEvent
from vmware_vi.models.vm_wwn_conflict_event import VmWwnConflictEvent
# TODO: Rewrite to not use raise_errors
VmEvent.model_rebuild(raise_errors=False)

